// ************************************************************************************************************************ //
//
//	File:			AI_Ini.h
//	Description:	Definitions of Ini & Eqp files
//	Author:			Beny
//
// ************************************************************************************************************************ //

#ifndef	__AI_INI_H__
#define	__AI_INI_H__


#include <inc\all\ai.h>




// + + + ------------------------------------------------------------------------------------------------------------------
// + + +	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC	VC
// + + + ------------------------------------------------------------------------------------------------------------------


//
// ************************************************* BODY INI definition **************************************************
//


//syntax: RankId, IniName, SubClassId

//SOLdier
s_charDef vcSolDef[] = 
{
	1, "vc03",	'A',		//VC local
	1, "vc03",	'B', 

	2, "vc02",	'A',		//VC mainfce
	2, "vc03",	'B', 

	3, "pvc02",	'A',		//VC elite
	3, "pvc03",	'B', 
	3, "militia02",	'C', 
	3, "pvc02",	'D',
	3, "militia02",	'E', 

	4, "nva01",	'A',		//NVA recr
	4, "nva01",	'B', 
	4, "nva02",	'C', 
	4, "nva01",	'D', 
	4, "nva02",	'E', 

	5, "nva01",	'A',		//NVA reg
	5, "nva01",	'B', 
	5, "nva02",	'C', 
	5, "nva01",	'D', 
	5, "nva02",	'E', 

	6, "nva01",	'A',		//NVA vet
	6, "nva01",	'B', 
	6, "nva02",	'C',
	6, "nva01",	'D', 
	6, "nva02",	'E', 

	0, NULL, 0				//end of list
};

//MachineGUnner
s_charDef vcMguDef[] = 
{
	1, "vc03",	'A', 
	2, "vc02",	'A', 
	3, "militia02",	'A', 
	4, "nva04",	'A', 
	5, "nva04",	'A', 
	6, "nva04",	'A', 
	0, NULL, 0				//end of list
};

/*

//Sapper a dalsi nemaji system adresaru pro eqp, takze zaremovano

//SAPper
s_charDef vcSapDef[] = 
{
	4, "nva04",	 ''
};
*/

//
// ************************************************* HEAD EQP definition **************************************************
//

//syntax: rank, headEqpName

//
s_headDef vcSolHead[] = 
{
	1, "hvm_003", "vhg009", 
	1, "hvm_010", "vhg009",
	1, "hvm_011", "vhg009", 

	2, "hvm_003", "vhg002", 
	2, "hvm_010", "vhg002", 
	2, "hvm_011", "vhg003", 

	3, "hvm_003", "vhg002", 
	3, "hvm_003", "vhg003", 
	3, "hvm_010", "vhg002", 
	3, "hvm_010", "vhg003", 
	3, "hvm_011", "vhg002", 
	3, "hvm_011", "vhg003", 

	4, "hvm_003", "vhg004", 
	4, "hvm_003", "vhg003", 
	4, "hvm_003", "vhg008", 
	4, "hvm_010", "vhg003", 
	4, "hvm_010", "vhg008", 
	4, "hvm_011", "vhg003", 
	4, "hvm_011", "vhg008", 

	5, "hvm_003", "vhg005", 
	5, "hvm_010", "vhg003", 
	5, "hvm_010", "vhg005", 
	5, "hvm_011", "vhg003", 
	5, "hvm_011", "vhg005", 
	5, "hvm_011", "vhg008", 

	6, "hvm_003", "vhg005", 
	6, "hvm_003", "vhg007", 
	6, "hvm_003", "vhg008", 
	6, "hvm_010", "vhg003", 
	6, "hvm_010", "vhg007", 
	6, "hvm_011", "vhg007", 
	6, "hvm_011", "vhg008", 

	0, NULL
};

//
s_headDef vcMguHead[] = 
{
	1, "hvm_003", "vhg009", 
	1, "hvm_010", "vhg009", 
	1, "hvm_011", "vhg004", 

	2, "hvm_003", "vhg004", 
	2, "hvm_010", "vhg004", 
	2, "hvm_011", "vhg002", 

	3, "hvm_003", "vhg002", 
	3, "hvm_010", "vhg004", 
	3, "hvm_011", "vhg002", 

	4, "hvm_003", "vhg003", 
	4, "hvm_003", "vhg004", 
	4, "hvm_010", "vhg002", 
	4, "hvm_010", "vhg003", 
	4, "hvm_011", "vhg003", 
	4, "hvm_011", "vhg004", 

	5, "hvm_003", "vhg005", 
	5, "hvm_003", "vhg008", 
	5, "hvm_010", "vhg005", 
	5, "hvm_010", "vhg008", 
	5, "hvm_011", "vhg005", 
	5, "hvm_011", "vhg002", 

	6, "hvm_003", "vhg003", 
	6, "hvm_003", "vhg007", 
	6, "hvm_003", "vhg008", 
	6, "hvm_010", "vhg003", 
	6, "hvm_010", "vhg005", 
	6, "hvm_010", "vhg007", 
	6, "hvm_011", "vhg005", 
	6, "hvm_011", "vhg008", 
	6, "hvm_011", "vhg007", 

	0, NULL
};



//
// ************************************************* WEAPON ID definition **************************************************
//


//syntax: Rank, WeaponId, SubClassId


//definition of weapons for VC Soldier
//!!! the subId is ignored now, because it's not specified in the document (VC2tabulkapostav.doc)
s_weapDef vcSolWeapDef[] = 
{
	1,  6,	'A',		//PPS-41
	1, 26,	'B',		//Mosin

	2, 54,	'A',		//MAT-49
	2,  6,	'A',		//PPS-41
	2, 15,	'B',		//SKS-45
	2, 54,	'B',		//MAT-49

	3,  2,	'A',		//AK-47
	3, 54,	'B',		//MAT-49
	3,  2,	'C',		//AK-47
	3, 39,	'D',		//vz.58
	3, 15,	'E',		//sks-45

	4,  2,	'A',		//AK-47
    4, 39,  'A',        //vz.58
	4,  2,	'B',		//AK-47
    4, 39,  'B',        //vz.58
	4, 15,	'C',		//SKS-45
	4, 39,	'D',		//vz.58
    4,  2,  'D',        //AK-47
	4, 15,	'E',		//SKS-45

	5,  2,	'A',		//AK-47
	5,  2,	'B',		//AK-47
	5, 15,	'C',		//SKS-45
	5, 39,	'D',		//vz.58
    5,  2,  'D',        //AK-47
	5, 15,	'E',		//SKS-45

	6,  2,	'A',		//AK-47
	6,  2,	'B',		//AK-47
	6, 15,	'C',		//SKS-45
	6, 39,	'D',		//vz.58
	6, 15,	'E',		//SKS-45

	0,  0,	 0
};

//definition of weapons for VC Machinegunner
s_weapDef vcMguWeapDef[] = 
{
	1,  5,	'A',		//DP-2
	2,  5,	'A',		//DP-2
	2, 18,	'A',		//RPD
	3, 35,	'A',		//CZ vz. 59
	3, 18,	'A',        //RPD
	4, 18,	'A',        //RPD
    4, 35,  'A',        //CZ vz. 59
	5, 18,	'A', 
	6, 18,	'A', 
	0,  0,	 0
};




// + + + ------------------------------------------------------------------------------------------------------------------
// + + +	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US	US
// + + + ------------------------------------------------------------------------------------------------------------------


//
// ************************************************* BODY INI definition **************************************************
//


//syntax: RankId, IniName, SubClassId

//SOLdier definition
s_charDef usSolDef[] = 
{
	3, "hocbao02",	'A',	//CIDG
	3, "hocbao02",	'B',
	3, "hocbao02",	'C',

	4, "arvn01",	'A',	//ARVN
	4, "arvn03",	'B',
	4, "arvn01",	'C',
	4, "arvn03",	'D',

	5, "usmc04",	'A',	//USMC
	5, "usmc04",	'B', 
	5, "usmc02",	'A', 
	5, "usmc02",	'B', 
	5, "usmc02",	'C', 
	5, "usmc04",	'D',  

	6, "hocbao02",	'A',	//Hoc Bao
	6, "hocbao03",	'B', 
	6, "hocbao03",	'C', 

	0, NULL, 0				//end of list
};

//Machine GUnner definition
s_charDef usMguDef[] = 
{
	3, "hocbao02",	'A',	//CIDG
	4, "arvn03",	'A',	//ARVN
	5, "usmc02",	'A',	//USMC
	6, "hocbao03",	'A',	//Hoc Bao
	0, NULL, 0				//end of list
};



//
// ************************************************* HEAD EQP definition **************************************************
//

//syntax: rank, headEqpName

//
s_headDef usSolHead[] = 
{
	3, "hvm_008", "uhg004",	
	3, "hvm_008", "uhg006",
	3, "hvm_017", "uhg004",	
	3, "hvm_017", "uhg006",

	4, "hvm_008", "uhg017",
	4, "hvm_012", "uhg017",
	4, "hvm_017", "uhg017",

	5, "hwm_006", "uhg014",
	5, "hwm_001", "uhg014",
	5, "hwm_013", "uhg014",
//	5, "hbm_004", "uhg014",

	6, "hvm_008", "uhg015",
	6, "hvm_008", "uhg016",
	6, "hvm_012", "uhg015",
	6, "hvm_012", "uhg016",
	6, "hvm_017", "uhg016",
	6, "hvm_017", "uhg015",

	0, NULL
};

//
s_headDef usMguHead[] = 
{
	3, "hvm_008", "uhg011",
	3, "hvm_017", "uhg011",

	4, "hvm_008", "uhg017",
	4, "hvm_012", "uhg017",
	4, "hvm_017", "uhg017",

	5, "hwm_001", "uhg014",
	5, "hwm_006", "uhg014",
	5, "hwm_013", "uhg014",

	6, "hvm_008", "uhg016",
	6, "hvm_012", "uhg016",
	6, "hvm_017", "uhg016",

	0, NULL
};



//
// ************************************************* WEAPON ID definition **************************************************
//


//syntax: Rank, WeaponId, SubClassId


//definition of weapons for US Soldier
//!!! the subId is ignored now, because it's not specified in the document (VC2tabulkapostav.doc)
s_weapDef usSolWeapDef[] = 
{
	3,	21,	 'A',   //Thompson
    3,  45,  'A',   //Carl Gustav
    3,  11,  'A',   //Remington 870
	3,	21,	 'B',   //Thompson
    3,  45,  'B',   //Carl Gustav
	3,	 6,	 'C',   //PPS

	4,	 1,	 'A',   //M-16
	4,	 1,	 'B',   //M-16
	4,  32,  'B',   //BAR
	4,	21,  'C',   //Thompson
	4,	 1,	 'D',   //M-16
//	4,	11,  'D',   //Remington 870

	5,	24,	 'A',	//M-14
	5,	 1,	 'B',   //M-16
    5,  47,  'B',   //XM-177
	5,	11,	 'C',   //Remington 870
	5,	24,	 'D', 	//M-14
 

	6,	 1,	 'A',   //M-16
	6,	47,	 'A',	//XM-177
	6,	47,	 'B',	//XM-177
	6,	 1,	 'B',   //M-16
	6,	 1,	 'C',   //M-16
	6,	47,	 'C',	//M-16
    6,  11,  'C',   //Remington 870

	0,  0,	 0
};

//definition of weapons for VC Machinegunner
s_weapDef usMguWeapDef[] = 
{
	3, 32,	'A',		//BAR
	3, 17,	'A',		//delete this when the BAR will be ready for use
	4, 32,	'A',		//BAR
	4, 17,	'A',		//M-60
	5, 17,	'A', 
	6, 17,	'A', 
	0,  0,	 0
};




#endif	//__AI_INI_H__
