#ifndef MAX_DYNAM_H	//az na konec scriptu !!!!
#define MAX_DYNAM_H

#include <inc\maxovo\!max_defs.h>

#ifndef MAX_COMMANDS
	#define MAX_COMMANDS	12
#endif

#define MAX_DYN_CMD_RENDER			0x1
#define MAX_DYN_CMD_PERIL			0x2
#define MAX_DYN_CMD_SET_DSTR		0x3
#define MAX_DYN_CMD_RESTORE_DSTR	0x4
#define MAX_DYN_CMD_MAROK_IMPULSE	0x5
#define MAX_DYN_CMD_MAROK_IMPULSE_C	0x6
#define MAX_DYN_CMD_MAROK_TRANSFORM	0x7
#define MAX_DYN_CMD_MESSAGE			0x8
#define MAX_DYN_CMD_VIEW_SHAKE		0x9
//#define MAX_DYN_CMD_ANIM_PLAY		0x9
#define MAX_DYN_CMD_SOUND_PLAY		0xA

/*typedef struct {
	float		delay;
	int			command_type;
} s_MAX_DYN_command;*/

typedef struct {
	dword		key;
	float		delay;
	//int			command_type;

	sc_nod			nod;
	s_SC_NodHandle	handle_nod;
	BOOL			render;
} s_MAX_DYN_object_render;

typedef struct {
	dword		key;
	float		delay;
	//int			command_type;

	dword		side;
	dword		group;
	float		time;

	dword		sc_helper_type;

	s_sphere		sphere;
	c_BoxOriented	box;

} s_MAX_DYN_peril;

typedef struct {
	dword		key;
	float		delay;
	int			command_type;

	sc_nod			nod;
	s_SC_NodHandle	handle_nod;
	char			name1[MAX_STRING_LEN], name2[MAX_STRING_LEN];

	dword			dstr_pl_handle;
	dword			weap_type;
} s_MAX_DYN_set_dstr;

typedef struct {
	dword		key;
	float		delay;
	int			command_type;

	sc_nod					nod, nod_m;
	s_SC_NodHandle			handle_nod, handle_nod_m;
	sc_nod					master_nod;
	s_SC_NodHandle			handle_master_nod;
	s_SC_Marok_Placement	rel_plc;
	char					name1[MAX_STRING_LEN], name2[MAX_STRING_LEN];
	float					fragment_impulse[3], fragment_impulse_r[3], fragment_impulse_p[3];
	float					time, interval;
} s_MAX_DYN_marok;

typedef struct {
	dword		key;
	float		delay;
	//int			command_type;

	sc_nod			nod;
	s_SC_NodHandle	handle_nod;
	sc_player		player;
	dword			handle_player;
	char			name[MAX_STRING_LEN];

	dword			message_p1, message_p2, message_p3;
	//c_Vector3		*param4;
} s_MAX_DYN_message;

typedef struct {
	dword		key;
	float		delay;
	//int			command_type;

	dword		snd_id;
	c_Vector3	pos;

	s_SC_Expl_CreateInfo	expl_info;
} s_MAX_DYN_sound_play;

dword	MAX_DYN_KEY			= 0;
//int	MAX_DYN_pos_in_list_command = -1;
int	MAX_DYN_pos_in_list_object_render	= -1;
int	MAX_DYN_pos_in_list_peril			= -1;
int	MAX_DYN_pos_in_list_set_dstr		= -1;
int	MAX_DYN_pos_in_list_marok			= -1;
int	MAX_DYN_pos_in_list_message			= -1;
int	MAX_DYN_pos_in_list_sound_play		= -1;

//s_MAX_DYN_command		MAX_DYN_command[MAX_COMMANDS];
s_MAX_DYN_object_render	MAX_DYN_object_render[MAX_COMMANDS];
s_MAX_DYN_peril			MAX_DYN_peril[MAX_COMMANDS];
s_MAX_DYN_set_dstr		MAX_DYN_set_dstr[MAX_COMMANDS];
s_MAX_DYN_marok			MAX_DYN_marok[MAX_COMMANDS];
s_MAX_DYN_message		MAX_DYN_message[MAX_COMMANDS];
s_MAX_DYN_sound_play	MAX_DYN_sound_play[MAX_COMMANDS];

BOOL MAX_DYN_remove_from_list(dword);

//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_DYN_get_key() {
	return ++MAX_DYN_KEY;
}
//-------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------  SOUNDS  ------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_sound_play(float delay, dword snd_id) { // pouziva se na to MAX_DYN_CMD_MESSAGE !!!!!!!!!!!!!
	if (MAX_DYN_pos_in_list_sound_play < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_sound_play++;

		CLEAR(MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play]);

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key		= MAX_DYN_get_key();

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].snd_id	= snd_id;
		//MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].pos		= *pos;

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].delay	= delay;

		return MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key;
	} else {
		SC_message("MAX_DYN_add_sound_play() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_sound_play(float delay, dword snd_id, c_Vector3 *pos) { // pouziva se na to MAX_DYN_CMD_MESSAGE !!!!!!!!!!!!!
	if (MAX_DYN_pos_in_list_sound_play < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_sound_play++;

		CLEAR(MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play]);

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key		= MAX_DYN_get_key();

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].snd_id	= snd_id;
		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].pos		= *pos;

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].delay	= delay;

		return MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key;
	} else {
		SC_message("MAX_DYN_add_sound_play() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_sound_play_explosion(float delay, dword snd_id, c_Vector3 *pos, dword ptc_id, dword typ, dword author_handle) { // pouziva se na to MAX_DYN_CMD_MESSAGE !!!!!!!!!!!!!
	if (MAX_DYN_pos_in_list_sound_play < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_sound_play++;

		CLEAR(MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play]);

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key		= MAX_DYN_get_key();

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].snd_id	= snd_id;
		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].pos		= *pos;

		MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].delay	= delay;

		if (ptc_id) {
			MAX_UNI_set_explosion_force(&MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].expl_info, typ);
			MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].expl_info.author_handle	= author_handle;
			MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].expl_info.ptc_id			= ptc_id;
			MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].expl_info.sph.pos		= *pos;
		}

		return MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play].key;
	} else {
		SC_message("MAX_DYN_add_sound_play_explosion() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------  ANIMS  ------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_anim_play(float delay, sc_player player, char *anim_name) { // pouziva se na to MAX_DYN_CMD_MESSAGE !!!!!!!!!!!!!
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		MAX_DYN_message[MAX_DYN_pos_in_list_message].player = player; /**/ MAX_DYN_message[MAX_DYN_pos_in_list_message].handle_player = MAX_SUP_get_handle_from_pl_id(MAX_DYN_message[MAX_DYN_pos_in_list_message].player);
		sprintf(MAX_DYN_message[MAX_DYN_pos_in_list_message].name, anim_name);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_anim_play() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------- VEHICLE ANIMS --------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_veh_anim_play(float delay, sc_nod nod, char *veh_anim_name) { // pouziva se na to MAX_DYN_CMD_MESSAGE !!!!!!!!!!!!!
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		MAX_DYN_message[MAX_DYN_pos_in_list_message].nod = nod; /**/ MAX_SUP_get_handle_from_nod(nod, &MAX_DYN_message[MAX_DYN_pos_in_list_message].handle_nod);
		sprintf(MAX_DYN_message[MAX_DYN_pos_in_list_message].name, veh_anim_name);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_veh_anim_play() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  IMPULSES  -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_constatnt_force(float delay, sc_nod nod, float *fragment_impulse, float *fragment_impulse_r, float *fragment_impulse_p, float time, float interval) {

	if (MAX_DYN_pos_in_list_marok < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_marok++;

		CLEAR(MAX_DYN_marok[MAX_DYN_pos_in_list_marok]);

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key = MAX_DYN_get_key();

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod					= nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod, &MAX_DYN_marok[MAX_DYN_pos_in_list_marok].handle_nod);
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[0]	= fragment_impulse[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[1]	= fragment_impulse[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[2]	= fragment_impulse[2];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[0]	= fragment_impulse_r[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[1]	= fragment_impulse_r[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[2]	= fragment_impulse_r[2];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[0]	= fragment_impulse_p[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[1]	= fragment_impulse_p[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[2]	= fragment_impulse_p[2];

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].time					= time;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].interval				= interval;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod_m					= 1;

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].delay			= delay;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].command_type	= MAX_DYN_CMD_MAROK_IMPULSE_C;

		return MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key;
	} else {
		SC_message("MAX_DYN_add_constatnt_force() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}

int MAX_DYN_add_view_shake(float delay, float force) {

	if (MAX_DYN_pos_in_list_marok < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_marok++;

		CLEAR(MAX_DYN_marok[MAX_DYN_pos_in_list_marok]);

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[0] = force;

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key = MAX_DYN_get_key();

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].delay			= delay;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].command_type	= MAX_DYN_CMD_VIEW_SHAKE;

		return MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key;
	} else {
		SC_message("MAX_DYN_add_view_shake() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------  RENDER  -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_show_nod(float delay, sc_nod nod) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= TRUE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_show_nod() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_show(float delay, char *name) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= SC_NOD_GetNoMessage_Entity(name); /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= TRUE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_show() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_show(float delay, char *g_name, char *s_name) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name); /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= TRUE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_show() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_hide_nod(float delay, sc_nod nod) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= FALSE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_hide_nod() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_hide(float delay, char *name) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= SC_NOD_GetNoMessage_Entity(name); /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= FALSE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_hide() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_hide(float delay, char *g_name, char *s_name) {

	if (MAX_DYN_pos_in_list_object_render < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_object_render++;

		CLEAR(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render]);

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key = MAX_DYN_get_key();

		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].delay			= delay;
		//MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].command_type	= MAX_DYN_CMD_RENDER;
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod			= SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name); /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].nod, &MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].handle_nod);
		MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].render			= FALSE;

		return MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render].key;
	} else {
		SC_message("MAX_DYN_add_hide() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------  PERIL  ------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_peril_sc_helper(float delay, char *name, dword side, dword group, float time) {

	if (MAX_DYN_pos_in_list_peril < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_peril++;

		CLEAR(MAX_DYN_peril[MAX_DYN_pos_in_list_peril]);

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].key = MAX_DYN_get_key();

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].sc_helper_type = SC_GetScriptHelper(name, &MAX_DYN_peril[MAX_DYN_pos_in_list_peril].sphere, &MAX_DYN_peril[MAX_DYN_pos_in_list_peril].box);

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].time	= time;
		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].side	= side;
		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].group	= group;

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].delay			= delay;
		//MAX_DYN_peril[MAX_DYN_pos_in_list_peril].command_type	= MAX_DYN_CMD_PERIL;

		return MAX_DYN_peril[MAX_DYN_pos_in_list_peril].key;
	} else {
		SC_message("MAX_DYN_add_peril_sc_helper() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_peril_dummy(float delay, char *name, float radius, dword side, dword group, float time) {

	if (MAX_DYN_pos_in_list_peril < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_peril++;

		CLEAR(MAX_DYN_peril[MAX_DYN_pos_in_list_peril]);

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].key = MAX_DYN_get_key();

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].sc_helper_type	= SC_SCRIPTHELPER_TYPE_SPHERE;
		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].sphere.rad		= radius;
		SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &MAX_DYN_peril[MAX_DYN_pos_in_list_peril].sphere.pos);

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].time	= time;
		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].side	= side;
		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].group	= group;

		MAX_DYN_peril[MAX_DYN_pos_in_list_peril].delay			= delay;
		//MAX_DYN_peril[MAX_DYN_pos_in_list_peril].command_type	= MAX_DYN_CMD_PERIL;

		return MAX_DYN_peril[MAX_DYN_pos_in_list_peril].key;
	} else {
		SC_message("MAX_DYN_add_peril_dummy() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- DESTRUCTION & MAROK ------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_set_dstr(float delay, sc_nod nod, char *name1, char *name2) {

	if (MAX_DYN_pos_in_list_set_dstr < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_set_dstr++;

		CLEAR(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr]);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key = MAX_DYN_get_key();

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod	= nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod, &MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].handle_nod);
		if (name1) sprintf(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].name1, name1);
		if (name2) sprintf(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].name2, name2);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].delay		= delay;
		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].command_type	= MAX_DYN_CMD_SET_DSTR;

		return MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key;
	} else {
		SC_message("MAX_DYN_add_set_dstr() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
/*int MAX_DYN_add_set_dstr(float delay, sc_nod nod, char *name1, char *name2, dword dstr_pl_handle, dword weap_type) {

	if (MAX_DYN_pos_in_list_set_dstr < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_set_dstr++;

		CLEAR(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr]);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key = MAX_DYN_get_key();

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod	= nod; /**/ //MAX_SUP_get_handle_from_nod(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod, &MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].handle_nod);
/*		if (name1) sprintf(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].name1, name1); //!!!!!!!!!!!!!!!!!!!!! ^^^^^^^^^^^^ !!!!!!!!!!!!!!!!!!!!!!!
		if (name2) sprintf(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].name2, name2);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].dstr_pl_handle	= dstr_pl_handle;
		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].weap_type		= weap_type;

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].delay		= delay;
		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].command_type	= MAX_DYN_CMD_SET_DSTR;

		return MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key;
	} else return -1;
}*/
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_restore_dstr(float delay, sc_nod nod) {

	if (MAX_DYN_pos_in_list_set_dstr < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_set_dstr++;

		CLEAR(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr]);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key = MAX_DYN_get_key();

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod = nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].nod, &MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].handle_nod);

		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].delay		= delay;
		MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].command_type	= MAX_DYN_CMD_RESTORE_DSTR;

		return MAX_DYN_set_dstr[MAX_DYN_pos_in_list_set_dstr].key;
	} else {
		SC_message("MAX_DYN_add_restore_dstr() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_marok_impulse(float delay, sc_nod nod, float *fragment_impulse, float *fragment_impulse_r, float *fragment_impulse_p) {

	if (MAX_DYN_pos_in_list_marok < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_marok++;

		CLEAR(MAX_DYN_marok[MAX_DYN_pos_in_list_marok]);

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key = MAX_DYN_get_key();

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod			= nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod, &MAX_DYN_marok[MAX_DYN_pos_in_list_marok].handle_nod);
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[0]		= fragment_impulse[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[1]		= fragment_impulse[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse[2]		= fragment_impulse[2];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[0]	= fragment_impulse_r[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[1]	= fragment_impulse_r[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_r[2]	= fragment_impulse_r[2];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[0]	= fragment_impulse_p[0];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[1]	= fragment_impulse_p[1];
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].fragment_impulse_p[2]	= fragment_impulse_p[2];

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].delay			= delay;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].command_type	= MAX_DYN_CMD_MAROK_IMPULSE;

		return MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key;
	} else {
		SC_message("MAX_DYN_add_marok_impulse() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_DYN_add_marok_transform(float delay, sc_nod master_nod, sc_nod nod, sc_nod nod_m, s_SC_Marok_Placement rel_plc, char *fragment_name) {
	if (MAX_DYN_pos_in_list_marok < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_marok++;

		CLEAR(MAX_DYN_marok[MAX_DYN_pos_in_list_marok]);

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key = MAX_DYN_get_key();

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].master_nod	= master_nod;	/**/ MAX_SUP_get_handle_from_nod(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].master_nod, &MAX_DYN_marok[MAX_DYN_pos_in_list_marok].handle_master_nod);
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod		= nod;			/**/ MAX_SUP_get_handle_from_nod(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod, &MAX_DYN_marok[MAX_DYN_pos_in_list_marok].handle_nod);
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod_m		= nod_m;		/**/ MAX_SUP_get_handle_from_nod(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].nod_m, &MAX_DYN_marok[MAX_DYN_pos_in_list_marok].handle_nod_m);
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].rel_plc	= rel_plc;
		if (fragment_name) sprintf(MAX_DYN_marok[MAX_DYN_pos_in_list_marok].name1, fragment_name);

		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].delay			= delay;
		MAX_DYN_marok[MAX_DYN_pos_in_list_marok].command_type	= MAX_DYN_CMD_MAROK_TRANSFORM;

		return MAX_DYN_marok[MAX_DYN_pos_in_list_marok].key;
	} else {
		SC_message("MAX_DYN_add_marok_transform() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  MESSAGES  -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
int	MAX_DYN_add_message_to_object(float delay, sc_nod nod, dword message_p1, dword message_p2, dword message_p3) {
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		MAX_DYN_message[MAX_DYN_pos_in_list_message].nod = nod; /**/ MAX_SUP_get_handle_from_nod(MAX_DYN_message[MAX_DYN_pos_in_list_message].nod, &MAX_DYN_message[MAX_DYN_pos_in_list_message].handle_nod);
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p1	= message_p1;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p2	= message_p2;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p3	= message_p3;
		//MAX_DYN_message[MAX_DYN_pos_in_list].param4	= message_p4;

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;
		//MAX_DYN_message[MAX_DYN_pos_in_list_message].command_type	= MAX_DYN_CMD_MESSAGE;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_message_to_object() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int	MAX_DYN_add_message_to_player(float delay, sc_player player, dword message_p1, dword message_p2, dword message_p3) {
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		MAX_DYN_message[MAX_DYN_pos_in_list_message].player = player; /**/ MAX_DYN_message[MAX_DYN_pos_in_list_message].handle_player = MAX_SUP_get_handle_from_pl_id(MAX_DYN_message[MAX_DYN_pos_in_list_message].player);
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p1	= message_p1;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p2	= message_p2;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p3	= message_p3;
		//MAX_DYN_message[MAX_DYN_pos_in_list].param4	= message_p4;

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;
		//MAX_DYN_message[MAX_DYN_pos_in_list_message].command_type	= MAX_DYN_CMD_MESSAGE;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_message_to_player() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int	MAX_DYN_add_message_to_sc_helper(float delay, char *name, dword message_p1, dword message_p2, dword message_p3) {
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		sprintf(MAX_DYN_message[MAX_DYN_pos_in_list_message].name, name);
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p1	= message_p1;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p2	= message_p2;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p3	= message_p3;
		//MAX_DYN_message[MAX_DYN_pos_in_list].param4	= message_p4;

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;
		//MAX_DYN_message[MAX_DYN_pos_in_list_message].command_type	= MAX_DYN_CMD_MESSAGE;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_message_to_sc_helper() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int	MAX_DYN_add_message_to_level(float delay, dword message_p1, dword message_p2, dword message_p3) {
	if (MAX_DYN_pos_in_list_message < MAX_COMMANDS-1) {
		MAX_DYN_pos_in_list_message++;

		CLEAR(MAX_DYN_message[MAX_DYN_pos_in_list_message]);

		MAX_DYN_message[MAX_DYN_pos_in_list_message].key = MAX_DYN_get_key();

		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p1	= message_p1;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p2	= message_p2;
		MAX_DYN_message[MAX_DYN_pos_in_list_message].message_p3	= message_p3;
		//MAX_DYN_message[MAX_DYN_pos_in_list].param4	= message_p4;

		MAX_DYN_message[MAX_DYN_pos_in_list_message].delay			= delay;
		//MAX_DYN_message[MAX_DYN_pos_in_list_message].command_type	= MAX_DYN_CMD_MESSAGE;

		return MAX_DYN_message[MAX_DYN_pos_in_list_message].key;
	} else {
		SC_message("MAX_DYN_add_message_to_level() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------  DO COMMAND  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_DYN_do_command(int i, int command_type, float elapsed_time) {

	switch(command_type) {
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_RENDER:
		SC_DUMMY_Set_DoNotRenHier2(MAX_DYN_object_render[i].nod, 1-MAX_DYN_object_render[i].render);
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_PERIL:
		{
			s_SC_AI_Peril	peril;

			if (MAX_DYN_peril[i].sc_helper_type == SC_SCRIPTHELPER_TYPE_SPHERE) {
				peril.forbidden_area->sph	= &MAX_DYN_peril[i].sphere;
				peril.forbidden_area->sphs	= 1;
			} else if (MAX_DYN_peril[i].sc_helper_type == SC_SCRIPTHELPER_TYPE_BOX) {
				peril.forbidden_area->box	= &MAX_DYN_peril[i].box;
				peril.forbidden_area->boxes	= 1;
			} else return;

			peril.time = MAX_DYN_peril[i].time;

			SC_AI_Peril_Add(MAX_DYN_peril[i].side, MAX_DYN_peril[i].group, &peril);
		}
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_SET_DSTR:
		#ifdef MAX_SCRIPT_DEBUG
			sprintf(_debug_tmp, "!max_dynam.h(%f) : %s : do_destruction() - destr_name: %s | prepnuti faze na: %s (??)", MAX_DYN_set_dstr[i].delay, SC_NOD_GetName(MAX_DYN_set_dstr[i].nod), MAX_DYN_set_dstr[i].name1, MAX_DYN_set_dstr[i].name2);
			SC_Log(3, _debug_tmp);
		#endif
		if (SC_StringSame(MAX_DYN_set_dstr[i].name2, ""))
			SC_NOD_SetDSTR2(MAX_DYN_set_dstr[i].nod, MAX_DYN_set_dstr[i].name1, NULL, MAX_DYN_set_dstr[i].dstr_pl_handle, MAX_DYN_set_dstr[i].weap_type);
		else
			SC_NOD_SetDSTR2(MAX_DYN_set_dstr[i].nod, MAX_DYN_set_dstr[i].name1, MAX_DYN_set_dstr[i].name2, MAX_DYN_set_dstr[i].dstr_pl_handle, MAX_DYN_set_dstr[i].weap_type);
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_RESTORE_DSTR:
		SC_NOD_Restore(MAX_DYN_set_dstr[i].nod);
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_MAROK_IMPULSE:
		{
			c_Vector3			zero_vec, impulse_vector, world_point_of_application;

			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_dynam.h(%f) : ?? : do_impulse() - name: %s", MAX_DYN_set_dstr[i].delay, SC_NOD_GetName(MAX_DYN_marok[i].nod));
				SC_Log(3, _debug_tmp);
			#endif

			if (MAX_SUP_is_active_destruction(MAX_DYN_marok[i].nod) <= 0) return;

			impulse_vector.x = frnd(MAX_DYN_marok[i].fragment_impulse_p[0]);
			impulse_vector.y = frnd(MAX_DYN_marok[i].fragment_impulse_p[1]);
			impulse_vector.z = frnd(MAX_DYN_marok[i].fragment_impulse_p[2]);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &impulse_vector, &world_point_of_application);

			impulse_vector.x = MAX_DYN_marok[i].fragment_impulse[0] + frnd(MAX_DYN_marok[i].fragment_impulse_r[0]);
			impulse_vector.y = MAX_DYN_marok[i].fragment_impulse[1] + frnd(MAX_DYN_marok[i].fragment_impulse_r[1]);
			impulse_vector.z = MAX_DYN_marok[i].fragment_impulse[2] + frnd(MAX_DYN_marok[i].fragment_impulse_r[2]);

			CLEAR(zero_vec);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &zero_vec, &zero_vec);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &impulse_vector, &impulse_vector);

			impulse_vector.x -= zero_vec.x;
			impulse_vector.y -= zero_vec.y;
			impulse_vector.z -= zero_vec.z;

			/*if (impulse_vector.z < 0) {
				impulse_vector.x *= -1;
				impulse_vector.y *= -1;
				impulse_vector.z *= -1;
			}*/

			SC_Marok_Impuls(MAX_DYN_marok[i].nod, &impulse_vector, &world_point_of_application);
		}
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_MAROK_IMPULSE_C:
		{
			c_Vector3			zero_vec, impulse_vector, world_point_of_application;

			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_dynam.h(%f) : ?? : do_impulse_c() - name: %s", MAX_DYN_set_dstr[i].delay, SC_NOD_GetName(MAX_DYN_marok[i].nod));
				SC_Log(3, _debug_tmp);
			#endif

			if (MAX_DYN_marok[i].nod_m >= 0) {
				if (MAX_SUP_is_active_destruction(MAX_DYN_marok[i].nod) <= 0) {
					MAX_DYN_remove_from_list(MAX_DYN_marok[i].key);
					return;
				}
				MAX_DYN_marok[i].nod_m = NULL;
			}

			//SC_Log(3, "asdasdasdasdasfsdgfhjgf %s", SC_NOD_GetName(MAX_DYN_marok[i].nod));

			impulse_vector.x = frnd(MAX_DYN_marok[i].fragment_impulse_p[0]);
			impulse_vector.y = frnd(MAX_DYN_marok[i].fragment_impulse_p[1]);
			impulse_vector.z = frnd(MAX_DYN_marok[i].fragment_impulse_p[2]);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &impulse_vector, &world_point_of_application);

			impulse_vector.x = (MAX_DYN_marok[i].fragment_impulse[0] + frnd(MAX_DYN_marok[i].fragment_impulse_r[0])) * elapsed_time / MAX_DYN_marok[i].interval;
			impulse_vector.y = (MAX_DYN_marok[i].fragment_impulse[1] + frnd(MAX_DYN_marok[i].fragment_impulse_r[1])) * elapsed_time / MAX_DYN_marok[i].interval;
			impulse_vector.z = (MAX_DYN_marok[i].fragment_impulse[2] + frnd(MAX_DYN_marok[i].fragment_impulse_r[2])) * elapsed_time / MAX_DYN_marok[i].interval;

			CLEAR(zero_vec);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &zero_vec, &zero_vec);
			SC_NOD_TransformToWorldSpace(MAX_DYN_marok[i].nod, &impulse_vector, &impulse_vector);

			impulse_vector.x -= zero_vec.x;
			impulse_vector.y -= zero_vec.y;
			impulse_vector.z -= zero_vec.z;

			SC_Marok_Impuls(MAX_DYN_marok[i].nod, &impulse_vector, &world_point_of_application);
		}
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_MAROK_TRANSFORM:
		{
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_dynam.h(%f) : %s : do_transform() - destr_name: %s | transformace: %s", MAX_DYN_set_dstr[i].delay, SC_NOD_GetName(MAX_DYN_marok[i].master_nod), SC_NOD_GetName(MAX_DYN_marok[i].nod_m), MAX_DYN_marok[i].name1);
				SC_Log(3, _debug_tmp);
			#endif
			SC_Marok_SetRelativePlacement2(MAX_DYN_marok[i].nod_m, MAX_DYN_marok[i].nod, &MAX_DYN_marok[i].rel_plc);
			SC_NOD_SetDSTR(MAX_DYN_marok[i].master_nod, MAX_DYN_marok[i].name1, MAX_DYN_marok[i].name1);
		}
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_MESSAGE:
		if ((MAX_DYN_message[i].name[0] != 0) && (MAX_DYN_message[i].player)) { //neni to zprava, ale prehrani animace pro hrace
			SC_P_Play3pvAnim(MAX_DYN_message[i].player, MAX_DYN_message[i].name);
			break;
		}

		if ((MAX_DYN_message[i].name[0] != 0) && (MAX_DYN_message[i].nod)) { //neni to zprava, ale prehrani animace pro vozidlo
			SC_VEH_StartAnim(MAX_DYN_message[i].nod, MAX_DYN_message[i].name);
			break;
		}

		if (MAX_DYN_message[i].nod)
			MAX_SUP_send_message_to_object(MAX_DYN_message[i].nod, MAX_DYN_message[i].message_p1, MAX_DYN_message[i].message_p2, MAX_DYN_message[i].message_p3, NULL);
		else if (MAX_DYN_message[i].player)
			MAX_SUP_send_message_to_player(MAX_DYN_message[i].player, MAX_DYN_message[i].message_p1, MAX_DYN_message[i].message_p2, MAX_DYN_message[i].message_p3, NULL);
		else if (MAX_DYN_message[i].name[0] != 0)
			MAX_SUP_send_message_to_sc_helper(MAX_DYN_message[i].name, MAX_DYN_message[i].message_p1, MAX_DYN_message[i].message_p2, MAX_DYN_message[i].message_p3, NULL);
		else
			MAX_SUP_send_message_to_level(MAX_DYN_message[i].message_p1, MAX_DYN_message[i].message_p2, MAX_DYN_message[i].message_p3, NULL);

		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_SOUND_PLAY:
		if (MAX_DYN_sound_play[i].snd_id > 0) {
			if ((MAX_DYN_sound_play[i].pos.x == 0.0) && (MAX_DYN_sound_play[i].pos.y == 0.0) && (MAX_DYN_sound_play[i].pos.z == 0.0))
				SC_SND_PlaySound2D(MAX_DYN_sound_play[i].snd_id);
			else
				SC_SND_PlaySound3D(MAX_DYN_sound_play[i].snd_id, &MAX_DYN_sound_play[i].pos);
		}
		if (MAX_DYN_sound_play[i].expl_info.ptc_id > 0) SC_Explosion_Make(&MAX_DYN_sound_play[i].expl_info);
		break;
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	case MAX_DYN_CMD_VIEW_SHAKE:
		SC_PC_MakeViewShake(MAX_DYN_marok[i].fragment_impulse[0]);
		break;

	default:
		break;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  TIME TICK  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_DYN_time_tick(float elapsed_time) {
	int i_dstr, i_marok, i_msg, i_render, i_peril, i_sound, j;
	BOOL	exit;

	i_dstr = 0;
	i_marok = 0;
	i_msg = 0;
	i_render = 0;
	i_peril = 0;
	i_sound = 0;

	do {
		exit = FALSE;
		while ((i_sound<=MAX_DYN_pos_in_list_sound_play) && (exit == FALSE)) {
			if (MAX_DYN_sound_play[i_sound].delay >= 0.0) MAX_DYN_sound_play[i_sound].delay -= elapsed_time;
			if (MAX_DYN_sound_play[i_sound].delay <  0.0) {
				MAX_DYN_do_command(i_sound, MAX_DYN_CMD_SOUND_PLAY, elapsed_time);
				MAX_DYN_sound_play[i_sound] = MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play];
				i_sound--;
				MAX_DYN_pos_in_list_sound_play--;
				exit = TRUE;
			} // if
			i_sound++;
		} // while

		while ((i_dstr<=MAX_DYN_pos_in_list_set_dstr) && (exit == FALSE)) {
			if (MAX_DYN_set_dstr[i_dstr].delay >= 0.0) MAX_DYN_set_dstr[i_dstr].delay -= elapsed_time;
			if (MAX_DYN_set_dstr[i_dstr].delay <  0.0) {
				MAX_DYN_do_command(i_dstr, MAX_DYN_set_dstr[i_dstr].command_type, elapsed_time);
				for (j=i_dstr; j<MAX_DYN_pos_in_list_set_dstr; j++) MAX_DYN_set_dstr[j] = MAX_DYN_set_dstr[j+1]; // musi zustat v puvodnim poradi !!!
				i_dstr--;
				MAX_DYN_pos_in_list_set_dstr--;
				exit = TRUE;
			} // if
			i_dstr++;
		} // while

		exit = FALSE;
		while ((i_marok<=MAX_DYN_pos_in_list_marok) && (exit == FALSE)) {
			if (MAX_DYN_marok[i_marok].delay >= 0.0) MAX_DYN_marok[i_marok].delay -= elapsed_time;
			if (MAX_DYN_marok[i_marok].delay <  0.0) {
				switch (MAX_DYN_marok[i_marok].command_type) {
				case MAX_DYN_CMD_MAROK_IMPULSE_C:
					if (MAX_DYN_marok[i_marok].time >= 0.0) {
						if (MAX_DYN_marok[i_marok].time != MAX_INFINITE_TIME) MAX_DYN_marok[i_marok].time -= elapsed_time;
						MAX_DYN_do_command(i_marok, MAX_DYN_CMD_MAROK_IMPULSE_C, elapsed_time);
					} else {
						for (j=i_marok; j<MAX_DYN_pos_in_list_marok; j++)	MAX_DYN_marok[j] = MAX_DYN_marok[j+1]; // musi zustat v puvodnim poradi !!!
						i_marok--;
						MAX_DYN_pos_in_list_marok--;
					}

					break;

				case MAX_DYN_CMD_MAROK_IMPULSE:
					MAX_DYN_do_command(i_marok, MAX_DYN_CMD_MAROK_IMPULSE, elapsed_time);
					for (j=i_marok; j<MAX_DYN_pos_in_list_marok; j++)	MAX_DYN_marok[j] = MAX_DYN_marok[j+1]; // musi zustat v puvodnim poradi !!!
					i_marok--;
					MAX_DYN_pos_in_list_marok--;
					break;

				case MAX_DYN_CMD_MAROK_TRANSFORM:
					MAX_DYN_do_command(i_marok, MAX_DYN_CMD_MAROK_TRANSFORM, elapsed_time);
					for (j=i_marok; j<MAX_DYN_pos_in_list_marok; j++)	MAX_DYN_marok[j] = MAX_DYN_marok[j+1]; // musi zustat v puvodnim poradi !!!
					i_marok--;
					MAX_DYN_pos_in_list_marok--;
					break;

				case MAX_DYN_CMD_VIEW_SHAKE:
					MAX_DYN_do_command(i_marok, MAX_DYN_CMD_VIEW_SHAKE, elapsed_time);
					for (j=i_marok; j<MAX_DYN_pos_in_list_marok; j++)	MAX_DYN_marok[j] = MAX_DYN_marok[j+1]; // musi zustat v puvodnim poradi !!!
					i_marok--;
					MAX_DYN_pos_in_list_marok--;
					break;
				}
				exit = TRUE;
			} // if
			i_marok++;
		} // while

		exit = FALSE;
		while ((i_msg<=MAX_DYN_pos_in_list_message) && (exit == FALSE)) {
			if (MAX_DYN_message[i_msg].delay >= 0.0) MAX_DYN_message[i_msg].delay -= elapsed_time;
			if (MAX_DYN_message[i_msg].delay <  0.0) {
				MAX_DYN_do_command(i_msg, MAX_DYN_CMD_MESSAGE, elapsed_time);
				for (j=i_msg; j<MAX_DYN_pos_in_list_message; j++) MAX_DYN_message[j] = MAX_DYN_message[j+1]; // musi zustat v puvodnim poradi !!!
				i_msg--;
				MAX_DYN_pos_in_list_message--;
				exit = TRUE;
			} // if
			i_msg++;
		} // while

		exit = FALSE;
		while ((i_render<=MAX_DYN_pos_in_list_object_render) && (exit == FALSE)) {
			if (MAX_DYN_object_render[i_render].delay >= 0.0) MAX_DYN_object_render[i_render].delay -= elapsed_time;
			if (MAX_DYN_object_render[i_render].delay <  0.0) {
				MAX_DYN_do_command(i_render, MAX_DYN_CMD_RENDER, elapsed_time);
				MAX_DYN_object_render[i_render] = MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render];
				i_render--;
				MAX_DYN_pos_in_list_object_render--;
				exit = TRUE;
			} // if
			i_render++;
		} // while

		exit = FALSE;
		while ((i_peril<=MAX_DYN_pos_in_list_peril) && (exit == FALSE)) {
			if (MAX_DYN_peril[i_peril].delay >= 0.0) MAX_DYN_peril[i_peril].delay -= elapsed_time;
			if (MAX_DYN_peril[i_peril].delay <  0.0) {
				MAX_DYN_do_command(i_peril, MAX_DYN_CMD_PERIL, elapsed_time);
				MAX_DYN_peril[i_peril] = MAX_DYN_peril[MAX_DYN_pos_in_list_peril];
				i_peril--;
				MAX_DYN_pos_in_list_peril--;
				exit = TRUE;
			} // if
			i_peril++;
		} // while
	} while ((i_dstr<=MAX_DYN_pos_in_list_set_dstr) || (i_marok<=MAX_DYN_pos_in_list_marok) || (i_msg<=MAX_DYN_pos_in_list_message) || (i_render<=MAX_DYN_pos_in_list_object_render) || (i_peril<=MAX_DYN_pos_in_list_peril));
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_DYN_is_list_empty() {
	if ((MAX_DYN_pos_in_list_marok == -1) && (MAX_DYN_pos_in_list_message == -1) &&
		(MAX_DYN_pos_in_list_object_render == -1) && (MAX_DYN_pos_in_list_peril == -1) &&
		(MAX_DYN_pos_in_list_set_dstr == -1) && (MAX_DYN_pos_in_list_sound_play == -1)) return TRUE;

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_DYN_remove_from_list(dword key) {
	int i, j;

	if (key == -1) return FALSE;

	for (i=0; i<=MAX_DYN_pos_in_list_set_dstr; i++) {
		if (MAX_DYN_set_dstr[i].key == key) {
			for (j=i; j<MAX_DYN_pos_in_list_set_dstr; j++)
				MAX_DYN_set_dstr[j] = MAX_DYN_set_dstr[j+1];

			MAX_DYN_pos_in_list_set_dstr--;
			return TRUE;
		}
	}

	for (i=0; i<=MAX_DYN_pos_in_list_marok; i++) {
		if (MAX_DYN_marok[i].key == key) {
			for (j=i; j<MAX_DYN_pos_in_list_marok; j++)
				MAX_DYN_marok[j] = MAX_DYN_marok[j+1];

			MAX_DYN_pos_in_list_marok--;
			return TRUE;
		}
	}

	for (i=0; i<=MAX_DYN_pos_in_list_message; i++) {
		if (MAX_DYN_message[i].key == key) {
			for (j=i; j<MAX_DYN_pos_in_list_message; j++)
				MAX_DYN_message[j] = MAX_DYN_message[j+1];

			MAX_DYN_pos_in_list_message--;
			return TRUE;
		}
	}

	for (i=0; i<=MAX_DYN_pos_in_list_object_render; i++) {
		if (MAX_DYN_object_render[i].key == key) {
			MAX_DYN_object_render[i] = MAX_DYN_object_render[MAX_DYN_pos_in_list_object_render];
			MAX_DYN_pos_in_list_object_render--;
			return TRUE;
		}
	}

	for (i=0; i<=MAX_DYN_pos_in_list_peril; i++) {
		if (MAX_DYN_peril[i].key == key) {
			MAX_DYN_peril[i] = MAX_DYN_peril[MAX_DYN_pos_in_list_peril];

			MAX_DYN_pos_in_list_peril--;
			return TRUE;
		}
	}

	for (i=0; i<=MAX_DYN_pos_in_list_sound_play; i++) {
		if (MAX_DYN_sound_play[i].key == key) {
			MAX_DYN_sound_play[i] = MAX_DYN_sound_play[MAX_DYN_pos_in_list_sound_play];

			MAX_DYN_pos_in_list_sound_play--;
			return TRUE;
		}
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_DYN_remove_all_from_list() {
	MAX_DYN_pos_in_list_set_dstr		= -1;
	MAX_DYN_pos_in_list_marok			= -1;
	MAX_DYN_pos_in_list_message			= -1;
	MAX_DYN_pos_in_list_object_render	= -1;
	MAX_DYN_pos_in_list_peril			= -1;
	MAX_DYN_pos_in_list_sound_play		= -1;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_DYN_just_loaded() {
	int		i;
	BOOL	success_pl = TRUE;

	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (i=0; i<=MAX_DYN_pos_in_list_object_render; i++)
		MAX_DYN_object_render[i].nod = MAX_SUP_get_nod_from_handle(&MAX_DYN_object_render[i].handle_nod);
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (i=0; i<=MAX_DYN_pos_in_list_peril; i++);
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (i=0; i<=MAX_DYN_pos_in_list_set_dstr; i++)
		MAX_DYN_set_dstr[i].nod = MAX_SUP_get_nod_from_handle(&MAX_DYN_set_dstr[i].handle_nod);
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (i=0; i<=MAX_DYN_pos_in_list_marok; i++)
		MAX_DYN_marok[i].nod = MAX_SUP_get_nod_from_handle(&MAX_DYN_marok[i].handle_nod);
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (i=0; i<=MAX_DYN_pos_in_list_message; i++) {
		if (MAX_DYN_message[i].nod) MAX_DYN_message[i].nod = MAX_SUP_get_nod_from_handle(&MAX_DYN_message[i].handle_nod);
		if (MAX_DYN_message[i].handle_player) 
			if ((MAX_DYN_message[i].player = MAX_SUP_get_pl_id_from_handle(MAX_DYN_message[i].handle_player)) == NULL) success_pl = FALSE;
	}

	return success_pl;

}
#endif //#ifndef MAX_DYNAM_H