#ifndef MAX_RENDER_HINT_H //az na konec scriptu !!!!
#define MAX_RENDER_HINT_H

#include <inc\maxovo\!max_defs.h>

#ifndef MAX_HINTS
	#define MAX_HINTS					10
#endif

typedef struct {
	dword	key;
	float	delay;
	float	min_time;
	float	max_time;

	int		text_nr;
} s_MAX_HITNT;

s_MAX_HITNT	MAX_HINT_items[MAX_HINTS];
int			MAX_HINT_pos_in_list = -1;

dword		MAX_HINT_KEY = 0;

BOOL		MAX_HINT_waiting = FALSE;
BOOL		MAX_HINT_rendering = FALSE;
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_HINTS_get_key() {
	return ++MAX_HINT_KEY;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_HINTS_add_item(float delay, float min_time, float max_time, int text_nr) {
	if (MAX_HINT_pos_in_list < MAX_HINTS-1) {
		MAX_HINT_pos_in_list++;

		CLEAR(MAX_HINT_items[MAX_HINT_pos_in_list]);

		MAX_HINT_items[MAX_HINT_pos_in_list].key		= MAX_HINTS_get_key();
		MAX_HINT_items[MAX_HINT_pos_in_list].delay		= delay;
		MAX_HINT_items[MAX_HINT_pos_in_list].min_time	= min_time;
		MAX_HINT_items[MAX_HINT_pos_in_list].max_time	= max_time;
		MAX_HINT_items[MAX_HINT_pos_in_list].text_nr	= text_nr;

		return MAX_HINT_items[MAX_HINT_pos_in_list].key;
	} else {
		SC_message("MAX_HINTS_add_item() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  TIME TICK  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_HINTS_time_tick(float elapsed_time) {
	int		i;
	//MAX_HINTS_elapsed_time = elapsed_time;
	for (i=0; i<=MAX_HINT_pos_in_list; i++) {
		if (MAX_HINT_items[i].delay > 0.0) {
			if ( (MAX_HINT_waiting) || (((MAX_HINT_items[i].delay - elapsed_time) <= 0.0) && (MAX_HINT_rendering)) ) {
				MAX_HINT_waiting = TRUE;
				continue;
			}
			MAX_HINT_items[i].delay -= elapsed_time;
			if (MAX_HINT_items[i].delay <= 0.0) {
				SC_HintSet(SC_Wtxt(MAX_HINT_items[i].text_nr));
				MAX_HINT_rendering = TRUE;
				MAX_HINT_waiting = FALSE;
				MAX_HINT_items[i].delay = -255.0;
			}
		} else if (MAX_HINT_items[i].delay == -255.0) {
			MAX_HINT_items[i].min_time -= elapsed_time;
			MAX_HINT_items[i].max_time -= elapsed_time;
			if ( (MAX_HINT_items[i].max_time <= 0.0) || ((MAX_HINT_items[i].min_time <= 0.0) && (MAX_HINT_waiting)) ) {
				SC_HintSet(NULL);
				MAX_HINT_items[i] = MAX_HINT_items[MAX_HINT_pos_in_list];
				MAX_HINT_pos_in_list--;
				i--;
				MAX_HINT_waiting = FALSE;
				MAX_HINT_rendering = FALSE;
			}
		}
	}
}

//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_HINTS_is_list_empty() {
	if (MAX_HINT_pos_in_list == -1) return TRUE;
	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_HINTS_remove_from_list(dword key) {
	int i;
	if (key == -1) return FALSE;
	for (i=0; i<=MAX_HINT_pos_in_list; i++) {
		if (MAX_HINT_items[i].key == key) {
			MAX_HINT_items[i] = MAX_HINT_items[MAX_HINT_pos_in_list];
			MAX_HINT_pos_in_list--;
			return TRUE;
		}
	}
	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_HINTS_remove_all_from_list() {
	MAX_HINT_pos_in_list = -1;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_HINTS_just_loaded() {
}

#endif //#ifndef MAX_PARTICLES_H