#ifndef MAX_SUPPORT_H //az na konec scriptu !!!!
#define MAX_SUPPORT_H

#include <inc\maxovo\!max_defs.h>

void MAX_SUP_clear_maintask(dword pl_id);

//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_move_at(sc_player player, char *name, dword callback) {
	c_Vector3	vec;

	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);
	MAX_SUP_clear_maintask(player);
	SC_P_Ai_SetScriptMode(player, TRUE);
	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &vec);
	SC_P_Ai_StopMoving(player);
	SC_P_Ai_MoveAt(player, &vec, 0, callback);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_move_at(sc_player player, c_Vector3 *vec, dword callback) {
	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);
	MAX_SUP_clear_maintask(player);
	SC_P_Ai_SetScriptMode(player, TRUE);
	//SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &vec);
	SC_P_Ai_StopMoving(player);
	SC_P_Ai_MoveAt(player, vec, 0, callback);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_save_game(int save_id, int desc_id) {
	s_SC_MissionSave	mission_save;

	CLEAR(mission_save);
	mission_save.savename_id = save_id;
	mission_save.description_id = desc_id;
	SC_MissionSave(&mission_save);
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_SUP_is_active_destruction(sc_nod nod) {
	sc_nod ret_nod = SC_NOD_GetDSTR(nod);

	if (ret_nod == NULL)
		return 0;
	else if (ret_nod == nod)
		return 1;
	else
		return -1;

}
//-------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------  VEHICLES  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_VEH_leave_group(dword side, dword group, sc_nod veh_nod) {
	int			i, num;
	sc_player	list[MAX_PLAYERS];
	sc_nod		tmp_veh_nod;

	num = SC_EnumPlayers(side, group, list, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_AI_ONLY);
	for (i=0; i<num; i++) {
		tmp_veh_nod = SC_P_IsUsingVehicle(list[i], NULL);
		if (tmp_veh_nod) {
			if (((veh_nod) && (veh_nod == tmp_veh_nod)) || (!veh_nod)) SC_P_Vehicle_Leave(list[i]);
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------  HANDLE -> NOD -> HANDLE  --------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_handle_from_nod(sc_nod nod, s_SC_NodHandle *handle) {
	SC_Get_NodHandle(nod, handle);
}
//-------------------------------------------------------------------------------------------------------------------------------
sc_nod MAX_SUP_get_nod_from_handle(s_SC_NodHandle *handle) {
	int	i;

	for (i=0; i<sizeof(handle->data)/sizeof(BYTE); i++) {
		if (handle->data[i] != 0)
			return SC_Get_NodByHandle(handle);

	}

	return NULL;
}
//-------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------  HANDLE -> PL_ID -> HANDLE  --------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_SUP_get_handle_from_pl_id(sc_player pl_id) {
	if (pl_id) return SC_P_GetHandle(pl_id);
	return NULL;
}
dword MAX_SUP_get_pl_id_from_handle(dword pl_handle) {
	if (pl_handle) return SC_P_GetByHandle(pl_handle);
	return NULL;
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_SUP_get_opp_side(dword side) {
	if (side == SC_P_SIDE_US) return SC_P_SIDE_VC;
	if (side == SC_P_SIDE_VC) return SC_P_SIDE_US;

	if (SC_IsMpGame()) SC_message("haluz v urcovani opp side");
	return SC_P_SIDE_NEUTRAL;
}
//-------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------- MULTIPLAYER --------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_clients_to_object(sc_nod nod, dword message_p1) {
	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)&message_p1, sizeof(dword));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_clients_to_object(sc_nod nod, dword message_p1, dword message_p2) {
	dword	data[2];

	data[0] = message_p1;
	data[1] = message_p2;
	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_clients_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3) {
	dword	data[3];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;
	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_clients_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3, dword message_p4) {
	dword	data[4];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;
	data[3] = message_p4;
	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_server_to_object(sc_nod nod, dword message_p1) {
	SC_ObjectScriptMessage_NodToSRV(nod, (void *)&message_p1, sizeof(dword));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_server_to_object(sc_nod nod, dword message_p1, dword message_p2) {
	dword	data[2];

	data[0] = message_p1;
	data[1] = message_p2;

	SC_ObjectScriptMessage_NodToSRV(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_server_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3) {
	dword	data[3];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;

	SC_ObjectScriptMessage_NodToSRV(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_server_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3, dword message_p4) {
	dword	data[4];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;
	data[3] = message_p4;

	SC_ObjectScriptMessage_NodToSRV(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------  DANGER & PERIL  -------------------------------------------------------
//------------------------------------------------------  DANGER & PERIL  -------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_SUP_add_fake_danger(char *name, dword side, dword group) {
	s_SC_AI_FakeDanger fakedanger;

	CLEAR(fakedanger);
	fakedanger.name = name;
	fakedanger.verify_time = 4.0;

	return SC_AI_FakeDanger_Add(side, group, &fakedanger);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_SUP_create_peril_sc_helper(char *name, dword side, dword group, float time) {
	s_SC_Area		area;
	s_sphere		sphere;
	c_BoxOriented	box;
	s_SC_AI_Peril	peril;
	dword			ret;

	CLEAR(sphere);
	CLEAR(box);
	CLEAR(area);
	CLEAR(peril);

	ret = SC_GetScriptHelper(name, &sphere, &box);

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
	} else return -1;

	peril.forbidden_area = &area;
	peril.time = time;

	return SC_AI_Peril_Add(side, group, &peril);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_SUP_create_peril_dummy(char *name, float radius, dword side, dword group, float time) {
	s_SC_Area		area;
	s_sphere		sphere;
	s_SC_AI_Peril	peril;
	c_Vector3		pos;

	CLEAR(sphere);
	CLEAR(area);
	CLEAR(peril);
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_create_peril_dummy() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &pos);
	sphere.pos = pos;
	sphere.rad = radius;

	area.sphs = 1;
	area.sph = &sphere;

	peril.forbidden_area = &area;
	peril.time = time;

	return SC_AI_Peril_Add(side, group, &peril);
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------  PLAYER  -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_enter_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.enter_vehicle = FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_enable_enter_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.enter_vehicle = TRUE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_leave_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.leave_vehicle = FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_enable_leave_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.leave_vehicle = TRUE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_swap_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.swap_vehicle = FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_enable_swap_vehicle() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.swap_vehicle = TRUE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_player() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.movement	= FALSE;
	control.looking		= TRUE;
	control.interaction	= FALSE;
	control.phasechange	= FALSE;
	control.weapons		= FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_total_player() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.movement	= FALSE;
	control.looking		= FALSE;
	control.interaction	= FALSE;
	control.phasechange	= FALSE;
	control.weapons		= FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_enable_player() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.movement	= TRUE;
	control.looking		= TRUE;
	control.interaction	= TRUE;
	control.phasechange	= TRUE;
	control.weapons		= TRUE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_get_hp(sc_player player) {
	s_SC_P_status	status;

	if (player == NULL) {
		//SC_message("Fatal MAX_SUP_get_hp() player == 0");
		return 0.0;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}

	if (SC_P_GetStatus(player, &status)) return status.hp; else return -1.0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_hp(sc_player player, float hp) {
	if (hp <= 0.0) 
		SC_P_MakeDamage(player, 1000000.0);
	else
		SC_P_SetHp(player, hp);

}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_push_player(sc_player player, dword body_part, float impulse_x, float impulse_y, float impulse_z) {
	c_Vector3	impulse;

	impulse.x = impulse_x;
	impulse.y = impulse_y;
	impulse.z = impulse_z;

	SC_P_IK_Impulse(player, body_part, &impulse);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_shoot_at_nod(sc_player player, sc_nod nod, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_player_shoot_at_nod() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(nod, &info_ws.pos);

	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_SHOOT | SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	
	info_ws.aim		= TRUE;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_shoot_at_nod(sc_player player, sc_nod nod, float time, int phase, int aim) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_player_shoot_at_nod() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(nod, &info_ws.pos);

	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_SHOOT;
	if (phase < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT; else info_ws.phase	= phase;
	if (aim   < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;   else info_ws.aim	= aim;
	
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_shoot_at_vec(sc_player player, c_Vector3 *vec, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	info_ws.pos		= *vec;
	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_SHOOT | SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	
	info_ws.aim		= TRUE;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_shoot_at_player(sc_player player, sc_player target, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	//SC_P_GetHeadPos(target, &info_ws.pos);
	info_ws.player = target;

	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_SHOOT | SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	
	info_ws.aim		= TRUE;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_shoot_at_player(sc_player player, sc_player target, float time, int phase, int aim) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	//SC_P_GetHeadPos(target, &info_ws.pos);
	info_ws.player = target;

	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_SHOOT;
	if (phase < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT; else info_ws.phase	= phase;
	if (aim   < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;   else info_ws.aim	= aim;
	
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_look_at_nod(sc_player player, sc_nod nod, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_player_look_at_nod() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(nod, &info_ws.pos);
	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_look_at_vec(sc_player player, c_Vector3 *vec, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	info_ws.pos		= *vec;
	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_look_at_vec(sc_player player, c_Vector3 *vec, float time, int phase, int aim) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	info_ws.pos		= *vec;
	info_ws.time	= time;
	info_ws.flags	= 0;
	if (phase < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT; else info_ws.phase	= phase;
	if (aim   < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;   else info_ws.aim	= aim;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_look_at_player(sc_player player, sc_player target, float time) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	//SC_P_GetHeadPos(target, &info_ws.pos);
	info_ws.player = target;

	info_ws.time	= time;
	info_ws.flags	= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;
	
	//info_ws.aim		= TRUE;
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_look_at_player(sc_player player, sc_player target, float time, int phase, int aim) {
	s_SC_P_AI_WatchShoot info_ws;

	if (time <= 0.0) {
		SC_P_Ai_SetWatchShoot(player, NULL);
		return;
	}

	CLEAR(info_ws);
	//SC_P_GetHeadPos(target, &info_ws.pos);
	info_ws.player = target;

	info_ws.time	= time;
	if (phase < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT; else info_ws.phase	= phase;
	if (aim   < 0) info_ws.flags |= SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;   else info_ws.aim	= aim;
	
	SC_P_Ai_SetWatchShoot(player, &info_ws);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_sort_players_dist_player(sc_player player, sc_player *list, int list_size) {
	s_SC_P_status	status, status2;
	float			dist[64], tmp_dist;
	int				i, j;
	sc_player		tmp_player;

	SC_P_GetStatus(player, &status);
	for (i=0; i<list_size; i++) {
		if (player == NULL) {
			SC_message("Fatal MAX_SUP_get_sort_players_dist_player() player == 0");
			return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
		}
		SC_P_GetStatus(list[i], &status2);
		dist[i] = SC_2VectorsDist(&status.pos, &status2.pos);
	}

	for (i=0; i<list_size-1; i++) {
		for (j=i+1; j<list_size; j++) {
			if (dist[i] > dist[j]) {
				tmp_dist = dist[i];
				dist[i]  = dist[j];
				dist[j]  = tmp_dist;

				tmp_player	= list[i];
				list[i]		= list[j];
				list[j]		= tmp_player;
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_SUP_get_sort_players_dist_player(sc_player player, sc_player *list, int list_size, float max_dist) {
	s_SC_P_status	status, status2;
	float			dist[64], tmp_dist;
	int				i, j;
	sc_player		tmp_player;
	int				remove_from_list = 0;

	SC_P_GetStatus(player, &status);
	for (i=0; i<list_size; i++) {
		if (player == NULL) {
			SC_message("Fatal MAX_SUP_get_sort_players_dist_player() player == 0");
			return 0;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
		}
		SC_P_GetStatus(list[i], &status2);
		dist[i] = SC_2VectorsDist(&status.pos, &status2.pos);
		if (dist[i] > max_dist) remove_from_list++;
	}

	for (i=0; i<list_size-1; i++) {
		for (j=i+1; j<list_size; j++) {
			if (dist[i] > dist[j]) {
				tmp_dist = dist[i];
				dist[i]  = dist[j];
				dist[j]  = tmp_dist;

				tmp_player	= list[i];
				list[i]		= list[j];
				list[j]		= tmp_player;
			}
		}
	}

	return list_size - remove_from_list;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_sort_players_dist_vec(c_Vector3 vec, sc_player *list, int list_size) {
	s_SC_P_status	status2;
	float			dist[64], tmp_dist;
	int				i, j;
	sc_player		tmp_player;

	for (i=0; i<list_size; i++) {
		if (list[i] == NULL) {
			SC_message("Fatal MAX_SUP_get_sort_players_dist_vec() player == 0");
			return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
		}
		SC_P_GetStatus(list[i], &status2);
		dist[i] = SC_2VectorsDist(&vec, &status2.pos);
	}

	for (i=0; i<list_size-1; i++) {
		for (j=i+1; j<list_size; j++) {
			if (dist[i] > dist[j]) {
				tmp_dist = dist[i];
				dist[i]  = dist[j];
				dist[j]  = tmp_dist;

				tmp_player	= list[i];
				list[i]		= list[j];
				list[j]		= tmp_player;
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_sort_players_dist_nod(sc_nod nod, sc_player *list, int list_size) {
	s_SC_P_status	status, status2;
	float			dist[64], tmp_dist;
	int				i, j;
	sc_player		tmp_player;
	c_Vector3		vec;

#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_get_sort_players_dist_nod() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(nod, &vec);
	for (i=0; i<list_size; i++) {
		if (list[i] == NULL) {
			SC_message("Fatal MAX_SUP_get_sort_players_dist_nod() player == 0");
			return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
		}
		SC_P_GetStatus(list[i], &status2);
		dist[i] = SC_2VectorsDist(&vec, &status2.pos);
	}

	for (i=0; i<list_size-1; i++) {
		for (j=i+1; j<list_size; j++) {
			if (dist[i] > dist[j]) {
				tmp_dist = dist[i];
				dist[i]  = dist[j];
				dist[j]  = tmp_dist;

				tmp_player	= list[i];
				list[i]		= list[j];
				list[j]		= tmp_player;
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_change_group(sc_player player, dword new_group) {
	dword	side, member_id;

	SC_P_GetSideGroupMemberId(player, &side, NULL, &member_id);
	SC_P_ChangeSideGroupMemberId(player, side, new_group, member_id);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_change_side_group(sc_player player, dword new_side, dword new_group) {
	dword	member_id;

	SC_P_GetSideGroupMemberId(player, NULL, NULL, &member_id);
	SC_P_ChangeSideGroupMemberId(player, new_side, new_group, member_id);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_US(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_US;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;
#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_US_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_US;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_US_PC(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_PC;
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER; 
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_US;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	"US_PC";
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_US_PC_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_PC;
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_US;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	"US_PC";
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_VC(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_VC;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_VC_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_VC;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_VC_PC(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;
	
	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_PC;
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_VC;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	"VC_PC";
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_VC_PC_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_PC;
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_VC;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	"VC_PC";
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_neutral_US(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_NEUTRAL;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_neutral_US_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_NEUTRAL;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_neutral_VC(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= create_player->flags;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_NEUTRAL;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.respawn = &resp_pos;			

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_create_player_neutral_VC_inactive(s_SC_Pscript_info *info, s_create_player *create_player) {
	s_SC_P_Create		create_info;

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		create_player->blocker ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;
	create_info.flags|=		create_player->death_comma ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;
#ifdef PLAYER_FORCE_IK
	create_info.flags|=		SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_NEUTRAL;
	create_info.group =		create_player->group;
	create_info.member_id =	create_player->member_id;

	create_info.name_nr =	create_player->name_nr;
	create_info.name_ansi =	NULL;
	create_info.name_unicode = NULL;

#ifdef VOICEGROUP
	create_info.genvoice_group = VOICEGROUP;
#endif

	create_info.inifile = create_player->inifile;
	create_info.eqp_inifile = create_player->eqp_inifile;
	create_info.head_name = create_player->head_name;
	create_info.head_eqp_inifile = create_player->head_eqp_inifile;

	create_info.weapons = create_player->weap_count;
	create_info.weap = create_player->weap;

	create_info.weap_select_tweap = create_player->weap[0].weap_id;

	return SC_P_Create(&create_info);
}
//-------------------------------------------------------------------------------------------------------------------------------





void MAX_SUP_respawn_player(s_SC_Pscript_info *info, dword flags) {
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
	resp_pos.flags |= flags;

	SC_P_Respawn(info->player, &resp_pos);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_derespawn_player(sc_player player) {
	SC_P_Derespawn(player);
}
void MAX_SUP_derespawn_player(s_SC_Pscript_info *info) {
	SC_P_Derespawn(info->player);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_release_player(sc_player player) {
	SC_P_Release(player);
}
void MAX_SUP_release_player(s_SC_Pscript_info *info) {
	SC_P_Release(info->player);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_player_get_pos(sc_player player, c_Vector3 *vec) {
	BOOL			ret;
	s_SC_P_status	status;

	if (player == NULL) {
		SC_message("Fatal MAX_SUP_player_get_pos() player == 0");
		return FALSE;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}

	ret = SC_P_GetStatus(player, &status);
	*vec = status.pos;

	return ret;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_pc_force_set_pos(sc_nod nod) {
	c_Vector3	vec;
	float		rz;
	sc_player	player;

	player = SC_PC_Get();

	SC_NOD_GetWorldPos(nod, &vec);
	rz = SC_NOD_GetWorldRotZ(nod);

	if (MAX_SUP_get_hp(player) <= 0.0) {
		s_SC_P_RespawnPos respawn_pos;

		CLEAR(respawn_pos);

		respawn_pos.flags = 0;
		respawn_pos.pos = vec;
		respawn_pos.rz  = rz;

		SC_P_Respawn(player, &respawn_pos);
	} else {
		SC_P_SetPos(player, &vec, SC_P_PHASE_STAND, &rz);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_force_set_pos(sc_player player, sc_nod nod) {
	c_Vector3	vec;
	float		rz;

	if (player == NULL) {
		SC_message("Fatal MAX_SUP_player_force_set_pos() player == 0");
		return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}


	SC_NOD_GetWorldPos(nod, &vec);
	rz = SC_NOD_GetWorldRotZ(nod);

	if (MAX_SUP_get_hp(player) <= 0.0) {
		s_SC_P_RespawnPos respawn_pos;

		CLEAR(respawn_pos);

		respawn_pos.flags = 0;
		respawn_pos.pos = vec;
		respawn_pos.rz  = rz;

		SC_P_Respawn(player, &respawn_pos);
	} else {
		MAX_SUP_clear_maintask(player);
		SC_P_Ai_StopMoving(player);
		SC_P_SetPos(player, &vec, SC_P_PHASE_STAND, &rz);
	}

	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);
	
	SC_P_Ai_SetScriptMode(player, TRUE);
	SC_P_Ai_MoveAt(player, &vec, NULL, 0);

	vec.x = 0.0;
	vec.y = 1.0;
	vec.z = 0.0;
	SC_NOD_TransformToWorldSpace(nod, &vec, &vec);
	vec.z+= 1.4;
	MAX_SUP_player_look_at_vec(player, &vec, 1.0);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_force_set_pos(sc_player player, sc_nod nod, dword hide_out) {
	c_Vector3	vec;
	float		rz;

	if (player == NULL) {
		SC_message("Fatal MAX_SUP_player_force_set_pos() player == 0");
		return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}


	SC_NOD_GetWorldPos(nod, &vec);
	rz = SC_NOD_GetWorldRotZ(nod);

	if (MAX_SUP_get_hp(player) <= 0.0) {
		s_SC_P_RespawnPos respawn_pos;

		CLEAR(respawn_pos);

		respawn_pos.flags = 0;
		respawn_pos.pos = vec;
		respawn_pos.rz  = rz;

		SC_P_Respawn(player, &respawn_pos);
	} else {
		MAX_SUP_clear_maintask(player);
		SC_P_Ai_StopMoving(player);
		SC_P_SetPos(player, &vec, SC_P_PHASE_STAND, &rz);
	}

	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);
	
	SC_P_Ai_SetScriptMode(player, TRUE);
	SC_P_Ai_MoveAt(player, &vec, hide_out, 0);

	vec.x = 0.0;
	vec.y = 1.0;
	vec.z = 0.0;
	SC_NOD_TransformToWorldSpace(nod, &vec, &vec);
	vec.z+= 1.4;
	MAX_SUP_player_look_at_vec(player, &vec, 1.0);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_force_set_pos(sc_player player, c_Vector3 *p_vec, float *p_rz) {
	c_Vector3	vec;
	float		rz;

	if (player == NULL) {
		SC_message("Fatal MAX_SUP_player_force_set_pos() player == 0");
		return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}

	vec = *p_vec;
	if (p_rz)
		rz  = *p_rz;
	else
		rz  = 0.0;

	if (MAX_SUP_get_hp(player) <= 0.0) {
		s_SC_P_RespawnPos respawn_pos;

		CLEAR(respawn_pos);

		respawn_pos.flags = 0;
		respawn_pos.pos = vec;
		respawn_pos.rz  = rz;

		SC_P_Respawn(player, &respawn_pos);
	} else {
		MAX_SUP_clear_maintask(player);
		SC_P_Ai_StopMoving(player);
		SC_P_SetPos(player, &vec, SC_P_PHASE_STAND, &rz);
	}

	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);
	
	SC_P_Ai_SetScriptMode(player, TRUE);
	SC_P_Ai_MoveAt(player, &vec, NULL, 0);

	vec.x = cos(rz) + vec.x;
	vec.y = sin(rz) + vec.x;
	vec.z = 1.4;
	MAX_SUP_player_look_at_vec(player, &vec, 1.0);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_player_force_set_pos(sc_player player, c_Vector3 *p_vec, float *p_rz, dword hide_out) {
	c_Vector3	vec;
	float		rz;

	if (player == NULL) {
		SC_message("Fatal MAX_SUP_player_force_set_pos() player == 0");
		return;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
	}

	vec = *p_vec;
	if (p_rz)
		rz  = *p_rz;
	else
		rz  = 0.0;

	if (MAX_SUP_get_hp(player) <= 0.0) {
		s_SC_P_RespawnPos respawn_pos;

		CLEAR(respawn_pos);

		respawn_pos.flags = 0;
		respawn_pos.pos = vec;
		respawn_pos.rz  = rz;

		SC_P_Respawn(player, &respawn_pos);
	} else {
		MAX_SUP_clear_maintask(player);
		SC_P_Ai_StopMoving(player);
		SC_P_SetPos(player, &vec, SC_P_PHASE_STAND, &rz);
	}
	
	if (SC_P_Ai_TeamCmds_Get(player)) SC_P_Ai_TeamCmds_Set(player, SC_P_AI_TEAMCMD_STATE_DISABLED);

	SC_P_Ai_SetScriptMode(player, TRUE);
	SC_P_Ai_MoveAt(player, &vec, hide_out, 0);

	vec.x = cos(rz) + vec.x;
	vec.y = sin(rz) + vec.x;
	vec.z = 1.4;
	MAX_SUP_player_look_at_vec(player, &vec, 1.0);
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------  AREA  -------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_prepare_area(s_SC_Area *area, s_sphere *sphere, c_BoxOriented *box) {
	//s_sphere		sphere;
	area->box = box;
	area->sph = sphere;
	area->boxes = 0;
	area->sphs  = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  MAIN TASK  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_default_maintask(s_SC_P_Ai_MainTask *maintask) { //vyplni pouze step, dist ...
	maintask->move_step			= 15.0;
	maintask->HO_movedist_max	= 15.0;
	maintask->HO_search_dist	= 10.0;
	maintask->HO_search_z_dist	= 3.0;
	//maintask->max_pc_distance	= maintask->move_step * 1.5;
	maintask->flags				= SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST | SC_P_AI_MAINTASK_FL_PCDIST_ALLOWAHEAD;
	maintask->last_perc_in_group_moves = 30.0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_clear_maintask(dword pl_id) {
	s_SC_P_Ai_MainTask	maintask;
//#ifdef PC_CONTROLLED
	if (SC_P_Ai_TeamCmds_Get(pl_id)) SC_P_Ai_TeamCmds_Set(pl_id, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM);
//#endif
	CLEAR(maintask);
	SC_P_Ai_SetMainTask(pl_id, &maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_custom_maintask_s_maintask(dword pl_id, s_maintask custom_maintask) {
	s_SC_P_Ai_MainTask	maintask;
	dword				ret;

	CLEAR(maintask);

	if ((custom_maintask.pc_id) || (custom_maintask.pl_handle)) {
		maintask.target_pl				= custom_maintask.pc_id ? custom_maintask.pc_id : MAX_SUP_get_pl_id_from_handle(custom_maintask.pl_handle);
		maintask.max_target_pl_dist		= custom_maintask.max_target_pl_dist ? custom_maintask.max_target_pl_dist : ((custom_maintask.step ? custom_maintask.step : custom_maintask.search_dist) * 0.8); // pokud je hrac na 80% hledaci vzdalenosti
		maintask.max_target_pl_z_dist	= 2.0;
	} else {
		if (custom_maintask.target) {
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_set_custom_maintask_s_maintask()[1] -> SC_NOD_GetWorldPos()");
#endif
			SC_NOD_GetWorldPos(custom_maintask.target, &maintask.target);
		} else {
			if (custom_maintask.target_area.sphs > 0)
				maintask.target = custom_maintask.target_area.sph->pos;
			else if (custom_maintask.target_area.boxes > 0)
				maintask.target = custom_maintask.target_area.box->pos;
			else if (custom_maintask.name[0] != 0) {
			} else {
				dword	side, group, member_id;
				SC_P_GetSideGroupMemberId(pl_id, &side, &group, &member_id);
				SC_message("haluz v zadani custom_maintask_s_maintask() %d/%d/%d", side, group, member_id);
			}
		}
	}

	if ((custom_maintask.target_area.boxes == 0) && (custom_maintask.target_area.sphs == 0) && (custom_maintask.name[0] != 0)) {
		ret = SC_GetScriptHelper(custom_maintask.name, &custom_maintask.target_sphere, &custom_maintask.target_box);
		if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
			custom_maintask.target_area.sphs = 1;
			custom_maintask.target_area.sph = &custom_maintask.target_sphere;
		} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
			custom_maintask.target_area.boxes = 1;
			custom_maintask.target_area.box = &custom_maintask.target_box;
		}
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_set_custom_maintask_s_maintask()[2] -> SC_NOD_GetWorldPos()");
#endif
		SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(custom_maintask.name), &maintask.target);	
	}

	if ((custom_maintask.target_area.boxes > 0) || (custom_maintask.target_area.sphs > 0)) maintask.target_area = &custom_maintask.target_area;

	maintask.cooperation_id		= custom_maintask.coop_id;
	maintask.flags				= custom_maintask.flags&0xFFF;
	maintask.move_step			= custom_maintask.step;
	maintask.HO_search_dist		= (custom_maintask.search_dist == 0.0) ? custom_maintask.step : custom_maintask.search_dist;
	if (maintask.HO_search_dist <= 0.0) maintask.HO_search_dist = 5.0;
	maintask.HO_search_z_dist	= custom_maintask.search_z_dist;
	maintask.HO_movedist_max	= (maintask.move_step != 0.0) ? maintask.HO_search_dist + maintask.move_step : /*maintask.HO_search_dist*2.0*/0.0;

	maintask.nextmove_interval		= custom_maintask.nextmove_interval;
	maintask.nextmove_interval_rand = custom_maintask.nextmove_interval_rand;
	maintask.max_pc_distance		= custom_maintask.max_pc_distance;
	
	//if (!custom_maintask.pl_handle)	maintask.max_pc_distance	= custom_maintask.max_pc_distance;
	
	if ((maintask.move_step > 0.0) && (custom_maintask.last_perc_in_group_moves == 0.0))
		maintask.last_perc_in_group_moves =  30.0;
	else
		maintask.last_perc_in_group_moves = 100.0;

	SC_P_Ai_SetMainTask(pl_id, &maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_default_maintask_sc_helper(char *name, dword pl_id, dword coop_id, float step, dword flags) {
	s_SC_P_Ai_MainTask	maintask;
	s_SC_Area			area;
	s_sphere			sphere;
	c_BoxOriented		box;
	dword				ret;

	CLEAR(area);
	CLEAR(sphere);
	CLEAR(box);
				
	CLEAR(maintask);

	ret = SC_GetScriptHelper(name, &sphere, &box); // pokud to neni SC_helper -> v maintask.target je NULL -> zadna oblast

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
		maintask.target_area = &area;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
		maintask.target_area = &area;
	}
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_set_default_maintask_sc_helper() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &maintask.target);	

	maintask.cooperation_id		= coop_id;
	maintask.flags				= flags&0xFFF;
	maintask.move_step			= step;
	maintask.HO_search_dist		= 10.0;
	maintask.HO_search_z_dist	= 3.0;
	maintask.HO_movedist_max	= (maintask.move_step != 0.0) ? maintask.HO_search_dist + maintask.move_step : maintask.HO_search_dist*2.0;

	//maintask.max_pc_distance	= step * 2.0;
	
	if (step > 0.0) 
		maintask.last_perc_in_group_moves =  30.0;
	else
		maintask.last_perc_in_group_moves = 100.0;

	SC_P_Ai_SetMainTask(pl_id, &maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_custom_maintask_sc_helper(char *name, dword pl_id, dword coop_id, float step, float search_dist, float search_z_dist, dword flags, sc_player pc_id) {
	s_SC_P_Ai_MainTask	maintask;
	s_SC_Area			area;
	s_sphere			sphere;
	c_BoxOriented		box;
	dword				ret;

	CLEAR(area);
	CLEAR(sphere);
	CLEAR(box);
				
	CLEAR(maintask);

	ret = SC_GetScriptHelper(name, &sphere, &box); // pokud to neni SC_helper -> v maintask.target je NULL -> zadna oblast

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
		maintask.target_area = &area;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
		maintask.target_area = &area;
	}

	if (pc_id) {
		maintask.target_pl				= pc_id;
		maintask.max_target_pl_dist		= (step ? step : search_dist) * 0.8; // pokud je hrac na 80% hledaci vzdalenosti
		maintask.max_target_pl_z_dist	= 2.0;

		maintask.nextmove_interval		= 1.0;
		maintask.nextmove_interval_rand = 1.0;
	} else {
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_set_custom_maintask_sc_helper() -> SC_NOD_GetWorldPos()");
#endif
		SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &maintask.target);	
	}

	maintask.cooperation_id		= coop_id;
	maintask.flags				= flags&0xFFF;
	
	maintask.move_step			= step;
	maintask.HO_search_dist		= search_dist;
	if (maintask.HO_search_dist <= 0.0) maintask.HO_search_dist = 5.0;
	maintask.HO_search_z_dist	= search_z_dist;
	maintask.HO_movedist_max	= (maintask.move_step != 0.0) ? maintask.HO_search_dist + maintask.move_step : maintask.HO_search_dist*2.0;

	//if (!pc_id)	maintask.max_pc_distance	= step * 2.0;
	
	if (step > 0.0) 
		maintask.last_perc_in_group_moves =  30.0;
	else
		maintask.last_perc_in_group_moves = 100.0;

	SC_P_Ai_SetMainTask(pl_id, &maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_follow_maintask_sc_helper(char *name, dword pc_id, dword pl_id, dword coop_id, float step, dword flags) {
	s_SC_P_Ai_MainTask	maintask;
	s_SC_Area			area;
	s_sphere			sphere;
	c_BoxOriented		box;
	dword				ret;

	CLEAR(area);
	CLEAR(sphere);
	CLEAR(box);
				
	CLEAR(maintask);

	ret = SC_GetScriptHelper(name, &sphere, &box); // pokud to neni SC_helper -> v maintask.target je NULL -> zadna oblast

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
		maintask.target_area = &area;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
		maintask.target_area = &area;
	}

	maintask.target_pl			= pc_id;
	
	maintask.cooperation_id		= coop_id;
	maintask.flags				= flags&0xFFF;
	maintask.move_step			= step;
	maintask.HO_search_dist		= 10.0;
	maintask.HO_search_z_dist	= 3.0;
	maintask.HO_movedist_max	=  maintask.move_step ? maintask.HO_search_dist + maintask.move_step : maintask.HO_search_dist*2.0;
	maintask.max_target_pl_dist	= (maintask.HO_search_dist ? maintask.HO_search_dist : maintask.move_step) * 0.8;
	maintask.max_target_pl_z_dist= 2.0;

	maintask.nextmove_interval		= 1.0;
	maintask.nextmove_interval_rand = 1.0;
	
	if (step > 0.0) 
		maintask.last_perc_in_group_moves =  30.0;
	else
		maintask.last_perc_in_group_moves = 100.0;

	SC_P_Ai_SetMainTask(pl_id, &maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_default_maintask_PC(dword pl_id) {
	s_SC_P_PC_MainTask pc_maintask;

	CLEAR(pc_maintask);
	pc_maintask.FDverify_maxdist_to_nearest_groupAI = 15.0;
	pc_maintask.FDverify_time_mult = 2.0;
	pc_maintask.FDverify_viewangle = PI/4.0;
	SC_P_PC_SetMainTask(pl_id, &pc_maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------- GROUP MESSAGES --------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group(dword side, dword group, dword flags, dword message_p1, dword message_p2) {
	int			i, num;
	sc_player	list[MAX_PLAYERS];

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, flags);
	for (i=0; i<num; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group_gen(dword side, dword group, dword flags, dword message_p1, dword message_p2) {
	int			i, num;
	sc_player	list[MAX_PLAYERS];
	dword		tmp_member_id;

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, flags);
	for (i=0; i<num; i++) {
		SC_P_GetSideGroupMemberId(list[i], NULL, NULL, &tmp_member_id);
		if (tmp_member_id >= SC_P_CREATE_MEMID_AUTO) SC_P_ScriptMessage(list[i], message_p1, message_p2);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group_perc(float perc, dword side, dword group, dword flags, dword message_p1, dword message_p2) {
	int			i, j, num;
	sc_player	list[MAX_PLAYERS];
	sc_player	player;

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, flags);

	for (i=0; i<num; i++) { // nahodne se prehazi poradi
		j = rand()%num;
		player = list[i];
		list[i] = list[j];
		list[j] = player;
	}

	for (i=0; i<num*perc; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group(dword side, dword group, dword flags, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	int			i, num;
	sc_player	list[MAX_PLAYERS];

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, flags);
	for (i=0; i<num; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group_perc(float perc, dword side, dword group, dword flags, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	int			i, j, num;
	sc_player	list[MAX_PLAYERS];
	sc_player	player;

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, flags);

	for (i=0; i<num; i++) { // nahodne se prehazi poradi
		j = rand()%num;
		player = list[i];
		list[i] = list[j];
		list[j] = player;
	}

	for (i=0; i<num*perc; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group_sc_helper(char *name, dword side, dword group, dword flags, dword message_p1, dword message_p2) {
	int					i, num;
	sc_player			list[MAX_PLAYERS];

	s_SC_Area			area;
	s_sphere			sphere;
	c_BoxOriented		box;
	dword				ret;

	CLEAR(area);
	CLEAR(sphere);
	CLEAR(box);
				
	ret = SC_GetScriptHelper(name, &sphere, &box);

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
	}

	num = 64;
	num = SC_EnumPlayersArea(side, group, list, num, flags, &area);
	for (i=0; i<num; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_group_sc_helper(char *name, dword side, dword group, dword flags, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	int					i, num;
	sc_player			list[MAX_PLAYERS];

	s_SC_Area			area;
	s_sphere			sphere;
	c_BoxOriented		box;
	dword				ret;

	CLEAR(area);
	CLEAR(sphere);
	CLEAR(box);
				
	ret = SC_GetScriptHelper(name, &sphere, &box); // pokud to neni SC_helper -> v maintask.target je NULL -> zadna oblast

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area.sphs = 1;
		area.sph = &sphere;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area.boxes = 1;
		area.box = &box;
	}

	num = 64;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayersArea(side, group, list, num, flags, &area);
	for (i=0; i<num; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------  OTHERS  -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_count_timeout(float *time_out, float elapsed_time) {
	if (*time_out >= 0.0) { // zmeneno z > na >= !! proc to tadky kua tak bylo???!!
		*time_out -= elapsed_time;
		if (*time_out < 0.0) return TRUE;
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_pos(char *name, c_Vector3 *pos) {
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_get_pos() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), pos);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_pos(char *g_name, char *s_name, c_Vector3 *pos) {
#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_get_pos() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name), pos);
}
//-------------------------------------------------------------------------------------------------------------------------------
int  MAX_SUP_get_area_sc_helper(char *name, s_SC_Area *area) {
	//s_sphere		sphere;
	//c_BoxOriented	box;
	dword			ret;

	if ((area->box == NULL) && (area->sph == NULL)) SC_message("MAX_SUP_get_area_sc_helper [FATAL ERROR]: area->box == NULL && area->sph == NULL  --->  crash");

	area->boxes	= 0;
	area->sphs	= 0;

	ret = SC_GetScriptHelper(name, area->sph, area->box);

	if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) {
		area->sphs	= 1;
		area->box	= NULL;
		//area->sph->pos = sphere.pos;
		//area->sph->rad = sphere.rad;
	} else if (ret == SC_SCRIPTHELPER_TYPE_BOX) {
		area->boxes	= 1;
		area->sph	= NULL;
		/*area->box->dx		= box.dx;
		area->box->dy		= box.dy;
		area->box->dz		= box.dz;
		area->box->front	= box.front;
		area->box->pos		= box.pos;
		area->box->right	= box.right;
		area->box->up		= box.up;*/
	} else return -1;

	return ret;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_area_dummy(char *name, float rad, s_SC_Area *area) {
	area->boxes	= 0;
	area->sphs	= 1;
	area->box	= NULL;
	area->sph	= NULL;

	MAX_SUP_get_pos(name, &area->sph->pos);
	area->sph->rad = rad;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_get_area_dummy(sc_nod nod, float rad, s_SC_Area *area) {
	area->boxes	= 0;
	area->sphs	= 1;
	area->box	= NULL;
	area->sph	= NULL;

#ifdef MAX_SCRIPT_DEBUG
	SC_Log(3, "MAX_SUP_get_area_dummy() -> SC_NOD_GetWorldPos()");
#endif
	SC_NOD_GetWorldPos(nod, &area->sph->pos);
	area->sph->rad = rad;
}
//-------------------------------------------------------------------------------------------------------------------------------
sc_nod MAX_SUP_SC_NOD_Get(char *g_name, char *s_name) {
	return SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_hide(char *name) {
	SC_DUMMY_Set_DoNotRenHier(name, TRUE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_hide(char *g_name, char *s_name) {
	SC_DUMMY_Set_DoNotRenHier2(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name), TRUE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_show(char *name) {
	SC_DUMMY_Set_DoNotRenHier(name, FALSE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_show(char *g_name, char *s_name) {
	SC_DUMMY_Set_DoNotRenHier2(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name), FALSE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_hide_nod(sc_nod nod) {
	SC_DUMMY_Set_DoNotRenHier2(nod, TRUE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_show_nod(sc_nod nod) {
	SC_DUMMY_Set_DoNotRenHier2(nod, FALSE);
}
//-------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------- MESSAGES -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_player(sc_player player, dword message_p1, dword message_p2) {
	SC_P_ScriptMessage(player, message_p1, message_p2);
}
//*((sc_nod*)&info->param4.x) 
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_player(sc_player player, dword message_p1, dword message_p2, dword message_p3, dword message_p4) { // bacha na bufferovani !!!!!
	c_Vector3	MAX_SUP_tmp_vec;

	MAX_SUP_tmp_vec.x = *(float *)&message_p4;
	SC_P_ScriptMessage(player, message_p1, message_p2, message_p3, &MAX_SUP_tmp_vec);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_player(sc_player player, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	SC_P_ScriptMessage(player, message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_object(sc_nod nod, dword message_p1, dword message_p2) {
	SC_ObjectScriptMessage(nod, message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3, dword message_p4) { // bacha na bufferovani !!!!!
	c_Vector3	MAX_SUP_tmp_vec;

	MAX_SUP_tmp_vec.x = *(float *)&message_p4;
	SC_ObjectScriptMessage(nod, message_p1, message_p2, message_p3, &MAX_SUP_tmp_vec);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	SC_ObjectScriptMessage(nod, message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_sc_helper(char *name, dword message_p1, dword message_p2) {
	SC_ScriptHelperMsg(name, message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_sc_helper(char *name, dword message_p1, dword message_p2, dword message_p3, dword message_p4) { // bacha na bufferovani !!!!!
	c_Vector3	MAX_SUP_tmp_vec;

	MAX_SUP_tmp_vec.x = *(float *)&message_p4;
	SC_ScriptHelperMsg(name, message_p1, message_p2, message_p3, &MAX_SUP_tmp_vec);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_sc_helper(char *name, dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	SC_ScriptHelperMsg(name, message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_level(dword message_p1, dword message_p2) {
	SC_LevelScriptMsg(message_p1, message_p2);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_level(dword message_p1, dword message_p2, dword message_p3, dword message_p4) { // bacha na bufferovani !!!!!
	c_Vector3	MAX_SUP_tmp_vec;

	MAX_SUP_tmp_vec.x = *(float *)&message_p4;
	SC_LevelScriptMsg(message_p1, message_p2, message_p3, &MAX_SUP_tmp_vec);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_level(dword message_p1, dword message_p2, dword message_p3, c_Vector3 *message_p4) {
	SC_LevelScriptMsg(message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_send_message_to_mp_script(dword message_p1, dword message_p2, dword message_p3, dword message_p4) {
	SC_MP_ModeScriptLocalMsg(message_p1, message_p2, message_p3, message_p4);
}
//-------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------- SPEECH ------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
sc_player MAX_SUP_get_nearest_gen_player(sc_player player) {
	sc_player	list[MAX_PLAYERS];
	int			num, i;
	dword		side, group, member_id1, member_id2;

	SC_P_GetSideGroupMemberId(player, &side, &group, &member_id1);
	num = SC_EnumPlayers(side, group, list, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY|SC_ENUMPLS_FL_ALIVEONLY);
	MAX_SUP_get_sort_players_dist_player(player, list, num);

	for (i=0; i<num; i++) {
		SC_P_GetSideGroupMemberId(list[i], NULL, NULL, &member_id2);
		if ((member_id2 >= SC_P_CREATE_MEMID_AUTO) && (member_id1 != member_id2))
			return list[i];
	}

	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
sc_player MAX_SUP_get_nearest_gen_player(sc_player player, dword side, dword group) {
	sc_player	list[MAX_PLAYERS];
	int			num, i;
	dword		member_id2;

	num = SC_EnumPlayers(side, group, list, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY|SC_ENUMPLS_FL_ALIVEONLY);
	MAX_SUP_get_sort_players_dist_player(player, list, num);

	for (i=0; i<num; i++) {
		SC_P_GetSideGroupMemberId(list[i], NULL, NULL, &member_id2);
		if ((member_id2 >= SC_P_CREATE_MEMID_AUTO) && (list[i] != player))
			return list[i];
	}

	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
sc_player MAX_SUP_get_nearest_gen_player_death(sc_player player, dword side, dword group) {
	sc_player	list[MAX_PLAYERS];
	int			num, i;
	dword		member_id2;

	num = SC_EnumPlayers(side, group, list, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY);
	MAX_SUP_get_sort_players_dist_player(player, list, num);

	for (i=0; i<num; i++) {
		SC_P_GetSideGroupMemberId(list[i], NULL, NULL, &member_id2);
		if ((member_id2 >= SC_P_CREATE_MEMID_AUTO) && (list[i] != player))
			return list[i];
	}

	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, char *str) {
	s_SC_SpeechAdd	sp_info;
	ushort			dest[MAX_STRING_LEN_LONG];

	SC_AnsiToUni(str, dest);

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_text = dest;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, int speech_nr) {
	s_SC_SpeechAdd	sp_info;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, char *str, float delay) {
	s_SC_SpeechAdd	sp_info;
	ushort			dest[MAX_STRING_LEN_LONG];

	SC_AnsiToUni(str, dest);

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_text = dest;
	sp_info.timer		= delay;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, int speech_nr, float delay) {
	s_SC_SpeechAdd	sp_info;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.timer		= delay;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, int speech_nr, float delay, int force_author) {
	s_SC_SpeechAdd	sp_info;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.force_authorname_id = force_author;
	sp_info.timer		= delay;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say(sc_player player, int speech_nr, float delay, char *anim, dword flags) {
	s_SC_SpeechAdd	sp_info;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.timer		= delay;
	sp_info.playanim_file	= anim;
	sp_info.playanim_flags	= flags;
	SC_Speech_Add(&sp_info);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say_to_player(sc_player player, sc_player target_player, char *str) {
	s_SC_SpeechAdd	sp_info;
	ushort			dest[MAX_STRING_LEN_LONG];
	c_Vector3		vec;

	SC_AnsiToUni(str, dest);

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_text = dest;
	sp_info.sayto_pl	= target_player;
	SC_Speech_Add(&sp_info);

	//SC_P_GetHeadPos(target_player, &vec);
	//MAX_SUP_player_look_at_vec(player, &vec, sp_info.timer);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say_to_player(sc_player player, sc_player target_player, int speech_nr) {
	s_SC_SpeechAdd	sp_info;
	c_Vector3		vec;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.sayto_pl	= target_player;
	SC_Speech_Add(&sp_info);

	//SC_P_GetHeadPos(target_player, &vec);
	//MAX_SUP_player_look_at_vec(player, &vec, sp_info.timer);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say_to_player(sc_player player, sc_player target_player, char *str, float delay) {
	s_SC_SpeechAdd	sp_info;
	ushort			dest[MAX_STRING_LEN_LONG];
	c_Vector3		vec;

	SC_AnsiToUni(str, dest);

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_text = dest;
	sp_info.timer		= delay;
	sp_info.sayto_pl	= target_player;
	SC_Speech_Add(&sp_info);

	//SC_P_GetHeadPos(target_player, &vec);
	//MAX_SUP_player_look_at_vec(player, &vec, sp_info.timer - delay);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say_to_player(sc_player player, sc_player target_player, int speech_nr, float delay) {
	s_SC_SpeechAdd	sp_info;
	c_Vector3		vec;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.timer		= delay;
	sp_info.sayto_pl	= target_player;
	SC_Speech_Add(&sp_info);

	//SC_P_GetHeadPos(target_player, &vec);
	//MAX_SUP_player_look_at_vec(player, &vec, sp_info.timer - delay);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_say_to_player(sc_player player, sc_player target_player, int speech_nr, float delay, char *anim, dword flags) {
	s_SC_SpeechAdd	sp_info;
	c_Vector3		vec;

	CLEAR(sp_info);
	sp_info.author.plid = player;
	sp_info.speech_nr	= speech_nr;
	sp_info.timer		= delay;
	sp_info.sayto_pl	= target_player;
	sp_info.playanim_file	= anim;
	sp_info.playanim_flags	= flags;
	SC_Speech_Add(&sp_info);

	//SC_P_GetHeadPos(target_player, &vec);
	//MAX_SUP_player_look_at_vec(player, &vec, sp_info.timer - delay);
	return sp_info.timer;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_SUP_is_speaking(sc_player player, float *time) {
	s_SC_Speech_Author	author;

	CLEAR(author);
	author.plid = player;

	//if (SC_Speech_IsTalking(&author)) {
		if (time) *time = SC_Speech_GetTalkTime(&author);
		if (*time > 0.0) return TRUE;
	//}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------- ANIMATION -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
float MAX_SUP_player_player_anim(sc_player player, char *name) {
	s_SC_P_Play3pvAnim	anim_info;

	CLEAR(anim_info);
	anim_info.begin_interpolate_time	= -1.0;
	anim_info.end_interpolate_time		= -1.0;
	anim_info.weight = 1.0;

	anim_info.stg_filename = name;

	return SC_P_Play3pvAnimExt(player, &anim_info);
}

float MAX_SUP_player_player_anim(sc_player player, char *name, float interpolace) {
	s_SC_P_Play3pvAnim	anim_info;

	CLEAR(anim_info);
	anim_info.begin_interpolate_time	= interpolace;
	anim_info.end_interpolate_time		= interpolace;
	anim_info.weight = 1.0;

	anim_info.stg_filename = name;

	return SC_P_Play3pvAnimExt(player, &anim_info);
}

float MAX_SUP_player_player_anim(sc_player player, char *name, float interpolace1, float interpolace2) {
	s_SC_P_Play3pvAnim	anim_info;

	CLEAR(anim_info);
	anim_info.begin_interpolate_time	= interpolace1;
	anim_info.end_interpolate_time		= interpolace2;
	anim_info.weight = 1.0;

	anim_info.stg_filename = name;

	return SC_P_Play3pvAnimExt(player, &anim_info);
}

float MAX_SUP_player_player_anim(sc_player player, char *name, float interpolace1, float interpolace2, dword call_back) {
	s_SC_P_Play3pvAnim	anim_info;

	CLEAR(anim_info);
	anim_info.begin_interpolate_time	= interpolace1;
	anim_info.end_interpolate_time		= interpolace2;
	anim_info.weight = 1.0;
	anim_info.callback_id = call_back;

	anim_info.stg_filename = name;

	return SC_P_Play3pvAnimExt(player, &anim_info);
}

int	is_walking = -1;

void MAX_SUP_set_move_phase_walk(sc_player player) {
#ifdef MAX_SCRIPT_DEBUG
	dword	side, group, member_id;

	if (is_walking == TRUE) return; // uz bezi

	SC_P_GetSideGroupMemberId(player, &side, &group, &member_id);
	sprintf(_debug_tmp, "MAX_SUP_set_move_phase_walk() - s/g/m: %d/%d/%d", side, group, member_id);
	SC_Log(3, _debug_tmp);
	//SC_message(_debug_tmp);
#else
	if (is_walking == TRUE) return; // uz bezi
#endif
	
	SC_P_SetMoveSpeed(player, 0, SC_P_MOVESPEED_STYLE_RUN, 1.5);
	SC_P_SetSystemAnim(player, 'X', 30, "g\\anims\\specials\\s008.stg");
	SC_P_SetAnimsVariations(player, SC_P_GetAnimsVariations(player)|SC_P_ANIMVARIATION_DISABLE_STOPINGANIM);

	is_walking = TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_move_phase_run(sc_player player) {
	dword variations;
#ifdef MAX_SCRIPT_DEBUG
	dword	side, group, member_id;

	if (is_walking == FALSE) return; // uz bezi

	SC_P_GetSideGroupMemberId(player, &side, &group, &member_id);
	sprintf(_debug_tmp, "MAX_SUP_set_move_phase_run() - s/g/m: %d/%d/%d", side, group, member_id);
	SC_Log(3, _debug_tmp);
	//SC_message(_debug_tmp);
#else
	if (is_walking == FALSE) return; // uz bezi
#endif

	SC_P_SetMoveSpeed(player, 0, SC_P_MOVESPEED_STYLE_RUN, 0.0);
	SC_P_SetSystemAnim(player, 'X', 30, NULL);
	variations = SC_P_GetAnimsVariations(player);
	if (variations&SC_P_ANIMVARIATION_DISABLE_STOPINGANIM) SC_P_SetAnimsVariations(player, variations-SC_P_ANIMVARIATION_DISABLE_STOPINGANIM);

	is_walking = FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_stopig_anim(sc_player player) {
	SC_P_SetAnimsVariations(player, SC_P_GetAnimsVariations(player)|SC_P_ANIMVARIATION_DISABLE_STOPINGANIM);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_enable_stopig_anim(sc_player player) {
	dword variations;
	variations = SC_P_GetAnimsVariations(player);
	if (variations&SC_P_ANIMVARIATION_DISABLE_STOPINGANIM) SC_P_SetAnimsVariations(player, variations-SC_P_ANIMVARIATION_DISABLE_STOPINGANIM);
}
//-------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------- MEDIK + ING -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_medik(sc_player player) {
	s_SC_P_Ai_Medik		medik_props;
	s_SC_P_AmmoRedefine	redefine;
	s_SC_PC_CmdMenu		menu;

	CLEAR(redefine);
	redefine.ammo_type = 22; //23 pro ing.
	redefine.max_ammo  = 1000;
	SC_P_AmmoRedefine_Add(player, &redefine);

	SC_AMMO_Set(player, 22, 1000);

	CLEAR(medik_props);
	SC_P_Ai_Medik_GetProps(player, &medik_props);
	medik_props.battle.hp_percentage	= 0.2;
	medik_props.battle.range			= 20.0;
	medik_props.battle.movedist_limit	= 20.0;
	medik_props.peace.hp_percentage		= 0.7;
	medik_props.peace.range				= 20.0;
	medik_props.peace.movedist_limit	= 20.0;
	SC_P_Ai_Medik_SetProps(player, &medik_props);

	CLEAR(menu);
	SC_PC_GetCommandMenu(&menu);
	menu.flags |= SC_PC_CMDMENU_FL_ENABLEMEDIC;
	menu.medik_max_call_distance = 20.0;
	SC_PC_SetCommandMenu(&menu);
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_disable_medik(sc_player player) {
	s_SC_P_Ai_Medik		medik_props;
	s_SC_P_AmmoRedefine	redefine;
	s_SC_PC_CmdMenu		menu;

	CLEAR(medik_props);
	SC_P_Ai_Medik_GetProps(player, &medik_props);
	medik_props.battle.hp_percentage	= 0.0;
	medik_props.battle.range			= 0.001;
	medik_props.peace.hp_percentage		= 0.0;
	medik_props.peace.range				= 0.001;
	SC_P_Ai_Medik_SetProps(player, &medik_props);

	CLEAR(menu);
	SC_PC_GetCommandMenu(&menu);
	if (menu.flags & SC_PC_CMDMENU_FL_ENABLEMEDIC) menu.flags -= SC_PC_CMDMENU_FL_ENABLEMEDIC;
	menu.medik_max_call_distance = 0.0;
	SC_PC_SetCommandMenu(&menu);
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_set_inzenyr(sc_player player) {
	s_SC_P_AmmoRedefine	redefine;
	s_SC_PC_CmdMenu		menu;
	//s_SC_PC_CmdMenuItem	menu_item;

	CLEAR(redefine);
	redefine.ammo_type = 23; //22 pro medik
	redefine.max_ammo  = 1000;
	SC_P_AmmoRedefine_Add(player, &redefine);

	SC_AMMO_Set(player, 23, 1000);

	//menu_item.cmd_id = CMD_CALL_INZENYR;
	//menu_item.txt_nr = 3183;

	CLEAR(menu);
	SC_PC_GetCommandMenu(&menu);
	menu.flags |= SC_PC_CMDMENU_FL_ENABLEAMMO;
	//menu.item[menu.items] = menu_item;
	//menu.items++;
	menu.ammo_max_call_distance = 20.0;
	SC_PC_SetCommandMenu(&menu);
}
//-------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------ SCREEN + HUD -----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_add_weap(sc_player player, dword weap, dword ammo_type, int ammo_amount, BOOL select) {
	dword	weapons_list[64];
	int		i, count;

	count = SC_P_GetWeapons(player, weapons_list, 64);
	for (i=0; i<count; i++) {
		if (weapons_list[i] == weap) break; // uz ji ma
	}

	if (i >= count) {// nenalezena
		weapons_list[count] = weap;
		SC_P_SetWeapons(player, weapons_list, count+1, select ? weap : 0);
		SC_AMMO_Set(player, ammo_type, ammo_amount);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_fade_in(float time) {
	SC_FadeTo(FALSE, time);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_fade_out(float time) {
	SC_FadeTo(TRUE, time);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_sound_play_3D(dword snd_id, char *name) {
	c_Vector3	pos;

	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &pos);
	SC_SND_PlaySound3D(snd_id, &pos);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_sound_play_3D(dword snd_id, sc_nod nod) {
	c_Vector3	pos;

	SC_NOD_GetWorldPos(nod, &pos);
	SC_SND_PlaySound3D(snd_id, &pos);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_save_current_weapons(sc_player player) {
	int	i, count;
	dword weapons_list[10];

	count = SC_P_GetWeapons(player, weapons_list, 10);
	SC_sgi(555, count);
	for (i=0; i<count; i++) SC_sgi(556+i, weapons_list[i]);

	SC_sgi(556+i, SC_P_GetSelectedWeapon(player));
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_SUP_load_current_weapons(sc_player player, s_SC_P_CreateWeap *weaps, dword *selected) {
	int	i, count;

	count = SC_ggi(555);

	for (i=0; i<count; i++) weaps[i].weap_id = SC_ggi(556+i);

	*selected = SC_ggi(556+i);

	return count;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_mission_end() {
	SC_MissionEnd(SC_MISSIONEND_TYPE_DONE_FADE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_mission_end(char *bink) {
	s_SC_MissionEnd info_m;
	CLEAR(info_m);
	sprintf(info_m.success_bink, bink);
	info_m.type = SC_MISSIONEND_TYPE_FINISHED;
	SC_MissionEndEx(&info_m);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_SUP_mission_failed(c_Vector3 *pos, c_Vector3 *dir) {
	s_SC_MissionEnd info_m;
	CLEAR(info_m);
	info_m.failed_watch_from = *pos;
	info_m.failed_watch_dir = *dir;
	info_m.type = SC_MISSIONEND_TYPE_FAILED;
	SC_MissionEndEx(&info_m);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
#endif //#ifndef MAX_SUPPORT_H