#include <inc/maxovo/!max_particles.h>
#include <inc/maxovo/!max_dynam.h>

/*#ifdef	INCLUDE_COUNT
#include <inc/maxovo/!max_extern_script.h>
int		script_handle[INCLUDE_COUNT];
int		script_result[INCLUDE_COUNT];
#endif*/

#define GROUND_TIME		1.5
#define GROUND_LIMIT	5.0

BOOL	IS_MP_CLIENT;
BOOL	IS_MP_GAME;

int		destr_phase[SETDSTR_COUNT];
sc_nod	destr_nod_valid[SETDSTR_COUNT];
float	HP;
float	SUM_HP[SETDSTR_COUNT], OLD_SUM_HP[SETDSTR_COUNT];
float	EXPL_SUM_HP[EXPL_COUNT], OLD_EXPL_SUM_HP[EXPL_COUNT];
float	SUM_MOVEMENT[EXPL_COUNT];
float	ground_timer[EXPL_COUNT];
int		ground_hits[EXPL_COUNT];
dword	is_on_ground[EXPL_COUNT];
float	is_exploded[EXPL_COUNT];
int		particle_id[EXPL_COUNT];
int		impulse_id[FRAGMENT_COUNT];
BOOL	check_ptc_in_marok_simulation;

#ifdef JOINTS_OBJ_COUNT
sc_nod	joint_obj_nod[JOINTS_OBJ_COUNT];
float	IK_SUM_HP[JOINTS_OBJ_COUNT], IK_OLD_SUM_HP[JOINTS_OBJ_COUNT];
sc_nod	joint_del_nod[JOINTS_OBJ_COUNT][JOINTS_DEL_COUNT];
BOOL	joint_removed[JOINTS_OBJ_COUNT][JOINTS_DEL_COUNT];
#endif

sc_nod	master_nod[SETDSTR_COUNT];
sc_nod	destr_nod[SETDSTR_COUNT][DESTR_COUNT];
sc_nod	fragment_nod[FRAGMENT_COUNT][2];
sc_nod	expl_nod[EXPL_COUNT][2];
#ifdef	HIDE_COUNT
	sc_nod	hide_nod[HIDE_COUNT][2];
#endif

sc_player	tmp_author_pl_id, act_author_pl_id;
float		glob_delay;
//dword		glob_priznak;
//dword		act_author_handle;

s_MAX_MUL_object_status	MAX_UNI_object_status;
dword					glob_side; // pouziva se pri validaci

s_SC_Marok_Placement	rel_plc[FRAGMENT_COUNT];

void do_destruction(s_SC_OBJ_info *info, int i, float new_hp, float delay);

void ptc_explosion(sc_nod nod, int i, float delay) {
	dword				key;
	s_MAX_PTC_particle	particle;

	CLEAR(particle);
	//SC_NOD_GetWorldPos(nod, &particle.pos);
	particle.nod		= nod;
	particle.move_with	= FALSE;

	particle.delay		= delay;
#ifdef DAMAGE_MULT_EXPL
	particle.typ		= (EXPL_TYPE[i]&0xffff)*DAMAGE_MULT_EXPL;
	particle.typ		|= EXPL_TYPE[i]&0xffff0000;
#else
	particle.typ		= EXPL_TYPE[i];
#endif

	particle.id			= EXPL_PTC[i][0];
	particle.time		= EXPL_TIME[i][0];
	particle.interval	= EXPL_INTERVAL[i][0];
	particle.scale		= EXPL_SCALE[i][0];
	particle.time_mult	= EXPL_TIME_MULT[i][0];
	key = MAX_PTC_add_particle(&particle);
	MAX_PTC_set_author(key, act_author_pl_id);
}
void ptc_fire_fly_player(sc_nod nod, int i, float delay, float time, BOOL move_with) {
	s_MAX_PTC_particle	particle;
	c_Vector3			vec;
	s_SC_Area			area;
	s_sphere			sphere;
	dword				num;
	sc_player			list[MAX_PLAYERS];

	CLEAR(particle);

	CLEAR(sphere);
	area.box	= NULL;
	area.boxes	= 0;
	area.sph	= NULL;
	area.sphs	= 0;

	SC_NOD_GetWorldPos(nod, &sphere.pos);
	sphere.rad = 10.0;

	area.sphs = 1;
	area.sph = &sphere;

	num = 64;
	num = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &area);

	/*if (num) {
		sphere.rad = 5.0;
		num = 64;
		num = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &area);
		if (num) particle.time_mult	= EXPL_TIME_MULT[i][1]*4.0+frnd(0.3); else particle.time_mult = EXPL_TIME_MULT[i][1]*2.0+frnd(0.1);
	} else {*/
		particle.time_mult = EXPL_TIME_MULT[i][1];
	//}

	particle.delay		= delay;
	particle.typ		= EXPLOSION_NONE;
	particle.nod		= nod;
	particle.move_with	= move_with;

	particle.id			= EXPL_PTC[i][1];
	particle.time		= time;
	particle.interval	= EXPL_INTERVAL[i][1];
	particle.scale		= EXPL_SCALE[i][1];
	particle_id[i] = MAX_PTC_add_particle(&particle);
}
void ptc_fire_grnd(sc_nod nod, int i, float delay, float time, BOOL move_with) {
	s_MAX_PTC_particle	particle;

	CLEAR(particle);
	particle.delay		= delay;
	particle.typ		= EXPLOSION_NONE;
	particle.nod		= nod;
	particle.move_with	= move_with;

	particle.id			= EXPL_PTC[i][2];
	particle.time		= time;
	particle.interval	= EXPL_INTERVAL[i][2];
	particle.scale		= EXPL_SCALE[i][2];
	particle.time_mult	= EXPL_TIME_MULT[i][2];
	MAX_PTC_add_particle(&particle);
}
void ptc_smoke(sc_nod nod, int i, float delay, float time, BOOL move_with) {
	s_MAX_PTC_particle	particle;

	CLEAR(particle);
	particle.delay		= delay;
	particle.typ		= EXPLOSION_NONE;
	particle.nod		= nod;
	particle.move_with	= move_with;

	particle.id			= EXPL_PTC[i][3];
	particle.time		= time;
	particle.interval	= EXPL_INTERVAL[i][3];
	particle.scale		= EXPL_SCALE[i][3];
	particle.time_mult	= EXPL_TIME_MULT[i][3];
	MAX_PTC_add_particle(&particle);
}
void ptc_hit_master(sc_nod nod, int i, float time, BOOL move_with) {
	/*s_MAX_PTC_particle	particle;

	CLEAR(particle);
	//SC_NOD_GetWorldPos(nod, &particle.pos);
	particle.nod		= nod;
	particle.delay		= 0.0;
	particle.typ		= EXPLOSION_NONE;
	particle.move_with	= move_with;

	particle.id			= EXPL_PTC[i][4];
	particle.time		= time;
	particle.interval	= EXPL_INTERVAL[i][4];
	particle.scale		= EXPL_SCALE[i][4];
	particle.time_mult	= EXPL_TIME_MULT[i][5];
	MAX_PTC_add_particle(&particle);*/

	if (move_with)
		SC_CreatePtcInNodSpace_Ext(EXPL_PTC[i][4], nod, time, EXPL_INTERVAL[i][4], EXPL_SCALE[i][4], EXPL_TIME_MULT[i][4]);
	else
		SC_CreatePtc_Ext(EXPL_PTC[i][4], nod, time, EXPL_INTERVAL[i][4], EXPL_SCALE[i][4], EXPL_TIME_MULT[i][4]);
}
void ptc_hit(sc_nod nod, int i, float time, BOOL move_with) {
	/*s_MAX_PTC_particle	particle;

	CLEAR(particle);
	//SC_NOD_GetWorldPos(nod, &particle.pos);
	particle.nod		= nod;
	particle.delay		= 0.0;
	particle.typ		= EXPLOSION_NONE;
	particle.move_with	= move_with;

	particle.id			= EXPL_PTC[i][5];
	particle.time		= time;
	particle.interval	= EXPL_INTERVAL[i][5];
	particle.scale		= EXPL_SCALE[i][5];
	particle.time_mult	= EXPL_TIME_MULT[i][5];
	MAX_PTC_add_particle(&particle);*/

	if (move_with)
		SC_CreatePtcInNodSpace_Ext(EXPL_PTC[i][5], nod, time, EXPL_INTERVAL[i][5], EXPL_SCALE[i][5], EXPL_TIME_MULT[i][5]);
	else
		SC_CreatePtc_Ext(EXPL_PTC[i][5], nod, time, EXPL_INTERVAL[i][5], EXPL_SCALE[i][5], EXPL_TIME_MULT[i][5]);
}

void do_ground_fire(sc_nod nod, int i) {
	MAX_PTC_remove_from_list(particle_id[i]);
	particle_id[i] = -1;
	if ((EXPL_PTC[i][1]!=0) && (EXPL_TIME[i][1] < 0.0)) ptc_fire_fly_player(nod, i, 0.0, abs(EXPL_TIME[i][1]), (EXPL_PTC[i][1] > 0) ? FALSE : TRUE);
	if (EXPL_PTC[i][2]!=0) ptc_fire_grnd(nod, i, 0.0, EXPL_TIME[i][2], (EXPL_PTC[i][2] > 0) ? FALSE : TRUE);
	if (EXPL_PTC[i][3]!=0) ptc_smoke(nod, i, EXPL_TIME[i][2], EXPL_TIME[i][3], (EXPL_PTC[i][3] > 0) ? FALSE : TRUE);
}

#ifdef HIDE_COUNT
void do_hide(sc_nod nod_m, float delay) {
	int				i;
	sc_nod			nod;


	for (i=0; i<HIDE_COUNT; i++) {
		nod = hide_nod[i][1];
		if ((nod == nod_m) || ((nod == NULL) && (nod_m == hide_nod[i][0]))) {
			if (nod == NULL)
				nod = nod_m;
			else
				nod = hide_nod[i][0];

			if (delay > 0.0)
				MAX_DYN_add_hide_nod(delay, nod);
			else
				MAX_SUP_hide_nod(nod);
		}
	}
}
#endif

void do_explosion(sc_nod nod_m, float delay) {
	int				i;
	sc_nod			nod;

	for (i=0; i<EXPL_COUNT; i++) {
		nod = expl_nod[i][1] ? expl_nod[i][1]:expl_nod[i][0];

		if (nod == nod_m) {

			nod = expl_nod[i][0];

			if ((EXPL_PTC[i][4]== -1) && (MAX_SUP_is_active_destruction(nod) <= 0) && (delay <= 0.0)) continue;
			/*else if ((delay > 0.0) && (MAX_SUP_is_active_destruction(nod) <= 0)) { // pokud by to delalo bordel, tak se to tady musi dopsat !!!!!!!!!!
			//prohledat jestli ten nod bude uz destruovany v cese delay

				}*/

			if (EXPL_PTC[i][0]!=0)	ptc_explosion(nod, i, delay);
			if (EXPL_PTC[i][1]!=0) {
				if (EXPL_TIME[i][1] > 0.0) {
					ptc_fire_fly_player(nod, i, delay, EXPL_TIME[i][1], (EXPL_PTC[i][1] > 0) ? FALSE : TRUE);
					if (EXPL_PTC[i][2]!=0) ptc_fire_grnd(nod, i, delay + EXPL_TIME[i][1], EXPL_TIME[i][2], (EXPL_PTC[i][2] > 0) ? FALSE : TRUE);
					if (EXPL_PTC[i][3]!=0) ptc_smoke(nod, i, delay + EXPL_TIME[i][1] + EXPL_TIME[i][2], EXPL_TIME[i][3], (EXPL_PTC[i][3] > 0) ? FALSE : TRUE);
					is_on_ground[i] = 2;
				} else {
					ptc_fire_fly_player(nod, i, delay, MAX_INFINITE_TIME, (EXPL_PTC[i][1] > 0) ? FALSE : TRUE);
				}
			}
			is_exploded[i] = delay;
		}
	}
}

void do_hit(s_SC_OBJ_info *info) {
	int				i;
	sc_nod			nod;

	for (i=0; i<EXPL_COUNT; i++) {
		if (EXPL_PTC[i][4]!=0 && EXPL_PTC[i][4]!=-1 && expl_nod[i][1]) {
			nod = expl_nod[i][1];
			if (nod == info->nod) {
				nod = expl_nod[i][0];
				ptc_hit_master(nod, i, EXPL_TIME[i][4], (EXPL_PTC[i][4] > 0) ? FALSE : TRUE);
				info->next_exe_time = 0.0;
			}
		}
		if (EXPL_PTC[i][5]!=0) {
			nod = expl_nod[i][0];
			if (nod == info->nod) {
				//nod = expl_nod[i][0];
				ptc_hit(nod, i, EXPL_TIME[i][5], (EXPL_PTC[i][5] > 0) ? FALSE : TRUE);
				info->next_exe_time = 0.0;
			}
		}
	}
}

void transfer_hp_to_child(s_SC_OBJ_info *info, sc_nod nod_m, int i1, int i2, float new_hp, float delay) {
	int		j, k;

	for (j=0; j<FRAGMENT_COUNT; j++) {				//projdu vsechny fragmenty[1] a hledam shodu s nod_m
		if (fragment_nod[j][1] == nod_m) {			//pokud takova je,

			for (k=0; k<SETDSTR_COUNT; k++) {		//tak projdu vsechny destrukce a pokud najdu shodu s fragment[0],
				//if ((i1 != k) && (destr_nod[k][i2] == fragment_nod[j][0])) {
				if ((i1 != k) && (destr_nod[k][0] == fragment_nod[j][0])) {
					SUM_HP[k]+= new_hp;	//tak pridam HP
					SC_Log(3, "transfer_hp_to_child() %s-->%s (%f)", FRAGMENT_NAME[j][1], FRAGMENT_NAME[j][0], new_hp);
					do_destruction(info, k, new_hp, delay);
				}
			}

		}
	}
}

void do_transform(s_SC_OBJ_info *info, sc_nod nod_m, float delay) {
	int					i, j, k;
	sc_nod				nod;
	s_SC_MarokObjState	state, state_m;

	if (nod_m == NULL) return;

	for (i=0; i<FRAGMENT_COUNT; i++) {
		
		nod = fragment_nod[i][1];
		if (nod == nod_m) {

			for (j=0; j<SETDSTR_COUNT; j++) { // prohledam jestli fragment_nod[i][0] neni master objekt
				for (k=0; k<DESTR_COUNT; k++) {
					if ((fragment_nod[i][0] == destr_nod[j][k]) && (DESTR_HP[j][k] <= 0.0)) break;
				}
				if (k < DESTR_COUNT) break;
			}

			if (j >= SETDSTR_COUNT) { // pokud neni, tak provedu transformaci
				nod = fragment_nod[i][0];

				if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(nod))) {


					#ifdef MAX_SCRIPT_DEBUG
						sprintf(_debug_tmp, "%s : do_transform() - destr_name: %s | transformace: %s", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(nod_m), FRAGMENT_NAME[i][0]);
						SC_Log(3, _debug_tmp);
					#endif
					if (delay > 0.0) {
						MAX_DYN_add_marok_transform(delay, info->master_nod, nod, nod_m, rel_plc[i], FRAGMENT_NAME[i][0]);
					} else {
						//SC_Marok_GetState(nod_m, &state_m);
						//SC_Marok_SetRelativePlacement(&state_m.placement, &state.placement, &rel_plc[i]);
						//SC_Marok_SetState(nod, &state);
						SC_Marok_SetRelativePlacement2(nod_m, nod, &rel_plc[i]);
						SC_NOD_SetDSTR(info->master_nod, FRAGMENT_NAME[i][0], FRAGMENT_NAME[i][0]);
					}

				} //MULTI
			}
		}
	}
}

float get_hp_dp_dl(c_Vector3 *hitmarok_dL, c_Vector3 *hitmarok_dP, float min) {
	float hp;
	hp = (SC_VectorLen(hitmarok_dL) + SC_VectorLen(hitmarok_dP)) / 120.0;
	hp*= hp;
	if (hp < min) return 0.0; else return hp;
}

float get_hp_energy(float hit_energy, float min) {
	float hp;
	hp = hit_energy*hit_energy / 100000.0;
	if (hp < min) return 0.0; else return hp;
}
//-----------------------------------------
#ifdef ACTIVE_OBJ_DIST
//-----------------------------------------
void do_push_impulse_from_msg(s_SC_OBJ_info *info, sc_player pl_id) {
	c_Vector3	vec, pl_pos;
	float		len;
	int			i;
	sc_nod		tmp_nod;

	for (i=0; i<SETDSTR_COUNT; i++)	{
		tmp_nod = *((dword *)(&info->param4.x));
		if ( (tmp_nod != NULL) && (tmp_nod != master_nod[i]) ) continue;

		info->nod = master_nod[i];

		if (ONLY_HITBY & HIT_BY_USED) {
			SUM_HP[i] += ACTIVE_OBJ_DAMAGE[i];
			do_destruction(info, i, SUM_HP[i], 0.0);
			OLD_SUM_HP[i] = SUM_HP[i];
		}

		SC_NOD_GetWorldPos(info->nod, &vec);

#ifdef ACTIVE_OBJ_FORCE
		pl_pos.x = ACTIVE_OBJ_FORCE_VEC[i][0];
		pl_pos.y = ACTIVE_OBJ_FORCE_VEC[i][1];
		pl_pos.z = ACTIVE_OBJ_FORCE_VEC[i][2];
		SC_NOD_TransformToWorldSpace(info->nod, &pl_pos, &pl_pos);

		pl_pos.x -= vec.x;
		pl_pos.y -= vec.y;
		pl_pos.z -= vec.z;

		pl_pos.x *= ACTIVE_OBJ_POWER[i];
		pl_pos.y *= ACTIVE_OBJ_POWER[i];
		pl_pos.z *= ACTIVE_OBJ_POWER[i];
#else
		SC_P_GetHeadPos(pl_id, &pl_pos);

		pl_pos.x -= vec.x;
		pl_pos.y -= vec.y;
		pl_pos.z -= vec.z;

		len = SC_VectorLen(&pl_pos);

		pl_pos.x /= len;
		pl_pos.y /= len;
		pl_pos.z /= len;

		pl_pos.x *= -ACTIVE_OBJ_POWER[i];
		pl_pos.y *= -ACTIVE_OBJ_POWER[i];
		pl_pos.z *= +ACTIVE_OBJ_POWER[i];
#endif
		vec.x += ACTIVE_OBJ_ROT[i][0];
		vec.y += ACTIVE_OBJ_ROT[i][1];
		vec.z += ACTIVE_OBJ_ROT[i][2];

		if ((tmp_nod != NULL) || ((tmp_nod == NULL) && (MAX_SUP_is_active_destruction(info->nod) == 1)))
			SC_Marok_Impuls(info->nod, &pl_pos, &vec);

		//break;
	}
}
//-----------------------------------------
void do_push_impulse(s_SC_OBJ_info *info) {
	c_Vector3	vec, pl_pos;
	float		len;
	int			i;

	for (i=0; i<SETDSTR_COUNT; i++)	{
		if (info->nod != master_nod[i]) continue;

		if (ONLY_HITBY & HIT_BY_USED) {
			SUM_HP[i] += ACTIVE_OBJ_DAMAGE[i];
			do_destruction(info, i, SUM_HP[i], 0.0);
			OLD_SUM_HP[i] = SUM_HP[i];
		}

		SC_NOD_GetWorldPos(info->nod, &vec);

#ifdef ACTIVE_OBJ_FORCE
		pl_pos.x = ACTIVE_OBJ_FORCE_VEC[i][0];
		pl_pos.y = ACTIVE_OBJ_FORCE_VEC[i][1];
		pl_pos.z = ACTIVE_OBJ_FORCE_VEC[i][2];
		SC_NOD_TransformToWorldSpace(info->nod, &pl_pos, &pl_pos);

		pl_pos.x -= vec.x;
		pl_pos.y -= vec.y;
		pl_pos.z -= vec.z;

		pl_pos.x *= ACTIVE_OBJ_POWER[i];
		pl_pos.y *= ACTIVE_OBJ_POWER[i];
		pl_pos.z *= ACTIVE_OBJ_POWER[i];
#else
		SC_P_GetHeadPos(info->param1, &pl_pos);

		pl_pos.x -= vec.x;
		pl_pos.y -= vec.y;
		pl_pos.z -= vec.z;

		len = SC_VectorLen(&pl_pos);

		pl_pos.x /= len;
		pl_pos.y /= len;
		pl_pos.z /= len;

		pl_pos.x *= -ACTIVE_OBJ_POWER[i];
		pl_pos.y *= -ACTIVE_OBJ_POWER[i];
		pl_pos.z *= +ACTIVE_OBJ_POWER[i];
#endif
		vec.x += ACTIVE_OBJ_ROT[i][0];
		vec.y += ACTIVE_OBJ_ROT[i][1];
		vec.z += ACTIVE_OBJ_ROT[i][2];

		if (MAX_SUP_is_active_destruction(info->nod) == 1)
			SC_Marok_Impuls(info->nod, &pl_pos, &vec);

		break;
	}
}
//-----------------------------------------
#endif
//-----------------------------------------
void do_impulse(sc_nod nod_m, float delay) {
	int					i;
	sc_nod				nod;
	c_Vector3			impulse_vector, world_point_of_application;

	for (i=0; i<FRAGMENT_COUNT; i++) {
		nod = fragment_nod[i][1];
		if ((nod == nod_m) || ((nod == NULL) && (nod_m == fragment_nod[i][0]))) {
			if (nod == NULL)
				nod = nod_m;
			else
				nod = fragment_nod[i][0];

			if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(nod))) {

				if ((FRAGMENT_IMPULSE[i][0] == 0.0) && (FRAGMENT_IMPULSE[i][1] == 0.0) && (FRAGMENT_IMPULSE[i][2] == 0.0)) continue;

				if ((delay <= 0.0) && (MAX_SUP_is_active_destruction(nod) <= 0)) continue;
				/*else if ((delay > 0.0) && (MAX_SUP_is_active_destruction(nod) <= 0)) { // pokud by to delalo bordel, tak se to tady musi dopsat !!!!!!!!!!

				}*/

				if (FRAGMENT_IMPULSE[i][3] >= 0.0) {
					impulse_id[i] = MAX_DYN_add_constatnt_force(delay, nod, FRAGMENT_IMPULSE[i], FRAGMENT_IMPULSE_R[i], FRAGMENT_IMPULSE_P[i], FRAGMENT_IMPULSE[i][3], 1.0);
					SC_Log(2, "do_impulse - cont[%s]!!!!!!!!!!!!!!", SC_NOD_GetName(nod_m));
					continue;
				}

#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_uni_destr.cxx : ??? : do_impulse() - destr_name: %s | impulse: %s (%f %f %f)",
					SC_NOD_GetName(nod_m), FRAGMENT_NAME[i][0], FRAGMENT_IMPULSE[i][0], FRAGMENT_IMPULSE[i][1], FRAGMENT_IMPULSE[i][2]);
				SC_Log(3, _debug_tmp);
#endif

				if (delay > 0.0) {
					MAX_DYN_add_marok_impulse(delay, nod, FRAGMENT_IMPULSE[i], FRAGMENT_IMPULSE_R[i], FRAGMENT_IMPULSE_P[i]);
				} else {
					c_Vector3	zero_vec;

					//SC_NOD_GetWorldPos(nod, &world_point_of_application); // tady bacha, nevim co to udela !!!!!!!!
					impulse_vector.x = (FRAGMENT_IMPULSE_P[i][0]);
					impulse_vector.y = (FRAGMENT_IMPULSE_P[i][1]);
					impulse_vector.z = (FRAGMENT_IMPULSE_P[i][2]);
					SC_NOD_TransformToWorldSpace(nod, &impulse_vector, &world_point_of_application);

					impulse_vector.x = FRAGMENT_IMPULSE[i][0] + frnd(FRAGMENT_IMPULSE_R[i][0]);
					impulse_vector.y = FRAGMENT_IMPULSE[i][1] + frnd(FRAGMENT_IMPULSE_R[i][1]);
					impulse_vector.z = FRAGMENT_IMPULSE[i][2] + frnd(FRAGMENT_IMPULSE_R[i][2]);

					CLEAR(zero_vec);
					SC_NOD_TransformToWorldSpace(nod, &zero_vec, &zero_vec);
					SC_NOD_TransformToWorldSpace(nod, &impulse_vector, &impulse_vector);

					impulse_vector.x -= zero_vec.x;
					impulse_vector.y -= zero_vec.y;
					impulse_vector.z -= zero_vec.z;

					SC_Marok_Impuls(nod, &impulse_vector, &world_point_of_application);
				}

			} //MULTI
		}
	}
}

#ifdef JOINTS_OBJ_COUNT
void do_destruction_ik(s_SC_OBJ_info *info, int i, float new_hp, float delay) {
	int					j, k;

	for (j=0; j<JOINTS_DEL_COUNT; j++) {
		if (joint_del_nod[i][j] == NULL) continue;
		if ((!joint_removed[i][j]) && (new_hp >= JOINT_DEL_HP[i][j])) {
			joint_removed[i][j] = TRUE;
			SC_Marok_IkJoint_Remove(joint_del_nod[i][j]);
		}
	}
}
#endif

void do_destruction(s_SC_OBJ_info *info, int i, float new_hp, float delay) {
	int					j, k;
	float				len;
	sc_nod				nod, nod_m;
	c_Vector3			vec, vec1, vec2, impulse_vector, world_point_of_application;
	BOOL				without_particles = FALSE;

	if (delay < 0.0) {
		delay = 0.0;
		without_particles = TRUE;
	}

	if (destr_phase[i] < DESTR_COUNT-1) {
		for (j=destr_phase[i]; j<DESTR_COUNT-1; j++) {
			if ((new_hp >= DESTR_HP[i][destr_phase[i]+1]) && (DESTR_HP[i][destr_phase[i]+1] > 0.0)) {
#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : do_destruction() - destr_name: %s | prepnuti faze na: %s (%d)", SC_NOD_GetName(info->master_nod), DESTR_NAME[i][destr_phase[i]], DESTR_NAME[i][destr_phase[i]+1], destr_phase[i]+1);
				SC_Log(3, _debug_tmp);
#endif
				for (k=0; k<EXPL_COUNT; k++) {
					if (( ((expl_nod[k][1]) && (EXPL_PTC[k][4] != -1)) ? expl_nod[k][1]:expl_nod[k][0]) == destr_nod[i][j]) {
						if (destr_nod[i][j] != destr_nod[i][j+1]) {
							//is_exploded[k] = 123456.0;
						//if ((((EXPL_NAME[k][1][0] != '\0') ? expl_nod[k][1]:expl_nod[k][0]) == destr_nod[i][j]) && (destr_nod[i][j] != destr_nod[i][j+1]) && (particle_id[k] >= 0)) {
							if (particle_id[k] >= 0) {
								MAX_PTC_remove_from_list(particle_id[k]);
								particle_id[k] = -1;
							}
						}
						//if ((ground_timer[k] > 0.0) && (((EXPL_PTC[k][4] >= 0 && EXPL_NAME[k][1][0] != '\0') ? expl_nod[k][1]:expl_nod[k][0]) == destr_nod[i][j])) {
						if (ground_timer[k] > 0.0) {
							do_ground_fire(expl_nod[k][0], k);
							is_on_ground[k] = 2;
							ground_timer[k] = 0.0;
						}
					}
				}

				for (k=0; k<FRAGMENT_COUNT; k++) {
					if ((FRAGMENT_IMPULSE[k][3] >= 0.0) && (impulse_id[k] >= 0)) {
						MAX_DYN_remove_from_list(impulse_id[k]);
						impulse_id[k] = -1;
					}
				}

#ifdef STATIC
				if ( ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(destr_nod[i][destr_phase[i]]))) && (destr_phase[i] == 0)) //muze se stat ze objekt a jeho destrukce se ==
					SC_Marok_MakeDynamic(destr_nod[i][destr_phase[i]]);
#endif

				destr_phase[i]++;

				do_transform(info, destr_nod[i][destr_phase[i]], DESTR_DELAY[i][destr_phase[i]] + delay);

				if (SC_StringSame(DESTR_NAME[i][destr_phase[i]], "")) {
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i]))) {
						if (DESTR_DELAY[i][destr_phase[i]] + delay > 0.0)
							MAX_DYN_add_set_dstr(DESTR_DELAY[i][destr_phase[i]] + delay, info->master_nod, MASTER_NAME[i], "");
						else
							SC_NOD_SetDSTR2(info->master_nod, MASTER_NAME[i], NULL, MAX_SUP_get_handle_from_pl_id(act_author_pl_id), info->hit_by_weap_type);
					} //MULTI
				} else {
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i]))) {
						if (DESTR_DELAY[i][destr_phase[i]] + delay > 0.0)
							MAX_DYN_add_set_dstr(DESTR_DELAY[i][destr_phase[i]] + delay, info->master_nod, MASTER_NAME[i], DESTR_NAME[i][destr_phase[i]]);
						else
							SC_NOD_SetDSTR2(info->master_nod, MASTER_NAME[i], DESTR_NAME[i][destr_phase[i]], MAX_SUP_get_handle_from_pl_id(act_author_pl_id), info->hit_by_weap_type);
					}

					do_impulse(destr_nod[i][destr_phase[i]], DESTR_DELAY[i][destr_phase[i]] + delay);
					transfer_hp_to_child(info, destr_nod[i][destr_phase[i]], i, destr_phase[i]-1, new_hp, delay);
					destr_nod_valid[i] = destr_nod[i][destr_phase[i]];
				}
				if (destr_nod[i][destr_phase[i]] != destr_nod[i][destr_phase[i]-1]) {
					#ifdef MAX_EXTERN_SCRIPT_H
						s_SC_OBJ_info tmp_info;
						tmp_info = *info;
						tmp_info.message = SC_OBJ_MSG_MESSAGE;
						tmp_info.param1 = MSG_OBJECT_EXPLODED;
						tmp_info.param2 = info->master_nod;
						tmp_info.param3 = destr_nod[i][destr_phase[i]];
						CLEAR(tmp_info.param4);

						MAX_SCR_run_scripts(&tmp_info, &MAX_UNI_object_status);
					#endif
					SC_LevelScriptMsg(MSG_OBJECT_EXPLODED, info->master_nod, info->nod, NULL); // kua bylo to zaremovany?!! ale proc ??!!
					//MAX_SUP_send_message_to_object(info->master_nod, MSG_OBJECT_EXPLODED, info->nod);
					MAX_UNI_object_status.state = STATE_DESTROYED;
					if (act_author_pl_id)
						MAX_UNI_object_status.pl_handle = MAX_SUP_get_handle_from_pl_id(act_author_pl_id);
				}
				if (without_particles == FALSE) do_explosion(destr_nod[i][destr_phase[i]], DESTR_DELAY[i][destr_phase[i]] + delay); // kdyz je delay <0.0, tak se to neprovede (SC_OBJ_MSG_DSTR_NETCLIENT)
				#ifdef	HIDE_COUNT
					do_hide(destr_nod[i][destr_phase[i]], DESTR_DELAY[i][destr_phase[i]] + delay);
				#endif
			}
		}
	}

	info->next_exe_time = 0.0; //next frame
}

float is_mooving_on_ground(sc_nod nod) {
	float				movement;
	s_SC_MarokObjState	state;

	if (MAX_SUP_is_active_destruction(nod) != 1) return 0.0;

	CLEAR(state);

	SC_Marok_GetState(nod, &state);
	state.linear_velocity.x	/= 100.0;
	state.linear_velocity.y	/= 100.0;
	state.linear_velocity.z *= state.linear_velocity.z / 2.0;
	movement = SC_VectorLen(&state.linear_velocity);
	movement*= movement;

	return movement;
}
//------------------------------------------------------------------
int		g_i, g_j, g_k;
float	g_movement;
//------------------------------------------------------------------
void check_ground(s_SC_OBJ_info *info) {
	sc_nod	nod;
	int	i;
	for (i=0; i<EXPL_COUNT; i++) {
		//if ((EXPL_PTC[i][2]) && (!(EXPL_PTC[i][1]) || ((EXPL_PTC[i][1]) && (is_exploded[i])))) {
		if ((is_exploded[i] <= 0.0) && ((EXPL_PTC[i][2]!=0 && !EXPL_PTC[i][1]!=0) || (EXPL_PTC[i][1]!=0))) {
			if ((expl_nod[i][1]) && (EXPL_PTC[i][4] != -1)) nod = expl_nod[i][1]; else nod = expl_nod[i][0];
			if (nod == info->nod) {
				g_movement = is_mooving_on_ground(nod);
				if ((!is_on_ground[i]) && (g_movement > 0.0)) {
					if (info->next_exe_time < 0.0) info->next_exe_time = 0.0;
					if (ground_timer[i] <= 0.0) {
						ground_timer[i] = GROUND_TIME;
						ground_hits[i]  = 1;
						SUM_MOVEMENT[i] = g_movement;
						//SC_Log(2, "Prvni dopad: %s g_movement: %f", SC_NOD_GetName(expl_nod[i][0]), g_movement);
					} else {
						ground_hits[i]++;
						SUM_MOVEMENT[i] += g_movement;
						//SC_Log(2, "Dalsi dopad: %s SUM_MOV: %f gr_hits: %d", SC_NOD_GetName(expl_nod[i][0]), SUM_MOVEMENT[i], ground_hits[i]);
					}
				} else if ((!is_on_ground[i]) && (g_movement == 0.0)) {
					do_ground_fire(expl_nod[i][0], i);
					is_on_ground[i] = 2;
					//SC_Log(2, "Posledni dopad: %s g_movement: %f", SC_NOD_GetName(expl_nod[i][0]), g_movement);
				}
			}
		}
	}
}
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
#ifdef MAX_VEC_UHLU
c_Vector3	validate_pl_pos, validate_old_pl_pos; // v initu dat CLEAR(validate_old_pl_vec); !!!!!!!!!!!!!!!!!!!!!!!!!!
c_Vector3	validate_nod_pos[SETDSTR_COUNT];

c_Vector3	validate_pl_vec[SETDSTR_COUNT];
c_Vector3	validate_trans_vec[SETDSTR_COUNT][MAX_VEC_UHLU];

BOOL		validate_result[SETDSTR_COUNT];

float		validate_cos_fi[SETDSTR_COUNT][MAX_VEC_UHLU];
BOOL		validate_is_in_area[MAX_VEC_UHLU];

BOOL		validate_nod_moveing[SETDSTR_COUNT];
BOOL		validate_nod_moved[SETDSTR_COUNT];
BOOL		validate_pl_moveing;

BOOL validate(sc_nod nod, int i) {
//--------------------------------------------------------------------------------------
	SC_P_GetHeadPos(SC_PC_Get(), &validate_pl_pos);
	if ((validate_pl_pos.x != validate_old_pl_pos.x) ||
		(validate_pl_pos.y != validate_old_pl_pos.y) ||
		(validate_pl_pos.z != validate_old_pl_pos.z)) {
			validate_pl_moveing = TRUE;
			validate_old_pl_pos = validate_pl_pos;
		}
	else
		validate_pl_moveing = FALSE;
//--------------------------------------------------------------------------------------
	if ((validate_nod_moved[i]) || (validate_nod_moveing[i])) //pravdepodobne to nedojde na druhou podminku
		SC_NOD_GetWorldPos(nod, &validate_nod_pos[i]);
//--------------------------------------------------------------------------------------
	if ((!validate_pl_moveing) && (!validate_nod_moved[i]) && (!validate_nod_moveing[i])) return validate_result[i];	// pokud se hrac ani objekt nepohnuli,
																													// tak se pouzije stary vysledek
//--------------------------------------------------------------------------------------
	validate_pl_vec[i].x = validate_pl_pos.x - validate_nod_pos[i].x;
	validate_pl_vec[i].y = validate_pl_pos.y - validate_nod_pos[i].y;
	validate_pl_vec[i].z = validate_pl_pos.z - validate_nod_pos[i].z;
//--------------------------------------------------------------------------------------
	for (g_j=0; g_j<MAX_VEC_UHLU; g_j++) {
	//----------------------------------------------------------------------------------
		if ((validate_nod_moved[i]) || (validate_nod_moveing[i])) {

			if ( (VEC_UHLY[i][g_j][0] == 0.0) && (VEC_UHLY[i][g_j][1] == 0.0) && (VEC_UHLY[i][g_j][2] == 0.0) ) {
				if (g_j > 0) validate_is_in_area[g_j] = validate_is_in_area[g_j-1]; else validate_is_in_area[g_j] = FALSE;
				continue;
			}
			validate_trans_vec[i][g_j].x = VEC_UHLY[i][g_j][0];
			validate_trans_vec[i][g_j].y = VEC_UHLY[i][g_j][1];
			validate_trans_vec[i][g_j].z = VEC_UHLY[i][g_j][2];

			SC_NOD_TransformToWorldSpace(nod, &validate_trans_vec[i][g_j], &validate_trans_vec[i][g_j]);

			validate_trans_vec[i][g_j].x -= validate_nod_pos[i].x;
			validate_trans_vec[i][g_j].y -= validate_nod_pos[i].y;
			validate_trans_vec[i][g_j].z -= validate_nod_pos[i].z;
		}
	//----------------------------------------------------------------------------------
		validate_cos_fi[i][g_j] = validate_trans_vec[i][g_j].x*validate_pl_vec[i].x + validate_trans_vec[i][g_j].y*validate_pl_vec[i].y + validate_trans_vec[i][g_j].z*validate_pl_vec[i].z;
		validate_cos_fi[i][g_j]/= SC_VectorLen(&validate_trans_vec[i][g_j])*SC_VectorLen(&validate_pl_vec[i]);
	//----------------------------------------------------------------------------------
		if (validate_cos_fi[i][g_j] >= VEC_UHLY[i][g_j][3])
			validate_is_in_area[g_j] = TRUE;
		else
			validate_is_in_area[g_j] = FALSE;
	//----------------------------------------------------------------------------------
	}
	if ((validate_nod_moved[i]) && (!validate_nod_moveing[i])) validate_nod_moved[i] = FALSE; //pokud se zastavila simulace, tak se uz nehybe
//--------------------------------------------------------------------------------------
	validate_result[i] = validate_is_in_area[0];
//--------------------------------------------------------------------------------------
	for (g_j=1; g_j<MAX_VEC_UHLU; g_j++) {
		switch(VEC_UHLY_OPER[i][g_j]) {
		//--------------------------------------------------------------------------------------
		case OPERATION_NONE:
			//SC_message("Nastavena operece OPERATION_NONE - muze byt pouze u prvniho kuzele!");
			break;
		//--------------------------------------------------------------------------------------
		case OPERATION_PLUS:
			if (validate_is_in_area[g_j]) validate_result[i] = TRUE;
			break;
		//--------------------------------------------------------------------------------------
		case OPERATION_MUL:
			if ((validate_result[i] == TRUE) && (validate_is_in_area[g_j] == TRUE))
				validate_result[i] = TRUE;
			else
				validate_result[i] = FALSE;

			break;
		//--------------------------------------------------------------------------------------
		case OPERATION_MINUS:
			if (validate_is_in_area[g_j]) validate_result[i] = FALSE;
			break;
		//--------------------------------------------------------------------------------------
		} // switch(VEC_UHLY_OPER[i][g_j])
	}
//--------------------------------------------------------------------------------------
	return validate_result[i];
}
#endif
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
void init_phys_load(s_SC_OBJ_info *info) {
	int			i, j;
	dword		tmp_flags = 0;

#ifdef JOINTS_OBJ_COUNT

	for (i=0; i<JOINTS_OBJ_COUNT; i++) {	// provede se zjisteni relative placementu k objektum (destrukcim)
		for (j=0; j<JOINTS_DEL_COUNT; j++) {
			if (SC_StringSame(JOINT_DEL_NAME[i][j], "")) {
				joint_del_nod[i][j] = NULL;
				continue;
			}
			joint_del_nod[i][j] = SC_NOD_Get(info->master_nod, JOINT_DEL_NAME[i][j]);
		}
		joint_obj_nod[i] = SC_NOD_Get(info->master_nod, JOINT_OBJ_NAME[i]);
	}
#endif

	for (i=0; i<SETDSTR_COUNT; i++) { // musim znovu zjistit co je destr_nod_valid a pak az to zinicializovat !!!
		for (j=0; j<DESTR_COUNT; j++) {
			if (destr_nod[i][j] == destr_nod_valid[i]) {
				destr_nod_valid[i] = SC_NOD_Get(info->master_nod, DESTR_NAME[i][j]);
				break;
			}
		}
	}

	for (i=0; i<SETDSTR_COUNT; i++) {
		master_nod[i] = SC_NOD_Get(info->master_nod, MASTER_NAME[i]);

		for (j=0; j<DESTR_COUNT; j++) {
			if (!SC_StringSame(DESTR_NAME[i][j], ""))
				destr_nod[i][j] = SC_NOD_Get(info->master_nod, DESTR_NAME[i][j]);
			else
				destr_nod[i][j] = NULL;
		}
	}

	for (i=0; i<FRAGMENT_COUNT; i++) {
		fragment_nod[i][0] = SC_NOD_Get(info->master_nod, FRAGMENT_NAME[i][0]);
		if (!SC_StringSame(FRAGMENT_NAME[i][1], "")) {
			fragment_nod[i][1] = SC_NOD_Get(info->master_nod, FRAGMENT_NAME[i][1]);
		} else {
			fragment_nod[i][1] = NULL;
		}
	}

	check_ptc_in_marok_simulation = FALSE;

	for (i=0; i<EXPL_COUNT; i++) {

		if (   ((EXPL_PTC[i][1] != 0) && (EXPL_TIME[i][1] <= 0.0))
			|| ((EXPL_PTC[i][2] != 0) && (EXPL_TIME[i][1] <= 0.0))
			|| ((EXPL_PTC[i][4] != 0) && (EXPL_PTC[i][4] != -1))
			||  (EXPL_PTC[i][5] != 0)   ) {
				tmp_flags = SC_OBJ_HIT_BY_MAROK | SC_OBJSCRIPT_FL_MAROKSIMULATION;
				check_ptc_in_marok_simulation = TRUE;
			}

		expl_nod[i][0] = SC_NOD_Get(info->master_nod, EXPL_NAME[i][0]);

		if (!SC_StringSame(EXPL_NAME[i][1], ""))
			expl_nod[i][1] = SC_NOD_Get(info->master_nod, EXPL_NAME[i][1]);
		else
			expl_nod[i][1] = NULL;
	}

#ifdef HIDE_COUNT
	for(i=0; i<HIDE_COUNT; i++) {
		hide_nod[i][0] = SC_NOD_Get(info->master_nod, HIDE_NAME[i][0]);
		hide_nod[i][1] = SC_NOD_Get(info->master_nod, HIDE_NAME[i][1]);
	}

	for (i=0; i<SETDSTR_COUNT; i++) {
		for (j=0; j<=destr_phase[i]; j++) {
			do_hide(destr_nod[i][j], 0.0);
		}
	}
#endif

#ifdef MAX_VEC_UHLU
	tmp_flags |= SC_OBJSCRIPT_FL_MAROKSIMULATION;
#endif

	if (ONLY_HITBY & HIT_BY_MWP) tmp_flags |= SC_OBJSCRIPT_FL_HITMISSILE;

	if (ONLY_HITBY & HIT_BY_C4) tmp_flags |= SC_OBJSCRIPT_FL_MAROKSIMULATION;

	if (ONLY_HITBY != HIT_BY_DISABLED) {
		SC_ObjScript_SetFlags(info->master_nod, SC_ObjScript_GetFlags(info->master_nod) | (ONLY_HITBY & 0xFF) | tmp_flags); // jenom spodni byte (horni jsou moje flagy)
	}
}
//--------------------------------------------------------------------------------------------------------------
void init_phys(s_SC_OBJ_info *info) {
	int			i, j, k;
	dword		tmp_flags = 0;
	s_SC_MarokObjState		state1, state2;

#ifdef FREEZE
#ifdef STATIC
	char	tmp[64];
	sprintf(tmp, "%s : je definovan FREEZE i STATIC !!!", SC_NOD_GetName(info->master_nod));
	SC_message(tmp);
#endif
#endif

#ifdef JOINTS_OBJ_COUNT
	for (i=0; i<JOINTS_OBJ_COUNT; i++)
		for (j=0; j<JOINTS_DEL_COUNT; j++)
			joint_removed[i][j] = FALSE;

	for (i=0; i<JOINTS_OBJ_COUNT; i++) {
		for (j=0; j<JOINTS_DEL_COUNT; j++) {
			if (SC_StringSame(JOINT_DEL_NAME[i][j], "")) {
				joint_del_nod[i][j] = NULL;
				continue;
			}
			joint_del_nod[i][j] = SC_NOD_Get(info->master_nod, JOINT_DEL_NAME[i][j]);
		}
		joint_obj_nod[i] = SC_NOD_Get(info->master_nod, JOINT_OBJ_NAME[i]);
#ifdef FREEZE
		//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(joint_obj_nod[i])))
			SC_Marok_FallAsleep(joint_obj_nod[i]);
#endif
#ifdef STATIC
		//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(joint_obj_nod[i])))
			SC_Marok_MakeStatic(joint_obj_nod[i]);
#endif
	}

#endif

	for (i=0; i<SETDSTR_COUNT; i++) {
		master_nod[i] = SC_NOD_Get(info->master_nod, MASTER_NAME[i]);
#ifdef FREEZE
		//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_Marok_FallAsleep(master_nod[i]);
#endif
#ifdef STATIC
		//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_Marok_MakeStatic(master_nod[i]);
#endif
		destr_nod_valid[i] = master_nod[i];
		for (j=0; j<DESTR_COUNT; j++) {
			if (!SC_StringSame(DESTR_NAME[i][j], ""))
				destr_nod[i][j] = SC_NOD_Get(info->master_nod, DESTR_NAME[i][j]);
			else
				destr_nod[i][j] = NULL;
		}
		SUM_HP[i]		= 0.0;
		OLD_SUM_HP[i]	= 0.0;
		destr_phase[i]	= 0;
		//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_NOD_SetDSTR(info->master_nod, MASTER_NAME[i], DESTR_NAME[i][0]);
	}

	for (i=0; i<FRAGMENT_COUNT; i++) {
		fragment_nod[i][0] = SC_NOD_Get(info->master_nod, FRAGMENT_NAME[i][0]);;
		if (!SC_StringSame(FRAGMENT_NAME[i][1], "")) {
#ifdef FREEZE
			//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0])))
				SC_Marok_FallAsleep(fragment_nod[i][0]);
#endif
#ifdef STATIC
			//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0])))
				SC_Marok_MakeStatic(fragment_nod[i][0]);
#endif
			fragment_nod[i][1] = SC_NOD_Get(info->master_nod, FRAGMENT_NAME[i][1]);
			
		} else {
			fragment_nod[i][1] = NULL;
		}
	}

	for (i=0; i<SETDSTR_COUNT; i++) {	// provede se zjisteni relative placementu k objektum (destrukcim)
		for (j=0; j<DESTR_COUNT; j++) {
			if ((DESTR_NAME[i][j][0] == 0) || (SC_StringSame(DESTR_NAME[i][j], ""))) continue;
			for (k=0; k<FRAGMENT_COUNT; k++) {
				if ((FRAGMENT_NAME[k][1][0] == 0) || (SC_StringSame(FRAGMENT_NAME[k][1], ""))) continue;
				if ((IS_MP_CLIENT) && (SC_Marok_IsMpSynchro(SC_NOD_Get(info->master_nod, FRAGMENT_NAME[k][0])))) continue;
				//if (SC_Marok_IsMpSynchro(SC_NOD_Get(info->master_nod, FRAGMENT_NAME[k][0]))) continue;
				if (SC_StringSame(FRAGMENT_NAME[k][1], DESTR_NAME[i][j])) {
					SC_Marok_GetRelativePlacement2(destr_nod[i][j], fragment_nod[k][0], &rel_plc[k]);
				} // if (fragment_nod ...
			} // for k
		} //for j
		//SC_NOD_SetDSTR(info->master_nod, MASTER_NAME[i], MASTER_NAME[i]);
	} //for i

	for (i=0; i<FRAGMENT_COUNT; i++) {
		if (fragment_nod[i][1] == NULL) continue;
		for (j=0; j<SETDSTR_COUNT; j++) {
			for (k=0; k<DESTR_COUNT; k++) {
				if ((fragment_nod[i][0] == destr_nod[j][k]) && (DESTR_HP[j][k] <= 0.0)) break;
			}
			if (k < DESTR_COUNT) break;
		}
		if (j >= SETDSTR_COUNT) {
			//if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0]))) {
				SC_NOD_SetDSTR(info->master_nod, FRAGMENT_NAME[i][0], NULL);
#ifdef MAX_SCRIPT_DEBUG
				SC_Log(3, "!max_uni_destr : %s : Mrazim: %s", SC_NOD_GetName(info->master_nod), FRAGMENT_NAME[i][0]);
#endif
//			} else {
//#ifdef MAX_SCRIPT_DEBUG
//				SC_Log(3, "!max_uni_destr : %s : NE-mrazim: %s", SC_NOD_GetName(info->master_nod), FRAGMENT_NAME[i][0]);
//#endif
//			}
		}
	}

	check_ptc_in_marok_simulation = FALSE;

	for (i=0; i<EXPL_COUNT; i++) {
		if (   ((EXPL_PTC[i][1] != 0) && (EXPL_TIME[i][1] <= 0.0))
			|| ((EXPL_PTC[i][2] != 0) && (EXPL_TIME[i][1] <= 0.0))
			|| ((EXPL_PTC[i][4] != 0) && (EXPL_PTC[i][4] != -1))
			||  (EXPL_PTC[i][5] != 0)   ) {
				tmp_flags = SC_OBJ_HIT_BY_MAROK | SC_OBJSCRIPT_FL_MAROKSIMULATION;
				check_ptc_in_marok_simulation = TRUE;
			}

		expl_nod[i][0] = SC_NOD_Get(info->master_nod, EXPL_NAME[i][0]);
		if (!SC_StringSame(EXPL_NAME[i][1], ""))
			expl_nod[i][1] = SC_NOD_Get(info->master_nod, EXPL_NAME[i][1]);
		else
			expl_nod[i][1] = NULL;

		ground_timer[i] = 0.0;
		SUM_MOVEMENT[i] = 0.0;
		is_on_ground[i] = 0;
		is_exploded[i]  = 123456.0;

		EXPL_SUM_HP[i]		= 0.0;
		OLD_EXPL_SUM_HP[i]	= 0.0;
	}

#ifdef HIDE_COUNT
	for(i=0; i<HIDE_COUNT; i++) {
		hide_nod[i][0] = SC_NOD_Get(info->master_nod, HIDE_NAME[i][0]);
		hide_nod[i][1] = SC_NOD_Get(info->master_nod, HIDE_NAME[i][1]);
	}
#endif

#ifdef MAX_VEC_UHLU
	tmp_flags |= SC_OBJSCRIPT_FL_MAROKSIMULATION;
#endif

	if (ONLY_HITBY & HIT_BY_MWP) tmp_flags |= SC_OBJSCRIPT_FL_HITMISSILE;

	if (ONLY_HITBY & HIT_BY_C4) tmp_flags |= SC_OBJSCRIPT_FL_MAROKSIMULATION;

	if (ONLY_HITBY != HIT_BY_DISABLED) {
		SC_ObjScript_SetFlags(info->master_nod, SC_ObjScript_GetFlags(info->master_nod) | (ONLY_HITBY & 0xFF) | tmp_flags); // jenom spodni byte (horni jsou moje flagy)
	}
}
//--------------------------------------------------------------------------------------------------------------
void reinit_phys(s_SC_OBJ_info *info) {
	int			i, j, k;

#ifdef FREEZE
#ifdef STATIC
	char	tmp[64];
	sprintf(tmp, "%s : je definovan FREEZE i STATIC !!!", SC_NOD_GetName(info->master_nod));
	SC_message(tmp);
#endif
#endif


	for (i=0; i<FRAGMENT_COUNT; i++)
		if (impulse_id[i] >= 0) {
			MAX_DYN_remove_from_list(impulse_id[i]);
			impulse_id[i] = -1;
		}

	for (i=0; i<EXPL_COUNT; i++)
		if (particle_id[i] >= 0) {
			MAX_PTC_remove_from_list(particle_id[i]);
			particle_id[i] = -1;
		}

#ifdef HIDE_COUNT
	for(i=0; i<HIDE_COUNT; i++)
		MAX_SUP_show_nod(hide_nod[i][0]);
#endif

#ifdef JOINTS_OBJ_COUNT
	for (i=0; i<JOINTS_OBJ_COUNT; i++)
		for (j=0; j<JOINTS_DEL_COUNT; j++)
			joint_removed[i][j] = FALSE;

	for (i=0; i<JOINTS_OBJ_COUNT; i++) {
#ifdef FREEZE
		if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(joint_obj_nod[i])))
			SC_Marok_FallAsleep(joint_obj_nod[i]);
#endif
#ifdef STATIC
		if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(joint_obj_nod[i])))
			SC_Marok_MakeStatic(joint_obj_nod[i]);
#endif
	}

#endif

	for (i=0; i<SETDSTR_COUNT; i++) {
#ifdef FREEZE
		if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_Marok_FallAsleep(master_nod[i]);
#endif
#ifdef STATIC
		if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_Marok_MakeStatic(master_nod[i]);
#endif
		destr_nod_valid[i] = master_nod[i];
		SUM_HP[i]		= 0.0;
		OLD_SUM_HP[i]	= 0.0;
		destr_phase[i]	= 0;
		if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(master_nod[i])))
			SC_NOD_SetDSTR(info->master_nod, MASTER_NAME[i], DESTR_NAME[i][0]);
	}

	for (i=0; i<FRAGMENT_COUNT; i++) {
		if (!SC_StringSame(FRAGMENT_NAME[i][1], "")) {
#ifdef FREEZE
			if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0])))
				SC_Marok_FallAsleep(fragment_nod[i][0]);
#endif
#ifdef STATIC
			if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0])))
				SC_Marok_MakeStatic(fragment_nod[i][0]);
#endif
		}
	}

	for (i=0; i<FRAGMENT_COUNT; i++) {
		if (fragment_nod[i][1] == NULL) continue;
		for (j=0; j<SETDSTR_COUNT; j++) {
			for (k=0; k<DESTR_COUNT; k++) {
				if ((fragment_nod[i][0] == destr_nod[j][k]) && (DESTR_HP[j][k] <= 0.0)) break;
			}
			if (k < DESTR_COUNT) break;
		}
		if (j >= SETDSTR_COUNT) {
			if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(fragment_nod[i][0]))) {
				SC_NOD_SetDSTR(info->master_nod, FRAGMENT_NAME[i][0], NULL);
#ifdef MAX_SCRIPT_DEBUG
				SC_Log(3, "!max_uni_destr : %s : Mrazim: %s", SC_NOD_GetName(info->master_nod), FRAGMENT_NAME[i][0]);
#endif
			} else {
#ifdef MAX_SCRIPT_DEBUG
				SC_Log(3, "!max_uni_destr : %s : NE-mrazim: %s", SC_NOD_GetName(info->master_nod), FRAGMENT_NAME[i][0]);
#endif
			}
		}
	}

	for (i=0; i<EXPL_COUNT; i++) {
		ground_timer[i] = 0.0;
		SUM_MOVEMENT[i] = 0.0;
		is_on_ground[i] = 0;
		is_exploded[i]  = 123456.0;

		EXPL_SUM_HP[i]		= 0.0;
		OLD_EXPL_SUM_HP[i]	= 0.0;
	}
}
//--------------------------------------------------------------------------------------------------------------
#ifdef MAX_VEC_UHLU
void init_validate() {
	int		i, j;
	CLEAR(validate_pl_pos);
	CLEAR(validate_old_pl_pos);
	validate_old_pl_pos.z = -1.0;

	for (i=0; i<SETDSTR_COUNT; i++) {
		SC_NOD_GetWorldPos(master_nod[i], &validate_nod_pos[i]);
		validate_nod_moveing[i] = FALSE;
		validate_nod_moved[i] = FALSE;

		for (j=0; j<MAX_VEC_UHLU; j++) {
			validate_trans_vec[i][j].x = VEC_UHLY[i][j][0];
			validate_trans_vec[i][j].y = VEC_UHLY[i][j][1];
			validate_trans_vec[i][j].z = VEC_UHLY[i][j][2];

			SC_NOD_TransformToWorldSpace(master_nod[i], &validate_trans_vec[i][j], &validate_trans_vec[i][j]);

			validate_trans_vec[i][j].x -= validate_nod_pos[i].x;
			validate_trans_vec[i][j].y -= validate_nod_pos[i].y;
			validate_trans_vec[i][j].z -= validate_nod_pos[i].z;
		}
	}
}
#endif
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
int ScriptMain(s_SC_OBJ_info *info) {

	if (info->message == SC_OBJ_MSG_DOTICK) info->next_exe_time = 0.5;

#ifdef MAX_EXTERN_SCRIPT_H
	if ((info->message == SC_OBJ_MSG_INIT) || (info->message == SC_OBJ_MSG_JUSTLOADED)) 
		MAX_SRC_init_fce();

	MAX_SCR_run_scripts(info, &MAX_UNI_object_status);
#endif

	switch(info->message) {
//------------------------------------------------------------------
		case SC_OBJ_MSG_INIT:
			IS_MP_CLIENT = SC_IsMpClient();
			IS_MP_GAME   = SC_IsMpGame();
			init_phys(info);
#ifdef MAX_VEC_UHLU
			init_validate();
#endif
#ifdef ACTIVE_OBJ_DIST

			CLEAR(MAX_UNI_object_status);
			MAX_UNI_object_status.side = SC_P_SIDE_ALL;
			MAX_UNI_object_status.timer = -1.0;

			for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
				if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Create(master_nod[g_i], ACTIVE_OBJ_DIST, ACTIVE_OBJ_TEXT[g_i]);
#endif

			for (g_i=0; g_i<FRAGMENT_COUNT; g_i++)
				impulse_id[g_i] = -1;

			for (g_i=0; g_i<EXPL_COUNT; g_i++)
				particle_id[g_i] = -1;

			info->next_exe_time = 0.5;
			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_RELEASE:
#ifdef ACTIVE_OBJ_DIST
			//if (!IS_MP_GAME){
				for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
					if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Remove(master_nod[g_i]);
			//}
#endif
			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_JUSTLOADED:
			MAX_PTC_just_loaded();
			MAX_DYN_just_loaded();
			init_phys_load(info);
/*#ifdef ACTIVE_OBJ_DIST
			for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
				if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Create(master_nod[g_i], ACTIVE_OBJ_DIST, ACTIVE_OBJ_TEXT[g_i]);
#endif*/
			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_USED:
			SC_Osi("used %s[%s]", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(info->nod));
			if (IS_MP_GAME) {
				//MAX_SUP_send_message_to_mp_script(MSG_UNI_DESTR_USE_MP, info->param1, info->master_nod, info->nod); //sam sobe na server poslu at se pouziju
				if (!IS_MP_CLIENT)
					MAX_SUP_send_message_to_object(info->master_nod, MSG_UNI_DESTR_USE_MP, MAX_SUP_get_handle_from_pl_id(info->param1));
				else
					MAX_SUP_send_message_to_server_to_object(info->master_nod, MSG_UNI_DESTR_USE_MP, MAX_SUP_get_handle_from_pl_id(info->param1));

			} else {
				#ifdef CALL_BACK_USED
					MAX_SUP_send_message_to_level(MSG_OBJECT_USED, info->param1, info->master_nod, info->nod);
				#endif
				#ifdef ACTIVE_OBJ_DIST
					do_push_impulse(info);
				#endif
			}
			#ifdef IS_VEHICLE
				if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
			#endif
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_VALIDATE_USE:
			// param1 is sc_player which wants to use it
			// param2 - return value, TRUE means enable, FALSE means disable, default is TRUE ( is set when this msg is called )
			//SC_Osi("validating %s[%s]", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(info->nod));
			if (info->param2 == FALSE) break; // pokud to neco predtimhle nastavilo na false;

			SC_P_GetSideGroupMemberId(info->param1, &glob_side, NULL, NULL);
			if ((MAX_UNI_object_status.side != SC_P_SIDE_ALL) && (MAX_UNI_object_status.side != glob_side)) {
				info->param2 = FALSE;
				return FALSE;
			}

			if ((MAX_UNI_object_status.state != STATE_INIT) && (MAX_UNI_object_status.state != STATE_ACTIVE) && (MAX_UNI_object_status.state != STATE_DEFUSED)) {
				info->param2 = FALSE;
				return FALSE;
			}

#ifdef MAX_VEC_UHLU
			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				if (info->nod == master_nod[g_i]) {
					if (validate(info->nod, g_i))
						info->param2 = TRUE;
					else
						info->param2 = FALSE;
					break;
				}
			}
#endif
			//SC_Osi("%s:%f,%f,%f| u:%f | v:%f", SC_NOD_GetName(info->master_nod), vec_nod_z.x, vec_nod_z.y, vec_nod_z.z, cos_u, cos_v);
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_HIT:
			check_ground(info);

			#ifdef JOINTS_OBJ_COUNT
			HP = 0.0;
			glob_delay = 0.0;
			for (g_i=0; g_i<JOINTS_OBJ_COUNT; g_i++) {
				if (info->nod != joint_obj_nod[g_i]) continue;

				if (info->hit_by == SC_OBJ_HIT_BY_MISSILE) {
					if ((ONLY_HITBY & HIT_BY_MWP) && (info->tmissile_id != 12) && (info->tmissile_id != 13) && (info->tmissile_id != 14)) return FALSE;
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = info->tmissile_damage;
						IK_SUM_HP[g_i] += HP * DAMAGE_MULT;
						//act_author_handle = 0;
						tmp_author_pl_id  = info->hit_by_player;
					}
				}

				if (info->hit_by == SC_OBJ_HIT_BY_EXPLOSION) {
					if (((ONLY_HITBY & HIT_BY_EXPLOSION) == 0) && (((ONLY_HITBY & HIT_BY_C4) > 0) && ((EXPLOSION_C4>>28) != info->hitexpl_script_type))) return TRUE;
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = info->hitexpl_damage;
						IK_SUM_HP[g_i] += HP * DAMAGE_MULT;
						tmp_author_pl_id  = info->hitexpl_by_player;
					}
				}

				if ((info->hit_by == SC_OBJ_HIT_BY_MAROK) && (ONLY_HITBY & HIT_BY_MAROK)){
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = get_hp_energy(info->hit_energy, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);
						HP += get_hp_dp_dl(&info->hitmarok_dL, &info->hitmarok_dP, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);
						IK_SUM_HP[g_i] += HP * DAMAGE_MULT_MAROK;
						tmp_author_pl_id  = 0;
						glob_delay = 0.0;
					}
				}

				if (IK_OLD_SUM_HP[g_i] != IK_SUM_HP[g_i]) {
					do_destruction_ik(info, g_i, IK_SUM_HP[g_i], glob_delay);
					IK_OLD_SUM_HP[g_i] = IK_SUM_HP[g_i];
				}
			}
			#endif
			
			#ifdef SETDSTR_COUNT
			HP = 0.0;
			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				if (info->nod != destr_nod_valid[g_i]) continue;
				
				if (info->hit_by == SC_OBJ_HIT_BY_MISSILE) {
					if ((ONLY_HITBY & HIT_BY_MWP) && (info->tmissile_id != 12) && (info->tmissile_id != 13) && (info->tmissile_id != 14)) return FALSE;
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = info->tmissile_damage;
						#ifdef DAMAGE_MULT
							SUM_HP[g_i] += HP * DAMAGE_MULT;
						#else
							SUM_HP[g_i] += HP;
						#endif
						//act_author_handle = 0;
						tmp_author_pl_id  = info->hit_by_player;
						glob_delay = 0.0;
					}
				}

				if (info->hit_by == SC_OBJ_HIT_BY_EXPLOSION) {
					if (((ONLY_HITBY & HIT_BY_EXPLOSION) == 0) && (((ONLY_HITBY & HIT_BY_C4) > 0) && ((EXPLOSION_C4>>28) != info->hitexpl_script_type))) return TRUE;
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = info->hitexpl_damage;
						#ifdef DAMAGE_MULT_EXPLOSION
							SUM_HP[g_i] += HP * DAMAGE_MULT_EXPLOSION;
						#else
							SUM_HP[g_i] += HP;
						#endif
						//act_author_handle = info->hitexpl_by_player;
						tmp_author_pl_id  = info->hitexpl_by_player;
#ifndef FORCE_NO_DELAY
						if (info->hitexpl_script_type)
							if (destr_phase[g_i]+1 < DESTR_COUNT) 
								glob_delay = (DESTR_HP[g_i][destr_phase[g_i]+1] - OLD_SUM_HP[g_i]) / HP;
							else
								glob_delay = 0.0;
						else
#endif
							glob_delay = 0.0;
					}
				}

				if ((info->hit_by == SC_OBJ_HIT_BY_MAROK) && (ONLY_HITBY & HIT_BY_MAROK)){
					if ((!IS_MP_CLIENT) || (!SC_Marok_IsMpSynchro(info->nod))) {
						HP = get_hp_energy(info->hit_energy, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);
						HP += get_hp_dp_dl(&info->hitmarok_dL, &info->hitmarok_dP, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);
						//SC_Log(3, "2: %s [%s] HP :%f", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(info->nod),  HP);
						#ifdef DAMAGE_MULT_MAROK
							SUM_HP[g_i] += HP * DAMAGE_MULT_MAROK;
						#else
							SUM_HP[g_i] += HP;
						#endif
						//act_author_handle = 0;
						tmp_author_pl_id  = 0;
						glob_delay = 0.0;
					}
				}

				SC_Osi("%s [%s] HP : %f[+%f]", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(info->nod), SUM_HP[g_i], SUM_HP[g_i]-OLD_SUM_HP[g_i]);
				//SC_Log(3, "%s [%s] HP : %f[+%f]", SC_NOD_GetName(info->master_nod), SC_NOD_GetName(info->nod), SUM_HP[g_i], SUM_HP[g_i]-OLD_SUM_HP[g_i]);

				if (OLD_SUM_HP[g_i] != SUM_HP[g_i]) {
					if (glob_delay > 1.0) glob_delay = 1.0;
					act_author_pl_id = tmp_author_pl_id;
					do_destruction(info, g_i, SUM_HP[g_i], glob_delay);
					OLD_SUM_HP[g_i] = SUM_HP[g_i];
					//do_hit(info);
				}
			}
			#endif

			for (g_i=0; g_i<EXPL_COUNT; g_i++) { //jenom zjistuje zda se ma udelat PTC -> neni treba osetrovat mp_synchro
				//if (expl_nod[g_i][0] == info->nod) {
					if (info->hit_by == SC_OBJ_HIT_BY_MISSILE) {
						if ((ONLY_HITBY & HIT_BY_MWP) && (info->tmissile_id != 12) && (info->tmissile_id != 13) && (info->tmissile_id != 14)) return FALSE;
						HP = info->tmissile_damage;
						#ifdef DAMAGE_MULT
							EXPL_SUM_HP[g_i] += HP * DAMAGE_MULT;
						#else
							EXPL_SUM_HP[g_i] += HP;
						#endif
					}

					if (info->hit_by == SC_OBJ_HIT_BY_EXPLOSION) {
						if (((ONLY_HITBY & HIT_BY_EXPLOSION) == 0) && (((ONLY_HITBY & HIT_BY_C4) > 0) && ((EXPLOSION_C4>>28) != info->hitexpl_script_type))) return TRUE;
						HP = info->hitexpl_damage;
						#ifdef DAMAGE_MULT_EXPLOSION
							EXPL_SUM_HP[g_i] += HP * DAMAGE_MULT_EXPLOSION;
						#else
							EXPL_SUM_HP[g_i] += HP;
						#endif
					}

					if (info->hit_by == SC_OBJ_HIT_BY_MAROK) {
						HP = get_hp_energy(info->hit_energy, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);
						HP += get_hp_dp_dl(&info->hitmarok_dL, &info->hitmarok_dP, MIN_DAMAGE_MAROK/* / DAMAGE_MULT_MAROK*/);

						#ifdef DAMAGE_MULT_MAROK
							EXPL_SUM_HP[g_i] += HP * DAMAGE_MULT_MAROK;
						#else
							EXPL_SUM_HP[g_i] += HP;
						#endif
					}

					if (OLD_EXPL_SUM_HP[g_i] != EXPL_SUM_HP[g_i]) {
						OLD_EXPL_SUM_HP[g_i] = EXPL_SUM_HP[g_i];
						do_hit(info);
					}
				//}
			}

			#ifdef IS_VEHICLE
				if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
			#endif

			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_DOTICK:
			if (!MAX_DYN_is_list_empty()) {
				MAX_DYN_time_tick(info->elapsed_time);
				info->next_exe_time = 0.0;
			}

			if (!MAX_PTC_is_list_empty()) {
				MAX_PTC_time_tick(info->elapsed_time);
				info->next_exe_time = 0.0;
			}

			for (g_i=0; g_i<EXPL_COUNT; g_i++) {
				if ((is_exploded[g_i] != 123456.0) && (is_exploded[g_i] > 0.0)) is_exploded[g_i] -= info->elapsed_time;
				if (ground_timer[g_i] > 0.0) {
					ground_timer[g_i] -= info->elapsed_time;
					info->next_exe_time = 0.1;
					if (ground_timer[g_i] <= 0.0) {
						g_movement = is_mooving_on_ground((EXPL_PTC[g_i][4] != -1 && EXPL_NAME[g_i][1][0] != '\0') ? expl_nod[g_i][1]:expl_nod[g_i][0]);
						SUM_MOVEMENT[g_i]+= g_movement;
						ground_hits[g_i]++;
						if (((SUM_MOVEMENT[g_i]/ground_hits[g_i]) < GROUND_LIMIT) /*|| (g_movement < GROUND_LIMIT/1000.0)*/) {
							do_ground_fire(expl_nod[g_i][0], g_i);
							is_on_ground[g_i] = 2;
#ifdef MAX_SCRIPT_DEBUG
							sprintf(_debug_tmp, "!max_uni_destr.cxx : %s[%s] : SC_OBJ_MSG_DOTICK - konec dopad | pru_movement: %f| movement: %f", SC_NOD_GetName(info->master_nod),SC_NOD_GetName((EXPL_PTC[g_i][4] != -1 && EXPL_NAME[g_i][1][0] != '\0') ? expl_nod[g_i][1]:expl_nod[g_i][0]), SUM_MOVEMENT[g_i]/ground_hits[g_i], g_movement);
							SC_Osi(_debug_tmp);
							SC_Log(3, _debug_tmp);
#endif
						} else {
#ifdef MAX_SCRIPT_DEBUG
							sprintf(_debug_tmp, "!max_uni_destr.cxx : %s[%s] : SC_OBJ_MSG_DOTICK - dopad | pru_movement: %f| movement: %f !< %f", SC_NOD_GetName(info->master_nod),SC_NOD_GetName((EXPL_PTC[g_i][4] != -1 && EXPL_NAME[g_i][1][0] != '\0') ? expl_nod[g_i][1]:expl_nod[g_i][0]), SUM_MOVEMENT[g_i]/ground_hits[g_i], g_movement, GROUND_LIMIT/1000.0);
							SC_Osi(_debug_tmp);
							SC_Log(3, _debug_tmp);
#endif
							SUM_MOVEMENT[g_i] = g_movement;
							ground_timer[g_i] = GROUND_TIME;
							ground_hits[g_i]  = 1;
						}
					}
				}
			}

			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_DSTR_NETCLIENT:
#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_DSTR_NETCLIENT - param1: %d | param2: %d", SC_NOD_GetName(info->master_nod), info->param1, info->param2);
				SC_Log(3, _debug_tmp);
#endif

			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				if (info->param1 == destr_nod[g_i][0]) {
					int i;

					//SC_DUMMY_Set_DoNotRenHier2(info->master_nod, TRUE);

					for (i=0; i<SETDSTR_COUNT; i++)
						if (!SC_Marok_IsMpSynchro(master_nod[i])) SC_NOD_Restore(master_nod[i]);

					for (i=0; i<FRAGMENT_COUNT; i++)
						if (!SC_Marok_IsMpSynchro(fragment_nod[i][0])) SC_NOD_Restore(fragment_nod[i][0]);

					reinit_phys(info);

					/*if ( (IS_MP_GAME) && (IS_MP_CLIENT) )   //protoze je tady schovavam
						MAX_DYN_add_show_nod(0.5, info->master_nod);*/

					#ifdef ACTIVE_OBJ_DIST
						CLEAR(MAX_UNI_object_status);
						MAX_UNI_object_status.side = SC_P_SIDE_ALL;
						MAX_UNI_object_status.timer = -1.0;

						/*for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
							if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Create(master_nod[g_i], ACTIVE_OBJ_DIST, ACTIVE_OBJ_TEXT[g_i]);*/
					#endif

					return TRUE;
				}
			}

			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				for (g_j=0; g_j<DESTR_COUNT; g_j++) {
					if (destr_nod[g_i][g_j] == info->nod) { // puvodni nod
						OLD_SUM_HP[g_i] = DESTR_HP[g_i][g_j];
						for (g_k=g_j+1; g_k<DESTR_COUNT; g_k++) { //zacnu hledat od dalsi faze
							if (destr_nod[g_i][g_k] == info->param1) { // jestli takova destrukce existuje
								SUM_HP[g_i] = DESTR_HP[g_i][g_k];
								if (SUM_HP[g_i] > OLD_SUM_HP[g_i]) {
									do_destruction(info, g_i, SUM_HP[g_i], info->param2 ? 0.0 : -1.0);
									OLD_SUM_HP[g_i] = SUM_HP[g_i];
								}
								return TRUE;
							}
						}
					}
				}
			}
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_MAROKSIMULATION:
#ifdef MAX_VEC_UHLU
			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				if (info->nod == master_nod[g_i]) {
					if (info->param1 == 1) {
						validate_nod_moveing[g_i] = TRUE;
						validate_nod_moved[g_i] = TRUE;
					} else {
						validate_nod_moveing[g_i] = FALSE;
					}
				}
			}
#endif
			if ((check_ptc_in_marok_simulation) && (info->param1 == 0)) { // objekt se zastavil
				for (g_i=0; g_i<EXPL_COUNT; g_i++) {
					if ((is_exploded[g_i] <= 0.0) && (is_on_ground[g_i] != 2)) {
						if (info->nod == ((EXPL_PTC[g_i][4] != -1 && EXPL_NAME[g_i][1][0] != '\0') ? expl_nod[g_i][1]:expl_nod[g_i][0])) {
							do_ground_fire(expl_nod[g_i][0], g_i);
							is_on_ground[g_i] = 2;
							ground_timer[g_i] = 0.0;
#ifdef MAX_SCRIPT_DEBUG
							sprintf(_debug_tmp, "!max_uni_destr.cxx : %s[%s] : SC_OBJ_MSG_MAROKSIMULATION - konec simulace", SC_NOD_GetName(info->master_nod),SC_NOD_GetName((EXPL_PTC[g_i][4] != -1 && EXPL_NAME[g_i][1][0] != '\0') ? expl_nod[g_i][1]:expl_nod[g_i][0]));
							SC_Osi(_debug_tmp);
							SC_Log(3, _debug_tmp);
#endif
						}
					}
				}
			}
			break;
//------------------------------------------------------------------
		#ifdef IS_VEHICLE
		case SC_OBJ_MSG_VEHICLE_REPAIR:
			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				if (destr_phase[g_i] > 0) return FALSE;
			}

			for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
				SUM_HP[g_i] -= (DESTR_HP[g_i][DESTR_COUNT-1]-DESTR_HP[g_i][0])*info->param6;
				if (SUM_HP[g_i] < 0.0) SUM_HP[g_i] = 0.0;
				OLD_SUM_HP[g_i] = SUM_HP[g_i];
			}
			for (g_i=0; g_i<EXPL_COUNT; g_i++) {
				EXPL_SUM_HP[g_i] -= (DESTR_HP[g_i][DESTR_COUNT-1]-DESTR_HP[g_i][0])*info->param6;
				if (EXPL_SUM_HP[g_i] < 0.0) EXPL_SUM_HP[g_i] = 0.0;
				OLD_EXPL_SUM_HP[g_i] = EXPL_SUM_HP[g_i];
			}

			if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));

			/*#ifdef JOINTS_OBJ_COUNT
				for (g_i=0; g_i<JOINTS_OBJ_COUNT; g_i++) {
					IK_SUM_HP[g_i] = IK_OLD_SUM_HP[g_i];
				}
			#endif*/

			break;
#endif
//------------------------------------------------------------------
		case SC_OBJ_MSG_FROMCLNNOD:
		case SC_OBJ_MSG_FROMSRVNOD:
		{
			int		i;
			dword	*data;
			dword	data_size = info->param2;

			data = (dword *)info->param1;

			info->param1 = 0;
			info->param2 = 0;
			info->param3 = 0;
			CLEAR(info->param4);

			if (data_size >=  4) info->param1 = data[0];
			if (data_size >=  8) info->param2 = data[1];
			if (data_size >= 12) info->param3 = data[2];

			info->message = SC_OBJ_MSG_MESSAGE;
		}
		case SC_OBJ_MSG_MESSAGE:
			switch(info->param1) {
			case MSG_UNI_DESTR_SET_HP:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_SET_HP] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
					SUM_HP[g_i] = info->param2;
					do_destruction(info, g_i, SUM_HP[g_i], 0.0);
				}
				#ifdef IS_VEHICLE
					if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
				#endif
				break;

			case MSG_UNI_DESTR_ADD_HP:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_ADD_HP] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
					SUM_HP[g_i] += info->param2;
					do_destruction(info, g_i, SUM_HP[g_i], 0.0);
				}
				#ifdef IS_VEHICLE
					if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
				#endif
				break;

			case MSG_UNI_DESTR_SET:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_SET] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				for (g_i=0; g_i<SETDSTR_COUNT; g_i++) {
					for (g_j=0; g_j<DESTR_COUNT; g_j++) {
						if (destr_nod[g_i][g_j] == info->param2) {
							SUM_HP[g_i] = DESTR_HP[g_i][g_j];
							if (SUM_HP[g_i] > OLD_SUM_HP[g_i]) {
								do_destruction(info, g_i, SUM_HP[g_i], 0.0);
								OLD_SUM_HP[g_i] = SUM_HP[g_i];
							}
							return TRUE;
						}
					}
				}
				#ifdef IS_VEHICLE
					if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
				#endif
				break;

			case MSG_UNI_DESTR_USE:
			case MSG_UNI_DESTR_USE_MP: // param2 je pl_handle(pl_id)
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_USE] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif

				if (info->param1 == MSG_UNI_DESTR_USE_MP)
					SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param2), &glob_side, NULL, NULL);
				else
					SC_P_GetSideGroupMemberId(info->param2, &glob_side, NULL, NULL);

				if ((MAX_UNI_object_status.side != SC_P_SIDE_ALL) && (MAX_UNI_object_status.side != glob_side)) {
					//info->param2 = FALSE;
					return FALSE;
				}

				#ifndef ACTIVE_OBJ_FORCE //if n def !!!
					if (info->param2 == 0) {
						#ifdef MAX_SCRIPT_DEBUG
							sprintf(_debug_tmp, "!max_uni_destr.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_USE] - nebylo zadano pl_id!!!", SC_NOD_GetName(info->master_nod));
							SC_Log(1, _debug_tmp);
							SC_message(_debug_tmp);
						#endif
						return FALSE;
					}
					//-----------------------------------------
					#ifdef ACTIVE_OBJ_DIST
						if (info->param1 == MSG_UNI_DESTR_USE_MP)
							do_push_impulse_from_msg(info, MAX_SUP_get_pl_id_from_handle(info->param2));
						else
							do_push_impulse_from_msg(info, info->param2);
					#endif
					//-----------------------------------------
				#else
					//-----------------------------------------
					#ifdef ACTIVE_OBJ_DIST
						do_push_impulse_from_msg(info, NULL);
					#endif
					//-----------------------------------------
				#endif

				#ifdef IS_VEHICLE
					if (!IS_MP_CLIENT) SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
				#endif
				break;

			case MSG_MUL_REQ_OBJECT_INFO:
				MAX_SUP_send_message_to_mp_script(MSG_MUL_ADD_OBJECT, info->master_nod, (dword)&MAX_UNI_object_status, NULL);
				break;

			case MSG_UNI_REINIT:
				MAX_DYN_remove_all_from_list();
				MAX_PTC_remove_all_from_list();
				/*#ifdef ACTIVE_OBJ_DIST
					for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
						if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Remove(master_nod[g_i]);
				#endif*/
				if ( ((IS_MP_GAME) && (!IS_MP_CLIENT)) || (!IS_MP_GAME) ) {
					SC_NOD_Restore(info->master_nod);
				} else {
					int i;

					for (i=0; i<SETDSTR_COUNT; i++)
						if (destr_phase[i] != 0) break;
					
					if (i >= SETDSTR_COUNT) {
						//SC_DUMMY_Set_DoNotRenHier2(info->master_nod, TRUE);

						for (i=0; i<SETDSTR_COUNT; i++)
							if (!SC_Marok_IsMpSynchro(master_nod[i])) SC_NOD_Restore(master_nod[i]);

						for (i=0; i<FRAGMENT_COUNT; i++)
							if (!SC_Marok_IsMpSynchro(fragment_nod[i][0])) SC_NOD_Restore(fragment_nod[i][0]);
					}

				}
				reinit_phys(info);

				/*if ( (IS_MP_GAME) && (IS_MP_CLIENT) )   //protoze je tady schovavam
					MAX_DYN_add_show_nod(0.5, info->master_nod);*/

				if ((IS_MP_GAME) && (!IS_MP_CLIENT)) {
					#ifdef IS_VEHICLE
						SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
					#endif
					SC_ObjectScriptMessage_NodToCLNs(info->master_nod, &info->param1, sizeof(info->param1));
				}

				#ifdef ACTIVE_OBJ_DIST
					CLEAR(MAX_UNI_object_status);
					MAX_UNI_object_status.side = SC_P_SIDE_ALL;
					MAX_UNI_object_status.timer = -1.0;

					/*for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
						if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Create(master_nod[g_i], ACTIVE_OBJ_DIST, ACTIVE_OBJ_TEXT[g_i]);*/
				#endif
				break;

			case MSG_UNI_RESPAWN:
				MAX_DYN_remove_all_from_list();
				MAX_PTC_remove_all_from_list();
				/*#ifdef ACTIVE_OBJ_DIST
					for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
						if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Remove(master_nod[g_i]);
				#endif*/
				if ( ((IS_MP_GAME) && (!IS_MP_CLIENT)) || (!IS_MP_GAME) ) {
					SC_NOD_Restore(info->master_nod);
				} else {
					return TRUE;
				}
				reinit_phys(info);

				/*if ( (IS_MP_GAME) && (IS_MP_CLIENT) )   //protoze je tady schovavam
					MAX_DYN_add_show_nod(0.5, info->master_nod);*/

				if ((IS_MP_GAME) && (!IS_MP_CLIENT)) {
					#ifdef IS_VEHICLE
						SC_VEH_SetHealthInfo(info->master_nod, 1.0-(SUM_HP[0]/DESTR_HP[0][DESTR_COUNT-1]));
					#endif
					SC_ObjectScriptMessage_NodToCLNs(info->master_nod, &info->param1, sizeof(info->param1));
				}

				#ifdef ACTIVE_OBJ_DIST
					CLEAR(MAX_UNI_object_status);
					MAX_UNI_object_status.side = SC_P_SIDE_ALL;
					MAX_UNI_object_status.timer = -1.0;

					/*for (g_i=0; g_i<SETDSTR_COUNT; g_i++)
						if (DESTR_HP[g_i][0] == 0.0) SC_ActiveObj_Create(master_nod[g_i], ACTIVE_OBJ_DIST, ACTIVE_OBJ_TEXT[g_i]);*/
				#endif
				break;

			} // switch
			break;
//------------------------------------------------------------------
	}// switch(info->event_type)

	return FALSE;

}// int ScriptMain(s_OBJ_info *info)
