#include <inc\maxovo\!max_multiplayer.h>

#define STARTING_CASH	 3000

#define CASH_KILLED_E	 1500
#define CASH_KILLED_BE	 2000
#define CASH_KILLED_S	 -500
#define CASH_KILLED_T	-1000

#define CASH_NEXT_ROUND	 1500

typedef struct {
	dword	pl_handle;
	int		cash;
	//BOOL	initialized;
}s_MUL_cash;

typedef struct {
	sc_player	player;
	int			weap_count;
	int			weapons[10];
	int			ammo_amount[10];
	int			selected_weapon;
} s_MUL_weapons;

s_MUL_weapons	MUL_weapons[MAX_MUL_PLAYERS];

s_MUL_cash	MUL_cash[MAX_MUL_PLAYERS];
int			MUL_cash_count = 0;

#define GAME_TYPE		GAME_TYPE_JS

dword	SIDE1 =			SC_P_SIDE_VC;		//musi byt definovano
dword	SIDE2 =			SC_P_SIDE_US;		//musi byt definovano

BOOL side1_rule1(s_MAX_RULE_data *MAX_RULE_data);
BOOL side1_rule2(s_MAX_RULE_data *MAX_RULE_data);

#define	GROUPS_COUNT_SIDE1	1
char	respawn_groups_side1_names[GROUPS_COUNT_SIDE1][MAX_STRING_LEN] =	{	"JS_VC"		};
char	respawn_groups_side1_op_names[GROUPS_COUNT_SIDE1][MAX_STRING_LEN] =	{		  ""	};
BOOL	respawn_groups_side1_active[GROUPS_COUNT_SIDE1] =					{	    TRUE	};
p_fce	respawn_groups_side1_rules[GROUPS_COUNT_SIDE1] =					{		NULL	};
#define	GROUPS_COUNT_SIDE2	1
char	respawn_groups_side2_names[GROUPS_COUNT_SIDE2][MAX_STRING_LEN] =	{	"JS_US"		};
char	respawn_groups_side2_op_names[GROUPS_COUNT_SIDE2][MAX_STRING_LEN] =	{		  ""	};
BOOL	respawn_groups_side2_active[GROUPS_COUNT_SIDE2] =					{	    TRUE	};
p_fce	respawn_groups_side2_rules[GROUPS_COUNT_SIDE2] =					{		NULL	};
//--------------------------------------------------------------------------------------------
BOOL MAX_MUL_RULE_sides_ready(s_MAX_RULE_data *MAX_RULE_data);

#define CHECK_SIDES_READY_COUNT		1
p_fce	CHECK_SIDES_READY[CHECK_SIDES_READY_COUNT] =					{	MAX_MUL_RULE_sides_ready	};
//--------------------------------------------------------------------------------------------

BOOL MP_bomb1_explode(s_MAX_RULE_data *MAX_RULE_data);
BOOL MP_bomb2_explode(s_MAX_RULE_data *MAX_RULE_data);
BOOL MP_bomb_defused(s_MAX_RULE_data *MAX_RULE_data);
BOOL MAX_MUL_RULE_side_wins_opp_death_extra(s_MAX_RULE_data *MAX_RULE_data);

BOOL MAX_MUL_give_c4(s_MAX_RULE_data *MAX_RULE_data);

BOOL MAX_MUL_get_players_weapons(s_MAX_RULE_data *MAX_RULE_data);
//--------------------------------------------------------------------------------------------
#define WHAT_NEXT_BEFORE_COUNT	1 //osravacka, aby nebyl next map
p_fce	WHAT_NEXT_BEFORE[WHAT_NEXT_BEFORE_COUNT] =				{	MAX_MUL_get_players_weapons		};

#define BEGIN_AFTER_COUNT			1
p_fce	BEGIN_AFTER[BEGIN_AFTER_COUNT] =						{	/*MAX_MUL_set_players_weapons,*/	MAX_MUL_give_c4		};


#define CALL_TO_MAIN

int call_to_main(s_SC_ModeScript_info *info);
//--------------------------------------------------------------------------------------------
#define WINNING_RULES_SIDE1_COUNT	3
#define WINNING_RULES_SIDE2_COUNT	2

p_fce	WINNING_RULES_SIDE1[WINNING_RULES_SIDE1_COUNT] =				{	MAX_MUL_RULE_side_wins_opp_death_extra, MP_bomb1_explode, MP_bomb2_explode	};
p_fce	WINNING_RULES_SIDE2[WINNING_RULES_SIDE2_COUNT] =				{	MAX_MUL_RULE_side_wins_opp_death_extra, MP_bomb_defused	};

// definuje se jake dalsi pravidla musi jeste platit s aktualnim pravidlem, -1 znamena zadne dalsi pravidlo
int		WINNING_RULES_SIDE1_OPP[WINNING_RULES_SIDE1_COUNT][WINNING_RULES_SIDE1_COUNT-1] =			{	-1, -1,		//zadne dalsi pravidlo nemusi platit
																										-1,	-1,		//musi platit jeste 2(index) -> 3ti
																										-1,	-1	};	//musi platit jeste 1(index) -> 2he
int		WINNING_RULES_SIDE2_OPP[WINNING_RULES_SIDE2_COUNT][WINNING_RULES_SIDE2_COUNT-1] =			{	-1, -1	};
//--------------------------------------------------------------------------------------------
#define OBJECTS_COUNT				2
char	*MAX_MUL_object_names[OBJECTS_COUNT] =							{	"aa_gun_destr",	"aa_gun_destr#1"	};

BOOL MAX_MUL_get_winning_side(s_MAX_RULE_data *MAX_RULE_data);

#define ROUND_TIMEOUT_WINNING_SIDE_COUNT	1 //todle asi bude vzdy pouze 1, ale ...
p_fce	ROUND_TIMEOUT_WINNING_SIDE[ROUND_TIMEOUT_WINNING_SIDE_COUNT] =	{	MAX_MUL_get_winning_side	};
//-------------------------------- MAPA ---------------------------------
#define MAP_NAME		"levels\\Checkpoint\\data\\checkpoint_mp\\mapfpv\\map.bmp"
#define MAP_TRANSFORM	"levels\\Checkpoint\\data\\checkpoint_mp\\mapfpv\\map_transform.dat"

void MAX_MUL_define_custom_items() {
}

void MAX_MUL_define_custom_objectives() {
}
//-----------------------------------------------------------------------
#include <inc\maxovo\!max_multiplayer.cxx>
//-----------------------------------------------------------------------
//------------------------------ PRAVIDLA -------------------------------
//-----------------------------------------------------------------------
int		iii;
float	time_out;
BOOL	game_restart = FALSE;

//-----------------------------------------------------------------------
BOOL MP_bomb1_explode(s_MAX_RULE_data *MAX_RULE_data) {
	static int pos_in_array = 0;
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		for (iii=0; iii<OBJECTS_COUNT; iii++) {
			if (MAX_MUL_object[iii].nod == SC_NOD_GetNoMessage_Entity(MAX_MUL_object_names[0])) { // u HB
				pos_in_array = iii;
				break;
			}
		}
		if (iii >= OBJECTS_COUNT) SC_message("Fatal ERROR - nepodarilo ne najit MP_bomb1_explode!!!");
		return FALSE;
	}

	if ((MAX_MUL_object[pos_in_array].nod) && (MAX_MUL_object[pos_in_array].SRV_object_status->state == STATE_DESTROYED)) return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------
BOOL MP_bomb2_explode(s_MAX_RULE_data *MAX_RULE_data) {
	static int pos_in_array = 1;
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		for (iii=0; iii<OBJECTS_COUNT; iii++) {
			if (MAX_MUL_object[iii].nod == SC_NOD_GetNoMessage_Entity(MAX_MUL_object_names[1])) { // u HELI
				pos_in_array = iii;
				break;
			}
		}
		if (iii >= OBJECTS_COUNT) SC_message("Fatal ERROR - nepodarilo ne najit MP_bomb2_explode!!!");
		return FALSE;
	}

	if ((MAX_MUL_object[pos_in_array].nod) && (MAX_MUL_object[pos_in_array].SRV_object_status->state == STATE_DESTROYED)) return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------
BOOL MP_bomb_defused(s_MAX_RULE_data *MAX_RULE_data) {
	static int pos_in_array1 = 0;
	static int pos_in_array2 = 1;
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		for (iii=0; iii<OBJECTS_COUNT; iii++) {
			if (MAX_MUL_object[iii].nod == SC_NOD_GetNoMessage_Entity(MAX_MUL_object_names[0])) { // u HB
				pos_in_array1 = iii;
				break;
			}
		}
		if (iii >= OBJECTS_COUNT) SC_message("Fatal ERROR - nepodarilo ne najit MP_bomb2_explode!!!");
		for (iii=0; iii<OBJECTS_COUNT; iii++) {
			if (MAX_MUL_object[iii].nod == SC_NOD_GetNoMessage_Entity(MAX_MUL_object_names[1])) { // u HELI
				pos_in_array2 = iii;
				break;
			}
		}
		if (iii >= OBJECTS_COUNT) SC_message("Fatal ERROR - nepodarilo ne najit MP_bomb2_explode!!!");
		return FALSE;
	}

	if ((MAX_MUL_object[pos_in_array1].nod) && (MAX_MUL_object[pos_in_array1].SRV_object_status->state == STATE_DEFUSED)) return TRUE;
	if ((MAX_MUL_object[pos_in_array2].nod) && (MAX_MUL_object[pos_in_array2].SRV_object_status->state == STATE_DEFUSED)) return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
BOOL MAX_MUL_get_winning_side(s_MAX_RULE_data *MAX_RULE_data) {
	MAX_RULE_data->side = SIDE2;
	return TRUE; //SIDE2 brani
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
BOOL MAX_MUL_get_players_weapons(s_MAX_RULE_data *MAX_RULE_data) {
	sc_player	list[MAX_MUL_PLAYERS];
	int			num, j;
	int			index;

	index = 0;

	num = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_allive(SC_P_SIDE_ALL, &num, list);
	for (iii=0; iii<num; iii++) {
		MUL_weapons[index].weap_count = SC_P_GetWeapons(list[iii], MUL_weapons[index].weapons, 10);
		if (MUL_weapons[index].weap_count >= 10) SC_message("bacha max zbrani!!");
		if (MUL_weapons[index].weap_count > 0) {
			MUL_weapons[index].player = list[iii];
			MUL_weapons[index].selected_weapon = SC_P_GetSelectedWeapon(list[iii]);

			//for (j=0; j<MUL_weapons[index].weap_count; j++)
				//MUL_weapons[index].ammo_amount[j] = SC_AMMO_Get(list[iii], MUL_weapons[index].weapons[j]);
			
			index++;
		} else {
			CLEAR(MUL_weapons[index]);
		}
	}
	if (index < MAX_MUL_PLAYERS) CLEAR(MUL_weapons[index]);

	game_restart = TRUE;

	return TRUE;
}
//-----------------------------------------------------------------------
//BOOL MAX_MUL_set_players_weapons(s_MAX_RULE_data *MAX_RULE_data) {
BOOL MAX_MUL_set_players_weapons() {
	sc_player	list[MAX_MUL_PLAYERS];
	int			num, j, k, l;
	int			weap_count;
	int			index;

	int			weapons[10];

	index = 0;

	num = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_allive(SC_P_SIDE_ALL, &num, list);
	for (iii=0; iii<num; iii++) {
		for (j=0; j<MAX_MUL_PLAYERS; j++) {
			if (MUL_weapons[j].player == 0) break;
			if (list[iii] != MUL_weapons[j].player) continue;

			weap_count = SC_P_GetWeapons(list[iii], weapons, 10);

			for (k=0; k<MUL_weapons[j].weap_count; k++) {
				if (MUL_weapons[j].weapons[k] == 67) continue;

				for (l=0; l<weap_count; l++) {
					if (MUL_weapons[j].weapons[k] == weapons[l]) break;
				}
				if (l >= weap_count) {
					dword		can_pickup;
					dword		swap;

					//SC_P_AddWeapon(list[iii], MUL_weapons[j].weapons[k]);
					can_pickup = SC_P_CanPickupWeapon(list[iii], MUL_weapons[j].weapons[k], &swap);

					switch(can_pickup) {
					case SC_P_CANPICKUPWEAP_YES:
						SC_P_PickupWeapon(list[iii], MUL_weapons[j].weapons[k], 0);
						break;

					case SC_P_CANPICKUPWEAP_SWAP:
						SC_P_PickupWeapon(list[iii], MUL_weapons[j].weapons[k], swap);
						break;
					}
					
					//SC_P_AddAmmo(list[iii], MUL_weapons[j].ammo_amount[k]);
					SC_P_SetSelectedWeapon(list[iii], MUL_weapons[j].selected_weapon, FALSE);
				}
			}

		}
	}
	return TRUE;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
BOOL MAX_MUL_give_c4(s_MAX_RULE_data *MAX_RULE_data) {
	int			i, num, pl_index;
	sc_player	list[MAX_MUL_PLAYERS];

	num = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_all(SIDE1, &num, list);

	if (num == 0) {
		SC_message("fatal - pocet hracu na side2 == 0");
		return FALSE;
	}

	pl_index = rand()%num; // vybere se nahodne hrac

	//MAX_SUP_add_weap(list[pl_index], 67, 36, 1, FALSE);
	
	SC_P_AddWeapon(list[pl_index], 67);
	SC_P_AddAmmo(list[pl_index], 36, 1);
	//SC_P_PickupWeapon(list[pl_index], 67, 0);
	/*if (SC_P_CanPickupAmmo(list[pl_index], 36)){
		SC_P_PickupAmmo(list[pl_index], 36, 1);			
	}*/

	for (i=0; i<num; i++) {
		if (i == pl_index) {
			MAX_MUL_send_message_to_client(MAX_SUP_get_handle_from_pl_id(list[i]), MSG_MUL_BOMB_YOU);
		} else {
			MAX_MUL_send_message_to_client(MAX_SUP_get_handle_from_pl_id(list[i]), MSG_MUL_BOMB_PLAYER, MAX_SUP_get_handle_from_pl_id(list[pl_index]));
		}
	}
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL MAX_MUL_RULE_side_wins_opp_death_extra(s_MAX_RULE_data *MAX_RULE_data) {

	for (iii=0; iii<OBJECTS_COUNT; iii++)
		if ((MAX_MUL_object[iii].nod) && ((MAX_MUL_object[iii].SRV_object_status->state == STATE_ACTIVE) || (MAX_MUL_object[iii].SRV_object_status->state == STATE_DEFUSING))) return FALSE;

	return MAX_MUL_RULE_side_wins_opp_death(MAX_RULE_data);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void add_cash_to_player(dword pl_handle, int cash) {
	for (iii=0; iii<MUL_cash_count; iii++)
		if (MUL_cash[iii].pl_handle == pl_handle) {
			MUL_cash[iii].cash += cash;
			if (MUL_cash[iii].cash < 0) MUL_cash[iii].cash = 0;
			MAX_MUL_send_message_to_client(pl_handle, MSG_WEAP_SET, MUL_cash[iii].cash);
			break;
		}
}

int call_to_main(s_SC_ModeScript_info *info) {
	switch(info->event) {
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_INIT:
		for (iii=0; iii<MAX_MUL_PLAYERS; iii++) {
			CLEAR(MUL_cash[iii]);
			//MUL_cash[iii].initialized = FALSE;
			//MUL_cash[iii].pl_handle = 0;
			//MUL_cash[iii].cash = 0;
		}

		//if (!MAX_MUL_is_server)
		//	MUL_cash[0].cash = STARTING_CASH; //staci jenom tady (je to pro klienty v podstate)
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_SRV:
		switch(SRV_game_phase) {
		case GAME_PHASE_INITIALIZING:
			time_out = 0.5;
			break;

		case GAME_PHASE_BEGIN:
			if (MAX_SUP_count_timeout(&time_out, info->elapsed_time))
				MAX_MUL_set_players_weapons();

			break;
		}
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RENDER:
		{
			float	x, y;
			char	txt[256];

			SC_GetScreenRes(&x, &y);

			y-= 150.0;
			sprintf(txt, "%d.00", MUL_cash[0].cash);
			x -= SC_Fnt_GetWidth(txt, 2.0f) + 10.0;
			SC_Fnt_Write(x, y, txt, 2.0f, 0xffffffff);	
		}
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLAYERCREATED:
		if (MUL_cash_count >= MAX_MUL_PLAYERS) return FALSE;

		for (iii=0; iii<MUL_cash_count; iii++)
			if (MUL_cash[iii].pl_handle == info->param1) break;

		if (iii >= MUL_cash_count) { // tedka se pripojil -> pridam ho do seznamu
			MUL_cash[MUL_cash_count].pl_handle = info->param1;
			MUL_cash[MUL_cash_count].cash = STARTING_CASH;
			MAX_MUL_send_message_to_client(MUL_cash[MUL_cash_count].pl_handle, MSG_WEAP_SET, STARTING_CASH);
			//MUL_cash[MUL_cash_count].initialized = TRUE;
			MUL_cash_count++;
		}

		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLAYERRELEASED:
		if (MUL_cash_count <= 0) return FALSE;

		for (iii=0; iii<MUL_cash_count; iii++)
			if (MUL_cash[iii].pl_handle == info->param1) break;

		if (iii < MUL_cash_count) { // odpojuje se -> odeberu ho ze seznamu
			MUL_cash[iii] = MUL_cash[MUL_cash_count-1];
			CLEAR(MUL_cash[MUL_cash_count-1]);
			MUL_cash_count--;
		}
		break;

	case SC_MODESCRIPT_EVENT_PLKILLED:
		{
			dword	side1, side2;
			int		value;
			dword	pl_handle;
			int		points;

			if (info->param1==info->param2) {	// suicide
				add_cash_to_player(info->param1, CASH_KILLED_S);
			} else if (info->param2) {	// nekdo ho zabil

				SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param1), &side1, NULL, NULL);
		#ifdef GROUPS_COUNT_SIDE2
				SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param2), &side2, NULL, NULL);
		#else
				side2 = -1;
		#endif

				if (side1 == side2){ // team kill
					value = CASH_KILLED_T;
				} else {
					if (MAX_MUL_get_best_player(&pl_handle, &points)) {
						if ((points > 0) && (info->param1 == pl_handle)) {
							value = CASH_KILLED_BE;
						} else {
							value = CASH_KILLED_E;
						}
					} else {
						value = CASH_KILLED_E;
					}
				}
							
				add_cash_to_player(info->param2, value);
			}
		}
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTMAP:
		if (!game_restart) {
			for (iii=0; iii<MUL_cash_count; iii++)
				MUL_cash[iii].cash = STARTING_CASH;
		} else {
			for (iii=0; iii<MUL_cash_count; iii++)
				add_cash_to_player(MUL_cash[iii].pl_handle, CASH_NEXT_ROUND);
		}

		game_restart = FALSE;
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTROUND:
		if (!game_restart) {
			for (iii=0; iii<MUL_cash_count; iii++)
				MUL_cash[iii].cash = STARTING_CASH;
		} else {
			for (iii=0; iii<MUL_cash_count; iii++)
				add_cash_to_player(MUL_cash[iii].pl_handle, CASH_NEXT_ROUND);
		}

		game_restart = FALSE;
		break;
//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_LOCALMSG:
		switch (info->param1) {
		case MSG_WEAP_PICK_UP:
			for (iii=0; iii<MUL_cash_count; iii++)
				if (MUL_cash[iii].pl_handle == info->param2) break;

			if (iii < MUL_cash_count) {
				if (MUL_cash[iii].cash >= info->param3) {
					MUL_cash[iii].cash -= info->param3;
					if (MAX_MUL_is_server)
						MAX_SUP_send_message_to_object(info->param4, MSG_WEAP_SET, info->param2);

					MAX_SUP_send_message_to_clients_to_object(info->param4, MSG_WEAP_SET, info->param2, MUL_cash[iii].cash);
				}
			}
			break;

		case MSG_AMMO_PICK_UP:
			for (iii=0; iii<MUL_cash_count; iii++)
				if (MUL_cash[iii].pl_handle == info->param2) break;

			if (iii < MUL_cash_count) {
				if (MUL_cash[iii].cash >= info->param3) {
					MUL_cash[iii].cash -= info->param3;
					if (MAX_MUL_is_server)
						MAX_SUP_send_message_to_object(info->param4, MSG_AMMO_SET, info->param2);

					MAX_SUP_send_message_to_clients_to_object(info->param4, MSG_AMMO_SET, info->param2, MUL_cash[iii].cash);
				}
			}
			break;

		case MSG_WEAP_SET: //jenom pro klienty
			MUL_cash[0].cash = info->param2;
			break;

		}
		break;

	case SC_MODESCRIPT_EVENT_MSG_TO_CLN:
		switch(info->param1) {
		case MSG_WEAP_SET: //jenom pro klienty
			MUL_cash[0].cash = info->param2;
			break;

		}

		break;

	}

	return TRUE;
}
int MAX_MUL_handle_message(s_SC_ModeScript_info *info, ...) {
	
	return TRUE;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
BOOL MAX_MUL_init_extras(s_MAX_RULE_data *MAX_RULE_data) {
	

	return TRUE;
}
BOOL MAX_MUL_render_extras(s_MAX_RULE_data *MAX_RULE_data) {
	float	x, y;
	char	txt[256];

	SC_GetScreenRes(&x, &y);

	y-= 150.0;
	sprintf(txt, "%d.00", MUL_cash[0].cash);
	x -= SC_Fnt_GetWidth(txt, 2.0f) + 50.0;
	SC_Fnt_Write(x, y, txt, 2.0f, 0xffffffff);	
	return TRUE;
}