#include <inc\Maxovo\!max_gameplay.h>

#define uni_CHECK_INVUL_LIMIT_TIMEOUT	5.0

#define	ID_RADIOEAR		1
#define	BES_RADIOEAR	"G\\Equipments\\field gear\\euw_radioear01.bes"
#define	EQP_RADIOEAR	"G\\Equipments\\field gear\\euw_radioear01.eqp"

//#ifdef MP_SEARCH_PLAYER
#include <inc\Maxovo\!max_multiplayer.h>
//#endif

#ifdef PENDL
s_pendl		pendl_points[PENDL_POINTS];
#endif

#ifdef MAINTASK
s_maintask	maintask[MAINTASK_COUNT];
#endif

#ifdef RESPAWN
#include <inc\Maxovo\pl_respawn.cxx>
#endif

#ifdef PENDL
#include <inc\Maxovo\pl_pendl.cxx>
#endif

#ifdef MAINTASK
#include <inc\Maxovo\pl_maintask.cxx>
#endif

#ifdef PREPADAVANI
#include <inc\Maxovo\pl_prepadavani.cxx>
#endif

s_SC_P_CreateWeap	uni_weap[MAX_WEAPONS];
int					uni_weap_count;
BOOL				uni_radio_speaking = FALSE;

float				uni_radio_stop_timeout = -1.0;
dword				uni_radio_stop_phase = 0;

void get_Weapons();
BOOL callback_to_main(s_SC_Pscript_info *info);

//float uni_gtime = 0.0f;
dword uni_gphase = 0;

s_SC_P_ScriptProps	uni_sc_props;
s_SC_P_AI_props		uni_ai_props;
s_SC_P_status		uni_status;

sc_player			uni_list[MAX_PLAYERS];
int					uni_num;
dword				uni_side, uni_group;
dword				uni_member_id;

//char				*uni_inifile;
//char				*uni_eqp_inifile;

#ifdef MP_SEARCH_PLAYER
float				MP_timeout;
float				MP_maintask_timeout;
#endif
sc_player			MP_followed_player = NULL;

#ifdef DERESPAWN_AFTER_KILLED
float				uni_derespawn_timeout = -1.0;
#endif

#ifdef INVUL_LIMIT
int					uni_begin_players_in_group;
float				uni_begin_received_damage_mult;
float				uni_tmp_float;
float				uni_check_invul_limit_timeout;

void check_invul_limit(s_SC_Pscript_info *info) {

	uni_check_invul_limit_timeout = uni_CHECK_INVUL_LIMIT_TIMEOUT;

	SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
	uni_num = 64;
	uni_num = SC_EnumPlayers(uni_side, uni_group, uni_list, uni_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY);

	CLEAR(uni_sc_props);
	SC_P_GetScriptProps(info->player, &uni_sc_props);

	if (uni_num > uni_begin_players_in_group) {
		uni_begin_players_in_group			= uni_num;
		if (uni_num > INVUL_LIMIT)
			uni_sc_props.received_damage_mult	= uni_begin_received_damage_mult;
		else
			uni_sc_props.received_damage_mult	= 0.0;

		SC_Osi("S: %d|G: %d|M: %d - Zjisteno vice panaku ve skupine[%d][L:%d] -> damage na %f", uni_side, uni_group, uni_member_id, uni_num, INVUL_LIMIT ,uni_sc_props.received_damage_mult);

		SC_P_SetScriptProps(info->player, &uni_sc_props);
		return;
	}

	uni_tmp_float = uni_begin_players_in_group - INVUL_LIMIT;
	if (uni_tmp_float > 0.0) {
		uni_sc_props.received_damage_mult = (uni_num - INVUL_LIMIT) * (uni_begin_received_damage_mult / uni_tmp_float);
		if (uni_sc_props.received_damage_mult < 0.0) uni_sc_props.received_damage_mult = 0.0;
	} else {
		uni_sc_props.received_damage_mult = 0.0;
	}

	SC_Osi("S: %d|G: %d|M: %d - Panaku ve skupine [%d][L:%d] - Nastavuje rec. damage na %f", uni_side, uni_group, uni_member_id, uni_num, INVUL_LIMIT, uni_sc_props.received_damage_mult);

	SC_P_SetScriptProps(info->player, &uni_sc_props);
}
#endif
int ScriptMain(s_SC_Pscript_info *info){
	//s_SC_P_Create create_info;
	s_SC_P_RespawnPos resp_pos;
	
	s_SC_Plscr_info plscr_info;

#ifndef DONT_CHANGE_NEXT_EXE_TIME
	info->next_exe_time = 1.0;
#endif

	if (!callback_to_main(info)) return 0;

#ifdef RESPAWN
	PL_RESPAWN(info);
#endif
#ifdef PENDL
	PL_PENDL(info);
#endif
#ifdef MAINTASK
	PL_MAINTASK(info);
#endif
#ifdef MAX_DYNAM_H
	if (!MAX_DYN_is_list_empty()) {
		MAX_DYN_time_tick(info->elapsed_time);
		#ifndef DONT_CHANGE_NEXT_EXE_TIME
			info->next_exe_time = 0.1;
		#endif
	}
#endif
//#ifdef MP_SEARCH_PLAYER

//#endif
#ifdef PREPADAVANI
	PL_PREPADAVANI(info);
#endif

	//SC_Log(1, "__uni_soldier.cxx : %d|%d|%d | %f|%f | %d", info->message, info->param1, info->param2, info->next_exe_time, info->elapsed_time, info->player);
	switch(info->message){

		case SC_PLSCR_MSG_SCRIPT_INIT:
			#ifdef MP_SEARCH_PLAYER
				MP_timeout = -1.0;
				MP_maintask_timeout = -1.0;
			#endif

			uni_radio_stop_timeout = -1.0;
			uni_radio_stop_phase = 0;

			MP_followed_player = NULL;

			{
				s_create_player	create_player;

				s_PlayerIniEqp	tmp_ini;
				dword	tmp_class_b, tmp_class_m;
				dword	tmp_rank;

				CLEAR(create_player);
				CLEAR(tmp_ini);

				#ifdef CLASS
					if ((CLASS == CLASS_HEAVY_GUNNER) || (CLASS == CLASS_LIGHT_GUNNER)) tmp_class_b = CLS_MACHINEGUN;
					else tmp_class_b = CLS_SOLDIER;

					tmp_class_m = CLASS;
				#else
					tmp_class_b = CLS_SOLDIER;
					tmp_class_m = CLASS_FIGHTER;
				#endif

				#ifndef CUSTOM_WEAPONS
				#ifndef SUB_CLASS
					if ((SC_IsMpGame()) || ((CLASS != CLASS_FIGHTER) && (CLASS != CLASS_HEAVY_GUNNER) && (CLASS != CLASS_LIGHT_GUNNER))) {
						SC_Log(2, "!max_gameplay.h - init_classes() - jiny class: %d | nastavuji zbran podle !max_gameplay.h(1)", CLASS);
						uni_weap_count = MAX_WEAPONS;
						MAX_GMP_set_weap_from_class(uni_weap, &uni_weap_count, tmp_class_m, PL_SIDE);
					} else {
						uni_weap_count = 1;
						uni_weap[0].weap_id = 0;
					}
				#else
					uni_weap_count = 1;
					uni_weap[0].weap_id = SUB_CLASS;
				#endif
				#endif

				if (uni_weap_count == 0) {
					SC_Log(2, "!uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_INIT - ERROR(pocet zbrani == 0)[s/g/m:%d/%d/%d]", PL_SIDE, PL_GROUP, PL_ID);
				}

				#ifdef RANK
					tmp_rank = RANK;
				#else
					tmp_rank = (PL_SIDE == SC_P_SIDE_VC) ? RNK_1 : RNK_3;
				#endif

				if ((PL_SIDE == SC_P_SIDE_US) || (PL_SIDE == SC_P_SIDE_NEUTRAL_US))
					usGetPlayerIniEqp(tmp_rank, tmp_class_b, uni_weap[0].weap_id, &tmp_ini);
				else if ((PL_SIDE == SC_P_SIDE_VC) || (PL_SIDE == SC_P_SIDE_NEUTRAL_VC))
					vcGetPlayerIniEqp(tmp_rank, tmp_class_b, uni_weap[0].weap_id, &tmp_ini);

				#ifdef INI_FILE_BODY
					create_player.inifile = INI_FILE_BODY;
				#else
					//uni_inifile = MAX_GMP_get_inifile(PL_SIDE, CLASS);
					create_player.inifile = tmp_ini.bodyIni;
				#endif

				#ifdef EQP_FILE_BODY
					create_player.eqp_inifile = EQP_FILE_BODY;
				#else
					//uni_eqp_inifile = MAX_GMP_get_eqp_inifile(PL_SIDE, CLASS);
					create_player.eqp_inifile = tmp_ini.bodyEqp;
				#endif

				#ifdef INI_FILE_HEAD
					create_player.head_name = INI_FILE_HEAD;
				#else
					create_player.head_name = tmp_ini.headIni;
				#endif

				#ifdef EQP_FILE_HEAD
					create_player.head_eqp_inifile = EQP_FILE_HEAD;
				#else
					create_player.head_eqp_inifile = tmp_ini.headEqp;
				#endif

				#ifdef NAME_NR
					create_player.name_nr = NAME_NR;
				#else
					if (PL_SIDE == SC_P_SIDE_US)
						create_player.name_nr = 2728;
					else
						#ifdef RANK
							if (RANK <= 3)
								create_player.name_nr = 2739;
							else
								create_player.name_nr = 2740;
						#else
							create_player.name_nr = 2739;
						#endif
				#endif

				#ifdef PL_CREATE_BLOCKER
					create_player.blocker = TRUE;
				#else
					create_player.blocker = FALSE;
				#endif

				#ifdef DEATH_COMMA
					create_player.death_comma = TRUE;
				#else
					create_player.death_comma = FALSE;
				#endif

				#ifndef CUSTOM_WEAPONS //ndef -> pokud je to definovano, tak pak chci zbran, kterou si vyberu ja

				#ifndef SUB_CLASS
					if (uni_weap[0].weap_id != tmp_ini.weapon) {
					#ifdef CLASS // LOCAL_CLASS je z !max_gameplay.h (v pripade ze se pouzije CLASS_RANDOM_NORMAL
						if ((uni_weap[0].weap_id == 0) || (LOCAL_CLASS == CLASS_FIGHTER) || (LOCAL_CLASS == CLASS_HEAVY_GUNNER) || (LOCAL_CLASS == CLASS_LIGHT_GUNNER)) {
							uni_weap[0].weap_id = tmp_ini.weapon; // v pripade, ze beny nenajde odpovidajici ini a eqp ke mno zadane zbrani
							SC_Log(2, "!max_gameplay.h - init_classes() - neshoda zbrani (class: %d) | nastavuji zbran podle benyho(2)", CLASS);
						}
					#else
						uni_weap[0].weap_id = tmp_ini.weapon; // v pripade, ze beny nenajde odpovidajici ini a eqp ke mno zadane zbrani
						SC_Log(2, "!max_gameplay.h - init_classes() - neshoda zbrani (class: %d) | nastavuji zbran podle benyho(3)", CLASS);
					#endif
					}
				#else
					uni_weap[0].weap_id = tmp_ini.weapon;
				#endif

				#endif

				#ifdef FORCE_ADD_WEAPON
					if (uni_weap_count < MAX_WEAPONS-1) {
						uni_weap[uni_weap_count].weap_id = FORCE_ADD_WEAPON;
						uni_weap_count++;
					} else {
						SC_message("uni_soldier.cxx - preteceni uni_weap[]");
					}
				#endif

				create_player.group = PL_GROUP;
				create_player.member_id = PL_ID;
				create_player.weap = uni_weap;
				create_player.weap_count = uni_weap_count;
				//create_player.inifile = uni_inifile;
				//create_player.eqp_inifile = uni_eqp_inifile;

				#ifdef RESPAWN_FLAGS
					create_player.flags = RESPAWN_FLAGS;
				#else
					create_player.flags = 0;
				#endif

				if (PL_SIDE == SC_P_SIDE_US) {
					#ifdef RESPAWN_INACTIVE
						if (CLASS == CLASS_TEAMLEADER)
							MAX_SUP_create_player_US_PC_inactive(info, &create_player);
						else
							MAX_SUP_create_player_US_inactive(info, &create_player);

					#else
						if (CLASS == CLASS_TEAMLEADER)
							MAX_SUP_create_player_US_PC(info, &create_player);
						else
							MAX_SUP_create_player_US(info, &create_player);

					#endif
				} else if (PL_SIDE == SC_P_SIDE_VC) {
					#ifdef RESPAWN_INACTIVE
						if (CLASS == CLASS_TEAMLEADER)
							MAX_SUP_create_player_VC_PC_inactive(info, &create_player);
						else
							MAX_SUP_create_player_VC_inactive(info, &create_player);

					#else
						if (CLASS == CLASS_TEAMLEADER)
							MAX_SUP_create_player_VC_PC(info, &create_player);
						else
							MAX_SUP_create_player_VC(info, &create_player);

					#endif
				} else if (PL_SIDE == SC_P_SIDE_NEUTRAL_US) {
					#ifdef RESPAWN_INACTIVE
						MAX_SUP_create_player_neutral_US_inactive(info, &create_player);
					#else
						MAX_SUP_create_player_neutral_US(info, &create_player);
					#endif
				} else if (PL_SIDE == SC_P_SIDE_NEUTRAL_VC) {
					#ifdef RESPAWN_INACTIVE
						MAX_SUP_create_player_neutral_VC_inactive(info, &create_player);
					#else
						MAX_SUP_create_player_neutral_VC(info, &create_player);
					#endif
				} else {
					SC_message("!uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_INIT - FATAL ERROR(PL_SIDE unknown)");
					return FALSE;
				}
			}


			//SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
			for (uni_gphase=0; uni_gphase<uni_weap_count; uni_gphase++) {
				SC_Log(2,"WEAP[s:%d][g:%d][m:%d]: %d[%d]", PL_SIDE, PL_GROUP, PL_ID, uni_weap[uni_gphase].weap_id, uni_gphase);
			}
			SC_Log(2,"--------------------------------------------------------------------------");

			uni_gphase = 0;

			#ifdef INVUL_LIMIT
				uni_check_invul_limit_timeout = -1.0;
			#endif

			if ( (PL_GROUP == 0) && (PL_SIDE == SC_P_SIDE_US) && ((PL_ID == PL_ID_MEDIK) || (PL_ID == PL_ID_ING) || (PL_ID == PL_ID_KULAS) || (PL_ID == PL_ID_RADIO)) ) {
				s_SC_AI_GroupProps gr_props;
				SC_AI_GetGroupProps(PL_SIDE, PL_GROUP, &gr_props);
				gr_props.flags |= SC_AI_GROUP_FL_SHOW_ON_RADAR;
				SC_AI_SetGroupProps(PL_SIDE, PL_GROUP, &gr_props);
			}

			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:			
			break;

		case SC_PLSCR_MSG_PL_CREATED:
			
			break;

		case SC_PLSCR_MSG_PL_RELEASED:
			
			break;

		case SC_PLSCR_MSG_JUSTLOADED:
			#ifdef CLASS
				if (CLASS == CLASS_MEDIK)	MAX_SUP_set_medik(info->player);
				if (CLASS == CLASS_INZENYR)	MAX_SUP_set_inzenyr(info->player);
			#endif
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
#ifdef DERESPAWN_AFTER_KILLED
			uni_derespawn_timeout = -1.0;
#endif
			#ifdef CLASS
				if (CLASS != CLASS_TEAMLEADER) MAX_GMP_set_skills_from_class(info->player, CLASS); //prerazeno SetRankClass() - cast se ale nastavi tady
				if (CLASS == CLASS_MEDIK)	MAX_SUP_set_medik(info->player);
				if (CLASS == CLASS_INZENYR)	MAX_SUP_set_inzenyr(info->player);
			#else
				/*if (SC_PC_Get() != info->player)*/ MAX_GMP_set_skills_from_class(info->player, CLASS_FIGHTER);
			#endif

			if (!SC_IsMpGame()) {
				dword	tmp_class_b = 0;
				dword	tmp_rank;

				#ifdef CLASS

					if ((CLASS == CLASS_HEAVY_GUNNER) || (CLASS == CLASS_LIGHT_GUNNER)) tmp_class_b = CLS_MACHINEGUN;
					else if (CLASS == CLASS_FIGHTER) tmp_class_b = CLS_SOLDIER;
				#else
					tmp_class_b = CLS_SOLDIER;
				#endif

				if (tmp_class_b) {

					#ifdef RANK
						tmp_rank = RANK;
					#else
						tmp_rank = (PL_SIDE == SC_P_SIDE_VC) ? RNK_1 : RNK_3;
					#endif

					SetRankClass(info->player, SC_GetDifficulty(), tmp_rank, tmp_class_b, 0);
				}
			} else { // je to sitova hra
				switch (SC_ggi(GLOBAL_GAME_DIFFICULTY)) {
				case 0:
					MAX_GMP_change_skill(info->player, 0.7);
					break;
				case 1:
					break;
				case 2:
					MAX_GMP_change_skill(info->player, 1.5);
					break;
				}
			}

			#ifdef INVUL_LIMIT
				SC_P_GetScriptProps(info->player, &uni_sc_props);
				uni_begin_received_damage_mult = uni_sc_props.received_damage_mult;
				uni_check_invul_limit_timeout = uni_CHECK_INVUL_LIMIT_TIMEOUT;
			#endif

			#ifdef MWP_SEARCH
				CLEAR(uni_ai_props);
				SC_P_Ai_GetProps(info->player, &uni_ai_props);
				uni_ai_props.mwp_search_dist = MWP_SEARCH;
				SC_P_Ai_SetProps(info->player, &uni_ai_props);
			#endif

			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			#ifdef MP_SEARCH_PLAYER
				MAX_SUP_clear_maintask(info->player); // muze se stat, ze nasleduje hrace, ktery se derespawnul -> FATAL SCRIPT ERROR
			#endif
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:
			#ifdef MP_SEARCH_PLAYER
				if (MP_timeout >= 0.0) {	//posle se zprava ostatnim zivym panakum, ze byl zabit
					MP_timeout -= info->elapsed_time;
					if (MP_timeout < 0.0) {
						MAX_MUL_send_message_to_group_count(PL_SIDE, PL_GROUP, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_AI_ONLY, MSG_MP_P_KILLED, 0);
					}
				}
				if (MP_maintask_timeout >= 0.0) {	//nastavi se mu maintask, aby sel hledat nejblizsi PC
					MP_maintask_timeout -= info->elapsed_time;
					if (MP_maintask_timeout < 0.0) {
						if (info->player == NULL) {SC_message("hups 1"); return 1;}  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
						if (!SC_P_GetStatus(info->player, &uni_status)) return 1; // pro pripad, ze by se to sem dostalo a nekdo ho derespawnul
						if (uni_status.hp <= 0.0) return 1; // pro pripad, ze by se to sem dostalo a on byl mrtvy
						#ifdef PENDL
							if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
							PL_PENDL_disable();
						#endif
						#ifdef MAINTASK
							PL_MAINTASK_disable();
							//SC_P_Ai_SetMainTask(info->player, NULL);
						#endif
						#ifdef MP_SEARCH_PLAYER_DIST
							MP_followed_player = MAX_MUL_set_maintask_to_follow_nearest_PC(info->player, (PL_SIDE == SC_P_SIDE_US) ? SC_P_SIDE_VC : SC_P_SIDE_US, 0, MP_SEARCH_PLAYER_DIST);
						#else
							MP_followed_player = MAX_MUL_set_maintask_to_follow_nearest_PC(info->player, (PL_SIDE == SC_P_SIDE_US) ? SC_P_SIDE_VC : SC_P_SIDE_US, 0, 0.0);
						#endif
						#ifdef MP_SEARCH_PLAYER_RETRY
							MP_maintask_timeout = MP_SEARCH_PLAYER_RETRY;
						#endif
					}
				}
			#endif
			switch(uni_gphase) {
			case 0:
				if (info->player == NULL) return 0;
				CLEAR(uni_status);
				if (!SC_P_GetStatus(info->player, &uni_status)) return 0;

				#ifdef PC_CONTROLLED
					if (!SC_P_Ai_GetScriptMode(info->player)) {
						SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_ENABLED);
						SC_P_Ai_TeamCmd_SetModeFollow(info->player);
					}
				#endif

				uni_gphase = 1;
				break;

			case 1:
#ifdef INVUL_LIMIT
				if (uni_check_invul_limit_timeout > 0.0) {
					uni_check_invul_limit_timeout -= info->elapsed_time;
					if (uni_check_invul_limit_timeout <= 0.0) {
						check_invul_limit(info);
					}
				}
#endif
#ifdef DERESPAWN_AFTER_KILLED
				if (MAX_SUP_count_timeout(&uni_derespawn_timeout, info->elapsed_time)) {
					if (MAX_SUP_get_hp(info->player) <= 0.0) MAX_SUP_send_message_to_player(info->player, MSG_DO_DERESPAWN, 0);
				}
#endif
				if (MAX_SUP_count_timeout(&uni_radio_stop_timeout, info->elapsed_time)) {
					uni_radio_speaking = FALSE;
					switch(uni_radio_stop_phase) {
					case 0:
						SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_STAND+CALLBACK_RADIO_STOP);
						MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s044.stg", 0.0, 0.1, CALLBACK_RADIO_STOP); //stejny call back jako zprava
						break;
					case 1:
						SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_CROUCH+CALLBACK_RADIO_STOP);
						MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s047.stg", 0.0, 0.1, CALLBACK_RADIO_STOP); //stejny call back jako zprava
						break;
					}
				}
				break;

			}
			break;

		case SC_PLSCR_MSG_PL_HIT:
			break;

		case SC_PLSCR_MSG_PL_KILLED:
#ifdef DERESPAWN_AFTER_KILLED
			uni_derespawn_timeout = DERESPAWN_AFTER_KILLED;
#endif
#ifdef MP_SEARCH_PLAYER
			MP_timeout = 2.0;	//pokud je player zabit, tak se posle za 2 s zprava ostatnim zivym panakum, ze byl zabit (je to v tiku)
			MP_maintask_timeout = -2.0;	//pokud mel hledaci maintask, tak se mu uz nezopakuje
#endif
			MP_followed_player = NULL;

			MAX_SUP_send_message_to_player(info->player, MSG_RADIO_RESET, 0);

			if (MAX_SUP_get_hp(info->player) == -1.0)
				SC_Speech_RemoveAll(TRUE);
			break;

		case SC_PLSCR_MSG_PL_HEALEDFROMCOMA:
#ifdef MP_SEARCH_PLAYER
			if (MP_maintask_timeout == -2.0) MP_maintask_timeout = 1.0;
#endif
			break;

		case SC_PLSCR_MSG_SCRIPT_MESSAGE:
			switch (info->param1) {
//---------------------------------------------------------
			case MSG_DO_RESPAWN:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_DO_RESPAWN] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				#ifdef RESPAWN_FLAGS
					MAX_SUP_respawn_player(info, RESPAWN_FLAGS);
				#else
					MAX_SUP_respawn_player(info, 0);
				#endif
				break;
//---------------------------------------------------------
			case MSG_DO_DERESPAWN:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_DO_DERESPAWN] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				MAX_SUP_derespawn_player(info->player);
				break;
//---------------------------------------------------------
			case MSG_SET_HP:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_SET_HP] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				MAX_SUP_set_hp(info->player, info->param2);
				break;
//---------------------------------------------------------
			case MSG_MP_P_KILLED:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MP_P_KILLED] - param1: %d | param2: %d | pocet: %d | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				#ifdef MP_SEARCH_PLAYER
					if (info->param3 <= MP_SEARCH_PLAYER) MP_maintask_timeout = abs(frnd(2.0)); // zacne se zadavat v casovych intervalech MT na hledani nejblizzsiho hrace
				#endif
				break;
//---------------------------------------------------------
			case MSG_PC_CONTROL_SET:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_SET_PC_CONTROL] - param1: %d | param2: %d | pocet: %d | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				#ifdef PC_CONTROLLED
					SC_P_Ai_TeamCmds_Set(info->player, info->param2);
				#endif
				break;
//---------------------------------------------------------
			case MSG_PC_CONTROL_FOLLOW:
				#ifdef MAX_SCRIPT_DEBUG
					SC_P_GetSideGroupMemberId(info->player, &uni_side, &uni_group, &uni_member_id);
					sprintf(_debug_tmp, "uni_soldier.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_PC_CONTROL_FOLLOW] - param1: %d | param2: %d | pocet: %d | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3, uni_side, uni_group, uni_member_id);
					SC_Log(3, _debug_tmp);
				#endif
				#ifdef PC_CONTROLLED
					MAX_SUP_clear_maintask(info->player);
					SC_P_Ai_SetScriptMode(info->player, FALSE);
					SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_ENABLED);
					SC_P_Ai_TeamCmd_SetModeFollow(info->player);
				#endif
				break;
//---------------------------------------------------------
			case MSG_PLAYER_KILLED: //nekdo byl zabit, musim zjistit jestli to nebyl ten koho mam v maintasku (MP_SEARCH)
				if (info->param2 == MP_followed_player) {
					MP_followed_player = NULL;
					MAX_SUP_clear_maintask(info->player);
#ifdef MP_SEARCH_PLAYER
					MP_maintask_timeout = abs(frnd(2.0)); // zacne se zadavat v casovych intervalech MT na hledani nejblizzsiho hrace
#endif
				}
				break;
//---------------------------------------------------------
			case MSG_PLAYER_FOLLOWING:
				MP_followed_player = info->param2;
				break;
//---------------------------------------------------------
			case MSG_FOLLOW_NEAREST_PC:
				MAX_SUP_clear_maintask(info->player);
				SC_P_Ai_SetScriptMode(info->player, FALSE);
				SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_DISABLED);
				if (info->param2 == 1)
					MAX_MUL_set_maintask_to_follow_PC_building(info->player, SC_PC_Get());
				else
					MAX_MUL_set_maintask_to_follow_PC(info->player, SC_PC_Get());

				break;
//---------------------------------------------------------
			case MSG_RADIO_BEGIN:
				SC_PreloadBES(ID_RADIOEAR, BES_RADIOEAR);
				SC_P_Eqp3pv_Add(info->player, 0, ID_RADIOEAR, EQP_RADIOEAR);

				uni_radio_speaking = TRUE;

				switch(info->param2) {
				case 0:
					MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s042.stg", 0.1, 0.0, CALLBACK_RADIO_BEGIN_STAND); //stejny call back jako zprava
					break;
				case 1:
					MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s045.stg", 0.1, 0.0, CALLBACK_RADIO_BEGIN_CROUCH); //stejny call back jako zprava
					break;
				}

				break;
//---------------------------------------------------------
			case MSG_RADIO_STOP:
				if (!uni_radio_speaking) break;

				if (info->param3 > 0.0) {
					uni_radio_stop_timeout = info->param3;
					uni_radio_stop_phase = info->param2;
					break;
				}

				uni_radio_speaking = FALSE;
				switch(info->param2) {
				case 0:
					SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_STAND+CALLBACK_RADIO_STOP);
					MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s044.stg", 0.0, 0.1, CALLBACK_RADIO_STOP); //stejny call back jako zprava
					break;
				case 1:
					SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_CROUCH+CALLBACK_RADIO_STOP);
					MAX_SUP_player_player_anim(info->player, "G\\Anims\\Specials\\s047.stg", 0.0, 0.1, CALLBACK_RADIO_STOP); //stejny call back jako zprava
					break;
				}

				break;
//---------------------------------------------------------
			case MSG_RADIO_RESET:
				if (!uni_radio_speaking) break;

				SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_STAND+CALLBACK_RADIO_STOP);
				SC_P_Stop3pvAnimLooped(info->player, CALLBACK_RADIO_BEGIN_CROUCH+CALLBACK_RADIO_STOP);

				uni_radio_speaking = FALSE;

				break;
//---------------------------------------------------------
			case MSG_DISABLE_STOP_ANIM:
				MAX_SUP_disable_stopig_anim(info->player);
				break;

			case MSG_ENABLE_STOP_ANIM:
				MAX_SUP_enable_stopig_anim(info->player);
				break;
			}
			break;
//---------------------------------------------------------
//---------------------------------------------------------
		case SC_PLSCR_MSG_ANIM_CALLBACK:
			switch(info->param1) {
			case CALLBACK_RADIO_BEGIN_STAND:
				SC_P_Play3pvAnimLooped(info->player, "G\\Anims\\Specials\\s043.stg", CALLBACK_RADIO_BEGIN_STAND+CALLBACK_RADIO_STOP);
				break;

			case CALLBACK_RADIO_BEGIN_CROUCH:
				SC_P_Play3pvAnimLooped(info->player, "G\\Anims\\Specials\\s046.stg", CALLBACK_RADIO_BEGIN_CROUCH+CALLBACK_RADIO_STOP);
				break;

			case CALLBACK_RADIO_STOP:
				SC_P_Eqp3pv_Remove(info->player, 0);
				break;
			}
			break;



		case SC_PLSCR_MSG_AI_TEAMCMD_VALIDATE:
			info->param1 = 1;
			if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE); // kdyby ho dal nekdo do scriptu
			break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)