// ************************************************************************************************************************ //
//																															//
//	File:			dBlocker.cxx																							//
//	Description:	Common Dynamic Blocker Script.																			//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//globals
BOOL	g_bEnabled = FALSE;
dword	g_hBlocker = 0;


//
int ScriptMain(s_SC_OBJ_info *info)
{
	switch(info->message)
	{
	case SC_OBJ_MSG_INIT:
		g_bEnabled = FALSE;
		g_hBlocker = 0;
		break;

	case SC_OBJ_MSG_RELEASE:
		break;

	case SC_OBJ_MSG_JUSTLOADED:
		break;

	case SC_OBJ_MSG_DOTICK:
		break;

	case SC_OBJ_MSG_MESSAGE:
		switch(info->param1)
		{
		case SCM_DB_ENABLE:
			if (info->param2)
			{
				g_hBlocker = SC_AI_Blocker_Add( SC_NOD_GetName(info->master_nod), NULL);
			}
			else if (g_hBlocker)
			{
				SC_AI_Blocker_Remove(g_hBlocker);
			}
			break;
		}
		break;


	default:
		return FALSE;
	}

	return TRUE;

}//int ScriptMain(s_SC_OBJ_info *info)
