//effects library

#ifndef SHIGOR_EFFECTS_LIBRARY
#define SHIGOR_EFFECTS_LIBRARY

#include <inc\sc_global.h>


//makes grenade like explosion in the centre of the nod
void GrenadeExpNOD(sc_nod NOD){
	s_SC_Expl_CreateInfo info;

	CLEAR(info);
	SC_NOD_GetWorldPos(NOD,&info.sph.pos);
	info.sph.rad=2;
	info.author_handle=0;
	info.damage=100;
	info.marok_impuls=300;
	info.piercing=10;
	info.ptc_id=199;
	SC_Explosion_Make(&info);
}

//makes grenade like explosion on specified pos
void GrenadeExpPos(c_Vector3 pos){
	s_SC_Expl_CreateInfo info;

	CLEAR(info);
	info.sph.pos=pos;
	info.sph.rad=2;
	info.author_handle=0;
	info.damage=100;
	info.marok_impuls=300;
	info.piercing=10;
	info.ptc_id=199;
	SC_Explosion_Make(&info);
}

//makes grenade like explosion in the centre of the nod specified by name
void GrenadeExpName(char *name){
	s_SC_Expl_CreateInfo info;

	CLEAR(info);
	SC_NOD_GetWorldPos(SC_NOD_Get(NULL,name),&info.sph.pos);
	info.sph.rad=2;
	info.author_handle=0;
	info.damage=100;
	info.marok_impuls=300;
	info.piercing=10;
	info.ptc_id=199;
	SC_Explosion_Make(&info);
}


/*
//makes this smoke in the centre of the nod

void NOD_Smoker(sc_nod NOD){
	SC_CreatePtc_Ext(181,NOD,10000,1,1,1);
}
*/











#endif