//#define MAX_SCRIPT_DEBUG

#ifndef SC_GLOBAL_H
#include <inc\sc_global.h>
#endif

#ifndef MAX_DEFS_H	//az na konec scriptu !!!!
#define MAX_DEFS_H

#define MAX_INFINITE_TIME	0xffff

#define SC_P_SIDE_NEUTRAL_US	(SC_P_SIDE_US|0x10)
#define SC_P_SIDE_NEUTRAL_VC	(SC_P_SIDE_VC|0x20)

#define MAX_STRING_LEN		32
#define MAX_STRING_LEN_LONG	64

#define MAX_PLAYERS			64

#define	PL_ID_KULAS			1
#define	PL_ID_MEDIK			2
#define	PL_ID_ING			3
#define	PL_ID_RADIO			4

#define LEWIS_NR			2705
#define RIGLEY_NR			2708
#define USMC_NR				2728

#define CMD_CALL_INZENYR		0x3
#define CMD_CALL_MEDIK			0x4

#define	ANIM_NONE		0
#define	ANIM_ONCE		1
#define	ANIM_LOOP		2

/*#define ICON_OBJ_PRIMARY1		"G\\mp\\iconsjp_primary_a"
#define ICON_OBJ_PRIMARY2		"G\\mp\\iconsjp_primary_b"
#define ICON_OBJ_FINAL			"G\\mp\\iconsjp_final"*/

#define ANIM_PLACING_3PV	"G\\Anims\\Specials\\s009.stg"
#define ANIM_PLACING_FPV	"G\\Anims\\Specials\\s009.stg"
#define ANIM_DEFUSING_3PV	"G\\Anims\\Specials\\s010.stg"
#define ANIM_DEFUSING_FPV	"G\\Anims\\Specials\\s010.stg"

#define MSG_HINT_SHOW			450

#define MSG_DISABLE_STOP_ANIM	611
#define MSG_ENABLE_STOP_ANIM	612

#define MSG_PC_CONTROL_FOLLOW	298
#define MSG_PC_CONTROL_SET		299
// ----------- RESPAWNING MAINTASK------------- //
#define MSG_DO_RESPAWN			301
#define MSG_DO_DERESPAWN		302
#define MSG_STOP_RESPAWNING		303
// ------------ RESPAWNING MOVEAT ------------- //
#define	CALLBCK_MOVEAT_FINISHED	320
// ---------------- MAINTASK ------------------ //
#define MSG_MAINTASK_ADD_PC		310
#define MSG_MAINTASK_REMOVE_PC	311
#define MSG_MAINTASK_RESUME		312
#define MSG_MAINTASK_SET		313
#define MSG_MAINTASK_NEXT		314
#define MSG_MAINTASK_STOP		315
#define MSG_MAINTASK_TELEPORT	316
#define MSG_FOLLOW_NEAREST_PC	317
// ------------------- PENDL ------------------ //
#define MSG_PENDL_NEXT			370
#define MSG_PENDL_SET			371
#define MSG_PENDL_RESUME		372
#define MSG_PENDL_STOP			373
// ----------------- MT +PENDL ---------------- //
#define MSG_MT_PENDL_PAUSE		379
// ------------------- MANM ------------------- //
#define MSG_MANM_CALL_BACK		340
#define MSG_MANM_STOP			341
#define MSG_MANM_RESUME			342
#define MSG_MANM_CHANGE_INDEX	343
#define MSG_MANM_CHANGE_CALLBACK 344
#define MSG_MANM_RESTART		345
#define MSG_MANM_FINISHED		349
// ---------------- SC_HELPER ----------------- //
#define MSG_SC_HELPER_ENABLE	350
#define MSG_SC_HELPER_DISABLE	351
#define MSG_SC_HELPER_REINIT	352
#define MSG_SC_HELPER_ALL_DEATH	353
// ----------------- OTHERS ------------------ //
#define MSG_SET_HP				360 //HP pro hrace
#define MSG_OBJECT_USED			361
#define MSG_OBJECT_EXPLODED		362
#define MSG_OBJECT_SET_VEH_MP	363	
// ---------------- UNI_DESTR ----------------- //
#define MSG_UNI_DESTR_SET		330	//param2 je nod, na ktery se to ma prepnout
#define MSG_UNI_DESTR_USE		331	//param2 je pl_id hrace (muze byt NULL)
#define MSG_UNI_DESTR_USE_MP	332	//param2 je pl_id hrace (muze byt NULL)
#define MSG_UNI_REINIT			333
#define MSG_UNI_RESPAWN			334
#define MSG_UNI_DESTR_SET_HP	335
#define MSG_UNI_DESTR_ADD_HP	336
#define MSG_UNI_C4				337
// --------------- MULTIPLAYER ---------------- //
#define MSG_PLAYER_KILLED		400
#define MSG_PLAYER_FOLLOWING	401
#define MSG_MP_P_KILLED			380
#define MSG_WEAP_PICK_UP		390
#define MSG_WEAP_SET			391
#define MSG_AMMO_PICK_UP		392
#define MSG_AMMO_SET			393
// ------------------ ZVUKY ------------------- //
#define MSG_SND_EMITOR_STOP		600
#define MSG_SND_EMITOR_START	601
// ------------------ RADIO ------------------- //
#define MSG_RADIO_BEGIN			605
#define MSG_RADIO_STOP			606
#define MSG_RADIO_RESET			607
#define CALLBACK_RADIO_BEGIN_STAND	608
#define CALLBACK_RADIO_BEGIN_CROUCH	609
#define CALLBACK_RADIO_STOP			610
// ---------------- UNI_DESTR ----------------- //
#define HIT_BY_DISABLED			0x00
#define HIT_BY_MISSILE			SC_OBJSCRIPT_FL_HITMISSILE
#define HIT_BY_EXPLOSION		SC_OBJSCRIPT_FL_HITEXPLOSION
#define HIT_BY_MAROK			SC_OBJSCRIPT_FL_HITMAROK
#define HIT_BY_PLAYER			SC_OBJSCRIPT_FL_HITPLAYER
#define HIT_BY_C4				0x100
#define HIT_BY_USED				0x200
#define HIT_BY_MWP				0x400

#define EXPL_TYPE_EXPLOSION		0x01
#define EXPL_TYPE_FIRE_FLY		0x02
#define EXPL_TYPE_FIRE_GRND		0x04
#define EXPL_TYPE_HIT			0x08
#define EXPL_TYPE_SMOKE			0x10
// ---------------- OPERATION ----------------- //
#define	OPERATION_NONE			0
#define	OPERATION_PLUS			1
#define	OPERATION_MUL			2
#define	OPERATION_MINUS			3
// ---------------- TYPY EXPLOZI -------------- //
// -4b script type -> 12b radius -> 16b damage- //
// ---z damage se pocita i impuls = damage ---- //
#define EXPLOSION_NONE			0x00000000

#define EXPLOSION_GRENADE		0x10050100
#define EXPLOSION_MORTAR		0x20070130
#define EXPLOSION_BAREL			0x30070150
#define EXPLOSION_C4			0x40070500

#define EXPLOSION_SMALL			0x00040100
#define EXPLOSION_MEDIUM		0x00070150
#define EXPLOSION_BIG			0x000A0200
// ------------------ GAMEPLAY -----------------//
#define MAX_WEAPONS				10

#define CLASS_FIGHTER			0x01
#define CLASS_SOLDIER_SHORT		0x02
#define CLASS_SOLDIER_LONG		0x03
#define CLASS_SOLDIER_XLONG		0x04
#define CLASS_SNIPER			0x05
#define CLASS_LIGHT_GUNNER		0x06
#define CLASS_HEAVY_GUNNER		0x07
#define CLASS_DEMOLISHER		0x08
#define CLASS_BAZOOKER			0x09
#define CLASS_KULAS				0x10
#define CLASS_MEDIK				0x11
#define CLASS_INZENYR			0x12
#define CLASS_RADIO				0x13

#define CLASS_CIVILIAN			0x20

#define CLASS_TEAMLEADER		0x30

#define CLASS_RANDOM_NORMAL		0xA0
#define CLASS_RANDOM_HEAVY		0xA1
#define CLASS_RANDOM_DEMOLISH	0xA2

#define CLASS_USER_DEFINED		0xFF

// ---------------- MULTIPLAYER ----------------//
#define GLOBAL_GAME_DIFFICULTY	1000

#define GAME_TYPE_DM			1
#define GAME_TYPE_TDM			2
#define GAME_TYPE_COOP			3
#define GAME_TYPE_CTF			4
#define GAME_TYPE_ASSAULT		5
#define GAME_TYPE_SAD			6
#define GAME_TYPE_JS			7

#define GAME_TYPE_DM_NAME		"DM"
#define GAME_TYPE_TDM_NAME		"TDM"
#define GAME_TYPE_COOP_NAME		"COOP"
#define GAME_TYPE_CTF_NAME		"CTF"
#define GAME_TYPE_ASSAULT_NAME	"ASSAULT"
#define GAME_TYPE_SAD_NAME		"SAD"
#define GAME_TYPE_JS_NAME		"JS"

#define MSG_MUL_ADD_OBJECT		500
#define MSG_MUL_REQ_OBJECT_INFO	501
#define MSG_MUL_START_SYNCHRO	502
#define MSG_MUL_STOP_SYNCHRO	503
#define MSG_MUL_RESTART			504
#define MSG_MUL_SET_GAME_PHASE	505

#define MSG_MUL_LEAD_YOU_BEST	510
#define MSG_MUL_LEAD_PL_ID_BEST	511
#define MSG_MUL_LEAD_YOU_LOST	512
#define MSG_MUL_LEAD_PL_ID_LOST	513
#define MSG_MUL_LEAD_TAKE_TEAM1	514
#define MSG_MUL_LEAD_TAKE_TEAM2	515
#define MSG_MUL_LEAD_LOST_TEAM1	516
#define MSG_MUL_LEAD_LOST_TEAM2	517

#define MSG_MUL_BOMB_YOU		520
#define MSG_MUL_BOMB_PLAYER		521

#define MSG_MUL_YOU_TAKE_FLAG		530
#define MSG_MUL_PL_ID_TAKE_FLAG_E	531
#define MSG_MUL_PL_ID_TAKE_FLAG_A	532
#define MSG_MUL_YOU_DROP_FLAG		533
#define MSG_MUL_PL_ID_FROP_FLAG_E	534
#define MSG_MUL_PL_ID_FROP_FLAG_A	535
#define MSG_MUL_YOU_RETURN_FLAG		536
#define MSG_MUL_PL_ID_RETURN_FLAG_E	537
#define MSG_MUL_PL_ID_RETURN_FLAG_A	538
#define MSG_MUL_TIME_RETURN_FLAG_E	539
#define MSG_MUL_TIME_RETURN_FLAG_A	540
#define MSG_MUL_YOU_SCORE_FLAG		541
#define MSG_MUL_PL_ID_SCORE_FLAG_E	542
#define MSG_MUL_PL_ID_SCORE_FLAG_A	543

#define MSG_MUL_PL_ID_KILL_FLAG		544
#define MSG_MUL_PL_ID_KILL_FLAG_CARRY 545

#define MSG_GET_RESPAWN				555
#define MSG_LOST_RESPAWN			556

#define MSG_MUL_ASSAULT_SWAP		557

//#define MSG_MP_TO_OBJECT		201
//#define MSG_MP_TO_OBJECT2		202
// ---------------- OBJECT STATE ---------------//
#define STATE_INIT				0
#define STATE_PLACING			1
#define STATE_ACTIVE			2
#define STATE_DEFUSING			3
#define STATE_DEFUSED			4
#define STATE_DESTROYED			5
// -------------- OBJECT STATE CTF -------------//
#define STATE_IN_BASE			0
#define STATE_STOLEN			10
#define STATE_DROPPED			11

#define HUD_ICON_CLOCKS				8
#define HUD_ICON_C4					16

#define HUD_ICON_FLAG_INBASE_US		6
#define HUD_ICON_FLAG_INBASE_VC		3

#define HUD_ICON_FLAG_STOLEN_US		7
#define HUD_ICON_FLAG_STOLEN_VC		4

#define HUD_ICON_FLAG_DROPPED_US	20
#define HUD_ICON_FLAG_DROPPED_VC	19

//#define STATE_RETURNED			12
//#define STATE_SCORED			13

typedef struct {
	c_Vector3	point;
	char		anim[MAX_STRING_LEN];
	dword		anim_type;
	float		wait;
	BOOL		leave_script;
	c_Vector3	look_dir; //smer kam se ma divat az dojde na point
	float		look_time; // pokud je 0.0, tak se pouzije wait

	BOOL		ignore_speak; //aby necekal az domluvi
}s_pendl;

typedef struct {
	char			name[MAX_STRING_LEN];
	sc_nod			target;
	s_SC_Area		target_area;
	c_BoxOriented	target_box;
	s_sphere		target_sphere;
	dword			coop_id;
	float			step;
	dword			flags;
	float			wait;
	float			last_perc_in_group_moves;
	float			max_pc_distance;

	float			search_dist;		// kdyz == 0, tak default_main_task
	float			search_z_dist;

	dword			pc_id;
	dword			pl_handle;

	float			max_target_pl_dist;

	float			nextmove_interval, nextmove_interval_rand;

	float			refresh_time;

	BOOL			ignore_speak; //aby necekal az domluvi
}s_maintask;

typedef struct {
	dword group, member_id;

	s_SC_P_CreateWeap *weap;
	dword weap_count;

	dword flags;

	char *inifile;
	char *eqp_inifile;
	char *head_name;
	char *head_eqp_inifile;

	dword name_nr;

	BOOL blocker;
	BOOL death_comma;

}s_create_player;
//----------------------------------------------------------------
typedef struct {
	dword	side;
	dword	reinit;
} s_MAX_RULE_data;

typedef struct {
	dword	state;		// stav objektu
	float	timer;		// tikani bomby napr.
	dword	side;		// strana, ktera muzes s objektem manipulovat
	dword	pl_handle;	// kdo polozil bombu napr.
	BOOL	update;		// updatni status na klientech v kazdem tiku
} s_MAX_MUL_object_status;

typedef BOOL (*p_fce)(s_MAX_RULE_data *MAX_RULE_data);
typedef int  (*p_fce_main)(s_SC_OBJ_info *info, ...);
typedef int  (*p_fce_mul)(s_SC_ModeScript_info *info, ...);
//typedef BOOL (*p_fce_winning_rule)(s_MAX_RULE_data *MAX_RULE_data);
//typedef BOOL (*p_fce_respawn_rule)(s_MAX_RULE_data *MAX_RULE_data);
//----------------------------------------------------------------
//----------------------------------------------------------------
char *GetUSRndIni() {
	switch (rand()%1) {
		case 0: return "default_AIUS"; break;
	}
	return "default_AIUS";
}

#define	MAX_WEAPS	4
dword us_weap[MAX_WEAPS] = {1,11,17,21};

int GetUSRndWeapon()
{
	return us_weap[ rand()%MAX_WEAPS ];
}

float abs(float num) {
	if (num > 0) return num; else return -num;
}

float sqr(float num) {
	return num*num;
}

int	strlen(char *str) {
	/*int		i;

	for (i=0; i<255; i++)
		if (str[i] == 0) return i;

	return -1;*/
	return sprintf(str, str);
}

int strcpy(char *dest, char *source) {
	int		i;

	for (i=0; i<strlen(source); i++)
		dest[i] = source[i];

	dest[i] = 0;

	return i;
}

void to_upcase(char *str) {
	int		i;

	for (i=0; i<strlen(str); i++)
		str[i] >= 'a' ? str[i] -= 'a'-'A' : str[i];
}

void MAX_UNI_set_explosion_force(s_SC_Expl_CreateInfo *expl_info, dword typ) {
	if (typ ==  0) return;
	if (typ == -1) {
		SC_message("!max_defs.h - MAX_UNI_set_explosion_force() - sila == -1");
		return;
	}
	expl_info->piercing = (typ & 0x0000FFFF) / 10.0;
	expl_info->damage =    typ & 0x0000FFFF;
	if (expl_info->damage > 2000.0) {
		SC_message("!max_defs.h - MAX_UNI_set_explosion_force - moc velka sila == %f", expl_info->damage);
	}
	expl_info->sph.rad =  (typ & 0x0FFF0000) >> 16;
	expl_info->marok_impuls = expl_info->damage/* * 0.5*/;
	expl_info->script_type = typ >> 28; // prvni byte pouze
}

#ifdef MAX_SCRIPT_DEBUG
char	_debug_tmp[255];
#endif

#endif //#ifndef MAX_DEFS_H