//#include <inc\maxovo\!max_support.h>
#ifdef MAX_SCRIPT_DEBUG // az do konce +-

#define WAIT_FOR_NEXT_KEY	2.0

float	time_out;

char	key_buffer[BUFFER_LEN];
int		pos_in_key_buffer;

//char	tmp_buf[255];

BOOL	system_is_on;

int MAX_KEY_derespawn_all(s_SC_ScriptHelper_info *info) {
	int			num, i;
	sc_player	list[255]; //vyjimka - protoze to je fakt pro fsechny playery

	num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, 255, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY);
	for (i=0; i<num; i++)
		SC_P_Derespawn(list[i]);

	return TRUE;
}

int MAX_KEY_replace_all_players(s_SC_ScriptHelper_info *info) {
	dword		hide_out;
	int			num, i;
	sc_player	list[255]; //vyjimka - protoze to je fakt pro fsechny playery

	s_sphere	sphere;
	s_SC_Area	area;
	c_Vector3	vec;

	MAX_SUP_prepare_area(&area, &sphere, NULL);
	area.sphs = 1;

	num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, 255, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY);
	for (i=0; i<num; i++) {
		MAX_SUP_player_get_pos(list[i], &sphere.pos);
		sphere.pos.z = 0.0;
		sphere.rad = 2.0;
		do {
			hide_out = SC_GetRndHideout(&area, 0, &vec);
			sphere.rad *= 2.0;
		} while ((hide_out == 0) && (sphere.rad < 2000.0));
		//if (!MAX_SUP_get_area_sc_helper(maintask[PL_MAINTASK_current_maintask].name, &PL_MAINTASK_area)) break;
		
		if (hide_out) {
			SC_P_SetPos(list[i], &vec, NULL, NULL);
		} else {
			dword	side, group, member_id;
			SC_P_GetSideGroupMemberId(list[i], &side, &group, &member_id);
			SC_message("nepodarilo se nalest HO pro %d/%d/%d", side, group, member_id);
		}
	}
	return TRUE;
}

int MAX_KEY_finish_all_maintasks(s_SC_ScriptHelper_info *info) {
	MAX_SUP_send_message_to_group(SC_P_SIDE_ALL, SC_P_GROUP_ALL, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_AI_ONLY, MSG_MAINTASK_TELEPORT, 0);
	return TRUE;
}

int MAX_KEY_stop_moving(s_SC_ScriptHelper_info *info) {
	int			num, i;
	sc_player	list[255]; //vyjimka - protoze to je fakt pro fsechny playery

	num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, 255, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY|SC_ENUMPLS_FL_ALIVEONLY);
	for (i=0; i<num; i++) 
		SC_P_Ai_StopMoving(list[i]);

	return TRUE;
}

#endif

int ScriptMain(s_SC_ScriptHelper_info *info) {

#ifndef MAX_SCRIPT_DEBUG //ndef
	if (info->event_type == SC_SCRHELPER_EVENTTYPE_TIMETICK) info->next_exe_time = -1.0;
#else
	int		i;

	switch (info->event_type) {
	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		MAX_KEY_init_fce(); // je to v hlavnim scriptu
		break;

	case SC_SCRHELPER_EVENTTYPE_INIT:
		MAX_KEY_init_fce(); // je to v hlavnim scriptu
#ifdef MAX_SCRIPT_DEBUG
		info->next_exe_time = 0.0;
#else
		info->next_exe_time = -1.0;
#endif
		time_out = -1.0;
		pos_in_key_buffer = 0;
		system_is_on = FALSE;
		break;

	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		if (time_out > 0.0) {
			time_out -= info->elapsed_time;
			if (time_out <= 0.0) {
				for (i=0; i<FUNCTIONS_COUNT; i++) {
					if (SC_StringSame(keys_buffer[i], key_buffer)) functions_buffer[i](info);
				}
				pos_in_key_buffer = 0;
				system_is_on = FALSE;
			}
		}

		if (!system_is_on) {
			if (SC_KeyJustPressed(44)) {
				system_is_on = TRUE;
				time_out = WAIT_FOR_NEXT_KEY;
			}
			return TRUE;
		}

		for (i=0; i<=255; i++) {
			if (SC_KeyJustPressed(i)) {
				if (pos_in_key_buffer < BUFFER_LEN-1) {
					key_buffer[pos_in_key_buffer] = i;
					pos_in_key_buffer++;
					key_buffer[pos_in_key_buffer] = 0;
					time_out = WAIT_FOR_NEXT_KEY;
				}
			}
		}

		sprintf(_debug_tmp, "key_buffer: ");
		for (i=0; i<pos_in_key_buffer; i++) {
			sprintf(_debug_tmp, "%s %d,", _debug_tmp, (int)key_buffer[i]);
		}
		SC_Osi(_debug_tmp);

		break;
	}
#endif


	return TRUE;
}