/*#ifndef MAX_MULTIPLAYER_CXX //az na konec scriptu !!!!
#define MAX_MULTIPLAYER_CXX*/

#include <inc\maxovo\!max_multiplayer.h>

#define MAX_MUL_REM_TIME_COUNT 4
dword	MAX_MUL_remaining_time[MAX_MUL_REM_TIME_COUNT][3] = {	180,	1695,	0,
																120,	1696,	0,
																 60,	1697,	0,
																 30,	1698,	0	};

int		MAX_MUL_old_remaining_time;

int					g_i, g_j;

sc_player			MAX_MUL_local_player;
dword				MAX_MUL_local_pl_handle;

BOOL				MAX_MUL_is_server = FALSE;

int					SRV_CLN_objectives_count = 0;

dword	original_SIDE1 = SIDE1;
dword	original_SIDE2 = SIDE2;

#ifdef GROUPS_COUNT_SIDE2
	#define ALL_GROUPS_COUNT	(GROUPS_COUNT_SIDE1+GROUPS_COUNT_SIDE2)
	s_MAX_MUL_respawn	MAX_MUL_respawn[GROUPS_COUNT_SIDE1+GROUPS_COUNT_SIDE2];
#else
	#define ALL_GROUPS_COUNT	(GROUPS_COUNT_SIDE1)
	s_MAX_MUL_respawn	MAX_MUL_respawn[GROUPS_COUNT_SIDE1];
#endif

#ifdef CHECK_SIDES_READY_COUNT
	BOOL				SRV_sides_ready = FALSE;
	BOOL				CLN_sides_ready = FALSE;
#endif

#ifdef OBJECTS_COUNT
	//int						MAX_MUL_object_count;
	s_MAX_MUL_object		MAX_MUL_object[OBJECTS_COUNT];
	//s_MAX_MUL_object_status	SRV_object_status[OBJECTS_COUNT],	CLN_object_status[OBJECTS_COUNT];
	//float					CLN_show_object_timeout[OBJECTS_COUNT];
	dword					SRV_old_object_state[OBJECTS_COUNT];
	dword					CLN_old_object_state[OBJECTS_COUNT];
	BOOL					SRV_CLN_object_is_initialized = FALSE;
#endif

dword					CLN_rank;

float					SRV_check_round_end_timer;
float					SRV_reinforcements_timer,			CLN_reinforcements_timer;
float					SRV_reinforcements_timer_update;
float					SRV_game_time,						CLN_game_time;
float					SRV_game_time_update;
float					SRV_round_time,						CLN_round_time;
float					SRV_round_time_update;
dword					SRV_game_phase,						CLN_game_phase;
int						SRV_winning_side,					CLN_winning_side;

BOOL					CLN_phase_changed;
dword					CLN_current_player_side = -1; //bacha je to dword

float					SRV_status_mode_timeout = -1.0;
//BOOL					CLN_waiting_to_respawn;

s_respawning			MAX_MUL_respawn_array[MAX_MUL_PLAYERS];
dword					MAX_MUL_respawn_count;

s_reinforcements		MAX_MUL_reinforcements_array[MAX_MUL_PLAYERS];
dword					MAX_MUL_reinforcements_count;

#ifdef WINNING_RULES_SIDE1_COUNT
BOOL MAX_MUL_winning_rules_side1_result[WINNING_RULES_SIDE1_COUNT];
#endif

#ifdef WINNING_RULES_SIDE2_COUNT
BOOL MAX_MUL_winning_rules_side2_result[WINNING_RULES_SIDE2_COUNT];
#endif

void MAX_MUL_respawn_group_remove(s_MAX_MUL_respawn *respawn, dword respawn_id);
BOOL MAX_MUL_get_best_player(dword *pl_handle, int *points);

void MAX_MUL_set_difficulty() {
	dword	data;
	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_DIFFICULTY, &data)) {
		SC_sgi(GLOBAL_GAME_DIFFICULTY, data);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reset_objectives() {
	int i;

	for (i=1; i<=SRV_CLN_objectives_count; i++)
		SC_MP_Map_ChangeObjectiveStatus(i, FALSE);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_remaining_time_tick(float time) {
	dword	data;
	//BOOL	result;
	/*if (GAME_TYPE == GAME_TYPE_ASSAULT) {
		result = MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data);
	} else {
		result = MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data);
	}
	if (result) {*/
	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {
		if (MAX_MUL_old_remaining_time-0.3 > data*60.0-time) {
			MAX_MUL_old_remaining_time = data*60.0-time;
			if (MAX_MUL_old_remaining_time <= 10.0) {
				ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
				ushort	help[MAX_STRING_LEN_LONG*2];

				swprintf(tmp_ustr, SC_AnsiToUni("%d", help), (int)(MAX_MUL_old_remaining_time+0.9));
				SC_HUD_AddStateText(tmp_ustr, 0.3, 0.9, 0xFFFFFF00, 0);
			} else {
				int	i;

				for (i=0; i<MAX_MUL_REM_TIME_COUNT; i++) {
					if (MAX_MUL_remaining_time[i][0] > data*60.0) {
						MAX_MUL_remaining_time[i][2] = 1;
						continue;
					}
					if ((MAX_MUL_old_remaining_time < MAX_MUL_remaining_time[i][0]) && (MAX_MUL_remaining_time[i][2] == 0)) {
						SC_HUD_AddStateText(SC_Wtxt(MAX_MUL_remaining_time[i][1]), HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFF00, 0);
						MAX_MUL_remaining_time[i][2] = 1; // TRUE
					}
				}

			}
		}

	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_map_shortinfo(s_SC_ModeScript_info *info){
	// info->param1 is index <0,2>
	// info->param2 is (ushort*) to be filled
	ushort	help[256];
	dword	data, value1, value2;

	switch(info->param1){
		case 0:// end rule time
			if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {

				swprintf((ushort *)info->param2, SC_AnsiToUni("%s: ", help), SC_Wtxt(1609)); //time
				//SC_AnsiToUni("Time: ",(ushort*)info->param2);

				swprintf((ushort *)info->param3,
					SC_AnsiToUni("%02d:%02d (%02d:00)",help),
						(dword)(CLN_game_time/60.0f),((dword)CLN_game_time)%60, data);
			}
			break;

		case 1:// end rule score
			if ((GAME_TYPE == GAME_TYPE_DM) || (GAME_TYPE == GAME_TYPE_COOP)) {
				if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_SCORE, &data)) {
					dword	tmp_handle;
					//SC_AnsiToUni("Score: ",(ushort*)info->param2);
					swprintf((ushort *)info->param2, SC_AnsiToUni("%s: ", help), SC_Wtxt(1610)); //score

					if (SC_MP_GetHighestPointsPlayer(&tmp_handle, &value1)) {
						//value2 = data;
						swprintf((ushort *)info->param3,
							SC_AnsiToUni("%d (%d)",help),
							value1,data);
					}
				}
			} else if (GAME_TYPE == GAME_TYPE_ASSAULT) {
				if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data)) {
					swprintf((ushort *)info->param2, SC_AnsiToUni("%s: ", help), SC_Wtxt(1609)); //time
					//SC_AnsiToUni("Time: ",(ushort*)info->param2);
	
					swprintf((ushort *)info->param3,
						SC_AnsiToUni("%02d:%02d (%02d:00)",help),
							(dword)(CLN_round_time/60.0f),((dword)CLN_round_time)%60, data);
				}
			} else {
				if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TEAMSCORE, &data)) {
					//SC_AnsiToUni("Score:",(ushort*)info->param2);
					swprintf((ushort *)info->param2, SC_AnsiToUni("%s: ", help), SC_Wtxt(1610)); //score

					value1 = SC_MP_Side_GetPoints(SC_P_SIDE_US);
					value2 = SC_MP_Side_GetPoints(SC_P_SIDE_VC);
					swprintf((ushort *)info->param3,
						SC_AnsiToUni("US: %d VC: %d (%d)",help),
						value1, value2, data);

					//swprintf((ushort *)info->param3, SC_AnsiToUni("%s: %d %s: %d (%d)", help), SC_Wtxt(xxx), value1, SC_Wtxt(xxx), value2, data); //score
				}
			}
			break;

		case 2:// reinforcements
			if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data)) {
				//SC_AnsiToUni("Reinforcements: ",(ushort*)info->param2);
				swprintf((ushort *)info->param2, /*SC_AnsiToUni("%s: ", help),*/ SC_Wtxt(1611)); //reinfo

				swprintf((ushort *)info->param3,
					SC_AnsiToUni("%02d:%02d",help),
					(dword)((CLN_reinforcements_timer+0.9)/60.0), ((dword)(CLN_reinforcements_timer+0.9))%60);
			}
			break;
	}// switch(info->param1)


}// void _GetMap_ShortInfo(s_SC_ModeScript_info *info)
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_side_stats(s_SC_ModeScript_info *info){
	ushort help[256];

	switch(info->param1) {
	case 0:
		if (SIDE1 == SC_P_SIDE_US)
			SC_AnsiToUni("US: %d", help);
		else
			SC_AnsiToUni("VC: %d", help);

		swprintf((ushort*)info->param2, help ,SC_MP_Side_GetPoints(SIDE1));
		break;
	case 1:
		if (SIDE2 == SC_P_SIDE_US)
			SC_AnsiToUni("US: %d", help);
		else
			SC_AnsiToUni("VC: %d", help);

		swprintf((ushort*)info->param2, help, SC_MP_Side_GetPoints(SIDE2));
		break;
	}// switch(info->param1)


}// void _GetSide_Stats(s_SC_ModeScript_info *info)
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_CLN_handle_message(s_SC_ModeScript_info *info) {
	char	tmp_str[MAX_STRING_LEN_LONG];
	ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
	ushort	help[MAX_STRING_LEN_LONG*2];
	float	x;

	//SC_GetScreenRes(&x, NULL);
	//x /= 2.0;

	switch(info->param1) {
	//------------------------------------------------------------------------------------
	case MSG_MUL_LEAD_YOU_BEST:
		//sprintf(tmp_str, "You take the lead");
		swprintf(tmp_ustr, SC_Wtxt(1612));
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFF0030FF, 0);
		break;

	case MSG_MUL_LEAD_PL_ID_BEST:
		//sprintf(tmp_str, "%s take's the lead", tmp_str);
		{
			sc_player	player;

			player = MAX_SUP_get_pl_id_from_handle(info->param2);
			if (player) {
				SC_P_GetName(player, tmp_str, NULL);
				SC_AnsiToUni(tmp_str, help);
				swprintf(tmp_ustr, SC_Wtxt(1613), help);
				SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
			}
		}
		break;

	case MSG_MUL_LEAD_YOU_LOST:
		//sprintf(tmp_str, "You lost the lead");
		swprintf(tmp_ustr, SC_Wtxt(1614));
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF0000, 0);
		break;

	case MSG_MUL_LEAD_PL_ID_LOST:
		//sprintf(tmp_str, "%s lost's the lead", tmp_str);
		{
			sc_player	player;

			player = MAX_SUP_get_pl_id_from_handle(info->param2);
			if (player) {
				SC_P_GetName(player, tmp_str, NULL);
				SC_AnsiToUni(tmp_str, help);
				swprintf(tmp_ustr, SC_Wtxt(1615), help);
				SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
			}
		}
		break;
	//------------------------------------------------------------------------------------
	case MSG_MUL_LEAD_TAKE_TEAM1:
		//sprintf(tmp_str, "%s take's the lead", (SIDE1==SC_P_SIDE_US)?"US Army":"Ting-Tong");
		SC_AnsiToUni(tmp_str, help);
		swprintf(tmp_ustr, SC_Wtxt(1616), (SIDE1==SC_P_SIDE_US)? SC_Wtxt(1620) : SC_Wtxt(1621) );
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
		break;

	case MSG_MUL_LEAD_TAKE_TEAM2:
		//sprintf(tmp_str, "%s take's the lead", (SIDE2==SC_P_SIDE_US)?"US Army":"Ting-Tong");
		SC_AnsiToUni(tmp_str, help);
		swprintf(tmp_ustr, SC_Wtxt(1616), (SIDE2==SC_P_SIDE_US)? SC_Wtxt(1620) : SC_Wtxt(1621) );
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
		break;

	case MSG_MUL_LEAD_LOST_TEAM1:
		//sprintf(tmp_str, "%s lost's the lead", (SIDE1==SC_P_SIDE_US)?"US Army":"Ting-Tong");
		SC_AnsiToUni(tmp_str, help);
		swprintf(tmp_ustr, SC_Wtxt(1656), (SIDE1==SC_P_SIDE_US)? SC_Wtxt(1620) : SC_Wtxt(1621) );
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
		break;

	case MSG_MUL_LEAD_LOST_TEAM2:
		//sprintf(tmp_str, "%s lost's the lead", (SIDE2==SC_P_SIDE_US)?"US Army":"Ting-Tong");
		SC_AnsiToUni(tmp_str, help);
		swprintf(tmp_ustr, SC_Wtxt(1656), (SIDE2==SC_P_SIDE_US)? SC_Wtxt(1620) : SC_Wtxt(1621) );
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
		break;
	//------------------------------------------------------------------------------------
	case MSG_MUL_BOMB_YOU:
		//sprintf(tmp_str, "You have the bomb");
		swprintf(tmp_ustr, SC_Wtxt(1617));
		SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF1000, 0);
		break;

	case MSG_MUL_BOMB_PLAYER:
		//sprintf(tmp_str, "%s has the bomb", tmp_str);
		{
			sc_player	player;

			player = MAX_SUP_get_pl_id_from_handle(info->param2);
			if (player) {
				SC_P_GetName(player, tmp_str, NULL);
				SC_AnsiToUni(tmp_str, help);
				swprintf(tmp_ustr, SC_Wtxt(1618), help);
				SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF9000, 0);
			}
		}
		break;
	//------------------------------------------------------------------------------------
	case MSG_GET_RESPAWN:
		SC_HUD_AddStateText(SC_Wtxt(1920), HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFF00, 0);
		break;
	case MSG_LOST_RESPAWN:
		SC_HUD_AddStateText(SC_Wtxt(1921), HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF0000, 0);
		break;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_check_best_player_score(BOOL disconnecting) {
	dword	pl_handle;
	int		points;

	pl_handle = MAX_MUL_PLAYERS; //pouziti promenne na neco jineho ...
	MAX_MUL_get_players_all(SIDE1, &pl_handle, NULL);
	

#ifdef GROUPS_COUNT_SIDE2
	if (pl_handle == 0) return; //na teto strane nikdo neni -> nevypisuju
	pl_handle = MAX_MUL_PLAYERS; //pouziti promenne na neco jineho ...
	MAX_MUL_get_players_all(SIDE2, &pl_handle, NULL);
	if (pl_handle == 0) return; //na teto strane nikdo neni -> nevypisuju
#else
	if (pl_handle <= 1) return; //je tu pouze jeden hrac a jedna strana, takze nevypisuju
#endif

	if (MAX_MUL_get_best_player(&pl_handle, &points)) { // existuje nejlepsi hrac
		//if (points 
		if (pl_handle != SRV_best_player) { // hrac ma o jeden bod mene nez nejlepsi -> zabije nejlepsiho -> stane se nejlepsi (+2 body) SRV_best_player muze byt i 0
			int			num, i;
			sc_player	list[MAX_MUL_PLAYERS];
			dword		tmp_handle;

			//num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, MAX_MUL_PLAYERS, 0);
			num = MAX_MUL_PLAYERS;
			MAX_MUL_get_players_all(SC_P_SIDE_ALL, &num, list);
			for (i=0; i<num; i++) {
				tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
				if (tmp_handle == pl_handle)
					MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_YOU_BEST);
				else
					MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_PL_ID_BEST, pl_handle);

			}
			SRV_best_player = pl_handle;
//		} else { // nic se nemeni
		}
	} else { //je vice nejlepsich
		if (SRV_best_player) { // nekdo byl nejlepsi -> tak se mu to zrusi
			int			num, i;
			sc_player	list[MAX_MUL_PLAYERS];
			dword		tmp_handle;

			num = MAX_MUL_PLAYERS;
			MAX_MUL_get_players_all(SC_P_SIDE_ALL, &num, list);
			//num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, list, MAX_MUL_PLAYERS, 0);
			for (i=0; i<num; i++) {
				tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
				if (tmp_handle == SRV_best_player) { // jina moznost by nemela nastat
					MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_YOU_LOST);
				} else {
					if ((disconnecting) && (SC_MP_GetHighestPointsPlayer(&pl_handle, &points)))
						MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_PL_ID_BEST, pl_handle);
					else
						MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_PL_ID_LOST, SRV_best_player);
				}

			}
			SRV_best_player = 0;
//		} else { // zmena se netyka nejlepsich hracu -> nic se nemeni
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_check_best_team_score() {
	int		side1_score, side2_score;

	//side1_score = MAX_MUL_get_score_side(SIDE1);
	//side2_score = MAX_MUL_get_score_side(SIDE2);

	side1_score = MAX_MUL_PLAYERS; //pouziti promenne na neco jineho ...
	side2_score = MAX_MUL_PLAYERS;

	MAX_MUL_get_players_all(SIDE1, &side1_score, NULL);
	MAX_MUL_get_players_all(SIDE2, &side2_score, NULL);

	if ((side1_score == 0) || (side1_score == 0)) return;//pouziti promenne na neco jineho ...

	side1_score = SC_MP_Side_GetPoints(SIDE1);
	side2_score = SC_MP_Side_GetPoints(SIDE2);

	if ((side1_score > side2_score) && ((SRV_best_team == -1) || (SRV_best_team == SIDE2))) {
		int			num, i;
		sc_player	list[MAX_MUL_PLAYERS];
		dword		tmp_handle;

		
		num = MAX_MUL_PLAYERS;
		MAX_MUL_get_players_all(SC_P_SIDE_ALL, &num, list);
		for (i=0; i<num; i++) {
			tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
			MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_TAKE_TEAM1);
		}

		SRV_best_team = SIDE1;

	} else if ((side1_score < side2_score) && ((SRV_best_team == -1) || (SRV_best_team == SIDE1))) {
		int			num, i;
		sc_player	list[MAX_MUL_PLAYERS];
		dword		tmp_handle;

		
		num = MAX_MUL_PLAYERS;
		MAX_MUL_get_players_all(SC_P_SIDE_ALL, &num, list);
		for (i=0; i<num; i++) {
			tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
			MAX_MUL_send_message_to_client(tmp_handle, MSG_MUL_LEAD_TAKE_TEAM2);
		}

		SRV_best_team = SIDE2;
	} else if ((side1_score == side2_score) && (SRV_best_team != -1)) {
		int			num, i;
		sc_player	list[MAX_MUL_PLAYERS];
		dword		tmp_handle;
		dword		tmp_msg;

		tmp_msg = (SRV_best_team == SIDE1) ? MSG_MUL_LEAD_LOST_TEAM1 : MSG_MUL_LEAD_LOST_TEAM2;
		
		num = MAX_MUL_PLAYERS;
		MAX_MUL_get_players_all(SC_P_SIDE_ALL, &num, list);
		for (i=0; i<num; i++) {
			tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
			MAX_MUL_send_message_to_client(tmp_handle, tmp_msg);
		}

		SRV_best_team = -1;
	}

}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_check_best_score(dword game_type, BOOL disconnecting) {
	switch(game_type) {
	case GAME_TYPE_DM:
		MAX_MUL_check_best_player_score(disconnecting);
		break;

	case GAME_TYPE_TDM:
		MAX_MUL_check_best_team_score();
		break;


	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_srv_check_winning_rules() {
BOOL	result;

//#ifdef SIDE1
#ifdef WINNING_RULES_SIDE1_COUNT
	for (g_i=0; g_i<WINNING_RULES_SIDE1_COUNT; g_i++) {
		if (WINNING_RULES_SIDE1[g_i] == NULL) continue;
		g_MAX_RULE_data.side = SIDE1;
		result = MAX_MUL_winning_rules_side1_result[g_i] = WINNING_RULES_SIDE1[g_i](&g_MAX_RULE_data); // v pripade ze by WINNING_RULES_SIDE1_COUNT bylo 1, tak uz mam vysledek
	}
#endif

#if (WINNING_RULES_SIDE1_COUNT > 1) // jinak to musim proverit pro ostatni pravidla
	result = FALSE;
	for (g_i=0; g_i<WINNING_RULES_SIDE1_COUNT; g_i++) {
		if (MAX_MUL_winning_rules_side1_result[g_i] == FALSE) continue;
		result = TRUE;
		for (g_j=0; g_j<WINNING_RULES_SIDE1_COUNT-1; g_j++) {
			if (WINNING_RULES_SIDE1_OPP[g_i][g_j] == -1) break;

			if (MAX_MUL_winning_rules_side1_result[WINNING_RULES_SIDE1_OPP[g_i][g_j]] == FALSE) {
				result = FALSE;
				break;
			}
		}
		if (result == TRUE) return SIDE1;
	}
#else
	if (result == TRUE) return SIDE1;
#endif
//#endif
//-----------------------------------------------------------------------------------------------
//#ifdef SIDE2
#ifdef WINNING_RULES_SIDE2_COUNT
	for (g_i=0; g_i<WINNING_RULES_SIDE2_COUNT; g_i++) {
		if (WINNING_RULES_SIDE2[g_i] == NULL) continue;
		g_MAX_RULE_data.side = SIDE2;
		result = MAX_MUL_winning_rules_side2_result[g_i] = WINNING_RULES_SIDE2[g_i](&g_MAX_RULE_data); // v pripade ze by WINNING_RULES_SIDE2_COUNT bylo 1, tak uz mam vysledek
	}
#endif

#if (WINNING_RULES_SIDE2_COUNT > 1) // jinak to musim proverit pro ostatni pravidla
	result = TRUE;
	for (g_i=0; g_i<WINNING_RULES_SIDE2_COUNT; g_i++) {
		if (MAX_MUL_winning_rules_side2_result[g_i] == FALSE) continue;
		for (g_j=0; g_j<WINNING_RULES_SIDE2_COUNT-1; g_j++) {
			if (WINNING_RULES_SIDE2_OPP[g_i][g_j] == -1) break;

			if (MAX_MUL_winning_rules_side2_result[WINNING_RULES_SIDE2_OPP[g_i][g_j]] == FALSE) {
				result = FALSE;
				break;
			}
		}
		if (result == TRUE) return SIDE2;
	}
#else
	if (result == TRUE) return SIDE2;
#endif
//#endif

	return -1; // pokud nebylo splneno ani jedno pravidlo

}
void MAX_MUL_switch_respawn(int respawn_index, dword side) {
	s_SC_MP_RespawnGroupCreate	resp_group;
	int							i;
	int							removed_respawn = -1;

	//SC_message("pridavam respawn %s", MAX_MUL_respawn[respawn_index].name);
	for (i=0; i<ALL_GROUPS_COUNT; i++) { // odstranim opozitni respawn
		if ((!MAX_MUL_respawn[i].is_active) || (i == respawn_index)) continue;
		if (SC_StringSame(MAX_MUL_respawn[respawn_index].op_name, MAX_MUL_respawn[i].name)) {
			MAX_MUL_respawn_group_remove(MAX_MUL_respawn, MAX_MUL_respawn[i].id);
			MAX_MUL_respawn[i].is_active = FALSE;
			removed_respawn = MAX_SUP_get_opp_side(side);
			//SC_message("mazu respawn %s", MAX_MUL_respawn[i].name);
			break;
		}
	}

	if (removed_respawn > -1) MAX_MUL_send_message_to_clns(removed_respawn, MSG_LOST_RESPAWN); // bylo tady >= -1, ale proc ???????????

	//if (i >= ALL_GROUPS_COUNT) SC_message("neodebiram zadny opozitni respawn");

	if (MAX_MUL_respawn[respawn_index].is_active) {
		SC_message("ojojoooooj");
		return;
	}

	CLEAR(resp_group);
	resp_group.respawn_name = MAX_MUL_respawn[respawn_index].name; // resp_group.respawn_name je pointer !!!
	resp_group.script_id = MAX_MUL_respawn[respawn_index].id;
	resp_group.resp_min_distance = 3.0f;

	if ((GAME_TYPE == GAME_TYPE_COOP) || (GAME_TYPE == GAME_TYPE_ASSAULT))
		resp_group.map_position_enable = TRUE;

	SC_MP_RespawnGroup_Create(&resp_group);
	MAX_MUL_respawn[respawn_index].is_active = TRUE;

	SC_MP_RespawnGroup_SetSide(MAX_MUL_respawn[respawn_index].id, side);

	MAX_MUL_send_message_to_clns(side, MSG_GET_RESPAWN);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_respawn_group_remove(s_MAX_MUL_respawn *respawn, dword respawn_id) {
	dword		pl_handle;
	int			i, j;
	int			num;
	sc_player	list[MAX_MUL_PLAYERS];

	SC_MP_RespawnGroup_Remove(respawn_id);

	if (respawn_id <= GROUPS_COUNT_SIDE1)
		num = SC_EnumPlayers(SIDE1, SC_P_GROUP_ALL, list, MAX_MUL_PLAYERS, 0);
	else
		num = SC_EnumPlayers(SIDE2, SC_P_GROUP_ALL, list, MAX_MUL_PLAYERS, 0);

	for (i=0; i<num; i++) {
		pl_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
		if (SC_MP_RespawnGroup_GetFromPlayer(pl_handle) == respawn_id) {
			if (respawn_id <= GROUPS_COUNT_SIDE1) {
				for (j=GROUPS_COUNT_SIDE1-1; j>=0; j++) {
					if (respawn[j].is_active) {
						SC_MP_RespawnGroup_SetForPlayer(respawn[j].id, pl_handle);
						break;
					} //if
				} //for
			} 
#ifdef GROUPS_COUNT_SIDE2
			else { // if respawn_id
				for (j=GROUPS_COUNT_SIDE2-1; j>=GROUPS_COUNT_SIDE1; j++) {
					if (respawn[j].is_active) {
						SC_MP_RespawnGroup_SetForPlayer(respawn[j].id, pl_handle);
						break;
					} //if
				} //for
			}
#endif
		} // if (SC_MP_RespawnGroup_GetFromPlayer(pl_handle) ...
	}

}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_srv_check_respawn_rules() {
	BOOL	result;

#ifdef GROUPS_COUNT_SIDE1
	for (g_i=0; g_i<GROUPS_COUNT_SIDE1; g_i++) {
		if ((respawn_groups_side1_rules[g_i] == NULL) || (MAX_MUL_respawn[g_i].is_active)) continue; //pokud je NULL nebo je uz aktivni
		g_MAX_RULE_data.side = SIDE1;
		result = respawn_groups_side1_rules[g_i](&g_MAX_RULE_data); // v pripade ze by WINNING_RULES_SIDE1_COUNT bylo 1, tak uz mam vysledek
		if (result == TRUE) MAX_MUL_switch_respawn(g_i, SIDE1);
	}
#endif
#ifdef GROUPS_COUNT_SIDE2
	for (g_i=0; g_i<GROUPS_COUNT_SIDE2; g_i++) {
		if ((respawn_groups_side2_rules[g_i] == NULL) || (MAX_MUL_respawn[GROUPS_COUNT_SIDE1+g_i].is_active)) continue; //pokud je NULL nebo je uz aktivni
		g_MAX_RULE_data.side = SIDE2;
		result = respawn_groups_side2_rules[g_i](&g_MAX_RULE_data); // v pripade ze by WINNING_RULES_SIDE1_COUNT bylo 1, tak uz mam vysledek
		if (result == TRUE) MAX_MUL_switch_respawn(GROUPS_COUNT_SIDE1+g_i, SIDE2);
	}
#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_init_sides(dword game_type) {
	int						side_count = 0;
	s_SC_MP_SideInfo		side[2];
	s_SC_MP_Props			mp_props;
	s_SC_WeapPickupLimits	pickup_limits;
	

	CLEAR(pickup_limits);
	pickup_limits.slot3_by_stamina = TRUE;
	pickup_limits.slot3_limit = 2;
	SC_SetWeaponsPickup(&pickup_limits);
	
	CLEAR(side);
	CLEAR(mp_props);
	SC_MP_GetProps(&mp_props);

	side_count = 1; // musi byt

	switch(game_type) {
	case GAME_TYPE_DM:
		mp_props.enable_pcpl_coma = FALSE;
		mp_props.teamgame = FALSE;

		side[0].side_id = SIDE1;
		//side[0].name_ansi = "DM_side";
		side[0].name_id = 1619;
		side[0].info_id = 1880;
		side[0].logo_filename = "g\\mp\\icons\\sides\\dm_flag_big.bmp";
		side[0].menu_profile = "dm";
		side[0].vehicle_flag_bes = VEHICLE_FLAG_DM;

		break;
	case GAME_TYPE_TDM:
		mp_props.enable_pcpl_coma = FALSE;
		mp_props.teamgame = TRUE;

		side[0].side_id = SIDE1;
		if (SIDE1 == SC_P_SIDE_US) {
			//side[0].name_ansi = "US - Amici";
			side[0].name_id = 1620;
			side[0].info_id = 1881;
			side[0].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
			side[0].menu_profile = "us";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_US;
		} else {
			//side[0].name_ansi = "VC - Trznice";
			side[0].name_id = 1621;
			side[0].info_id = 1882;
			side[0].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
			side[0].menu_profile = "vc";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_VC;
		}

		#ifdef GROUPS_COUNT_SIDE2 // bacha SC_P_SIDE_US je taky 0 !!!
			side_count = 2; // musi byt
			side[1].side_id = SIDE2;
			if (SIDE2 == SC_P_SIDE_US) {
				//side[1].name_ansi = "US - Amici";
				side[1].name_id = 1620;
				side[1].info_id = 1881;
				side[1].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
				side[1].menu_profile = "us";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_US;
			} else {
				//side[1].name_ansi = "VC - Trznice";
				side[1].name_id = 1621;
				side[1].info_id = 1882;
				side[1].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
				side[1].menu_profile = "vc";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_VC;
			}
		#endif

		break;
	case GAME_TYPE_COOP:
		if (SIDE1 == SC_P_SIDE_US) {
#ifdef SIDE1_OBJECTIVE
			side[0].info_id = SIDE1_OBJECTIVE;
#else
			side[0].info_id = 1885;
#endif
		} else {
		}

		mp_props.enable_pcpl_coma = TRUE;
		mp_props.teamgame = TRUE;


		side[0].side_id = SIDE1;
		if (SIDE1 == SC_P_SIDE_US) {
			//side[0].name_ansi = "US - Amici";
			side[0].name_id = 1620;
			side[0].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
			side[0].menu_profile = "us";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_US;
		} else {
			//side[0].name_ansi = "VC - Trznice";
			side[0].name_id = 1621;
			side[0].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
			side[0].menu_profile = "vc";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_VC;
		}

		break;

	case GAME_TYPE_ASSAULT:
		mp_props.enable_pcpl_coma = TRUE;
		mp_props.teamgame = TRUE;

		side[0].side_id = SIDE1;
		if (SIDE1 == SC_P_SIDE_US) {
			//side[0].name_ansi = "US - Amici";
			side[0].name_id = 1620;
#ifdef SIDE1_OBJECTIVE
			side[0].info_id = SIDE1_OBJECTIVE;
#else
			side[0].info_id = 1881;
#endif
			side[0].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
			side[0].menu_profile = "us";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_US;
		} else {
			//side[0].name_ansi = "VC - Trznice";
			side[0].name_id = 1621;
#ifdef SIDE1_OBJECTIVE
			side[0].info_id = SIDE1_OBJECTIVE;
#else
			side[0].info_id = 1882;
#endif
			side[0].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
			side[0].menu_profile = "vc";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_VC;
		}

		#ifdef GROUPS_COUNT_SIDE2 // bacha SC_P_SIDE_US je taky 0 !!!
			side_count = 2; // musi byt
			side[1].side_id = SIDE2;
			if (SIDE2 == SC_P_SIDE_US) {
				//side[1].name_ansi = "US - Amici";
				side[1].name_id = 1620;
#ifdef SIDE2_OBJECTIVE
				side[1].info_id = SIDE2_OBJECTIVE;
#else
				side[1].info_id = 1881;
#endif
				side[1].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
				side[1].menu_profile = "us";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_US;
			} else {
				//side[1].name_ansi = "VC - Trznice";
				side[1].name_id = 1621;
#ifdef SIDE2_OBJECTIVE
				side[1].info_id = SIDE2_OBJECTIVE;
#else
				side[1].info_id = 1882;
#endif
				side[1].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
				side[1].menu_profile = "vc";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_VC;
			}
		#endif

		break;

	case GAME_TYPE_CTF:
		if (SIDE1 == SC_P_SIDE_US) {
			side[0].info_id = 1883;
		} else {
			side[0].info_id = 1884;
		}
		#ifdef GROUPS_COUNT_SIDE2 // bacha SC_P_SIDE_US je taky 0 !!!
			if (SIDE2 == SC_P_SIDE_US) {
				side[1].info_id = 1883;
			} else {
				side[1].info_id = 1884;
			}
		#endif
	case GAME_TYPE_SAD:
	case GAME_TYPE_JS:
		mp_props.enable_pcpl_coma = TRUE;
		mp_props.teamgame = TRUE;


		side[0].side_id = SIDE1;
		if (SIDE1 == SC_P_SIDE_US) {
			//side[0].name_ansi = "US - Amici";
			side[0].name_id = 1620;
			side[0].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
			side[0].menu_profile = "us";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_US;
		} else {
			//side[0].name_ansi = "VC - Trznice";
			side[0].name_id = 1621;
			side[0].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
			side[0].menu_profile = "vc";
			side[0].vehicle_flag_bes = VEHICLE_FLAG_VC;
		}

		#ifdef GROUPS_COUNT_SIDE2 // bacha SC_P_SIDE_US je taky 0 !!!
			side_count = 2; // musi byt
			side[1].side_id = SIDE2;
			if (SIDE2 == SC_P_SIDE_US) {
				//side[1].name_ansi = "US - Amici";
				side[1].name_id = 1620;
				side[1].logo_filename = "g\\mp\\icons\\sides\\us_flag_big.bmp";
				side[1].menu_profile = "us";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_US;
			} else {
				//side[1].name_ansi = "VC - Trznice";
				side[1].name_id = 1621;
				side[1].logo_filename = "g\\mp\\icons\\sides\\vc_flag_big.bmp";
				side[1].menu_profile = "vc";
				side[1].vehicle_flag_bes = VEHICLE_FLAG_VC;
			}
		#endif
		break;
	}

	SC_MP_SetProps(&mp_props);

	SC_MP_InitSides(side, side_count);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_init_classes(dword game_type) {
	switch(game_type) {
	case GAME_TYPE_DM:
		SC_MP_Classes_Init("ini\\mp\\classes\\dm.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\dm_rpg.ini");
		break;
	case GAME_TYPE_TDM:
		SC_MP_Classes_Init("ini\\mp\\classes\\tdm.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\tdm_rpg.ini");
		break;
	case GAME_TYPE_COOP:
		SC_MP_Classes_Init("ini\\mp\\classes\\coop.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\coop_rpg.ini");
		SC_MP_ActivateScenePlayersScripts();
		break;
	case GAME_TYPE_CTF:
		SC_MP_Classes_Init("ini\\mp\\classes\\ctf.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\ctf_rpg.ini");
		break;
	case GAME_TYPE_ASSAULT:
		SC_MP_Classes_Init("ini\\mp\\classes\\assault.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\assault_rpg.ini");
		break;
	case GAME_TYPE_SAD:
		SC_MP_Classes_Init("ini\\mp\\classes\\ctf.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\ctf_rpg.ini");
		break;
	case GAME_TYPE_JS:
		SC_MP_Classes_Init("ini\\mp\\classes\\js.ini");
		SC_MP_RPG_Init("ini\\mp\\classes\\dm_rpg.ini");
		break;

	default:
		break;

	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_mode_settings_add(dword settings_ptr, dword game_type) {
	switch(game_type) {
	case GAME_TYPE_DM:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_dm.ini");
		break;
	case GAME_TYPE_TDM:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_tdm.ini");
		break;
	case GAME_TYPE_COOP:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_coop.ini");
		break;
	case GAME_TYPE_CTF:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_ctf.ini");
		break;
	case GAME_TYPE_ASSAULT:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_assault.ini");
		break;
	case GAME_TYPE_SAD:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_sad.ini");
		break;
	case GAME_TYPE_JS:
		SC_MP_ModeSettings_Add(settings_ptr, "ini\\mp\\settings\\!max_js.ini");
		break;

	default:
		break;

	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_init_respawnes(s_MAX_MUL_respawn *respawn, int count) {
	s_SC_MP_RespawnGroupCreate	resp_group;
	int							i;

	CLEAR(resp_group);

	for (i=0; i<count; i++) {
		if (!respawn[i].is_active) continue;

		resp_group.respawn_name = respawn[i].name; // resp_group.respawn_name je pointer !!!
		resp_group.script_id = respawn[i].id;
		resp_group.resp_min_distance = 3.0f;
		if ((GAME_TYPE == GAME_TYPE_COOP) || (GAME_TYPE == GAME_TYPE_ASSAULT))
			resp_group.map_position_enable = TRUE;

		SC_MP_RespawnGroup_Create(&resp_group);
		SC_MP_RespawnGroup_SetSide(respawn[i].id, (i<GROUPS_COUNT_SIDE1) ? SIDE1 : SIDE2);
	}

	SC_MP_RespawnGroup_SetAsDefaultForSide(respawn[0].id, SIDE1); //nastavim 1. polozku v seznamu jako defaultni respawn
#ifdef GROUPS_COUNT_SIDE2 //GROUPS_COUNT_SIDE1 je to dobre!!!
	SC_MP_RespawnGroup_SetAsDefaultForSide(respawn[GROUPS_COUNT_SIDE1].id, SIDE2); //nastavim 1. polozku v seznamu jako defaultni respawn
#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_release_respawnes(s_MAX_MUL_respawn *respawn, int count) {
	int	i;

	for (i=0; i<count; i++) {
		if (!respawn[i].is_active) continue;
		MAX_MUL_respawn_group_remove(respawn, respawn[i].id);
		respawn[i].is_active = FALSE;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reinit_respawnes(s_MAX_MUL_respawn *respawn, int count) {
	int	i, j;
	s_SC_MP_RespawnGroupCreate	resp_group;


	for (i=0; i<GROUPS_COUNT_SIDE1; i++) {
		if (respawn[i].is_active != respawn_groups_side1_active[respawn[i].id-1]) {
		//SC_message("reinit respawnes side1 index: %d", i);
			if (respawn_groups_side1_active[respawn[i].id-1] == TRUE) {
				CLEAR(resp_group);
			
				resp_group.respawn_name = respawn[i].name; // resp_group.respawn_name je pointer !!!
				resp_group.script_id = respawn[i].id;
				resp_group.resp_min_distance = 3.0f;
				if ((GAME_TYPE == GAME_TYPE_COOP) || (GAME_TYPE == GAME_TYPE_ASSAULT))
					resp_group.map_position_enable = TRUE;

				SC_MP_RespawnGroup_Create(&resp_group);
				SC_MP_RespawnGroup_SetSide(respawn[i].id, SIDE1);

				respawn[i].is_active = TRUE;
			} else {
				respawn[i].is_active = FALSE;
				MAX_MUL_respawn_group_remove(respawn, respawn[i].id);
			}
		}
	}

	#ifdef GROUPS_COUNT_SIDE2
		for (i=0; i<GROUPS_COUNT_SIDE2; i++) {
			if (respawn[GROUPS_COUNT_SIDE1+i].is_active != respawn_groups_side2_active[respawn[GROUPS_COUNT_SIDE1+i].id-GROUPS_COUNT_SIDE1]) {
				//SC_message("reinit respawnes side2 index: %d", i);
				if (respawn_groups_side2_active[respawn[GROUPS_COUNT_SIDE1+i].id-GROUPS_COUNT_SIDE1] == TRUE) {
					CLEAR(resp_group);
				
					resp_group.respawn_name = respawn[GROUPS_COUNT_SIDE1+i].name; // resp_group.respawn_name je pointer !!!
					resp_group.script_id = respawn[GROUPS_COUNT_SIDE1+i].id;
					resp_group.resp_min_distance = 3.0f;
					if ((GAME_TYPE == GAME_TYPE_COOP) || (GAME_TYPE == GAME_TYPE_ASSAULT))
						resp_group.map_position_enable = TRUE;

					SC_MP_RespawnGroup_Create(&resp_group);
					SC_MP_RespawnGroup_SetSide(respawn[GROUPS_COUNT_SIDE1+i].id, SIDE2);

					respawn[GROUPS_COUNT_SIDE1+i].is_active = TRUE;
				} else {
					respawn[GROUPS_COUNT_SIDE1+i].is_active = FALSE;
					MAX_MUL_respawn_group_remove(respawn, respawn[GROUPS_COUNT_SIDE1+i].id);
				}
			}
		}
	#endif

	SC_MP_RespawnGroup_SetAsDefaultForSide(respawn[0].id, SIDE1); //nastavim 1. polozku v seznamu jako defaultni respawn
#ifdef GROUPS_COUNT_SIDE2 //GROUPS_COUNT_SIDE1 je to dobre!!!
	SC_MP_RespawnGroup_SetAsDefaultForSide(respawn[GROUPS_COUNT_SIDE1].id, SIDE2); //nastavim 1. polozku v seznamu jako defaultni respawn
#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_init_synchro(BOOL is_server, dword game_type) {
	int		i;

//	SC_Log(2, "XXXXX - MAX_MUL_init_synchro");

	if (is_server){
		SC_MP_Synch_Create(SYNCH_REINFORCEMENT,	&SRV_reinforcements_timer,	sizeof(SRV_reinforcements_timer));
		SC_MP_Synch_Create(SYNCH_GAME_TIMER,	&SRV_game_time,				sizeof(SRV_game_time));
		SC_MP_Synch_Create(SYNCH_ROUND_TIMER,	&SRV_round_time,			sizeof(SRV_round_time));
		SC_MP_Synch_Create(SYNCH_GAME_PHASE,	&SRV_game_phase,			sizeof(SRV_game_phase));
		SC_MP_Synch_Create(SYNCH_WINNING_SIDE,	&SRV_winning_side,			sizeof(SRV_winning_side));
		SC_MP_Synch_Create(SYNCH_SIDE1,			&SIDE1,						sizeof(SIDE1));
		SC_MP_Synch_Create(SYNCH_SIDE2,			&SIDE2,						sizeof(SIDE2));
#ifdef CHECK_SIDES_READY_COUNT
		SC_MP_Synch_Create(SYNCH_SIDES_READY,	&SRV_sides_ready,			sizeof(SRV_sides_ready));
#endif
	} else {
		SC_MP_Synch_Create(SYNCH_REINFORCEMENT,	&CLN_reinforcements_timer,	sizeof(CLN_reinforcements_timer));
		SC_MP_Synch_Create(SYNCH_GAME_TIMER,	&CLN_game_time,				sizeof(CLN_game_time));
		SC_MP_Synch_Create(SYNCH_ROUND_TIMER,	&CLN_round_time,			sizeof(CLN_round_time));
		SC_MP_Synch_Create(SYNCH_GAME_PHASE,	&CLN_game_phase,			sizeof(CLN_game_phase));
		SC_MP_Synch_Create(SYNCH_WINNING_SIDE,	&CLN_winning_side,			sizeof(CLN_winning_side));
		SC_MP_Synch_Create(SYNCH_SIDE1,			&SIDE1,						sizeof(SIDE1));
		SC_MP_Synch_Create(SYNCH_SIDE2,			&SIDE2,						sizeof(SIDE2));
#ifdef CHECK_SIDES_READY_COUNT
		SC_MP_Synch_Create(SYNCH_SIDES_READY,	&CLN_sides_ready,			sizeof(CLN_sides_ready));
#endif
	}
#ifdef OBJECTS_COUNT
	for (i=0; i<OBJECTS_COUNT; i++) {
		MAX_MUL_object[i].nod = NULL;
		MAX_MUL_object[i].CLN_object_status = NULL;
		MAX_MUL_object[i].SRV_object_status = NULL;
		MAX_MUL_object[i].is_synchro = FALSE;
	}
#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_release_synchro(dword game_type) {
	int		i;

//	SC_Log(2, "XXXXX - MAX_MUL_release_synchro");

	SC_MP_Synch_Remove(SYNCH_REINFORCEMENT);
	SC_MP_Synch_Remove(SYNCH_GAME_TIMER);
	SC_MP_Synch_Remove(SYNCH_ROUND_TIMER);
	SC_MP_Synch_Remove(SYNCH_GAME_PHASE);
	SC_MP_Synch_Remove(SYNCH_WINNING_SIDE);
	SC_MP_Synch_Remove(SYNCH_SIDE1);
	SC_MP_Synch_Remove(SYNCH_SIDE2);
#ifdef CHECK_SIDES_READY_COUNT
	SC_MP_Synch_Remove(SYNCH_SIDES_READY);
#endif

	#ifdef OBJECTS_COUNT
		for (i=0; i<OBJECTS_COUNT; i++) {
			if (MAX_MUL_object[i].is_synchro) {
				SC_MP_Synch_Remove(SYNCH_OBJECTS_STATUS+i);
				MAX_MUL_object[i].is_synchro = FALSE;
			}
		}
	#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_init_all(BOOL is_server) {
	int	i, j;
	//-------------------------------------------------------------------------
	for (i=0; i<GROUPS_COUNT_SIDE1; i++) {
		MAX_MUL_respawn[i].id			= i+1;
		MAX_MUL_respawn[i].is_active	= respawn_groups_side1_active[i];
		sprintf(MAX_MUL_respawn[i].name, respawn_groups_side1_names[i]);
		sprintf(MAX_MUL_respawn[i].op_name, respawn_groups_side1_op_names[i]);
	}

	#ifdef GROUPS_COUNT_SIDE2
		for (j=0; j<GROUPS_COUNT_SIDE2; j++) {
			MAX_MUL_respawn[j+i].id			= j+i+1;
			MAX_MUL_respawn[j+i].is_active	= respawn_groups_side2_active[j];
			sprintf(MAX_MUL_respawn[j+i].name, respawn_groups_side2_names[j]);
			sprintf(MAX_MUL_respawn[j+i].op_name, respawn_groups_side1_op_names[j]);
		}
	#endif

	/*#ifdef OBJECTS_COUNT
		for (i=0; i<OBJECTS_COUNT; i++) {
			MAX_MUL_object[i].CLN_object_status = &CLN_object_status[i];
			MAX_MUL_object[i].SRV_object_status = &SRV_object_status[i];
		}
	#endif*/
	//-------------------------------------------------------------------------
	//MAX_MUL_init_map();
	//-------------------------------------------------------------------------
	MAX_MUL_init_sides(GAME_TYPE);
	//-------------------------------------------------------------------------
	MAX_MUL_init_classes(GAME_TYPE);
	//-------------------------------------------------------------------------
	//SIDE1 = SC_P_SIDE_VC;
	//SIDE2 = SC_P_SIDE_US;
	if (is_server) MAX_MUL_init_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
	//-------------------------------------------------------------------------
	MAX_MUL_init_synchro(is_server, GAME_TYPE);
	//-------------------------------------------------------------------------
#ifdef MAP_NAME
	//-------------------------------------------------------------------------
	MAX_MUL_map_init(GAME_TYPE, MAP_NAME, MAP_TRANSFORM); // externi
	//-------------------------------------------------------------------------
	MAX_MUL_define_custom_items(); // externi, v prvnim scriptu
	//-------------------------------------------------------------------------
	SRV_CLN_objectives_count = MAX_MUL_define_custom_objectives(); // externi, v prvnim scriptu
	//-------------------------------------------------------------------------
#endif

	if (is_server) {
		//SC_MP_Class_SetLimit("Amik L1",0);
		//SC_MP_Class_SetLimit("Rakosnik L1",29);
	}

	MAX_MUL_respawn_count = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_release_hud() {
	MAX_HUD_remove_all();

	#ifdef OBJECTS_COUNT
		{
			int	i;
			for (i=0; i<OBJECTS_COUNT; i++) {
				MAX_MUL_object[i].hud_is_rendering = FALSE;
			}
		}
	#endif
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_release_all(BOOL is_server) {
	//-------------------------------------------------------------------------
	if (is_server) MAX_MUL_release_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
	//-------------------------------------------------------------------------
	MAX_MUL_release_synchro(GAME_TYPE);
	//-------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
#ifdef OBJECTS_COUNT
void MAX_MUL_object_add(sc_nod nod, s_MAX_MUL_object_status *object_state) {
	int		i;

	for (i=0; i<OBJECTS_COUNT; i++) {
		if (MAX_MUL_object[i].nod == nod) {
			return;
		}
	}

	for (i=0; i<OBJECTS_COUNT; i++) {
		if (SC_StringSame(SC_NOD_GetName(nod), MAX_MUL_object_names[i])) {
			MAX_MUL_object[i].nod = nod;
			MAX_MUL_object[i].CLN_object_status = object_state;

			if (MAX_MUL_is_server)
				MAX_MUL_object[i].SRV_object_status = object_state;

			//SC_message("%s", SC_NOD_GetName(nod));

			object_state->pl_handle = 0;
			object_state->side = SIDE1;
			object_state->state = STATE_INIT;
			object_state->timer = -1.0;
			object_state->update = FALSE;

			if (MAX_MUL_object[i].is_synchro) SC_MP_Synch_Remove(SYNCH_OBJECTS_STATUS+i);
			SC_MP_Synch_Create(SYNCH_OBJECTS_STATUS+i, object_state, sizeof(s_MAX_MUL_object_status));
			MAX_MUL_object[i].is_synchro = TRUE;

			break;
		}
	}

	if (i>=OBJECTS_COUNT) SC_message("Prisla zprava od objektu, ktery neni v MAX_MUL_object_names");
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_object_remove_all() {
	int		i;
//SC_Log(2, "XXXXX - MAX_MUL_object_remove_all");
	for (i=0; i<OBJECTS_COUNT; i++) {
		MAX_MUL_object[i].nod = NULL;
		MAX_MUL_object[i].CLN_object_status = NULL;
		MAX_MUL_object[i].SRV_object_status = NULL;
		if (MAX_MUL_object[i].is_synchro) {
			SC_MP_Synch_Remove(SYNCH_OBJECTS_STATUS+i);
			MAX_MUL_object[i].is_synchro = FALSE;
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_srv_object_update_tick() {
	int		i;

	for (i=0; i<OBJECTS_COUNT; i++) {
		if (MAX_MUL_object[i].SRV_object_status->update) {
			MAX_MUL_object[i].SRV_object_status->update = FALSE;
			SC_MP_Synch_SendChanges(SYNCH_OBJECTS_STATUS+i, TRUE);
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_objects_send_request() {
	int		i;

	for (i=0; i<OBJECTS_COUNT; i++) {
		MAX_SUP_send_message_to_object(SC_NOD_GetNoMessage_Entity(MAX_MUL_object_names[i]), MSG_MUL_REQ_OBJECT_INFO, 0);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_check_objects(dword pl_handle) {
	int	i;

	for (i=0; i<OBJECTS_COUNT; i++) {
		if (MAX_MUL_object[i].SRV_object_status == NULL) continue;
		if (MAX_MUL_object[i].CLN_object_status == NULL) continue;
		if (MAX_MUL_object[i].SRV_object_status->pl_handle == pl_handle) {
			MAX_MUL_object[i].SRV_object_status->pl_handle = 0;
			MAX_MUL_object[i].CLN_object_status->pl_handle = MAX_MUL_object[i].SRV_object_status->pl_handle;
			MAX_MUL_object[i].SRV_object_status->update = TRUE;
		}
	}
}
#endif
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_render_game_inactive(float elapsed_time) {
	static float	timeout = 1.0;

	if (MAX_SUP_count_timeout(&timeout, elapsed_time)) {
		SC_HUD_AddStateText(SC_Wtxt(1699), 2.0, 4.0, 0xffffff00, 0);
		timeout = 7.0;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_render_game_round_info(float elapsed_time) {
	dword	data;
	//char	txt[256];
	ushort	tmp_ustr[256];
	//float	x, y;
	static float	timeout = 0.5;


	//SC_GetScreenRes(&x, &y);

	switch(CLN_game_phase) {
	case GAME_PHASE_WAITING:
		if (MAX_SUP_count_timeout(&timeout, elapsed_time)) {
			SC_HUD_AddStateText(SC_Wtxt(1622), 0.5, 0.9, 0xffffff00, 0);
			timeout = 1.0;
		}
		//swprintf(tmp_ustr, SC_AnsiToUni("%s: ", help), SC_Wtxt(1609)); //time
		//sprintf(txt, "Waiting for other players ...", ((dword)(CLN_round_time+0.9)));
		//SC_Fnt_Write(x/2.0 - SC_Fnt_GetWidth(txt, 2.0f)/2.0, y-50.0, txt, 2.0f, 0xffffff00);
		//swprintf(tmp_ustr, SC_Wtxt(1622));
		//SC_Fnt_WriteW(x/2.0 - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0, y-50.0, tmp_ustr, 2.0f, 0xffffff00);
		break;
	case GAME_PHASE_INITIALIZING:
		timeout = 0.5;
		break;
	case GAME_PHASE_BEGIN:
		if (MAX_SUP_count_timeout(&timeout, elapsed_time)) {
			swprintf(tmp_ustr, SC_Wtxt(1623), ((dword)(CLN_round_time+0.9)));
			SC_HUD_AddStateText(tmp_ustr, 0.15, 0.7, 0xffffff00, 0);
			timeout = 0.5;
		}
		
		//sprintf(txt, "Round begins in %d s !!!", ((dword)(CLN_round_time+0.9)));
		//SC_Fnt_WriteW(x/2.0 - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0, y-50.0, tmp_ustr, 2.0f, 0xffffff00);
		break;
	case GAME_PHASE_RUNNING:
		break;
	case GAME_PHASE_ENDING:

		if (MAX_SUP_count_timeout(&timeout, elapsed_time)) {
			//sprintf(txt, "Round Ends");
			//swprintf(tmp_ustr, SC_Wtxt(1624));
			//SC_Fnt_WriteW(x/2.0 - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0, y-50.0, tmp_ustr, 2.0f, 0xff00ff00);

			if (CLN_winning_side >= -1) { // znamena, ze bylo ukonceno kolo
				switch(/*MAX_MUL_get_real_side(*/CLN_winning_side)/*)*/ {
				case SC_P_SIDE_US:
					swprintf(tmp_ustr, SC_Wtxt(1630));
					SC_SND_PlaySound2D(3167);
					//sprintf(txt, "US army wins");
					break;
				case SC_P_SIDE_VC:
					swprintf(tmp_ustr, SC_Wtxt(1631));
					SC_SND_PlaySound2D(3148);
					//sprintf(txt, "Vietcong wins");
					break;
				case -1:
					swprintf(tmp_ustr, SC_Wtxt(1632));
					//sprintf(txt, "??? draw game ???");
					break;
				}
				//SC_Fnt_WriteW(x/2.0 - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0, y/2.0, tmp_ustr, 2.0f, 0xffff8000);
				SC_HUD_AddStateText(tmp_ustr, GAME_PHASE_ENDING_LENGHT, GAME_PHASE_ENDING_LENGHT+2.0, 0xffff8000, 0);

			} else { // (asi -2) znamena, ze bylo splneno end_rule (DM) a vitezna hrac se vezme podle bodu
				dword		pl_handle;
				dword		side;
				sc_player	player;
				int			points;

				if (SC_MP_GetHighestPointsPlayer(&pl_handle, &points)) {
					player = MAX_SUP_get_pl_id_from_handle(pl_handle);
					if (player) {
						SC_P_GetName(player, NULL, tmp_ustr);
						SC_P_GetSideGroupMemberId(player, &side, NULL, NULL);

						if (side == SC_P_SIDE_US)
							SC_SND_PlaySound2D(3167);
						else
							SC_SND_PlaySound2D(3148);

						swprintf(tmp_ustr, SC_Wtxt(1633), tmp_ustr);
						//sprintf(txt, "%s win's the round", txt);
						//x -= SC_Fnt_GetWidthW(tmp_ustr, 2.0)/2.0;

						//SC_Fnt_WriteW(x/2.0, 150, tmp_ustr, 2.0f, 0xffffffff);
						SC_HUD_AddStateText(tmp_ustr, GAME_PHASE_ENDING_LENGHT, GAME_PHASE_ENDING_LENGHT+2.0, 0xffffffff, 0);
					}
				}
			}

			//timeout = 1.0;
			timeout = GAME_PHASE_ENDING_LENGHT;
		}
		break;

	case GAME_PHASE_RESTARTING:
		timeout -= elapsed_time;
		if (timeout <= 0.0) {
			swprintf(tmp_ustr, SC_Wtxt(1655), ((dword)(CLN_round_time+0.9)));
			SC_HUD_AddStateText(tmp_ustr, 0.15, 0.7, 0xffff0000, 0);
			timeout = 0.5;
		}
		break;
	/*case ENDRULE_PH_ENDTIME:
		sprintf(txt,"End rule time reached");
		SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
		break;
	case ENDRULE_PH_ENDSCORE:
		sprintf(txt,"End rule score reached");
		SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
		break;*/

	}// switch
}
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_render_team_score() {
	ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
	char	tmp_str[MAX_STRING_LEN_LONG];
	int		i;
	int		index;

	static int	hud_pos_side1 = -1, hud_pos_side2 = -1;

	if (hud_pos_side1 == -1)
		MAX_HUD_add_item(&hud_pos_side1);

	if (hud_pos_side2 == -1)
		MAX_HUD_add_item(&hud_pos_side2);

	sprintf(tmp_str, "%d", SC_MP_Side_GetPoints(SIDE1));
	SC_AnsiToUni(tmp_str, tmp_ustr);

	SC_HUD_SetLeftTopIcon(hud_pos_side1, HUD_ICON_FLAG_INBASE_US, tmp_ustr);

	sprintf(tmp_str, "%d", SC_MP_Side_GetPoints(SIDE2));
	SC_AnsiToUni(tmp_str, tmp_ustr);

	SC_HUD_SetLeftTopIcon(hud_pos_side2, HUD_ICON_FLAG_INBASE_VC, tmp_ustr);
}*/
//-------------------------------------------------------------------------------------------------------------------------------
#ifdef OBJECTS_COUNT
void MAX_MUL_render_objects_status() {
	//char	txt[256];
	ushort	tmp_ustr[256];
	float	x, y;
	int		i;
	dword	side1, side2;
	dword	color;
	float	tmp_time;

	if (MAX_MUL_local_player == 0) MAX_MUL_local_player = SC_PC_Get();

	/*if (MAX_MUL_object[i].CLN_object_status->pl_handle)
		SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(MAX_MUL_object[i].CLN_object_status->pl_handle), &side1, NULL, NULL);
	else
		side1 = -2;*/

	if (MAX_MUL_local_player)
		SC_P_GetSideGroupMemberId(MAX_MUL_local_player, &side2, NULL, NULL);
	else
		side2 = -1;

#ifdef ROUND_TIMEOUT_WINNING_SIDE_COUNT
	CLEAR(g_MAX_RULE_data);
	ROUND_TIMEOUT_WINNING_SIDE[0](&g_MAX_RULE_data);
	side1 = MAX_SUP_get_opp_side(g_MAX_RULE_data.side);
#else
	side1 = side2;
#endif

	SC_GetScreenRes(NULL, &y);

	if (side1 == side2) {
		switch(CLN_game_phase) {
		case GAME_PHASE_ENDING:
		case GAME_PHASE_RUNNING:
			y -= 100.0;

			for (i=0; i<OBJECTS_COUNT; i++) {
				if (MAX_MUL_object[i].nod == NULL) continue;
				if (MAX_MUL_object[i].CLN_object_status == NULL) continue;
				/*x  = 10.0;
				sprintf(txt, "%s: ", SC_NOD_GetName(MAX_MUL_object[i].nod));
				SC_Fnt_Write(x, y, txt, 1.0f, 0xffffffff);
				x += SC_Fnt_GetWidth(txt, 1.0f);*/
				
				switch (MAX_MUL_object[i].CLN_object_status->state) {
				case STATE_INIT:
					if (MAX_MUL_object[i].hud_is_rendering) {
						MAX_MUL_object[i].hud_is_rendering = FALSE;
						MAX_HUD_remove_item(&MAX_MUL_object[i].hud_pos);
					}
					/*sprintf(txt, "OK");
					color = 0xff00ff00;*/
					break;
				case STATE_PLACING:
					/*sprintf(txt, "PLACING");
					color = 0xffffff00;*/
					break;
				case STATE_ACTIVE:
				case STATE_DEFUSING:
					if (!MAX_MUL_object[i].hud_is_rendering) {
						MAX_MUL_object[i].hud_is_rendering = TRUE;
						MAX_HUD_add_item(&MAX_MUL_object[i].hud_pos);
					}

					if (MAX_MUL_object[i].CLN_object_status->timer < 0.0)
						tmp_time = 0.0;
					else
						tmp_time = MAX_MUL_object[i].CLN_object_status->timer;

					{
						ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
						ushort	help[MAX_STRING_LEN_LONG*2];

						swprintf(tmp_ustr, SC_AnsiToUni("%02d:%02d", help), (dword)(tmp_time/60.0f),((dword)tmp_time)%60);
						SC_HUD_SetLeftTopIcon(MAX_MUL_object[i].hud_pos, HUD_ICON_C4, tmp_ustr);
					}
					
					break;
				//case STATE_DEFUSING:
				//	break;
				case STATE_DEFUSED:
					if (MAX_MUL_object[i].hud_is_rendering) {
						MAX_MUL_object[i].hud_is_rendering = FALSE;
						MAX_HUD_remove_item(&MAX_MUL_object[i].hud_pos);
					}
					break;
				case STATE_DESTROYED:
					if (MAX_MUL_object[i].hud_is_rendering) {
						MAX_MUL_object[i].hud_is_rendering = FALSE;
						MAX_HUD_remove_item(&MAX_MUL_object[i].hud_pos);
					}
					break;
				}
				
				/*SC_Fnt_Write(x, y, txt, 1.0f, color);
				y += 15;*/
			} //for
			break;
		} // switch
	} /*else {// if (side1 == side2)
		switch(CLN_game_phase) {
		case GAME_PHASE_ENDING:
		case GAME_PHASE_RUNNING:
			y -= 100.0;

			for (i=0; i<OBJECTS_COUNT; i++) {
				if (MAX_MUL_object[i].nod == NULL) continue;
				if (MAX_MUL_object[i].CLN_object_status == NULL) continue;
				x  = 10.0;
				sprintf(txt, "%s: ", SC_NOD_GetName(MAX_MUL_object[i].nod));
				SC_Fnt_Write(x, y, txt, 1.0f, 0xffffffff);
				x += SC_Fnt_GetWidth(txt, 1.0f);
				
				switch (MAX_MUL_object[i].CLN_object_status->state) {
				case STATE_INIT:
				case STATE_PLACING:
				case STATE_ACTIVE:
				case STATE_DEFUSING:
				case STATE_DEFUSED:
					sprintf(txt, "OK");
					color = 0xff00ff00;
					break;
				case STATE_DESTROYED:
					sprintf(txt, "DESTROYED");
					color = 0xffff0000;
					break;
				}
				
				SC_Fnt_Write(x, y, txt, 1.0f, color);
				y += 15;
			} //for
			break;
		} // switch
	}*/


	switch(CLN_game_phase) {
	case GAME_PHASE_ENDING:
	case GAME_PHASE_RUNNING:
		SC_GetScreenRes(&x, &y);
		x /= 2.0;
		y /= 2.0;
		y -= 150.0;

		for (i=0; i<OBJECTS_COUNT; i++) {
			if (MAX_MUL_object[i].nod == NULL) continue;
			if (MAX_MUL_object[i].CLN_object_status == NULL) continue;
			if (CLN_old_object_state[i] == MAX_MUL_object[i].CLN_object_status->state) continue;
			switch (MAX_MUL_object[i].CLN_object_status->state) {
			case STATE_INIT:
				//CLN_show_object_timeout[i] = -1.0;
				break;
			case STATE_PLACING:
				//swprintf(tmp_ustr, SC_Wtxt(1638));
				//SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFFFFFF, 0);
				//sprintf(txt, "Bomb has been defused !!!"); // kdyby to nekdo zacal hnedka pokladat
				break;
			case STATE_ACTIVE:
				//swprintf(tmp_ustr, SC_Wtxt(1639));
				//sprintf(txt, "Bomb has been placed !!!");
				//if (CLN_old_object_state[i] == STATE_PLACING) CLN_show_object_timeout[i] = 5.0;
				if (CLN_old_object_state[i] == STATE_PLACING) {
					sc_player	player;

					player = MAX_SUP_get_pl_id_from_handle(MAX_MUL_object[i].CLN_object_status->pl_handle);
					if (player) {
						SC_P_GetName(player, NULL, tmp_ustr);
						swprintf(tmp_ustr, SC_Wtxt(1711), tmp_ustr);
						//SC_HUD_AddStateText(SC_Wtxt(1639), HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF1000, 0);
						SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF1000, 0);
					}
				}
				break;
			case STATE_DEFUSING:
				//swprintf(tmp_ustr, SC_Wtxt(1639));
				//sprintf(txt, "Bomb has been placed !!!"); // kdyby to nekdo zacal hnedka odstranovat ...
				break;
			case STATE_DEFUSED:
				//sprintf(txt, "Bomb has been defused !!!");
				//swprintf(tmp_ustr, SC_Wtxt(1638));
				//if (CLN_old_object_state[i] == STATE_DEFUSING) CLN_show_object_timeout[i] = 5.0;
				//SC_HUD_AddStateText(SC_Wtxt(1638), HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF1000, 0);
				if (CLN_old_object_state[i] == STATE_DEFUSING) {
					sc_player	player;
					player = MAX_SUP_get_pl_id_from_handle(MAX_MUL_object[i].CLN_object_status->pl_handle);
					if (player) {
						SC_P_GetName(player, NULL, tmp_ustr);
						swprintf(tmp_ustr, SC_Wtxt(1710), tmp_ustr);
						SC_HUD_AddStateText(tmp_ustr, HUD_MIN_TIME, HUD_MAX_TIME, 0xFFFF1000, 0);
					}
				}
				break;
			case STATE_DESTROYED:
				//CLN_show_object_timeout[i] = -1.0;
				break;
			} //switch (MAX_MUL_object[i].CLN_object_status->state)

			/*if (CLN_show_object_timeout[i] > 0.0) {
				SC_Fnt_WriteW(x - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0, y, tmp_ustr, 2.0f, 0xffff1000);
				SC_Fnt_WriteW(x - SC_Fnt_GetWidthW(tmp_ustr, 2.0f)/2.0 + 1.0, y, tmp_ustr, 2.0f, 0xffff1000);
				y += 15.0;
			}*/

			CLN_old_object_state[i] = MAX_MUL_object[i].CLN_object_status->state;
		} // for

		break;
	}// switch(CLN_game_phase)
}
#endif
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_render_end_rules() {
	dword	data;
	char	txt[256];
	float	x, y;
	dword	best_mp_id;
	int		best_score;


	SC_GetScreenRes(&x, NULL);

	switch(CLN_game_phase) {
	case GAME_PHASE_ENDING:
	case GAME_PHASE_RUNNING:
		x-= 10.0;
		y = 20.0;

		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data)) {
			sprintf(txt, "Round time: %02d:%02d", (dword)(CLN_round_time/60.0f),((dword)CLN_round_time)%60);
			//sprintf(txt, "End rule time: %02d:%02d ( %02d:00 )", (dword)(CLN_round_time/60.0f),((dword)CLN_round_time)%60, data);

			SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
			y += 15;
		}

		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {
			sprintf(txt, "End rule time: %02d:%02d ( %02d:00 )", (dword)(CLN_game_time/60.0f),((dword)CLN_game_time)%60, data);

			SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
			y += 15;
		}

		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_SCORE, &data)) {

			if (!SC_MP_GetHighestPointsPlayer(&best_mp_id, &best_score)) best_score = 0;
			sprintf(txt, "End rule score: %d ( %d )", best_score, data);

			SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
			y += 15;
		}

		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TEAMSCORE, &data)) {
			int		side1_score, side2_score;

			side1_score = MAX_MUL_get_score_side(SIDE1);
			side2_score = MAX_MUL_get_score_side(SIDE2);

			//if (!SC_MP_GetHighestPointsPlayer(&best_mp_id, &best_score)) best_score = 0;
			sprintf(txt, "End rule team score: %d ( %d )", side1_score>side2_score?side1_score:side2_score, data);

			SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
			y += 15;
		}

		break;
	//case ENDRULE_PH_ENDTIME:
		//sprintf(txt,"End rule time reached");
		//SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
		//break;
	//case ENDRULE_PH_ENDSCORE:
		//sprintf(txt,"End rule score reached");
		//SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);
		//break;

	}// switch
}*/
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_render_reinforcements() {
	dword	data;
	char	txt[256];
	float	x, y;
	float	reinforcement_time;

	SC_GetScreenRes(&x, NULL);
	x-= 10.0;
	y =  5.0;


	switch(CLN_game_phase) {
	case GAME_PHASE_RUNNING:
		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data)) {

			switch(data) {
			case 0:
				return; //zadne posily -> respawn okamzite
				break;
			case 1:
				reinforcement_time = 10.0;
				break;
			case 2:
				reinforcement_time = 30.0;
				break;
			case 3:
				reinforcement_time = 60.0;
				break;
			case 4:
				return; // cely tym
				break;

			default:
				reinforcement_time = (float)data;
				break;
			}
			sprintf(txt,"Reinforcements in %02d:%02d ( %02d:%02d )", (dword)((CLN_reinforcements_timer+0.9)/60.0), ((dword)(CLN_reinforcements_timer+0.9))%60,
				(dword)(reinforcement_time/60.0), ((dword)reinforcement_time)%60);

			if (CLN_reinforcements_timer+0.9 < 5.0)
				SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffff2000);
			else
				SC_Fnt_Write(x - SC_Fnt_GetWidth(txt, 1.0f), y, txt, 1.0f, 0xffffffff);

			y += 15;
		}
		break;
	}
}*/
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_respawning_add(dword pl_handle, float time){
	dword i;	

	for (i=0; i<MAX_MUL_respawn_count; i++) {
		if (MAX_MUL_respawn_array[i].pl_handle == pl_handle) {
			MAX_MUL_respawn_array[i].time = time;
			return;
		}
	}

	if (MAX_MUL_respawn_count >= MAX_MUL_PLAYERS) {
		SC_message("!max_multiplayer.cxx err : MAX_MUL_respawn_count >= MAX_MUL_PLAYERS");
	} else {
		MAX_MUL_respawn_array[MAX_MUL_respawn_count].pl_handle = pl_handle;
		MAX_MUL_respawn_array[MAX_MUL_respawn_count].time = time;
		MAX_MUL_respawn_count++;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_respawning_add(dword pl_handle, float time, int repeat){
	dword i;	

	for (i=0; i<MAX_MUL_respawn_count; i++) {
		if (MAX_MUL_respawn_array[i].pl_handle == pl_handle) {
			MAX_MUL_respawn_array[i].time = time;
			return;
		}
	}

	if (MAX_MUL_respawn_count >= MAX_MUL_PLAYERS) {
		SC_message("!max_multiplayer.cxx err : MAX_MUL_respawn_count >= MAX_MUL_PLAYERS");
	} else {
		MAX_MUL_respawn_array[MAX_MUL_respawn_count].pl_handle = pl_handle;
		MAX_MUL_respawn_array[MAX_MUL_respawn_count].time = time;
		MAX_MUL_respawn_count++;
	}
}*/
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_respawning_remove(dword pl_handle) {
	dword	i;

	for (i=0; i<MAX_MUL_respawn_count; i++)
		if (MAX_MUL_respawn_array[i].pl_handle == pl_handle){
			MAX_MUL_respawn_count--;
			MAX_MUL_respawn_array[i] = MAX_MUL_respawn_array[MAX_MUL_respawn_count];
			i--;
			break;
		}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_respawning_remove_all() {
	MAX_MUL_respawn_count = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_srv_respawning_tick(float elapsed_time) {
	dword	i;

	for (i=0; i<MAX_MUL_respawn_count; i++) {
		MAX_MUL_respawn_array[i].time -= elapsed_time;
		if (MAX_MUL_respawn_array[i].time <= 0.0f){

			SC_MP_P_PressFireRequest(MAX_MUL_respawn_array[i].pl_handle, TRUE);

			MAX_MUL_respawn_count--;
			MAX_MUL_respawn_array[i] = MAX_MUL_respawn_array[MAX_MUL_respawn_count];
			i--;
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_respawn_player(dword pl_handle) {
	dword	respawn_id;

	respawn_id = SC_MP_RespawnGroup_GetFromPlayer(pl_handle);
	if (respawn_id == 0) {
		dword	side;
		int		i;

		SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(pl_handle), &side, NULL, NULL);

		if (side == SIDE1) {
			for (i=0; i<GROUPS_COUNT_SIDE1; i++) {
				if (MAX_MUL_respawn[i].is_active) {
					respawn_id = MAX_MUL_respawn[i].id;
					break;
				}
			}
#ifdef GROUPS_COUNT_SIDE2
		} else if (side == SIDE2) {
			for (i=0; i<GROUPS_COUNT_SIDE2; i++) {
				if (MAX_MUL_respawn[GROUPS_COUNT_SIDE1+i].is_active) {
					respawn_id = MAX_MUL_respawn[GROUPS_COUNT_SIDE1+i].id;
					break;
				}
			}
#endif
		} else if (side == SC_P_SIDE_MP_SPECTATOR) {
			//SC_message("MAX_MUL_respawn_player - error - hrac ma SIDE == SC_P_SIDE_MP_SPECTATOR");
			return;
		}
	}

	if (respawn_id == 0) SC_message("MAX_MUL_respawn_player() total FATAL");

	SC_MP_RespawnPlayer(pl_handle, respawn_id);
	MAX_MUL_local_player = 0;
	MAX_MUL_local_pl_handle = 0;

	//MAX_MUL_check_best_score(GAME_TYPE, FALSE);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reinforcements_add(dword pl_handle, BOOL respawn_now) {
	dword i;

	if (respawn_now) {
		MAX_MUL_respawn_player(pl_handle);
		return;
	}

	for (i=0; i<MAX_MUL_reinforcements_count; i++) {
		if (MAX_MUL_reinforcements_array[i].pl_handle == pl_handle) return;
	}

	if (MAX_MUL_reinforcements_count >= MAX_MUL_PLAYERS) {
		SC_message("!max_multiplayer.cxx err : MAX_MUL_reinforcements_count >= MAX_MUL_PLAYERS");
	} else {
		MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count].pl_handle = pl_handle;
		MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count].repeat = 0;
		MAX_MUL_reinforcements_count++;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reinforcements_add(dword pl_handle, BOOL respawn_now, int repeat) {
	dword i;

	if (respawn_now) {
		MAX_MUL_respawn_player(pl_handle);
		return;
	}

	for (i=0; i<MAX_MUL_reinforcements_count; i++) {
		if (MAX_MUL_reinforcements_array[i].pl_handle == pl_handle) return;
	}

	if (MAX_MUL_reinforcements_count >= MAX_MUL_PLAYERS) {
		SC_message("!max_multiplayer.cxx err : MAX_MUL_reinforcements_count >= MAX_MUL_PLAYERS");
	} else {
		MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count].pl_handle = pl_handle;
		MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count].repeat = repeat;
		MAX_MUL_reinforcements_count++;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reinforcements_remove(dword pl_handle) {
	dword	i;

	for (i=0; i<MAX_MUL_reinforcements_count; i++)
		if (MAX_MUL_reinforcements_array[i].pl_handle == pl_handle) {
			SC_MP_P_PressFireRequest(pl_handle, FALSE);
			MAX_MUL_reinforcements_count--;
			MAX_MUL_reinforcements_array[i] = MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count];
			i--;
			break;
		}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_reinforcements_remove_all() {
	dword	i;
	for (i=0; i<MAX_MUL_reinforcements_count; i++) {
		SC_MP_P_PressFireRequest(MAX_MUL_reinforcements_array[i].pl_handle, FALSE);
	}
	MAX_MUL_reinforcements_count = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_do_reinforcements_respawn(int side_mask) {
	dword	i;

	for (i=0; i<MAX_MUL_reinforcements_count; i++) {
		if (MAX_MUL_reinforcements_array[i].repeat > 0) {
			MAX_MUL_reinforcements_array[i].repeat--;
		} else {
			if (side_mask >=0x100) continue;
			if (side_mask > 0) {
				sc_player	player;
				dword		side;

				player = MAX_SUP_get_pl_id_from_handle(MAX_MUL_reinforcements_array[i].pl_handle);
				SC_P_GetSideGroupMemberId(player, &side, NULL, NULL);
				if ( ((side == SIDE1) && (side_mask&1)) || ((side == SIDE2) && (side_mask&2)) ) {
					SC_MP_P_PressFireRequest(MAX_MUL_reinforcements_array[i].pl_handle, FALSE);
					MAX_MUL_respawn_player(MAX_MUL_reinforcements_array[i].pl_handle);
					//MAX_MUL_reinforcements_remove(MAX_MUL_reinforcements_array[i].pl_handle);
					MAX_MUL_reinforcements_count--;
					MAX_MUL_reinforcements_array[i] = MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count];
					i--;
				}
			} else if (side_mask == 0) {
				SC_MP_P_PressFireRequest(MAX_MUL_reinforcements_array[i].pl_handle, FALSE);
				MAX_MUL_respawn_player(MAX_MUL_reinforcements_array[i].pl_handle);
				//MAX_MUL_reinforcements_remove(MAX_MUL_reinforcements_array[i].pl_handle);
				MAX_MUL_reinforcements_count--;
				MAX_MUL_reinforcements_array[i] = MAX_MUL_reinforcements_array[MAX_MUL_reinforcements_count];
				i--;
			}
		}
	}

	//MAX_MUL_reinforcements_remove_all();
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_cln_reinforcements_tick(float elapsed_time) {
	CLN_reinforcements_timer -= elapsed_time;
	if (CLN_reinforcements_timer <= 0.0) CLN_reinforcements_timer = 0.0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_srv_reinforcements_tick(float elapsed_time) {
	dword		data;
	static int	side_mask = 0; // 1 pro SIDE1, 2 pro SIDE2, 3 pro OBE
	static BOOL	case4_respawn = FALSE;

	SRV_reinforcements_timer -= elapsed_time;
	if (SRV_reinforcements_timer <= 0.0) {
		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data)) {
			switch(data) {
			case 0:
				SRV_reinforcements_timer = 0.0; //zadne posily -> respawn okamzite
				side_mask = 0;
				case4_respawn = FALSE;
				break;
			case 1:
				SRV_reinforcements_timer = 10.0;
				side_mask = 0;
				case4_respawn = FALSE;
				SC_MP_Synch_SendChanges(SYNCH_REINFORCEMENT, TRUE);
				break;
			case 2:
				SRV_reinforcements_timer = 30.0;
				side_mask = 0;
				case4_respawn = FALSE;
				SC_MP_Synch_SendChanges(SYNCH_REINFORCEMENT, TRUE);
				break;
			case 3:
				SRV_reinforcements_timer = 60.0;
				side_mask = 0;
				case4_respawn = FALSE;
				SC_MP_Synch_SendChanges(SYNCH_REINFORCEMENT, TRUE);
				break;
			case 4:
				SRV_reinforcements_timer = -1.0; // cely tym
				{
					int			num;

					if (case4_respawn) {
						case4_respawn = FALSE;
						break;
					}
					side_mask = -1;

					num = MAX_MUL_PLAYERS;
					MAX_MUL_get_players_allive_coma(SIDE1, &num, NULL);

					if (num == 0) {
						if (side_mask == -1)
							side_mask = 1;
						else
							side_mask |= 1;

						SRV_reinforcements_timer = 2.0;
						case4_respawn = TRUE;

						//goto max_mp_preskoc;
						break;
					}

					#ifdef GROUPS_COUNT_SIDE2
						num = MAX_MUL_PLAYERS;
						MAX_MUL_get_players_allive_coma(SIDE2, &num, NULL);

						if (num == 0) {
							if (side_mask == -1)
								side_mask = 2;
							else
								side_mask |= 2;

							SRV_reinforcements_timer = 2.0;
							case4_respawn = TRUE;
							//goto max_mp_preskoc;

							break;
						}
					#endif
				}
				break;

			default:
				SRV_reinforcements_timer = (float)data;
				SC_MP_Synch_SendChanges(SYNCH_REINFORCEMENT, TRUE);
				break;
			} // switch
		} else {
			SRV_reinforcements_timer = 0.0;
		}

		if (!case4_respawn) MAX_MUL_do_reinforcements_respawn(side_mask);
		//if (side_mask < 0x100) side_mask = 0; // pokud probehlo druhe kolo z case 4
//max_mp_preskoc:
		SRV_reinforcements_timer_update = 4.0;		//update time !!!
	}
	CLN_reinforcements_timer  = SRV_reinforcements_timer;

	SRV_reinforcements_timer_update -= elapsed_time;
	if (SRV_reinforcements_timer_update <= 0.0) {
		SRV_reinforcements_timer_update = 4.0;		//update time !!!
		SC_MP_Synch_SendChanges(SYNCH_REINFORCEMENT, TRUE);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
#ifdef OBJECTS_COUNT
void MAX_MUL_srv_object_changed_state() {
	int		i;

	for (i=0; i<OBJECTS_COUNT; i++) {
		switch (MAX_MUL_object[i].CLN_object_status->state) { // na serveru je CLN_object_status a SRV_object_status stejny pointer
		case STATE_INIT:
			break;
		case STATE_PLACING:
			break;
		case STATE_ACTIVE:
			if (SRV_old_object_state[i] == STATE_PLACING)
				SC_MP_P_ChangePoint(MAX_MUL_object[i].CLN_object_status->pl_handle, P_ACTIVATE);
			break;
		case STATE_DEFUSING:
			break;
		case STATE_DEFUSED:
			if (SRV_old_object_state[i] == STATE_DEFUSING)
				SC_MP_P_ChangePoint(MAX_MUL_object[i].CLN_object_status->pl_handle, P_DEACTIVATE);
			break;
		case STATE_DESTROYED: // pricita se primo u testovani znicineho objektu v .c souboru, ktery tohle includuje
			break;
		} //switch (MAX_MUL_object[i].CLN_object_status->state)

		SRV_old_object_state[i] = MAX_MUL_object[i].CLN_object_status->state;
	}
}
#endif
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_get_best_player(dword *pl_handle, int *points) { // vraci NULL, pokud je vice lepsich (shodne skore)
	int			i, num, num_tmp, tmp_points, best_points = -1000;
	sc_player	list[MAX_MUL_PLAYERS];
	sc_player	list_tmp[MAX_MUL_PLAYERS];
	sc_player	best_player;
	dword		tmp_handle;
	BOOL		best_player_exist;

	best_player_exist = FALSE;

	num = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_respawned(SC_P_SIDE_US, &num, list);
	num_tmp = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_respawned(SC_P_SIDE_VC, &num_tmp, list_tmp);

	for (i=0; i<num_tmp; i++) {
		if (i+num >= MAX_MUL_PLAYERS) break;
		list[i+num] = list_tmp[i];
	}

	for (i=0; i<num; i++) {
		tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
		tmp_points = SC_MP_P_GetPoints(tmp_handle);

		if (!best_player_exist) {
			s_SC_MP_P_PlayStats	stats;

			SC_MP_P_GetPlayStats(tmp_handle, &stats);

			if ((stats.kills != 0) || (stats.deaths != 0) || (stats.exp != 0))
				best_player_exist = TRUE;
		}

		if (best_points < tmp_points) {
			best_player = list[i];
			best_points = tmp_points;
		} else if (best_points == tmp_points) {
			best_player = NULL;
		}
	}

	if (!best_player_exist) return FALSE;

	if (best_player) {
		*pl_handle = MAX_SUP_get_handle_from_pl_id(best_player);
		*points = SC_MP_P_GetPoints(*pl_handle);
		return TRUE;
	} else {
		*points = 0;
		*pl_handle = 0;
		return FALSE;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_player_com_healed(s_SC_ModeScript_info *info) {
	SC_MP_P_ChangePoint(info->param1, P_HEAL_COMMA);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_player_killed(s_SC_ModeScript_info *info) {
	dword	side1, side2;
	int		value;
	dword	pl_handle;
	int		points;

#ifdef CHECK_SIDES_READY_COUNT
	if (!SRV_sides_ready) {
		info->param10 = 0;
		info->param11 = 0;
		return; //strany nejsou ready -> neprideluji body
	}
#endif

	if (info->param1==info->param2) {	// suicide
		//SC_MP_P_ChangePoint(info->param1, P_SUICIDE);
		info->param10 = 0;
		info->param11 = P_SUICIDE;
		if (GAME_TYPE == GAME_TYPE_TDM) {
			SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param1), &side1, NULL, NULL);
			SC_MP_Side_SetPoints((side1==SIDE1)?SIDE1:SIDE2, SC_MP_Side_GetPoints((side1==SIDE1)?SIDE1:SIDE2)-1);
		}
	} else if (info->param2) {	// nekdo ho zabil

		SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param1), &side1, NULL, NULL);
#ifdef GROUPS_COUNT_SIDE2
		SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param2), &side2, NULL, NULL);
#else
		if (GAME_TYPE == GAME_TYPE_COOP)
			SC_P_GetSideGroupMemberId(MAX_SUP_get_pl_id_from_handle(info->param2), &side2, NULL, NULL);
		else
			side2 = -1;
#endif

		if (side1 == side2) {
			if (info->param5 == 0) // team kill
				value = P_KILL_ALLY;
			else
				value = P_KILL_ALLY_ACCIDENT;

		} else {
			if (MAX_MUL_get_best_player(&pl_handle, &points)) {
				if ((points > 0) && (info->param1 == pl_handle)) {
					value = P_KILL_ENEMY_BEST;
				} else {
					value = P_KILL_ENEMY;
				}
			} else {
				value = P_KILL_ENEMY;
			}

			if ((info->param3 == 29)||(info->param3 == 30)||(info->param3 == 69)) value += P_KILL_ENEMY_KNIFE - P_KILL_ENEMY;
		}
					
		//SC_MP_P_ChangePoint(info->param2, value);
		info->param10 = 0;
		info->param11 = value;

		if (GAME_TYPE == GAME_TYPE_TDM) {
			if (value < 0)
				SC_MP_Side_SetPoints((side2==SIDE1)?SIDE1:SIDE2, SC_MP_Side_GetPoints((side2==SIDE1)?SIDE1:SIDE2)-1);
			else if (value > 0)
				SC_MP_Side_SetPoints((side2==SIDE1)?SIDE1:SIDE2, SC_MP_Side_GetPoints((side2==SIDE1)?SIDE1:SIDE2)+1);
		}
	}

	//MAX_MUL_check_best_score(GAME_TYPE, FALSE);
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_press_fire_text(s_SC_ModeScript_info *info) {
	if (info->param1) {
		dword data;
		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data))
			switch (data) {
			case 0:
				swprintf((ushort *)info->param2, SC_Wtxt(1648));
				break;
			case 1:
			case 2:
			case 3:
				swprintf((ushort *)info->param2, SC_Wtxt(1649), (dword)((CLN_reinforcements_timer+0.9)/60.0), ((dword)(CLN_reinforcements_timer+0.9))%60);
				break;
			case 4:
				swprintf((ushort *)info->param2, SC_Wtxt(1648));
				break;
			default:
				swprintf((ushort *)info->param2, SC_Wtxt(1649), (dword)((CLN_reinforcements_timer+0.9)/60.0), ((dword)(CLN_reinforcements_timer+0.9))%60);
				break;
			}
			//swprintf((ushort *)info->param2, SC_Wtxt(1649), (dword)((CLN_reinforcements_timer+0.9)/60.0), ((dword)(CLN_reinforcements_timer+0.9))%60);
		else
			swprintf((ushort *)info->param2, SC_Wtxt(1648));
		//swprintf((ushort *)info->param2, SC_AnsiToUni("%s: ", help), SC_Wtxt(1610)); //score
		//swprintf((ushort *)info->param2, SC_Wtxt(1648));
		//SC_AnsiToUni("You are waiting to respawn ...", (ushort*)info->param2);
		info->param3 = 0xA0ffff00;
	} else {
		swprintf((ushort *)info->param2, SC_Wtxt(1650));
		//SC_AnsiToUni("Press Fire to respawn", (ushort*)info->param2);
		info->param3 = 0xffffff00;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_check_round_end(dword *side) {
	//int				i, num;
	//sc_player		list[MAX_MUL_PLAYERS];
	//static dword	pc_side = -1;
	int				result;
	dword			data;

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_SCORE, &data)) {
		dword	best_mp_id;
		int		best_score;
		if (SC_MP_GetHighestPointsPlayer(&best_mp_id, &best_score)){ 
			if (best_score >= (int)data) {
				*side = -2;
				return TRUE;
			}
		}
	}

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TEAMSCORE, &data)) {
		if (data > 0) {
			if (SC_MP_Side_GetPoints(SIDE1) >= (int)data) {
				*side = SIDE1;
				return TRUE;
			}
			else if (SC_MP_Side_GetPoints(SIDE2) >= (int)data) {
				*side = SIDE2;
				return TRUE;
			}
		}
	}

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {
		if (SRV_game_time > (data*60.0)) {

			if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TEAMSCORE, &data)) {
				if (SC_MP_Side_GetPoints(SIDE1) > SC_MP_Side_GetPoints(SIDE2))
					*side = SIDE1;
				else if (SC_MP_Side_GetPoints(SIDE1) < SC_MP_Side_GetPoints(SIDE2))
					*side = SIDE2;
				else
					*side = -1;

			} else {
				*side = -2;
			}
			
			return TRUE;
		}
	}

	if ((MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, NULL)) && (SRV_round_time <= 0.0)) {
#ifdef ROUND_TIMEOUT_WINNING_SIDE_COUNT
		for (g_i=0; g_i<ROUND_TIMEOUT_WINNING_SIDE_COUNT; g_i++) {
			CLEAR(g_MAX_RULE_data);
			if (ROUND_TIMEOUT_WINNING_SIDE[g_i](&g_MAX_RULE_data)) {
				*side = g_MAX_RULE_data.side;
				return TRUE;
			}
		}
#endif
		*side = -1;
		return TRUE;
	}

	result = MAX_MUL_srv_check_winning_rules();
	if (result == -1) return FALSE;

	*side = result;
	return TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------------
/*BOOL MAX_MUL_check_next_map() {
	dword	data;
	dword	best_mp_id;
	int		best_score;

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {
		if (SRV_game_time > (data*60.0)) {
			return TRUE;
		}
	}
	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_SCORE, &data)) {
		if (SC_MP_GetHighestPointsPlayer(&best_mp_id, &best_score)){ 
			if (best_score >= (int)data) {
				return TRUE;
			}
		}
	}
	switch(game_type) {
	case GAME_TYPE_DM:
		return TRUE;
		break;
	case GAME_TYPE_TDM:
		return TRUE;
		break;
	case GAME_TYPE_COOP:
		return TRUE;
		break;
	case GAME_TYPE_CTF:
		return TRUE;
		break;
	case GAME_TYPE_ASSAULT:
		break;
	case GAME_TYPE_SAD:
		return TRUE;
		break;

	default:
		break;

	}

	return FALSE;
}*/
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_switch_game_phase(dword phase, float new_phase_time) {
	if (phase == SRV_game_phase) return;

//	SC_Log(3, "Changing phase: %d", phase);

	SRV_game_time_update = new_phase_time;
	SRV_game_phase = phase;
	CLN_game_phase = phase;
	SC_MP_Synch_SendChanges(SYNCH_GAME_PHASE, TRUE);
	CLN_phase_changed = TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_cln_game_time_tick(float elapsed_time) {
	switch(CLN_game_phase) {
	case GAME_PHASE_WAITING:
		break;

	case GAME_PHASE_INITIALIZING:
		break;

	case GAME_PHASE_BEGIN:
		CLN_round_time -= elapsed_time;
		if (CLN_round_time < 0.0) CLN_round_time = 0.0;
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_RUNNING:
		CLN_game_time += elapsed_time;
		CLN_round_time-= elapsed_time;
		if (CLN_round_time < 0.0) CLN_round_time = 0.0;
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_ENDING:
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_RESTARTING:
		CLN_round_time -= elapsed_time;
		if (CLN_round_time < 0.0) CLN_round_time = 0.0;
		break;
	//-----------------------------------------------------------
	} // switch
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_srv_game_time_tick(float elapsed_time) {
	dword	data;
	dword	best_mp_id;
	int		best_score;
	static float	tmp_timeout = 0.0;

	switch(SRV_game_phase) {
	case GAME_PHASE_WAITING:
		break;

	case GAME_PHASE_INITIALIZING:
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_BEGIN:
		SRV_game_time_update -= elapsed_time;
		tmp_timeout -= elapsed_time;
		if (tmp_timeout <= 0.0) {
			SC_MP_Synch_SendChanges(SYNCH_ROUND_TIMER, FALSE);
			tmp_timeout = 1.8;
		}
		if (SRV_game_time_update <= 0.0) {
			MAX_MUL_switch_game_phase(GAME_PHASE_RUNNING, GAME_PHASE_RUNNING_LENGHT);

			if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data)) {
				SRV_round_time = data*60.0;
				SRV_round_time_update = 0.0;
			} else {
				SRV_round_time = -1.0;
				SRV_round_time_update = -1.0;
				//SRV_check_round_end_timer = -1.0;
			}
			SRV_reinforcements_timer = 0.0;
			SRV_reinforcements_timer_update = 0.0;

			// todle musi byt az tady protoze v restartu se posila request a ten dojde az nejakou dobu ...
			#ifdef WINNING_RULES_SIDE1_COUNT
				for (g_i=0; g_i<WINNING_RULES_SIDE1_COUNT; g_i++) {
					CLEAR(g_MAX_RULE_data);
					g_MAX_RULE_data.reinit = TRUE;
					WINNING_RULES_SIDE1[g_i](&g_MAX_RULE_data);
				}
			#endif
			#ifdef WINNING_RULES_SIDE2_COUNT
				for (g_i=0; g_i<WINNING_RULES_SIDE2_COUNT; g_i++) {
					CLEAR(g_MAX_RULE_data);
					g_MAX_RULE_data.reinit = TRUE;
					WINNING_RULES_SIDE2[g_i](&g_MAX_RULE_data);
				}
			#endif
			#ifdef GROUPS_COUNT_SIDE1
				for (g_i=0; g_i<GROUPS_COUNT_SIDE1; g_i++) {
					CLEAR(g_MAX_RULE_data);
					g_MAX_RULE_data.reinit = TRUE;
					if (respawn_groups_side1_rules[g_i]) respawn_groups_side1_rules[g_i](&g_MAX_RULE_data);
				}
			#endif
			#ifdef GROUPS_COUNT_SIDE2
				for (g_i=0; g_i<GROUPS_COUNT_SIDE2; g_i++) {
					CLEAR(g_MAX_RULE_data);
					g_MAX_RULE_data.reinit = TRUE;
					if (respawn_groups_side2_rules[g_i]) respawn_groups_side2_rules[g_i](&g_MAX_RULE_data);
				}
			#endif

			#ifdef BEGIN_AFTER_COUNT
				for (g_i=0; g_i<BEGIN_AFTER_COUNT; g_i++) {
					CLEAR(g_MAX_RULE_data);
					BEGIN_AFTER[g_i](&g_MAX_RULE_data);
				}
			#endif

			#ifdef OBJECTS_COUNT
				for (g_i=0; g_i<OBJECTS_COUNT; g_i++) {
					if (MAX_MUL_object[g_i].SRV_object_status == NULL) continue;
					MAX_MUL_object[g_i].SRV_object_status->side = SIDE1;
					MAX_MUL_object[g_i].SRV_object_status->state = STATE_INIT;
					MAX_MUL_object[g_i].SRV_object_status->timer = -1.0;
					MAX_MUL_object[g_i].SRV_object_status->pl_handle = 0;
					MAX_MUL_object[g_i].SRV_object_status->update = TRUE;
				}
			#endif

			SC_MP_Synch_SendChanges(SYNCH_SIDE1, FALSE);
			SC_MP_Synch_SendChanges(SYNCH_SIDE2, FALSE);
		}
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_RUNNING:
		// ------------------ ROUND TIME --------------------
		if (SRV_round_time >= 0.0) { // pokud je tohle od zacatku v minusu -> hra nema kola -> nepocita se round time
			SRV_round_time -= elapsed_time;
			CLN_round_time  = SRV_round_time;

			SRV_round_time_update -= elapsed_time;
			if (SRV_round_time_update <= 0.0) {
				SRV_round_time_update = 20.0;	//update time !!!
				SC_MP_Synch_SendChanges(SYNCH_ROUND_TIMER, TRUE);
			}
		}

		// ------------------ GAME TIME ---------------------
		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &data)) {
			SRV_game_time += elapsed_time;
			CLN_game_time  = SRV_game_time;

			/*if (SRV_game_time > (data*60.0)) {
				SRV_winning_side = -1;
				CLN_winning_side = SRV_winning_side;
				SC_MP_Synch_SendChanges(SYNCH_WINNING_SIDE, TRUE);
				MAX_MUL_switch_game_phase(GAME_PHASE_ENDING, GAME_PHASE_ENDING_LENGHT);
				return;
			}*/

			SRV_game_time_update -= elapsed_time;
			if (SRV_game_time_update <= 0.0) {
				SRV_game_time_update = 20.0;	//update time !!!
				SC_MP_Synch_SendChanges(SYNCH_GAME_TIMER, TRUE);
			}
		}
		// ----------------- GAME SCORE ---------------------
		/*if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_SCORE, &data)) {
			if (SC_MP_GetHighestPointsPlayer(&best_mp_id, &best_score)){ 
				if (best_score >= (int)data) {
					SRV_winning_side = -2;
					CLN_winning_side = SRV_winning_side;
					SC_MP_Synch_SendChanges(SYNCH_WINNING_SIDE, TRUE);
					MAX_MUL_switch_game_phase(GAME_PHASE_ENDING, GAME_PHASE_ENDING_LENGHT);
					return;
				}
			}
		}*/

		break;
	//-----------------------------------------------------------
	case GAME_PHASE_ENDING:
		SRV_game_time_update -= elapsed_time;
		if (MAX_SUP_count_timeout(&SRV_status_mode_timeout, elapsed_time)) {
			s_SC_MP_ResultsMode resultmode_info;
			CLEAR(resultmode_info);
			SC_MP_EnableResultsMode(&resultmode_info);
		}
		if (SRV_game_time_update <= 0.0) {
			MAX_MUL_respawning_remove_all();
			MAX_MUL_reinforcements_remove_all();
			MAX_MUL_switch_game_phase(GAME_PHASE_WHAT_NEXT, 0.0);
		}

		break;
	//-----------------------------------------------------------
	case GAME_PHASE_WHAT_NEXT:
		break;
	//-----------------------------------------------------------
	case GAME_PHASE_RESTARTING:
		SRV_game_time_update -= elapsed_time;
		if (SRV_game_time_update <= 0.0) {
#ifdef GROUPS_COUNT_SIDE1
			SC_MP_Side_SetPoints(SIDE1, 0);
#endif
#ifdef GROUPS_COUNT_SIDE2
			SC_MP_Side_SetPoints(SIDE2, 0);
#endif
			SC_MP_RestartRound();
		}
		break;
	}// switch
}// void _Srv_DoTick_EndRule(float time)
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_is_ready_to_respawn(dword pl_handle) {
	dword	data;

	if ((SRV_game_phase != GAME_PHASE_BEGIN) && (SRV_game_phase != GAME_PHASE_RUNNING)) return FALSE; // pro pripad, ze ho nekdo zabil v jine fazi

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data)) {
		switch(data) {
		case 0: // pokud nejsou zadne posily, tak se vypise za x sec press xxx to respawn
			return TRUE;
			break;

		case 1: // pokud jsou casove posily, tak se vypise za x sec press xxx to respawn
		case 2: // pokud jsou casove posily, tak se vypise za x sec press xxx to respawn
		case 3: // pokud jsou casove posily, tak se vypise za x sec press xxx to respawn
			return TRUE;
			break;

		case 4: // pokud pouze cely tym (ATG), tak pouze v RESPAWN_AFTER_CONNECT_TIME_LIMIT (restart)
			/*if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data)) 
				if (SRV_round_time >= (data*60.0 - RESPAWN_AFTER_CONNECT_TIME_LIMIT)) return TRUE;*/
			MAX_MUL_reinforcements_add(pl_handle, FALSE);
			SC_MP_P_PressFireRequest(pl_handle, TRUE);
			return FALSE;
			break;

		default:
			return TRUE;
			break;
		}
	} else {
		return TRUE;
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_restart_round() {
	int		i;

	SRV_status_mode_timeout = -1.0;

	CLN_rank = -1;
	MAX_MUL_old_remaining_time = 99999.0;

	MAX_MUL_reset_objectives();

	if (MAX_MUL_is_server) {
		MAX_MUL_release_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
		MAX_MUL_reinit_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
	}

#ifdef OBJECTS_COUNT
	SRV_CLN_object_is_initialized = FALSE;
#endif

	SRV_check_round_end_timer = 0.0;

	SRV_game_phase =		GAME_PHASE_WAITING;
	SRV_game_time_update =	0.0;
	SRV_round_time =		0.0;
	SRV_round_time_update =	0.0;
	SRV_reinforcements_timer = 0.0;
	SRV_reinforcements_timer_update = 0.0;

	CLN_game_phase =		GAME_PHASE_WAITING;
	CLN_round_time =		0.0;
	CLN_reinforcements_timer = 0.0;

	SRV_best_player = 0;
	SRV_best_team = -1;

	//SC_MP_DerespawnAllPlayers();
	if (MAX_MUL_is_server) {
		dword	side;

		MAX_MUL_respawning_remove_all();
		MAX_MUL_reinforcements_remove_all();

		MAX_MUL_num = MAX_MUL_PLAYERS;
		MAX_MUL_num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_num, SC_ENUMPLS_FL_NORESPAWNEDONLY|SC_ENUMPLS_FL_PC_ONLY);

		/*for (i=0; i<MAX_MUL_num; i++) {
			SC_P_GetSideGroupMemberId(MAX_MUL_list[i], &side, NULL, NULL);
			if (side != SC_P_SIDE_MP_SPECTATOR) MAX_MUL_reinforcements_add(MAX_SUP_get_handle_from_pl_id(MAX_MUL_list[i]), TRUE);
		}*/
		SC_MP_Synch_SendChanges(SYNCH_SIDE1, FALSE);
		SC_MP_Synch_SendChanges(SYNCH_SIDE2, FALSE);

		SC_MP_Synch_SendChanges(SYNCH_GAME_PHASE, FALSE);

		#ifdef CHECK_SIDES_READY_COUNT
			SRV_sides_ready = FALSE;
			SC_MP_Synch_SendChanges(SYNCH_SIDES_READY, FALSE);
		#endif

		MAX_MUL_set_difficulty();
	}

	#ifdef OBJECTS_COUNT
		MAX_MUL_object_remove_all();
	#endif

	#ifdef CHECK_SIDES_READY_COUNT
		CLN_sides_ready = FALSE;
	#endif

	MAX_MUL_local_player = 0;
	MAX_MUL_local_pl_handle = 0;

	MAX_MUL_release_hud();

	//SC_HUD_AddStateText((ushort *)"", 0.0, 0.0, 0x00000000, 0);
//	CLN_waiting_to_respawn = FALSE;

}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_restart_map() {
	int		i;

	SRV_status_mode_timeout = -1.0;

	CLN_rank = -1;
	MAX_MUL_old_remaining_time = 99999.0;

	MAX_MUL_reset_objectives();

	SIDE1 = original_SIDE1;
	SIDE2 = original_SIDE2;

#ifdef OBJECTS_COUNT
	SRV_CLN_object_is_initialized = FALSE;
#endif

	if (MAX_MUL_is_server) {
		MAX_MUL_release_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
		MAX_MUL_reinit_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);
	}

	SRV_check_round_end_timer = 0.0;

	SRV_game_phase =		GAME_PHASE_WAITING;
	SRV_game_time =			0.0;
	SRV_game_time_update =	0.0;
	SRV_round_time =		0.0;
	SRV_round_time_update =	0.0;
	SRV_reinforcements_timer = 0.0;
	SRV_reinforcements_timer_update = 0.0;

	CLN_game_phase =		GAME_PHASE_WAITING;
	CLN_game_time =			0.0;
	CLN_round_time =		0.0;
	CLN_reinforcements_timer = 0.0;

	SRV_best_player = 0;
	SRV_best_team = -1;

	//SC_MP_DerespawnAllPlayers();
	if (MAX_MUL_is_server) {
		dword	side;

		MAX_MUL_respawning_remove_all();
		MAX_MUL_reinforcements_remove_all();

		MAX_MUL_num = MAX_MUL_PLAYERS;
		MAX_MUL_num = SC_EnumPlayers(SC_P_SIDE_ALL, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_num, SC_ENUMPLS_FL_NORESPAWNEDONLY|SC_ENUMPLS_FL_PC_ONLY);

		/*for (i=0; i<MAX_MUL_num; i++) {
			SC_P_GetSideGroupMemberId(MAX_MUL_list[i], &side, NULL, NULL);
			if (side != SC_P_SIDE_MP_SPECTATOR) MAX_MUL_reinforcements_add(MAX_SUP_get_handle_from_pl_id(MAX_MUL_list[i]), TRUE);
			//SC_MP_P_ChangePoint(MAX_SUP_get_handle_from_pl_id(MAX_MUL_list[i]), 0);
		}*/
#ifdef GROUPS_COUNT_SIDE1
		SC_MP_Side_SetPoints(SIDE1, 0);
#endif

#ifdef GROUPS_COUNT_SIDE2
		SC_MP_Side_SetPoints(SIDE2, 0);
#endif

		SC_MP_Synch_SendChanges(SYNCH_SIDE1, FALSE);
		SC_MP_Synch_SendChanges(SYNCH_SIDE2, FALSE);

		SC_MP_Synch_SendChanges(SYNCH_GAME_PHASE, FALSE);

		#ifdef CHECK_SIDES_READY_COUNT
			SRV_sides_ready = FALSE;
			SC_MP_Synch_SendChanges(SYNCH_SIDES_READY, FALSE);
		#endif

		MAX_MUL_set_difficulty();
	}

	#ifdef OBJECTS_COUNT
		MAX_MUL_object_remove_all();
	#endif

	#ifdef CHECK_SIDES_READY_COUNT
		CLN_sides_ready = FALSE;
	#endif

	MAX_MUL_local_player = 0;
	MAX_MUL_local_pl_handle = 0;

	MAX_MUL_release_hud();

	//SC_HUD_AddStateText((ushort *)"", 0.0, 0.0, 0x00000000, 0);
//	CLN_waiting_to_respawn = FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_disable_player() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.movement	= FALSE;
	control.looking		= TRUE;
	control.interaction	= FALSE;
	control.phasechange	= FALSE;
	control.weapons		= FALSE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_enable_player() {
	s_SC_PC_Control	control;

	CLEAR(control);
	SC_PC_GetControl(&control);
	control.movement	= TRUE;
	control.looking		= TRUE;
	control.interaction	= TRUE;
	control.phasechange	= TRUE;
	control.weapons		= TRUE;
	SC_PC_SetControl(&control);
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_cln_event_dotick(s_SC_ModeScript_info *info) {

	switch(CLN_game_phase) {
	case GAME_PHASE_WAITING:
		/*#ifdef OBJECTS_COUNT
			if ((!SRV_CLN_object_is_initialized) && (!MAX_MUL_is_server)) {
				SRV_CLN_object_is_initialized = TRUE;
				for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
					SRV_old_object_state[g_i] = STATE_INIT;

				MAX_MUL_object_remove_all();
				MAX_MUL_objects_send_request();
			}
		#endif*/
//		SC_Log(3, "Client phase: GAME_PHASE_WAITING");
		break;

	case GAME_PHASE_INITIALIZING:
//		SC_Log(3, "Client phase: GAME_PHASE_INITIALIZING");
		if (CLN_phase_changed) {
			#ifdef OBJECTS_COUNT
				if ((SRV_CLN_object_is_initialized) && (!MAX_MUL_is_server))
					SRV_CLN_object_is_initialized = FALSE; // v dalsim tiku se to inicializuje
			#endif
			/*#ifdef OBJECTS_COUNT
				for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
					CLN_old_object_state[g_i] = STATE_INIT;

				if (!MAX_MUL_is_server) {
//					SC_Log(2, "XXXXX - remove_all - init");
					MAX_MUL_object_remove_all();
//					SC_Log(2, "XXXXX - send_request - init");
					MAX_MUL_objects_send_request();
//					SC_Log(2, "XXXXX - OK - init");
				}
			#endif*/
		}
		break;

	case GAME_PHASE_BEGIN:
//		SC_Log(3, "Client phase: GAME_PHASE_BEGIN");
		if (CLN_phase_changed) {
			MAX_MUL_disable_player();
		}
		break;

	case GAME_PHASE_RUNNING:
		if (CLN_phase_changed) {
			MAX_MUL_enable_player();
		}

		MAX_MUL_remaining_time_tick(CLN_game_time);

/*#ifdef OBJECTS_COUNT
		for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
			MAX_SUP_count_timeout(&CLN_show_object_timeout[g_i], info->elapsed_time);
#endif*/

		if ((SC_IsMpClient()) && ((GAME_TYPE == GAME_TYPE_DM) || (GAME_TYPE == GAME_TYPE_TDM)) ) {
			dword	tmp_rank;

			if (MAX_MUL_local_pl_handle == 0) MAX_MUL_local_pl_handle = MAX_SUP_get_handle_from_pl_id(SC_PC_Get());

			tmp_rank = SC_MP_P_GetCurrentRanking(MAX_MUL_local_pl_handle);
			if (CLN_rank == -1) CLN_rank = tmp_rank;
			if (tmp_rank < CLN_rank) {
				ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];

				swprintf(tmp_ustr, SC_Wtxt(1686), tmp_rank);
				SC_MP_AddMsgToKillList(tmp_ustr, 0, 0.0); // lost
			} else if (tmp_rank > CLN_rank) {
				ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];

				swprintf(tmp_ustr, SC_Wtxt(1687), tmp_rank);
				SC_MP_AddMsgToKillList(tmp_ustr, 0, 0.0); // better
			}
			CLN_rank = tmp_rank;
		}
		MAX_MUL_cln_reinforcements_tick(info->elapsed_time);
		break;

	case GAME_PHASE_ENDING:
/*#ifdef OBJECTS_COUNT
		for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
			MAX_SUP_count_timeout(&CLN_show_object_timeout[g_i], info->elapsed_time);
#endif*/
		break;

	/*case GAME_PHASE_WHAT_NEXT:
		if (!MAX_MUL_is_server) { // na serveru se to provede jinde
			#ifdef WHAT_NEXT_BEFORE_COUNT
				CLEAR(g_MAX_RULE_data);
				for (g_i=0; g_i<WHAT_NEXT_BEFORE_COUNT; g_i++)
					WHAT_NEXT_BEFORE[g_i](&g_MAX_RULE_data);
			#endif
			#ifdef WHAT_NEXT_AFTER_COUNT
				CLEAR(g_MAX_RULE_data);
				for (g_i=0; g_i<WHAT_NEXT_AFTER_COUNT; g_i++)
					WHAT_NEXT_AFTER[g_i](&g_MAX_RULE_data);
			#endif
		}
		break;*/

	case GAME_PHASE_NEXTMAP:
		break;

	} // switch

	#ifdef OBJECTS_COUNT
		if ((!SRV_CLN_object_is_initialized) && (!MAX_MUL_is_server)) {
			SRV_CLN_object_is_initialized = TRUE;
			for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
				SRV_old_object_state[g_i] = STATE_INIT;

			MAX_MUL_object_remove_all();
			MAX_MUL_objects_send_request();
		}
	#endif

	MAX_MUL_cln_game_time_tick(info->elapsed_time);

	CLN_phase_changed = FALSE;

	return TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------------
s_SC_NodHandle	g_nod_handle;
//-------------------------------------------------------------------------------------------------------------------------------
int ScriptMain(s_SC_ModeScript_info *info) {	
	dword side;

skok_begin:

#ifdef SYNCHRO_OBJECT_COUNT
	MAX_SYN_synchro_object(info);
#endif

	if (info->event == SC_MODESCRIPT_EVENT_MSG_TO_CLN) // protoze se to muze dostat do call_to_main(), tak je to uz tady
		MAX_MUL_receive_message(info);

#ifdef CALL_TO_MAIN
	if (!call_to_main(info)) return TRUE;
#endif

	switch(info->event){
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_INIT:
		// param1 - is server
		MAX_MUL_is_server = info->param1;

		original_SIDE1 = SIDE1;
		original_SIDE2 = SIDE2;

		MAX_MUL_init_all(MAX_MUL_is_server);

		MAX_MUL_restart_map();
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RELEASE:
		// param1 - is server
		MAX_MUL_release_all(info->param1);
		MAX_MUL_release_hud();
		break;
	//----------------- SERVER TICK -----------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_SRV:

		#ifdef CHECK_SIDES_READY_COUNT
			CLEAR(g_MAX_RULE_data);
			for (g_i=0; g_i<CHECK_SIDES_READY_COUNT; g_i++) {
				//if (SRV_sides_ready == FALSE) break;
				if ( !CHECK_SIDES_READY[g_i](&g_MAX_RULE_data) ) {
					SRV_sides_ready = FALSE;
					CLN_sides_ready = FALSE;
					SC_MP_Synch_SendChanges(SYNCH_SIDES_READY, FALSE);
					break;
				}
			}

			if (g_i >= CHECK_SIDES_READY_COUNT) {
				if ((SRV_sides_ready == FALSE) && (SRV_game_phase == GAME_PHASE_RUNNING)) {
					SRV_round_time = GAME_PHASE_RESTARTING_LENGTH; // musi byt quli vykreslovani count downu na klientech
					CLN_round_time = SRV_round_time;
					SC_MP_Synch_SendChanges(SYNCH_ROUND_TIMER, TRUE);
					MAX_MUL_switch_game_phase(GAME_PHASE_RESTARTING, GAME_PHASE_RESTARTING_LENGTH);
					//SC_MP_RestartRound();
				}
				if (SRV_sides_ready == FALSE) {
					SRV_sides_ready = TRUE;
					CLN_sides_ready = TRUE;
					SC_MP_Synch_SendChanges(SYNCH_SIDES_READY, FALSE);
				}
			}
		#endif

		switch(SRV_game_phase) {
		case GAME_PHASE_WAITING:
			#ifdef OBJECTS_COUNT
				if (!SRV_CLN_object_is_initialized) {
					SRV_CLN_object_is_initialized = TRUE;
					for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
						SRV_old_object_state[g_i] = STATE_INIT;

					MAX_MUL_object_remove_all();
					MAX_MUL_objects_send_request();
				}
				/*for (g_i=0; g_i<OBJECTS_COUNT; g_i++)
					if ((MAX_MUL_object[g_i].SRV_object_status) && (MAX_MUL_object[g_i].SRV_object_status->state != STATE_INIT)) MAX_MUL_object[g_i].SRV_object_status->state = STATE_INIT;*/
			#endif

//			SC_Log(3, "Server phase: GAME_PHASE_WAITING");
			MAX_MUL_srv_reinforcements_tick(info->elapsed_time);
			MAX_MUL_switch_game_phase(GAME_PHASE_INITIALIZING, 0.0);
			break;

		case GAME_PHASE_INITIALIZING:
			if (GAME_TYPE != GAME_TYPE_COOP) {
				int			i, num;
				sc_player	list[MAX_MUL_PLAYERS];

				SC_MP_DerespawnAllPlayers();

				num = MAX_MUL_PLAYERS;
				MAX_MUL_get_players_all(SIDE1, &num, list);
				for (i=0; i<num; i++)
					MAX_MUL_reinforcements_add(MAX_SUP_get_handle_from_pl_id(list[i]), TRUE);

				num = MAX_MUL_PLAYERS;
				MAX_MUL_get_players_all(SIDE2, &num, list);
				for (i=0; i<num; i++)
					MAX_MUL_reinforcements_add(MAX_SUP_get_handle_from_pl_id(list[i]), TRUE);
			}

			SRV_round_time = GAME_PHASE_BEGIN_LENGHT; // musi byt quli vykreslovani count downu na klientech
			CLN_round_time = SRV_round_time;
			SC_MP_Synch_SendChanges(SYNCH_ROUND_TIMER, TRUE);
			
			MAX_MUL_switch_game_phase(GAME_PHASE_BEGIN, GAME_PHASE_BEGIN_LENGHT);
			break;

		case GAME_PHASE_BEGIN:
			MAX_MUL_srv_reinforcements_tick(info->elapsed_time);
			break;

		case GAME_PHASE_RUNNING:
			#ifdef OBJECTS_COUNT
				MAX_MUL_srv_object_update_tick();
				MAX_MUL_srv_object_changed_state();
			#endif
			MAX_MUL_srv_check_respawn_rules();
			MAX_MUL_srv_respawning_tick(info->elapsed_time);
			MAX_MUL_srv_reinforcements_tick(info->elapsed_time);
			if (SRV_check_round_end_timer >= 0.0) {
				SRV_check_round_end_timer -= info->elapsed_time;
				if (SRV_check_round_end_timer < 0.0) {
					SRV_check_round_end_timer = 0.5;
					if (MAX_MUL_check_round_end(&side)) {

						#ifdef OBJECTS_COUNT
							for (g_i=0; g_i<OBJECTS_COUNT; g_i++) {
								if (MAX_MUL_object[g_i].SRV_object_status == NULL) continue;
								MAX_MUL_object[g_i].SRV_object_status->state = STATE_INIT;
								MAX_MUL_object[g_i].SRV_object_status->timer = -1.0;
								MAX_MUL_object[g_i].SRV_object_status->pl_handle = 0;
								MAX_MUL_object[g_i].SRV_object_status->update = TRUE;
								MAX_MUL_srv_object_update_tick();
							}
						#endif

						MAX_MUL_switch_game_phase(GAME_PHASE_ENDING, GAME_PHASE_ENDING_LENGHT);
						SRV_winning_side = side;
						CLN_winning_side = SRV_winning_side;
						SRV_status_mode_timeout = 1.0;
						SC_MP_Synch_SendChanges(SYNCH_WINNING_SIDE, TRUE);
						/*{
							s_SC_MP_ResultsMode resultmode_info;
							CLEAR(resultmode_info);
							SC_MP_EnableResultsMode(&resultmode_info);
						}*/
						return TRUE;
					}
				}
			}
			break;

		case GAME_PHASE_ENDING:
			#ifdef OBJECTS_COUNT
				MAX_MUL_srv_object_update_tick();
				MAX_MUL_srv_object_changed_state();
			#endif
			break;

		case GAME_PHASE_WHAT_NEXT:
			//if (MAX_MUL_check_next_map(GAME_TYPE)) SC_MP_SwitchToNextMap();
			#ifdef WHAT_NEXT_BEFORE_COUNT
				CLEAR(g_MAX_RULE_data);
				for (g_i=0; g_i<WHAT_NEXT_BEFORE_COUNT; g_i++)
					WHAT_NEXT_BEFORE[g_i](&g_MAX_RULE_data);
			#else
				MAX_MUL_switch_game_phase(GAME_PHASE_NEXTMAP, 999.9);
				SC_MP_SwitchToNextMap(); // pokud nejsou definovana kriteria, tak hned konec mapy, jinak to necham na fci
				return TRUE;
			#endif

			SC_MP_DerespawnAllPlayers();
			SC_MP_RestartRound();

			#ifdef WHAT_NEXT_AFTER_COUNT
				CLEAR(g_MAX_RULE_data);
				for (g_i=0; g_i<WHAT_NEXT_AFTER_COUNT; g_i++)
					WHAT_NEXT_AFTER[g_i](&g_MAX_RULE_data);
			#endif
			break;

		case GAME_PHASE_NEXTMAP:
			break;

		case GAME_PHASE_RESTARTING:
			break;

		} // switch

		MAX_MUL_srv_game_time_tick(info->elapsed_time);

		break;
	//----------------- CLIENT TICK -----------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_CLN:
		MAX_MUL_cln_event_dotick(info);
		#ifdef CHECK_SIDES_READY_COUNT
			if ((!CLN_sides_ready) && (CLN_game_phase == GAME_PHASE_RUNNING)) MAX_MUL_render_game_inactive(info->elapsed_time); //strany nejsou ready
		#endif

#ifndef CUSTOM_RENDER
		//MAX_HUD_time_tick(info->elapsed_time);
		MAX_MUL_render_game_round_info(info->elapsed_time);
		if (CLN_game_phase != GAME_PHASE_WAITING) {
			//if (GAME_TYPE == GAME_TYPE_TDM) MAX_MUL_render_team_score();
			#ifdef OBJECTS_COUNT
				MAX_MUL_render_objects_status();
			#endif
		}
#endif

		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_SYNCHCHANGE:
		switch(info->param1) {
		case SYNCH_GAME_PHASE:
			CLN_phase_changed = TRUE;
			//MAX_MUL_cln_event_dotick(info);
			info->elapsed_time = 0.0;
			info->event = SC_MODESCRIPT_EVENT_DOTICK_CLN;
			goto skok_begin;
			break;
		}

#ifdef OBJECTS_COUNT
		if ((info->param1 >= SYNCH_OBJECTS_STATUS) && (info->param1 < SYNCH_SYNCHRO_OBJECT) && (MAX_MUL_object[0].CLN_object_status == NULL))
			SC_message("TOTAL BRUTAL FATAL ERROR - klient nema nastavenej CLN_object_status a doslo SC_MODESCRIPT_EVENT_SYNCHCHANGE");
#endif

		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLREADYTORESPAWN:
		if ((SRV_game_phase == GAME_PHASE_WAITING) || (SRV_game_phase == GAME_PHASE_INITIALIZING) || (SRV_game_phase == GAME_PHASE_BEGIN)) MAX_MUL_reinforcements_add(info->param1, TRUE);
		if ( SRV_game_phase == GAME_PHASE_RUNNING ) {
			if (MAX_MUL_is_ready_to_respawn(info->param1))
				MAX_MUL_respawning_add(info->param1, 1.2);
		}
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_COMAHEAL:
		MAX_MUL_player_com_healed(info);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLKILLED:
		// param1 - player handle
		// param2 - killed by player handle
		// param3 - killed by weapon type
		// param4 - 0-"full_death", 1 - "coma"

		MAX_MUL_player_killed(info);

		if (!SC_P_IsAi(SC_P_GetByHandle(info->param1))) {
			if (GAME_TYPE == GAME_TYPE_COOP) MAX_MUL_coop_player_killed(info->param1);
			if (!info->param4) { // pokud neni v koma a neni to AI
				if (((SRV_game_phase == GAME_PHASE_INITIALIZING) || (SRV_game_phase == GAME_PHASE_BEGIN) || (SRV_game_phase == GAME_PHASE_RUNNING)) && (MAX_MUL_is_ready_to_respawn(info->param1))) MAX_MUL_respawning_add(info->param1, 3.0);
			}
		}

		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLKILLEDFROMCOMA:
		//MAX_MUL_check_best_score(GAME_TYPE, FALSE);

		if (((SRV_game_phase == GAME_PHASE_INITIALIZING) || (SRV_game_phase == GAME_PHASE_BEGIN) || (SRV_game_phase == GAME_PHASE_RUNNING)) && (MAX_MUL_is_ready_to_respawn(info->param1))) MAX_MUL_respawning_add(info->param1, 1.0);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLSSTATSCHANGED:
		if (MAX_MUL_is_server)
			MAX_MUL_check_best_score(GAME_TYPE, FALSE);

		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_GET_PRESSFIRE_TEXT:
		// param1 is BOOL already pressed
		// param2 is (ushort*) text to be filled
		// param3 is color to be filled ( default is white, no need to be changed )
		if (CLN_game_phase != GAME_PHASE_RUNNING) { //chodi i na klientech !!!
			//SC_MP_P_PressFireRequest(info->param1, FALSE);
			info->param1 = TRUE; // ojeb ??!!
			//return FALSE;
		}
		if (CLN_game_phase == GAME_PHASE_RUNNING) {
			dword	data;
			if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_REINFORCEMENTS, &data)) {
				if (data == 4) {
					info->param1 = TRUE; //ojeb
				}
			}
		}

		MAX_MUL_get_press_fire_text(info);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PRESSFIRE_PRESSED:
		//SC_MP_P_PressFireRequest(info->param1, FALSE);
		MAX_MUL_reinforcements_add(info->param1, FALSE);
		//SC_MP_RespawnPlayer(info->param1, 1);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLRELEASED:			
		//_Srv_CheckFlagDrop(info->param1);
		if (MAX_MUL_is_server) {
			MAX_MUL_respawning_remove(info->param1);
			MAX_MUL_reinforcements_remove(info->param1);
			/*if (SRV_best_player == info->param1) {
				//int	points;
				//SRV_best_player = 0;
				//MAX_MUL_get_best_player(&SRV_best_player, &points);
				MAX_MUL_check_best_score();
			}*/
			//if (SRV_best_player == info->param1) SRV_best_player = 0;
			MAX_MUL_check_best_score(GAME_TYPE, TRUE);
#ifdef OBJECTS_COUNT
			if (SRV_game_phase == GAME_PHASE_RUNNING)
				MAX_MUL_check_objects(info->param1);
#endif
		}
		MAX_MUL_release_hud();
		break;

	case SC_MODESCRIPT_EVENT_PLAYERCREATED: // hrac se pripojil
		break;

	case SC_MODESCRIPT_EVENT_PLAYERRELEASED: // hrac se odpojil
		break;

	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_MSG_TO_CLN:
		//_Cln_MsgCame(info);
		//MAX_MUL_receive_message(info);
		MAX_MUL_CLN_handle_message(info);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_MSG_TO_SRV:
		//MAX_MUL_get_message_from_client(info->param1, (BYTE *)info->param3, info->param2); // 1 3 2 - je to dobre !!!
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RENDER:
		//MAX_MUL_render_end_rules();
		//MAX_MUL_render_reinforcements();
		//MAX_MUL_render_game_round_info();
		//MAX_HUD_render();
		/*#ifdef OBJECTS_COUNT
			MAX_MUL_render_objects_status();
		#endif*/
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_FILLMODESETTINGS:
		MAX_MUL_mode_settings_add(info->param1, GAME_TYPE);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_GETSIDESTATS:
		if ((GAME_TYPE != GAME_TYPE_DM) && (GAME_TYPE != GAME_TYPE_COOP)) MAX_MUL_get_side_stats(info);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_GETMAP_SHORTINFO:
		MAX_MUL_get_map_shortinfo(info);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTMAP:
		MAX_MUL_restart_map();
		MAX_SUP_send_message_to_level(MSG_MUL_RESTART, 0);
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTROUND:
		switch(GAME_TYPE) {
		case GAME_TYPE_ASSAULT:
			info->param1 = 1;
			break;

		default:
			info->param1 = 0;
			break;
		}
		#ifdef CHECK_SIDES_READY_COUNT
			info->param1 = 1;
		#endif

		if (info->param1 == 1) {
			MAX_MUL_restart_round();
			MAX_SUP_send_message_to_level(MSG_MUL_RESTART, 0);
		}
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_LOCALMSG:
		switch(info->param1) {
		case MSG_MUL_ADD_OBJECT:
			#ifdef OBJECTS_COUNT
//				SC_Log(2, "XXXXX - SC_MODESCRIPT_EVENT_LOCALMSG - %d", info->param2);
				MAX_MUL_object_add(info->param2, (s_MAX_MUL_object_status *)info->param3);
			#endif
			break;

		case MSG_MUL_SET_GAME_PHASE:
			MAX_MUL_switch_game_phase(info->param2, 0.0);
			break;

		case MSG_UNI_DESTR_USE_MP:
			/*MAX_SUP_get_handle_from_nod(info->param4, &g_nod_handle);
			MAX_MUL_send_message_to_server_to_object2(MAX_SUP_get_handle_from_pl_id(SC_PC_Get()), info->param3, info->param4, info->param1, MAX_SUP_get_handle_from_pl_id(info->param2));*/
			/*if (MAX_MUL_is_server)
				MAX_SUP_send_message_to_object(info->param3, MSG_UNI_DESTR_USE_MP, MAX_SUP_get_handle_from_pl_id(info->param2));
			else
				MAX_MUL_send_message_to_server_to_object(info->param3, MSG_UNI_DESTR_USE_MP, MAX_SUP_get_handle_from_pl_id(info->param2));*/
			//if (MAX_MUL_is_server)
			//	MAX_SUP_send_message_to_object(info->param3, MSG_UNI_DESTR_USE_MP, info->param2);

			break;

		}
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLRESPAWNED:
		#ifdef SIDE1_HINT_BEGIN
		{
			dword		side;
			sc_player	player;

			if (MAX_MUL_local_pl_handle == 0) MAX_MUL_local_pl_handle = MAX_SUP_get_handle_from_pl_id(SC_PC_Get());

			if (MAX_MUL_local_pl_handle == info->param1) {
				if (MAX_MUL_local_player == 0) MAX_MUL_local_player = SC_PC_Get();
				SC_P_GetSideGroupMemberId(MAX_MUL_local_player, &side, NULL, NULL);
				if (side != CLN_current_player_side) {
					if (side == SIDE1)
						MAX_SUP_send_message_to_level(MSG_HINT_SHOW, SIDE1_HINT_BEGIN);
					#ifdef SIDE2_HINT_BEGIN
					else if (side == SIDE2)
						MAX_SUP_send_message_to_level(MSG_HINT_SHOW, SIDE2_HINT_BEGIN);
					#endif

					CLN_current_player_side = side;
				}
			}
		}
		#endif

		break;

	}// switch(info->event)


	return 0;

}// int ScriptMain(s_SC_ModeScript_info *info)

//#endif //#ifndef MAX_MULTIPLAYER_CXX