#ifndef MAX_OBJECTS_H	//az na konec scriptu !!!!
#define MAX_OBJECTS_H

#include <inc\maxovo\!max_defs.h>


#define MAX_OBJECTIVES	10
c_Vector3			MAX_OBJ_radar_pos[MAX_OBJECTIVES];
s_SC_SP_Objective	MAX_OBJ_objective[MAX_OBJECTIVES];
int					MAX_OBJ_objective_pos = -1;

void MAX_OBJ_radar_test_objectives();
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_OBJ_add_primary(char *objective_str) {
	ushort	tmp_ustr[MAX_STRING_LEN_LONG];
	int		obj_count = 0;

	if (MAX_OBJ_objective_pos < MAX_OBJECTIVES-1) {
		MAX_OBJ_objective_pos++;
		//sprintf(tmp_str, objective_str);
		MAX_OBJ_objective[MAX_OBJ_objective_pos].text_uni	= SC_AnsiToUni(objective_str, tmp_ustr);
		MAX_OBJ_objective[MAX_OBJ_objective_pos].state		= SC_SP_OBJECTIVE_STATE_ACTIVE;
		SC_SP_SetObjectives(MAX_OBJ_objective_pos+1, MAX_OBJ_objective);
	} else return -1;

	return MAX_OBJ_objective_pos;
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_OBJ_add_primary(int speech_nr) {
	ushort	tmp_ustr[MAX_STRING_LEN_LONG];
	int		obj_count = 0;

	if (MAX_OBJ_objective_pos < MAX_OBJECTIVES-1) {
		MAX_OBJ_objective_pos++;
		//sprintf(tmp_str, objective_str);
		MAX_OBJ_objective[MAX_OBJ_objective_pos].text_id	= speech_nr;
		MAX_OBJ_objective[MAX_OBJ_objective_pos].state		= SC_SP_OBJECTIVE_STATE_ACTIVE;
		SC_SP_SetObjectives(MAX_OBJ_objective_pos+1, MAX_OBJ_objective);
	} else return -1;

	return MAX_OBJ_objective_pos;
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_OBJ_change_state_primary(int index, dword state) {
	if ((MAX_OBJ_objective_pos >= index) && (index >= 0)) {
		MAX_OBJ_objective[index].state = state;
		SC_SP_SetObjectives(MAX_OBJ_objective_pos+1, MAX_OBJ_objective);
		MAX_OBJ_radar_test_objectives();
	} else return -1;

	return MAX_OBJ_objective_pos;
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_OBJ_remove_primary() {
	if (MAX_OBJ_objective_pos >= 0) {
		MAX_OBJ_objective_pos--;
		SC_SP_SetObjectives(MAX_OBJ_objective_pos+1, MAX_OBJ_objective);
		MAX_OBJ_radar_test_objectives();
	} else return -1;

	return MAX_OBJ_objective_pos;
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_OBJ_remove_primary(int index) {
	int	i;

	if ((MAX_OBJ_objective_pos >= index) && (index >= 0)) {
		for (i=index; i<=MAX_OBJ_objective_pos; i++) {
			MAX_OBJ_objective[i] = MAX_OBJ_objective[i+1];
			MAX_OBJ_radar_pos[i] = MAX_OBJ_radar_pos[i+1];
		}
		MAX_OBJ_objective_pos--;
		SC_SP_SetObjectives(MAX_OBJ_objective_pos+1, MAX_OBJ_objective);
		MAX_OBJ_radar_test_objectives();
	} else return -1;

	return MAX_OBJ_objective_pos;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_clear() {
	SC_Radar_SetTarget(NULL);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_test_objectives() {
	int		i;

	for (i=MAX_OBJ_objective_pos; i>=0; i--) {
		if (MAX_OBJ_objective[i].state == SC_SP_OBJECTIVE_STATE_ACTIVE) {
			SC_Radar_SetTarget(&MAX_OBJ_radar_pos[i]);
			return;
		}
	}

	MAX_OBJ_radar_clear();
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_init() {
	s_SC_RadarProp	radar_props;

	CLEAR(radar_props);
	SC_Radar_GetProps(&radar_props);
	radar_props.range = 40.0;
	SC_Radar_SetProps(&radar_props);
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_set_target(int objective_pos, c_Vector3 *pos) {

	if ((objective_pos <= MAX_OBJ_objective_pos) && (objective_pos >= 0)) {
		MAX_OBJ_radar_pos[objective_pos] = *pos;
		//if (objective_pos == 0) SC_Radar_SetTarget(&pos);
		MAX_OBJ_radar_test_objectives();
	} else {
		SC_message("MAX_OBJ_radar_set_target() - index error");
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_set_target(int objective_pos, char *name) {
	c_Vector3	pos;

	if ((objective_pos <= MAX_OBJ_objective_pos) && (objective_pos >= 0)) {
		SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &pos);
		MAX_OBJ_radar_pos[objective_pos] = pos;
		//if (objective_pos == 0) SC_Radar_SetTarget(&pos);
		MAX_OBJ_radar_test_objectives();
	} else {
		SC_message("MAX_OBJ_radar_set_target() - index error");
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_set_target(int objective_pos, char *g_name, char *s_name) {
	c_Vector3	pos;

	if ((objective_pos <= MAX_OBJ_objective_pos) && (objective_pos >= 0)) {
		SC_NOD_GetWorldPos(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(g_name), s_name), &pos);
		MAX_OBJ_radar_pos[objective_pos] = pos;
		//if (objective_pos == 0) SC_Radar_SetTarget(&pos);
		MAX_OBJ_radar_test_objectives();
	} else {
		SC_message("MAX_OBJ_radar_set_target() - index error");
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_OBJ_radar_set_target(int objective_pos, sc_nod nod) {
	c_Vector3	pos;

	if ((objective_pos <= MAX_OBJ_objective_pos) && (objective_pos >= 0)) {
		SC_NOD_GetWorldPos(nod, &pos);
		MAX_OBJ_radar_pos[objective_pos] = pos;
		//if (objective_pos == 0) SC_Radar_SetTarget(&pos);
		MAX_OBJ_radar_test_objectives();
	} else {
		SC_message("MAX_OBJ_radar_set_target() - index error");
	}
}
#endif //#ifndef MAX_OBJECTS_H