#ifndef MAX_PARTICLES_H //az na konec scriptu !!!!
#define MAX_PARTICLES_H

#include <inc\maxovo\!max_defs.h>

#ifndef MAX_PTC
	#define MAX_PTC					12
#endif

typedef struct {
	dword			key;
	float			delay;
	int				typ;
	c_Vector3		pos;
	sc_nod			nod;
	s_SC_NodHandle	handle_nod;

	dword		id;
	float		time;
	float		interval;
	float		scale;
	float		time_mult;

	float		tmp_interval;
	BOOL		move_with;

	dword		author_handle;

	int			flags;
} s_MAX_PTC_particle;


dword	MAX_PTC_KEY			= 0;
int		MAX_PTC_pos_in_list = -1;

s_MAX_PTC_particle	MAX_particle[MAX_PTC];
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_get_key() {
	return ++MAX_PTC_KEY;
}
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_PTC_set_explosion_force(s_SC_Expl_CreateInfo *expl_info, dword typ) {
	if (typ ==  0) return;
	if (typ == -1) {
		SC_message("!max_particles.h - MAX_PTC_set_explosion_force() - sila == -1");
		return;
	}
	expl_info->piercing = (typ & 0x0000FFFF) / 10.0;
	expl_info->damage =    typ & 0x0000FFFF;
	if (expl_info->damage > 2000.0) {
		SC_message("!max_particles.h - MAX_PTC_set_explosion_force() - moc velka sila == %f", expl_info->damage);
	}
	expl_info->sph.rad =  (typ & 0x0FFF0000) >> 16;
	expl_info->marok_impuls = expl_info->damage;
	expl_info->script_type = typ >> 28; // prvni byte pouze
}*/
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_set_explosion_ptc(s_SC_Expl_CreateInfo *expl_info, dword typ) { // pouze pro MAX_PTC_explosion_make()
	switch(typ >> 28) {
		case 1:
			expl_info->ptc_id = 199;
			break;

		case 2:
			expl_info->ptc_id = 198;
			break;

		case 3:
			expl_info->ptc_id = 195;
			break;

		case 4:
			expl_info->ptc_id = 195;
			break;

		default:
			expl_info->ptc_id = 195;
			break;

	} // switch
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_do_explosion(sc_nod nod, dword author_handle, dword typ, int flags) {
	s_SC_Expl_CreateInfo expl_info;

	CLEAR(expl_info);
	expl_info.author_handle = author_handle;
#ifdef EXPL_CHANGE_DEFAULT_FLAGS
	expl_info.flags = (flags != 0) ? flags : EXPL_CHANGE_DEFAULT_FLAGS;
	#else
	expl_info.flags = (flags < 0) ? 0 : flags;
#endif
	SC_NOD_GetWorldPos(nod, &expl_info.sph.pos);

	MAX_UNI_set_explosion_force(&expl_info, typ);

	SC_Explosion_Make(&expl_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_do_explosion(c_Vector3 pos, dword author_handle, dword typ, int flags) {
	s_SC_Expl_CreateInfo expl_info;

	CLEAR(expl_info);
	expl_info.author_handle = author_handle;
#ifdef EXPL_CHANGE_DEFAULT_FLAGS
	expl_info.flags = (flags != 0) ? flags : EXPL_CHANGE_DEFAULT_FLAGS;
	#else
	expl_info.flags = (flags < 0) ? 0 : flags;
#endif
	expl_info.sph.pos.x = pos.x;
	expl_info.sph.pos.y = pos.y;
	expl_info.sph.pos.z = pos.z;
	
	MAX_UNI_set_explosion_force(&expl_info, typ);

	SC_Explosion_Make(&expl_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- EXTERNI FCE PRO VYBUCHY ---------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_explosion_make(sc_nod nod, dword author_handle, dword typ) { // jde pouzit i externe !!!
	s_SC_Expl_CreateInfo expl_info;

	CLEAR(expl_info);
	expl_info.author_handle = author_handle;
#ifdef EXPL_CHANGE_DEFAULT_FLAGS
	expl_info.flags = EXPL_CHANGE_DEFAULT_FLAGS;
#endif
	SC_NOD_GetWorldPos(nod, &expl_info.sph.pos);

	MAX_UNI_set_explosion_force(&expl_info, typ);
	MAX_PTC_set_explosion_ptc(&expl_info, typ);

	SC_Explosion_Make(&expl_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_explosion_make(c_Vector3 *pos, dword author_handle, dword typ) { // jde pouzit i externe !!!
	s_SC_Expl_CreateInfo expl_info;

	CLEAR(expl_info);
	expl_info.author_handle = author_handle;
#ifdef EXPL_CHANGE_DEFAULT_FLAGS
	expl_info.flags = EXPL_CHANGE_DEFAULT_FLAGS;
#endif
	expl_info.sph.pos = *pos;

	MAX_UNI_set_explosion_force(&expl_info, typ);
	MAX_PTC_set_explosion_ptc(&expl_info, typ);

	SC_Explosion_Make(&expl_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  PARTICLES  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_particle(s_MAX_PTC_particle *particle) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= particle->delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= particle->typ;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= particle->pos.x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= particle->pos.y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= particle->pos.z;
		MAX_particle[MAX_PTC_pos_in_list].nod	= particle->nod;
		if (particle->nod) MAX_SUP_get_handle_from_nod(particle->nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= abs(particle->id);
		MAX_particle[MAX_PTC_pos_in_list].time		= particle->time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= particle->interval;
		MAX_particle[MAX_PTC_pos_in_list].scale		= particle->scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= particle->time_mult;
		MAX_particle[MAX_PTC_pos_in_list].move_with	= (particle->id < 0) ? TRUE : particle->move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_particle(%d) faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!", particle->id);
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_small(float delay, int typ, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 17;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.7;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_small() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_small(float delay, int typ, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 17;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.7;
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_small() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_medium(float delay, int typ, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z + 1.0;

		MAX_particle[MAX_PTC_pos_in_list].id		= 182;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 0.5;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.6;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_medium() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_medium(float delay, int typ, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 182;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 0.5;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.6;
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_medium() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_big(float delay, int typ, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-2) { //protoze pridavam 2ptc naraz
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 182;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;
		//----------------------------------------------------------------------------------
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_particle[MAX_PTC_pos_in_list-1].key;
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 29;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_big() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_explosion_big(float delay, int typ, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-2) { //protoze pridavam 2ptc naraz
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 182;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;
		//----------------------------------------------------------------------------------
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_particle[MAX_PTC_pos_in_list-1].key;
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= typ;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 29;
		MAX_particle[MAX_PTC_pos_in_list].time		= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.0;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0;
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_explosion_big() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_fire(float delay, float scale, float time, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 177;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.4;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_fire() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_fire(float delay, float scale, float time, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 177;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.4;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_fire() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_y(float delay, float scale, float time, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 173;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.2;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_y() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_y(float delay, float scale, float time, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 173;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.2;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_y() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_r(float delay, float scale, float time, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 184;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.6;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 0.7*scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.6/sqrt(scale);

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_r() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_r(float delay, float scale, float time, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 184;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 0.6;
		MAX_particle[MAX_PTC_pos_in_list].scale		= 0.7*scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 0.6/sqrt(scale);
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_r() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_b(float delay, float scale, float time, c_Vector3 *pos) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].pos.x	= pos->x;
		MAX_particle[MAX_PTC_pos_in_list].pos.y	= pos->y;
		MAX_particle[MAX_PTC_pos_in_list].pos.z	= pos->z;

		MAX_particle[MAX_PTC_pos_in_list].id		= 186;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 1.6;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_b() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_PTC_add_smoke_b(float delay, float scale, float time, sc_nod nod, BOOL move_with) {

	if (MAX_PTC_pos_in_list < MAX_PTC-1) {
		MAX_PTC_pos_in_list++;
		CLEAR(MAX_particle[MAX_PTC_pos_in_list]);
		MAX_particle[MAX_PTC_pos_in_list].key	= MAX_PTC_get_key();
		MAX_particle[MAX_PTC_pos_in_list].delay	= delay;
		MAX_particle[MAX_PTC_pos_in_list].typ	= EXPLOSION_NONE;
		MAX_particle[MAX_PTC_pos_in_list].nod	= nod;
		MAX_SUP_get_handle_from_nod(nod, &MAX_particle[MAX_PTC_pos_in_list].handle_nod);

		MAX_particle[MAX_PTC_pos_in_list].id		= 186;
		MAX_particle[MAX_PTC_pos_in_list].time		= time;
		MAX_particle[MAX_PTC_pos_in_list].interval	= 1.6;
		MAX_particle[MAX_PTC_pos_in_list].scale		= scale;
		MAX_particle[MAX_PTC_pos_in_list].time_mult	= 1.0/sqrt(scale);
		MAX_particle[MAX_PTC_pos_in_list].move_with	= move_with;

		MAX_particle[MAX_PTC_pos_in_list].tmp_interval = MAX_particle[MAX_PTC_pos_in_list].interval;

		return MAX_particle[MAX_PTC_pos_in_list].key;
	} else {
		SC_message("MAX_PTC_add_smoke_b() faild!\nBuffer full!\n ZAVOLEJ MAXE!!!!");
		return -1;
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------  TIME TICK  ----------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_time_tick(float elapsed_time) {
	int			i, j;
	c_Vector3	glob_impulse, glob_point_of_app, zero_vec;

	i=0;
	while (i<=MAX_PTC_pos_in_list) {
		if (MAX_particle[i].delay >= 0.0) MAX_particle[i].delay -= elapsed_time;
		if (MAX_particle[i].delay <  0.0) {
			
			if (MAX_particle[i].time >= 0.0) {

				if ((MAX_particle[i].typ != EXPLOSION_NONE) && ( (!SC_IsMpGame()) || (SC_IsMpGame() && !SC_IsMpClient()) ) ) {
					if (MAX_particle[i].nod)
						MAX_PTC_do_explosion(MAX_particle[i].nod, MAX_particle[i].author_handle, MAX_particle[i].typ, MAX_particle[i].flags);
					else
						MAX_PTC_do_explosion(MAX_particle[i].pos, MAX_particle[i].author_handle, MAX_particle[i].typ, MAX_particle[i].flags);
				} 

				if (MAX_particle[i].time != MAX_INFINITE_TIME) MAX_particle[i].time -= elapsed_time;
				MAX_particle[i].tmp_interval -= elapsed_time;
				if (MAX_particle[i].tmp_interval < 0.0) {
					MAX_particle[i].tmp_interval = MAX_particle[i].interval;
					if ((MAX_particle[i].nod != NULL) && (MAX_particle[i].move_with)) {
						SC_CreatePtcInNodSpace_Ext(
							MAX_particle[i].id,
							MAX_particle[i].nod,
							0.0,	//time -> prehraje se pouze 1x
							0.0,	//interval -> prehraje se pouze 1x
							MAX_particle[i].scale,
							MAX_particle[i].time_mult
						);
					}else if ((MAX_particle[i].nod != NULL) && (!MAX_particle[i].move_with)) {
						SC_NOD_GetWorldPos(MAX_particle[i].nod, &MAX_particle[i].pos);
						SC_CreatePtcVec_Ext(
							MAX_particle[i].id,
							&MAX_particle[i].pos,
							0.0,	//time -> prehraje se pouze 1x
							0.0,	//interval -> prehraje se pouze 1x
							MAX_particle[i].scale,
							MAX_particle[i].time_mult
						);
					} else {
						SC_CreatePtcVec_Ext(
							MAX_particle[i].id,
							&MAX_particle[i].pos,
							0.0,	//time -> prehraje se pouze 1x
							0.0,	//interval -> prehraje se pouze 1x
							MAX_particle[i].scale,
							MAX_particle[i].time_mult
						);
					}
				}
			} else {
				for (j=i; j<=MAX_PTC_pos_in_list-1; j++) MAX_particle[j] = MAX_particle[j+1];
				CLEAR(MAX_particle[j]);
				i--;
				MAX_PTC_pos_in_list--;
			}
		} // if
		i++;
	} // while
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_PTC_is_list_empty() {
	if (MAX_PTC_pos_in_list == -1) return TRUE;
	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_PTC_remove_from_list(dword key) {
	int i;
	if (key == -1) return FALSE;
	for (i=0; i<=MAX_PTC_pos_in_list; i++) {
		if (MAX_particle[i].key == key) {
			MAX_particle[i] = MAX_particle[MAX_PTC_pos_in_list];
			MAX_PTC_pos_in_list--;
			return TRUE;
		}
	}
	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_remove_all_from_list() {
	MAX_PTC_pos_in_list = -1;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_set_author(dword key, sc_player author) {
	int i, j;
	if (key == -1) return;
	for (i=0; i<=MAX_PTC_pos_in_list; i++) {
		if (MAX_particle[i].key == key) {
			MAX_particle[i].author_handle = MAX_SUP_get_handle_from_pl_id(author);
		}
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_PTC_just_loaded() {
	int		i;

	for (i=0; i<=MAX_PTC_pos_in_list; i++) {
		if (MAX_particle[i].nod) MAX_particle[i].nod = MAX_SUP_get_nod_from_handle(&MAX_particle[i].handle_nod);
	}
}

#endif //#ifndef MAX_PARTICLES_H