#ifdef SC_GLOBAL_H
#define INCLUDED
#endif

#include <inc\maxovo\!max_defs.h>
#include <inc\maxovo\!max_support.h>
//-----------------------------------------------------------------------------------
#ifdef INCLUDED
int call_back_main(s_SC_ScriptHelper_info *);
#endif
//-----------------------------------------------------------------------------------
#ifdef CALL_BACK_PC
void call_back_pc (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_AI
void call_back_ai (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_ALL
void call_back_all(s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
//-----------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ALLIVE
void call_back_pc_allive (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_AI_ALLIVE
void call_back_ai_allive (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_ALL_ALLIVE
void call_back_all_allive(s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
//-----------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ALL_DEATH
void call_back_pc_all_death (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_AI_ALL_DEATH
void call_back_ai_all_death (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
#ifdef CALL_BACK_ALL_ALL_DEATH
void call_back_all_all_death(s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int);
#endif
//-----------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ONE_DEATH
void call_back_pc_all_death (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int, int);
#endif
#ifdef CALL_BACK_AI_ONE_DEATH
void call_back_ai_all_death (s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int, int);
#endif
#ifdef CALL_BACK_ALL_ONE_DEATH
void call_back_all_all_death(s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int, int);
#endif
//-----------------------------------------------------------------------------------
#ifdef CALL_BACK_SPECIAL
void call_back_special(s_SC_ScriptHelper_info *, sc_player[MAX_PLAYERS], int, int);
#endif
//-----------------------------------------------------------------------------------
//BOOL sc_helper_disabled = FALSE;

int				sc_i/*, sc_j*/;
dword			sc_num1, sc_num2;
sc_player		sc_list1[MAX_PLAYERS], sc_list2[MAX_PLAYERS];
s_sphere		sc_sphere;
c_BoxOriented	sc_box;
s_SC_Area		sc_area;
char			*sc_name;

void sc_helper_disable(s_SC_ScriptHelper_info *info) {
	info->next_exe_time = -1.0;
	//sc_helper_disabled = TRUE;
}

void sc_helper_enable(s_SC_ScriptHelper_info *info) {
	info->next_exe_time = 0.0;
	//sc_helper_disabled = FALSE;
}

void sc_helper_reinit(s_SC_ScriptHelper_info *info) {
	info->next_exe_time = 0.0;
	//sc_helper_disabled = FALSE;
	//sc_area.box = &sc_box;
	//sc_area.sph = &sc_sphere;
	MAX_SUP_prepare_area(&sc_area, &sc_sphere, &sc_box);
	MAX_SUP_get_area_sc_helper(sc_name, &sc_area);
}


int ret;

int ScriptMain(s_SC_ScriptHelper_info *info) {

	if (SC_IsMpGame() && SC_IsMpClient()) {
		info->next_exe_time = -1.0;
		return 0;
	}

	switch(info->event_type) {
	case SC_SCRHELPER_EVENTTYPE_INIT:
		info->next_exe_time = 1.0;
		break;
	}

#ifdef INCLUDED
	if (!call_back_main(info)) return 0;
#endif

	switch(info->event_type) {
	case SC_SCRHELPER_EVENTTYPE_INIT:
		//sc_helper_disabled = FALSE;

		sc_name = info->nod_name;
		/*sc_area.box = &sc_box;
		sc_area.sph = &sc_sphere;*/
		MAX_SUP_prepare_area(&sc_area, &sc_sphere, &sc_box);
		MAX_SUP_get_area_sc_helper(sc_name, &sc_area);
		break;

	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		sc_name = info->nod_name;
		/*sc_area.box = &sc_box;
		sc_area.sph = &sc_sphere;*/
		MAX_SUP_prepare_area(&sc_area, &sc_sphere, &sc_box);
		MAX_SUP_get_area_sc_helper(sc_name, &sc_area);
		break;

	case SC_SCRHELPER_EVENTTYPE_MSG:
		switch(info->param1) {
		case MSG_SC_HELPER_DISABLE:
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_sc_helper.cxx : %s : SC_SCRHELPER_EVENTTYPE_MSG[MSG_SC_HELPER_DISABLE] - param1: %d | param2: %d | nod: %s", info->nod_name, info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
				SC_Log(3, _debug_tmp);
			#endif
			sc_helper_disable(info);
			break;

		case MSG_SC_HELPER_ENABLE:
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_sc_helper.cxx : %s : SC_SCRHELPER_EVENTTYPE_MSG[MSG_SC_HELPER_ENABLE] - param1: %d | param2: %d | nod: %s", info->nod_name, info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
				SC_Log(3, _debug_tmp);
			#endif
			sc_helper_enable(info);
			break;

		case MSG_SC_HELPER_REINIT:
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_sc_helper.cxx : %s : SC_SCRHELPER_EVENTTYPE_MSG[MSG_SC_HELPER_REINIT] - param1: %d | param2: %d | nod: %s", info->nod_name, info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
				SC_Log(3, _debug_tmp);
			#endif
			sc_helper_reinit(info);
			break;

		} // switch(info->param1)
		break;

	case SC_SCRHELPER_EVENTTYPE_RELEASE:
		break;

	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		//if (sc_helper_disabled) return FALSE;

#ifdef CALL_BACK_PC
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
		if (sc_num1) call_back_pc(info, sc_list1, sc_num1);
#endif
#ifdef CALL_BACK_AI
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
		if (sc_num1) call_back_ai(info, sc_list1, sc_num1);
#endif
#ifdef CALL_BACK_ALL
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY, &sc_area);
		if (sc_num1) call_back_all(info, sc_list1, sc_num1);
#endif
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ALLIVE
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
		if (sc_num1) call_back_pc_allive(info, sc_list1, sc_num1);
#endif
#ifdef CALL_BACK_AI_ALLIVE
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
		if (sc_num1) call_back_ai_allive(info, sc_list1, sc_num1);
#endif

#ifdef CALL_BACK_ALL_ALLIVE
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY, &sc_area);
		if (sc_num1) call_back_all_allive(info, sc_list1, sc_num1);
#endif
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ALL_DEATH //napred zjistim zive, az pak mrtve -> vetsi pravdepodobnost, ze budou zivi
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
		if (sc_num1 == 0) {
			sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
			if (sc_num1) call_back_pc_all_death(info, sc_list1, sc_num1);
		}
#endif
#ifdef CALL_BACK_AI_ALL_DEATH
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
		if (sc_num1 == 0) {
			sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
			if (sc_num1) call_back_ai_all_death(info, sc_list1, sc_num1);
		}
#endif
#ifdef CALL_BACK_PC_ALL_DEATH
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY, &sc_area);
		if (sc_num1 == 0) {
			sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY, &sc_area);
			if (sc_num1) call_back_all_all_death(info, sc_list1, sc_num1);
		}
#endif
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifdef CALL_BACK_PC_ONE_DEATH //napred zjistim mrtve, az pak zive -> vetsi pravdepodobnost, ze bude alespon jeden mrtvi
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
		if (sc_num1) {
			sc_num2 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &sc_area);
			call_back_pc_all_death(info, sc_list1, sc_num1, sc_num2);
		}
#endif
#ifdef CALL_BACK_AI_ONE_DEATH
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
		if (sc_num1) {
			sc_num2 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY, &sc_area);
			call_back_ai_all_death(info, sc_list1, sc_num1, sc_num2);
		}
#endif
#ifdef CALL_BACK_PC_ONE_DEATH
		sc_num1 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY, &sc_area);
		if (sc_num1) {
			sc_num2 = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, sc_list1, MAX_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY, &sc_area);
			call_back_all_all_death(info, sc_list1, sc_num1, sc_num2);
		}
#endif
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#ifdef CALL_BACK_SPECIAL
		for (sc_i=0; sc_i<SPECIAL_ENUM_COUNT ; sc_i++) {
			sc_num1 = SC_EnumPlayersArea(SPECIAL_ENUM[sc_i][0], SPECIAL_ENUM[sc_i][1], sc_list1, MAX_PLAYERS, SPECIAL_ENUM[sc_i][2], &sc_area);
			call_back_special(info, sc_list1, sc_num1, sc_i); //sc_num1 muze byt i 0 !!!
		}
#endif
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		break;

	}// switch(info->event_type)
	return TRUE;

}// int ScriptMain(s_OBJ_info *info)