#include <inc/sc_global.h>

int ScriptMain(s_SC_OBJ_info *info) {
	switch(info->message) {
		case SC_OBJ_MSG_INIT:
			SC_ObjScript_SetFlags(info->master_nod, SC_ObjScript_GetFlags(info->master_nod)| 
				SC_OBJSCRIPT_FL_HITMISSILE|SC_OBJSCRIPT_FL_HITEXPLOSION|SC_OBJSCRIPT_FL_HITMAROK);
			return TRUE;

		case SC_OBJ_MSG_JUSTLOADED:
			SC_ObjScript_SetFlags(info->master_nod, SC_ObjScript_GetFlags(info->master_nod)| 
				SC_OBJSCRIPT_FL_HITMISSILE|SC_OBJSCRIPT_FL_HITEXPLOSION|SC_OBJSCRIPT_FL_HITMAROK);
			return TRUE;

		case SC_OBJ_MSG_HIT:
			SC_CreatePtc_Ext(PARTICLE_NR, SC_NOD_Get(info->master_nod, OBJECT_NAME), 0.0, 0.0, PARTICLE_SC, 1.0);
			SC_NOD_SetDSTR(info->master_nod, OBJECT_NAME, NULL);

			break;

		case SC_OBJ_MSG_RELEASE:
			return TRUE;

		case SC_OBJ_MSG_MESSAGE:
			break;
	}// switch(info->event_type)

	return FALSE;

}// int ScriptMain(s_OBJ_info *info)



