#define CALL_TO_MAIN
int call_to_main(s_SC_ModeScript_info *info);

BOOL MAX_MUL_swap_sides(s_MAX_RULE_data *MAX_RULE_data);
BOOL MAX_MUL_set_time(s_MAX_RULE_data *MAX_RULE_data);

#define WHAT_NEXT_BEFORE_COUNT		1
p_fce	WHAT_NEXT_BEFORE[WHAT_NEXT_BEFORE_COUNT] =				{	MAX_MUL_swap_sides	};
#define WHAT_NEXT_AFTER_COUNT		1
p_fce	WHAT_NEXT_AFTER[WHAT_NEXT_AFTER_COUNT] =				{	MAX_MUL_set_time	};
#define BEGIN_AFTER_COUNT			1
p_fce	BEGIN_AFTER[BEGIN_AFTER_COUNT] =						{	MAX_MUL_set_time	};

BOOL MAX_MUL_get_winning_side_timeout(s_MAX_RULE_data *MAX_RULE_data);

#define ROUND_TIMEOUT_WINNING_SIDE_COUNT	1 //todle asi bude vzdy pouze 1, ale ...
p_fce	ROUND_TIMEOUT_WINNING_SIDE[ROUND_TIMEOUT_WINNING_SIDE_COUNT] =	{	MAX_MUL_get_winning_side_timeout	};

//#define CUSTOM_RENDER // !!!!!!!!!!!!!

#include <inc\maxovo\!max_multiplayer.cxx>
//-----------------------------------------------------------------------
float	assault_round_time;
int		assault_round_nr = 1;

int		assault_hud_pos_side1 = -1, assault_hud_pos_side2 = -1;
int		assault_hud_pos_round_time = -1;

BOOL MAX_MUL_swap_sides(s_MAX_RULE_data *MAX_RULE_data) {
	dword	temp;
	int		i;

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TEAMSCORE, &temp)) {
		if (temp > 0) {
			if (SC_MP_Side_GetPoints(SIDE1) >= (int)temp) {
				assault_round_time = -1.0;
				MAX_MUL_switch_game_phase(GAME_PHASE_NEXTMAP, 999.9);
				SC_MP_SwitchToNextMap();
				return FALSE;
			}
			else if (SC_MP_Side_GetPoints(SIDE2) >= (int)temp) {
				assault_round_time = -1.0;
				MAX_MUL_switch_game_phase(GAME_PHASE_NEXTMAP, 999.9);
				SC_MP_SwitchToNextMap();
				return FALSE;
			}
		}
	}

	if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_END_TIME, &temp)) {
		if (SRV_game_time > (temp*60.0)) {
			assault_round_time = -1.0;
			MAX_MUL_switch_game_phase(GAME_PHASE_NEXTMAP, 999.9);
			SC_MP_SwitchToNextMap();
			return FALSE;
		}
	}

	temp  = SIDE1;
	SIDE1 = SIDE2;
	SIDE2 = temp;

	SC_MP_Synch_SendChanges(SYNCH_SIDE1, TRUE);
	SC_MP_Synch_SendChanges(SYNCH_SIDE2, TRUE);

	/*if (assault_round_nr >= 2) {
		SC_MP_SwitchToNextMap();
		return FALSE;
	}*/

	MAX_MUL_release_respawnes(MAX_MUL_respawn, ALL_GROUPS_COUNT);

	for (i=0; i<GROUPS_COUNT_SIDE1; i++) { // prehodim vsechny respawny oproti startu -> inicializuji se vsechny znovu (kvuli swapu stran)
		MAX_MUL_respawn[i].is_active = FALSE;
	}

	#ifdef GROUPS_COUNT_SIDE2
		for (i=0; i<GROUPS_COUNT_SIDE2; i++) {
			MAX_MUL_respawn[GROUPS_COUNT_SIDE1+i].is_active = FALSE;
		}
	#endif

	if (assault_round_nr%2 == 1) {
		assault_round_time = SRV_round_time;
	} else {
		assault_round_time = -1.0;
	}

	MAX_MUL_send_message_to_clns(SC_P_SIDE_ALL, MSG_MUL_ASSAULT_SWAP);
	//MAX_MUL_swap_custom_items();

	assault_round_nr++;

	return FALSE;
}

BOOL MAX_MUL_set_time(s_MAX_RULE_data *MAX_RULE_data) {
	if (assault_round_time > 0.0) {
		dword	data;

		if (MAX_MUL_get_item(GAME_TYPE, ITEM_TYPE_ROUND_TIME, &data)) {
			SRV_round_time = data*60.0 - assault_round_time;
		}
	}

	return FALSE;
}

BOOL MAX_MUL_get_winning_side_timeout(s_MAX_RULE_data *MAX_RULE_data) {
	MAX_RULE_data->side = SIDE2;
	return TRUE; //SIDE2 brani
}

void MAX_MUL_render_team_score() {
	ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
	char	tmp_str[MAX_STRING_LEN_LONG];
	int		i;
	int		index;

	if (assault_hud_pos_side1 == -1)
		MAX_HUD_add_item(&assault_hud_pos_side1);

	if (assault_hud_pos_side2 == -1)
		MAX_HUD_add_item(&assault_hud_pos_side2);

	sprintf(tmp_str, "%d", SC_MP_Side_GetPoints(SIDE1));
	SC_AnsiToUni(tmp_str, tmp_ustr);

	SC_HUD_SetLeftTopIcon(assault_hud_pos_side1, (SIDE1==SC_P_SIDE_US)?HUD_ICON_FLAG_INBASE_US:HUD_ICON_FLAG_INBASE_VC, tmp_ustr);

	sprintf(tmp_str, "%d", SC_MP_Side_GetPoints(SIDE2));
	SC_AnsiToUni(tmp_str, tmp_ustr);

	SC_HUD_SetLeftTopIcon(assault_hud_pos_side2, (SIDE2==SC_P_SIDE_US)?HUD_ICON_FLAG_INBASE_US:HUD_ICON_FLAG_INBASE_VC, tmp_ustr);
}

void MAX_MUL_render_round_time() {
	ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
	char	tmp_str[MAX_STRING_LEN_LONG];
	int		i;
	int		index;

	if (assault_hud_pos_round_time == -1)
		MAX_HUD_add_item(&assault_hud_pos_round_time);

	sprintf(tmp_str, "%02d:%02d", (dword)(CLN_round_time/60.0f),((dword)CLN_round_time)%60 );
	SC_AnsiToUni(tmp_str, tmp_ustr);

	SC_HUD_SetLeftTopIcon(assault_hud_pos_round_time, HUD_ICON_CLOCKS, tmp_ustr);
}

BOOL	side_points_set = FALSE;

int call_to_main(s_SC_ModeScript_info *info) {
	switch(info->event) {
	case SC_MODESCRIPT_EVENT_INIT:
		assault_hud_pos_side1 = -1;
		assault_hud_pos_side2 = -1;
		assault_hud_pos_round_time = -1;
		side_points_set = FALSE;
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_CLN:
		if (CLN_game_phase != GAME_PHASE_WAITING) {
			MAX_MUL_render_team_score();
		}

		if ( (CLN_game_phase == GAME_PHASE_RUNNING) || (CLN_game_phase == GAME_PHASE_ENDING) ){
			MAX_MUL_render_round_time();
		}

		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_SRV:
		if ((SRV_game_phase == GAME_PHASE_ENDING) && (side_points_set == FALSE)) {
			side_points_set = TRUE;
			#ifdef CHECK_SIDES_READY_COUNT
				if (!SRV_sides_ready) return TRUE; //strany nejsou ready
			#endif
			SC_MP_Side_SetPoints((SRV_winning_side==SIDE1)?SIDE1:SIDE2, SC_MP_Side_GetPoints((SRV_winning_side==SIDE1)?SIDE1:SIDE2)+1);
		}
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLAYERCREATED: // connect?
		MAX_MUL_send_message_to_client(info->param1, MSG_MUL_ASSAULT_SWAP);
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLAYERRELEASED: // disconnect
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLRELEASED:
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RELEASE:
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLREADYTORESPAWN:
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_GET_PRESSFIRE_TEXT:
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PRESSFIRE_PRESSED:
		break;
	//-----------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLKILLED:
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_PLKILLEDFROMCOMA:
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTMAP:
		MAX_MUL_release_hud();
		assault_hud_pos_side1 = -1;
		assault_hud_pos_side2 = -1;
		assault_hud_pos_round_time = -1;
		side_points_set = FALSE;
		assault_round_time = -1.0;
		assault_round_nr = 1;
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RESTARTROUND:
		MAX_MUL_release_hud();
		assault_hud_pos_side1 = -1;
		assault_hud_pos_side2 = -1;
		assault_hud_pos_round_time = -1;
		side_points_set = FALSE;
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_LOCALMSG:
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_MSG_TO_CLN:
		switch (info->param1) {
		case MSG_MUL_ASSAULT_SWAP:
			MAX_MUL_swap_custom_items();
			MAX_MUL_swap_custom_objectives();
			break;

		}
		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_SYNCHCHANGE:

		break;
	//---------------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RENDER:
		return FALSE; // obsravacka, aby se nerenderoval object status
		break;

	}

	return TRUE;
}