//#define PL_MAINTASK_REFRESH		1.0
//float	PL_MAINTASK_teleport_time = 0.0;

#define PL_MAINTASK_FORCE_STAND		0x1000
#define PL_MAINTASK_FORCE_CROUCH	0x2000
#define PL_MAINTASK_FORCE_WALK		0x4000
#define PL_MAINTASK_FORCE_RUN		0x8000
#define PL_MAINTASK_FORCE_SPRINT	0x10000
#define PL_MAINTASK_FORCE_AIM		0x20000
#define PL_MAINTASK_FORCE_NO_AIM	0x40000

float	PL_MAINTASK_refresh_time= -1.0;
float	PL_MAINTASK_time		= 0.1f;
BOOL	PL_MAINTASK_bDead		= TRUE;
BOOL	PL_MAINTASK_bEnabled	= TRUE;
BOOL	PL_MAINTASK_bBlocked	= FALSE;
BOOL	PL_MAINTASK_defined		= FALSE;
int		PL_MAINTASK_current_maintask = 0;
sc_nod	PL_MAINTASL_nodes[MAINTASK_COUNT];

s_SC_P_AI_MoveStyle PL_MAINTASK_old_movestyle;

c_Vector3		PL_MAINTASK_vec;

s_sphere		PL_MAINTASK_sphere;
c_BoxOriented	PL_MAINTASK_box;
s_SC_Area		PL_MAINTASK_area;
dword			PL_MAINTASK_hide_out;
dword			PL_MAINTASK_player;
BOOL			PL_MAINTASK_reload;

#ifdef MAX_SCRIPT_DEBUG
dword			PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id;
#endif

int define_maintask();
void PL_MAINTASK_set_maintask();

void PL_MAINTASK_restart() {
	//define_maintask();
	PL_MAINTASK_time = maintask[0].wait;
	PL_MAINTASK_current_maintask = 0;
	PL_MAINTASK_reload = TRUE;
}

void PL_MAINTASK_next() {	//index maintasku v poli
	if (PL_MAINTASK_current_maintask < MAINTASK_COUNT-1) 
		PL_MAINTASK_current_maintask++;
	else if ((PL_MAINTASK_current_maintask >= MAINTASK_COUNT-1) && (MAINTASK_LOOPED))
		PL_MAINTASK_current_maintask = 0;
	else {
		#ifdef MAX_SCRIPT_DEBUG
			//SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
			sprintf(_debug_tmp, "pl_maintask.cxx : PL_MAINTAKS_next() - uz zadny next neni | s/g/m: %d/%d/%d", PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
			SC_Log(3, _debug_tmp);
			SC_message(_debug_tmp);
		#endif
		return;
	}
	
	PL_MAINTASK_time = maintask[PL_MAINTASK_current_maintask].wait;
	PL_MAINTASK_bBlocked = TRUE;
	//if ((PL_MAINTASK_bEnabled) && (PL_MAINTASK_defined)) PL_MAINTASK_set_maintask();
}

void PL_MAINTASK_set(int i) {	//index maintasku v poli
	int		j;

	for (j=0; j<MAINTASK_COUNT; j++) {
		if (maintask[j].coop_id == i) {
			PL_MAINTASK_current_maintask = j;
			PL_MAINTASK_time = maintask[PL_MAINTASK_current_maintask].wait;
			PL_MAINTASK_bBlocked = TRUE;
			break;
		}
	}
	if (j >= MAINTASK_COUNT) {
		#ifdef MAX_SCRIPT_DEBUG
			//SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
			sprintf(_debug_tmp, "pl_maintask.cxx : PL_MAINTASK_set(%d) - spatny index | s/g/m: %d/%d/%d", i, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
			SC_Log(3, _debug_tmp);
			SC_message(_debug_tmp);
		#endif
		return;
	}
	
	//if ((PL_MAINTASK_bEnabled) && (PL_MAINTASK_defined)) PL_MAINTASK_set_maintask();
}

int PL_MAINTASK_get_index() {
	return PL_MAINTASK_current_maintask;
}

int PL_MAINTASK_get_coop_id() {
	return maintask[PL_MAINTASK_current_maintask].coop_id;
}

void PL_MAINTASK_enable() {
	PL_MAINTASK_bEnabled = TRUE;
	PL_MAINTASK_time = maintask[PL_MAINTASK_current_maintask].wait;	//aby se znovu nastavil MT ||| dodano wait (bylo tu 0.0, ale proc?)
}

void PL_MAINTASK_disable() {
	PL_MAINTASK_bEnabled = FALSE;
}

BOOL PL_MAINTASK_is_enabled() {
	return PL_MAINTASK_bEnabled;
}

void get_maintask_nodes() {
	int		i;

	for (i=0; i<MAINTASK_COUNT; i++) {
		if (!SC_StringSame(maintask[i].name, ""))
			PL_MAINTASL_nodes[i] = SC_NOD_GetNoMessage_Entity(maintask[i].name);
		else
			PL_MAINTASL_nodes[i] = NULL;
	}
}

#ifdef MAX_SCRIPT_DEBUG
void find_remove_pc_maintask(sc_nod nod, s_SC_Pscript_info *info) {
#else
void find_remove_pc_maintask(sc_nod nod) {
#endif
	int		i;

	for (i=0; i<MAINTASK_COUNT; i++) {
		if (nod == PL_MAINTASL_nodes[i]) {
			maintask[i].step = 0.0;
			maintask[i].pl_handle = NULL;
			/*#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : find_remove_pc_maintask() - Odebira se PC z NE-aktualniho MainTasku: %d | s/g/m: %d/%d/%d", maintask[i].coop_id, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
				SC_message(_debug_tmp);
			#endif*/
			break;
		}
	}
}
//-----------------------------------------------------------------------------------------------------------------
void PL_MAINTASK_set_maintask() {

#ifdef PC_CONTROLLED
	if (SC_P_Ai_TeamCmds_Get(PL_MAINTASK_player) == SC_P_AI_TEAMCMD_STATE_ENABLED) SC_P_Ai_TeamCmds_Set(PL_MAINTASK_player, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM); //nebuto te prepinat, kdyz je to vyple ...
#endif

	if (maintask[PL_MAINTASK_current_maintask].flags >= PL_MAINTASK_FORCE_STAND) {

		s_SC_P_AI_MoveStyle			move_style;

		CLEAR(PL_MAINTASK_old_movestyle);
		SC_P_Ai_GetMoveStyle(PL_MAINTASK_player, &PL_MAINTASK_old_movestyle);
		CLEAR(move_style);
		//move_style.battle.flags	= 0; //SC_P_AI_MOVESTYLE_FL_PHASE // SC_P_AI_MOVESTYLE_FL_AIM // SC_P_AI_MOVESTYLE_FL_SPRINT
		
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_STAND) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.peace.phase =		0.0;
			move_style.danger.phase	=		0.0;
			move_style.fakedanger.phase	=	0.0;
			move_style.battle.phase	=		0.0;
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_CROUCH) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_PHASE;
			move_style.peace.phase =		1.0;
			move_style.danger.phase =		1.0;
			move_style.fakedanger.phase	=	1.0;
			move_style.battle.phase	=		1.0;
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_WALK) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.peace.sprint	=		0.0;
			move_style.danger.sprint =		0.0;
			move_style.fakedanger.sprint=	0.0;
			move_style.battle.sprint =		0.0;
			MAX_SUP_set_move_phase_walk(PL_MAINTASK_player);
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_RUN) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.peace.sprint	=		0.0;
			move_style.danger.sprint =		0.0;
			move_style.fakedanger.sprint=	0.0;
			move_style.battle.sprint =		0.0;
			MAX_SUP_set_move_phase_run(PL_MAINTASK_player);
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_SPRINT) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_SPRINT;
			move_style.peace.sprint	=		1.0;
			move_style.danger.sprint =		1.0;
			move_style.fakedanger.sprint=	1.0;
			move_style.battle.sprint =		1.0;
			MAX_SUP_set_move_phase_run(PL_MAINTASK_player);
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_AIM) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.peace.aim	=		1.0;
			move_style.danger.aim =			1.0;
			move_style.fakedanger.aim =		1.0;
			move_style.battle.aim =			1.0;
		}
		if (maintask[PL_MAINTASK_current_maintask].flags & PL_MAINTASK_FORCE_NO_AIM) {
			move_style.peace.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.danger.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.fakedanger.flags |=	SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.battle.flags |=		SC_P_AI_MOVESTYLE_FL_AIM;
			move_style.peace.aim	=		0.0;
			move_style.danger.aim =			0.0;
			move_style.fakedanger.aim =		0.0;
			move_style.battle.aim =			0.0;
		}

		SC_P_Ai_SetMoveStyle(PL_MAINTASK_player, &move_style);
	}

	PL_MAINTASK_bBlocked = FALSE;

	if ((maintask[PL_MAINTASK_current_maintask].target) || (maintask[PL_MAINTASK_current_maintask].target_area.boxes) || (maintask[PL_MAINTASK_current_maintask].target_area.sphs) ||
		(maintask[PL_MAINTASK_current_maintask].name[0] == 0) || (maintask[PL_MAINTASK_current_maintask].nextmove_interval > 0.0) || (maintask[PL_MAINTASK_current_maintask].nextmove_interval_rand > 0.0) ||
		(maintask[PL_MAINTASK_current_maintask].max_pc_distance > 0.0)) {
		MAX_SUP_set_custom_maintask_s_maintask(PL_MAINTASK_player, maintask[PL_MAINTASK_current_maintask]);
		PL_MAINTASK_refresh_time = maintask[PL_MAINTASK_current_maintask].refresh_time;
		return;
	}

	PL_MAINTASK_refresh_time = -1.0;

	if ((maintask[PL_MAINTASK_current_maintask].pc_id) || (maintask[PL_MAINTASK_current_maintask].pl_handle)) {
		if (maintask[PL_MAINTASK_current_maintask].search_dist == 0.0)
			MAX_SUP_set_follow_maintask_sc_helper(	maintask[PL_MAINTASK_current_maintask].name,	//jmenno sc_helperu
													maintask[PL_MAINTASK_current_maintask].pc_id ? maintask[PL_MAINTASK_current_maintask].pc_id : MAX_SUP_get_pl_id_from_handle(maintask[PL_MAINTASK_current_maintask].pl_handle),	//id nasledovaneho hrace
													PL_MAINTASK_player,								//hrac
													maintask[PL_MAINTASK_current_maintask].coop_id,	//coop_id
													maintask[PL_MAINTASK_current_maintask].step,	//step
													maintask[PL_MAINTASK_current_maintask].flags);	//flags
		else
			MAX_SUP_set_custom_maintask_sc_helper(	maintask[PL_MAINTASK_current_maintask].name,	//jmenno sc_helperu
													PL_MAINTASK_player,								//hrac
													maintask[PL_MAINTASK_current_maintask].coop_id,	//coop_id
													maintask[PL_MAINTASK_current_maintask].step,	//step
													maintask[PL_MAINTASK_current_maintask].search_dist,
													maintask[PL_MAINTASK_current_maintask].search_z_dist,
													maintask[PL_MAINTASK_current_maintask].flags,	//flags
													maintask[PL_MAINTASK_current_maintask].pc_id ? maintask[PL_MAINTASK_current_maintask].pc_id : MAX_SUP_get_pl_id_from_handle(maintask[PL_MAINTASK_current_maintask].pl_handle));	//pc_id
	//-----------------------------------------------------------------------------------------------------------------
	} else {
	//-----------------------------------------------------------------------------------------------------------------
		if (maintask[PL_MAINTASK_current_maintask].search_dist == 0.0)
			MAX_SUP_set_default_maintask_sc_helper(	maintask[PL_MAINTASK_current_maintask].name,	//jmenno sc_helperu
													PL_MAINTASK_player,								//hrac
													maintask[PL_MAINTASK_current_maintask].coop_id,	//coop_id
													maintask[PL_MAINTASK_current_maintask].step,	//step
													maintask[PL_MAINTASK_current_maintask].flags);	//flags
		else
			//MAX_SUP_set_follow_maintask_sc_helper(
			MAX_SUP_set_custom_maintask_sc_helper(	maintask[PL_MAINTASK_current_maintask].name,	//jmenno sc_helperu
													PL_MAINTASK_player,								//hrac
													maintask[PL_MAINTASK_current_maintask].coop_id,	//coop_id
													maintask[PL_MAINTASK_current_maintask].step,	//step
													maintask[PL_MAINTASK_current_maintask].search_dist,
													maintask[PL_MAINTASK_current_maintask].search_z_dist,
													maintask[PL_MAINTASK_current_maintask].flags,	//flags
													NULL);											//pc_id
	}

}
//-----------------------------------------------------------------------------------------------------------------

int PL_MAINTASK(s_SC_Pscript_info *info) {

	switch(info->message) {

		case SC_PLSCR_MSG_SCRIPT_INIT:
			PL_MAINTASK_time		= 0.1f;
			PL_MAINTASK_bDead		= TRUE;
			PL_MAINTASK_bEnabled	= TRUE;
			PL_MAINTASK_bBlocked	= FALSE;
			PL_MAINTASK_defined		= FALSE;
			PL_MAINTASK_reload		= FALSE;
			PL_MAINTASK_current_maintask = -1;

			CLEAR(PL_MAINTASK_area);
			PL_MAINTASK_area.box = &PL_MAINTASK_box;
			PL_MAINTASK_area.sph = &PL_MAINTASK_sphere;

			CLEAR(PL_MAINTASK_old_movestyle);
			break;

		case SC_PLSCR_MSG_JUSTLOADED:
			PL_MAINTASK_player = info->player;
			PL_MAINTASK_area.box = &PL_MAINTASK_box;
			PL_MAINTASK_area.sph = &PL_MAINTASK_sphere;
			PL_MAINTASK_reload  = TRUE;
			//get_maintask_nodes();
			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:
			break;

		case SC_PLSCR_MSG_PL_CREATED:
			PL_MAINTASK_player = info->player;
			PL_MAINTASK_current_maintask  = 0;
			break;

		case SC_PLSCR_MSG_PL_RELEASED:
			PL_MAINTASK_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
			PL_MAINTASK_time  = 0.1f;
			PL_MAINTASK_bDead = FALSE;
			info->next_exe_time = 0.0;
			/*if (PL_MAINTASK_hide_out) {
				if (!SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, TRUE);
				SC_P_Ai_MoveAt(info->player, &vec1, PL_MAINTASK_hide_out, 0);
				SC_P_Ai_SetScriptMode(info->player, FALSE);
				PL_MAINTASK_hide_out = 0;
			}*/
			SC_P_Ai_GetMoveStyle(PL_MAINTASK_player, &PL_MAINTASK_old_movestyle);
			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			PL_MAINTASK_bDead = TRUE;
			MAX_SUP_clear_maintask(info->player);
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:
			
			if (PL_MAINTASK_bDead) return 0;

			if (PL_MAINTASK_reload) {
				info->next_exe_time = 0.0;
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				if (define_maintask() != MAINTASK_COUNT) SC_message("pl_maintasl.cxx - define_maintask() : nespravny pocet maintasku | s/g/m: %d/%d/%d", PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
#else
				define_maintask();
#endif
				get_maintask_nodes();
#ifdef RESPAWN
#ifdef RESPAWN_DYN_NAME
				check_respawn_maintasks();
#endif
#endif
				PL_MAINTASK_reload = FALSE;
			}

			if (!PL_MAINTASK_defined) {
				info->next_exe_time = 0.0;
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				if (define_maintask() != MAINTASK_COUNT) SC_message("pl_maintasl.cxx - define_maintask() : nespravny pocet maintasku | s/g/m: %d/%d/%d", PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
#else
				define_maintask();
#endif
				get_maintask_nodes();
#ifdef RESPAWN
#ifdef RESPAWN_DYN_NAME
				check_respawn_maintasks();
#endif
#endif
				PL_MAINTASK_time = maintask[0].wait;
				PL_MAINTASK_defined = TRUE;
#ifdef MAINTASK_RESPAWN
				MAX_SUP_prepare_area(&PL_MAINTASK_area, &PL_MAINTASK_sphere, &PL_MAINTASK_box);
				if (!MAX_SUP_get_area_sc_helper(maintask[PL_MAINTASK_current_maintask].name, &PL_MAINTASK_area)) break;
				PL_MAINTASK_hide_out = SC_GetRndHideout(&PL_MAINTASK_area, SC_GETHIDEOUT_FL_EMPTYONLY, &PL_MAINTASK_vec);
				if (PL_MAINTASK_hide_out) {
					if (!SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, TRUE);
					SC_P_SetPos(info->player, &PL_MAINTASK_vec, NULL, NULL);
					SC_P_Ai_MoveAt(info->player, &PL_MAINTASK_vec, PL_MAINTASK_hide_out, 0);
					SC_P_Ai_SetScriptMode(info->player, FALSE);
				}
#endif
			}

			if (PL_MAINTASK_bEnabled == FALSE) return 0;

			if (PL_MAINTASK_refresh_time > 0.0) { //protoze default je 0.0, tak by to delalo kazdy snimek !!!
				PL_MAINTASK_refresh_time -= info->elapsed_time;
				if (PL_MAINTASK_refresh_time <= 0.0) {
					if (SC_P_Ai_GetScriptMode(info->player)) {
						if ((!maintask[PL_MAINTASK_current_maintask].ignore_speak) && (MAX_SUP_is_speaking(info->player, &PL_MAINTASK_time))) {// pokud nemluvi, tak se do time da doba mluveni
							return FALSE;	// a ukonci se tick
						} else {
							SC_P_Ai_SetScriptMode(info->player, FALSE); // pokud nemluvi, tak se vypne ze scriptu a
						}
					}
					PL_MAINTASK_set_maintask(); //nastavi se mu MT
					//PL_MAINTASK_refresh_time = PL_MAINTASK_REFRESH;
				}
			}

			if (PL_MAINTASK_time >= 0.0) {
				PL_MAINTASK_time -= info->elapsed_time;
				if (PL_MAINTASK_time < 0.0) {
					if (SC_P_Ai_GetScriptMode(info->player)) {

						if ((!maintask[PL_MAINTASK_current_maintask].ignore_speak) && (MAX_SUP_is_speaking(info->player, &PL_MAINTASK_time))) {// pokud nemluvi, tak se do time da doba mluveni
							return FALSE;	// a ukonci se tick
						} else {
							SC_P_Ai_SetScriptMode(info->player, FALSE); // pokud nemluvi, tak se vypne ze scriptu a
						}
					}
					PL_MAINTASK_set_maintask();
				}
			}

			/*if (MAX_SUP_count_timeout(&PL_MAINTASK_teleport_time, info->elapsed_time)) {
				check_teleport(info->player);
				PL_MAINTASK_teleport_time = 10.0;
			}*/
			break;

		case SC_PLSCR_MSG_PL_HIT:
			break;

		case SC_PLSCR_MSG_PL_KILLED:
			PL_MAINTASK_bDead = TRUE;
			MAX_SUP_clear_maintask(info->player);
			break;

		case SC_PLSCR_MSG_PL_HEALEDFROMCOMA:
			PL_MAINTASK_bDead = FALSE;
			break;

		case SC_PLSCR_MSG_AI_MAINTASK_FINISHED:
			//SC_message("fin1");
#ifdef MAX_SCRIPT_DEBUG
			SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
			sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_AI_MAINTASK_FINISHED - param1: %d | param2: %d | s/g/m: %d/%d/%d", info->param1, info->param2, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
			SC_Log(3, _debug_tmp);
#endif
/*#ifdef PC_CONTROLLED
			SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM);
#endif*/
			SC_P_Ai_SetMoveStyle(PL_MAINTASK_player, &PL_MAINTASK_old_movestyle);
			if (!PL_MAINTASK_bBlocked) { // pokud je zablokovan, znamena to, ze nekdo pouzil SET nebo NEXT a doba v maintask.wait jeste neuplynula
				if (PL_MAINTASK_current_maintask < MAINTASK_COUNT-1) {
					PL_MAINTASK_current_maintask++;
					PL_MAINTASK_time = maintask[PL_MAINTASK_current_maintask].wait;
				} else if ((PL_MAINTASK_current_maintask >= MAINTASK_COUNT-1) && (MAINTASK_LOOPED)) {
					PL_MAINTASK_current_maintask = 0;
					PL_MAINTASK_time = maintask[PL_MAINTASK_current_maintask].wait;
				}
			}
			//SC_message("fin2");
			break;

		case SC_PLSCR_MSG_SCRIPT_MESSAGE:
			switch (info->param1) {
			case MSG_MAINTASK_ADD_PC:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_ADD_PC] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				maintask[PL_MAINTASK_current_maintask].pl_handle = MAX_SUP_get_pl_id_from_handle(SC_PC_Get());

				if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
				PL_MAINTASK_set_maintask();
				break;

			case MSG_MAINTASK_REMOVE_PC:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_REMOVE_PC] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				//neresi se jestli je povolen nebo ne !!!
				//if (PL_MAINTASK_is_enabled()) {
				if (PL_MAINTASL_nodes[PL_MAINTASK_current_maintask] == info->param3) {
					maintask[PL_MAINTASK_current_maintask].pl_handle = NULL;
					maintask[PL_MAINTASK_current_maintask].step = 0.0;
					maintask[PL_MAINTASK_current_maintask].flags|= SC_P_AI_MAINTASK_FL_ALLOW_MOVE_TO_NOCOVER;

					if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
					PL_MAINTASK_set_maintask();
				} else {
#ifdef MAX_SCRIPT_DEBUG
					find_remove_pc_maintask(info->param3, info);
#else
					find_remove_pc_maintask(info->param3);
#endif
				}
				break;

			case MSG_MAINTASK_SET:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_SET] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				SC_P_Ai_SetMoveStyle(PL_MAINTASK_player, &PL_MAINTASK_old_movestyle);
				MAX_SUP_set_move_phase_run(PL_MAINTASK_player);

				PL_MAINTASK_enable();
				PL_MAINTASK_set(info->param2);
				MAX_SUP_clear_maintask(info->player);
				break;

			case MSG_MAINTASK_NEXT:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_NEXT] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				SC_P_Ai_SetMoveStyle(PL_MAINTASK_player, &PL_MAINTASK_old_movestyle);
				MAX_SUP_set_move_phase_run(PL_MAINTASK_player);

				PL_MAINTASK_enable();
				PL_MAINTASK_next();
				MAX_SUP_clear_maintask(info->player);
				break;

			case MSG_MAINTASK_RESUME:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_RESUME] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				if ((info->param2 == 0) || (info->param2 == PL_MAINTASK_get_coop_id() ))
					PL_MAINTASK_enable();
				break;

			case MSG_MAINTASK_STOP:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_STOP] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				PL_MAINTASK_disable();
				MAX_SUP_clear_maintask(info->player);
/*#ifdef PC_CONTROLLED
				SC_P_Ai_TeamCmds_Set(info->player, TRUE);
#endif*/
				break;

			case MSG_MAINTASK_TELEPORT:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MAINTASK_TELEPORT] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				MAX_SUP_prepare_area(&PL_MAINTASK_area, &PL_MAINTASK_sphere, &PL_MAINTASK_box);
				if (maintask[PL_MAINTASK_current_maintask].name[0] == 0) return FALSE;
				if (!MAX_SUP_get_area_sc_helper(maintask[PL_MAINTASK_current_maintask].name, &PL_MAINTASK_area)) break;
				PL_MAINTASK_hide_out = SC_GetRndHideout(&PL_MAINTASK_area, SC_GETHIDEOUT_FL_EMPTYONLY, &PL_MAINTASK_vec);
				if (PL_MAINTASK_hide_out) 
					MAX_SUP_player_force_set_pos(info->player, &PL_MAINTASK_vec, NULL, PL_MAINTASK_hide_out);
				else
					MAX_SUP_player_force_set_pos(info->player, &PL_MAINTASK_vec, NULL, NULL);

				PL_MAINTASK_enable();
				PL_MAINTASK_time = 0.0;
				break;

			case MSG_MT_PENDL_PAUSE:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_MAINTASK_side, &PL_MAINTASK_group, &PL_MAINTASK_member_id);
				sprintf(_debug_tmp, "pl_maintask.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MT_PENDL_PAUSE] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_MAINTASK_side, PL_MAINTASK_group, PL_MAINTASK_member_id);
				SC_Log(3, _debug_tmp);
#endif
				if (PL_MAINTASK_bEnabled) {
					MAX_SUP_clear_maintask(info->player);
					SC_P_Ai_StopMoving(info->player);
					PL_MAINTASK_enable();
					PL_MAINTASK_time = info->param4.x;
				}
				break;

			} // switch (info->param1)
			break;

		case SC_PLSCR_MSG_AI_TEAMCMD_VALIDATE:
			info->param1 = 1;
			PL_MAINTASK_disable();
			MAX_SUP_clear_maintask(info->player);
			break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)