// us_soldier.cxx - vytvoril MaxPayne

#include <inc\Maxovo\!max_support.h>

dword PL_PREPADAVANI_gphase = 0;

void set_invul(sc_player player) {
	s_SC_P_ScriptProps	sc_props;

	SC_P_GetScriptProps(player, &sc_props);
	sc_props.received_damage_mult = 0.001;
	SC_P_SetScriptProps(player, &sc_props);
}

void remove_invul(sc_player player) {
	s_SC_P_ScriptProps	sc_props;

	SC_P_GetScriptProps(player, &sc_props);
	sc_props.received_damage_mult = 1.0;
	SC_P_SetScriptProps(player, &sc_props);
}

float					PL_PREPADAVANI_my_hp = 200.0;
float					PL_PREPADAVANI_death_timeout = -1.0;
int						PL_PREPADAVANI_celkem = 0, PL_PREPADAVANI_prepadlych = 0, PL_PREPADAVANI_zustava = 0;
//float					PL_PREPADAVANI_pravdepodobnost = 0.5;
s_SC_P_status			PL_PREPADAVANI_status;
float					tmp1, tmp2;

void PL_PREPAD_prepadnuti(sc_player player) {
	c_Vector3	vec1, vec2;

	MAX_SUP_get_pos(PREPADAVANI, &vec1);
	MAX_SUP_player_get_pos(player, &vec2);

	vec1.x -= vec2.x;
	vec1.y -= vec2.y;
	vec1.z -= vec2.z;

	SC_VectorNormalize(&vec1);

	MAX_SUP_push_player(player, SC_SIK_CHEST, 150.0*vec1.x, 150.0*vec1.y , 100.0);
}

BOOL PL_PREPADAVANI(s_SC_Pscript_info *info) {

	switch(info->message){
	//------------------------------------
	case SC_PLSCR_MSG_SCRIPT_TIMETICK:
		switch(PL_PREPADAVANI_gphase) {
		case 0:
			if (info->player == NULL) return 1;  // pro pripad, ze by se to sem dostalo a nekdo ho releasnul
			if (SC_P_GetStatus(info->player, &PL_PREPADAVANI_status)) {
				MAX_SUP_send_message_to_group(PL_SIDE, PL_GROUP, 0, 2222, 0);
				set_invul(info->player);
				PL_PREPADAVANI_gphase = 1;

				#ifdef PREPADAVANI_FORCE_STAND
				{
					s_SC_P_AI_MoveStyle			move_style;

					CLEAR(move_style);
					SC_P_Ai_GetMoveStyle(info->player, &move_style);
					move_style.battle.flags	= SC_P_AI_MOVESTYLE_FL_PHASE;
					move_style.battle.phase	= 0.0;
					move_style.peace.flags	= SC_P_AI_MOVESTYLE_FL_PHASE;
					move_style.peace.phase	= 0.0;
					move_style.fakedanger.flags	= SC_P_AI_MOVESTYLE_FL_PHASE;
					move_style.fakedanger.phase	= 0.0;
					move_style.danger.flags	= SC_P_AI_MOVESTYLE_FL_PHASE;
					move_style.danger.phase	= 0.0;
					SC_P_Ai_SetMoveStyle(info->player, &move_style);
				}
				#endif
			}
			break;

		case 1:
			if (PL_PREPADAVANI_death_timeout > 0.0) {
				PL_PREPADAVANI_death_timeout -= info->elapsed_time;
				if (PL_PREPADAVANI_death_timeout <= 0.0) {
					PL_PREPADAVANI_gphase = 10;
					PL_PREPADAVANI_my_hp = -1000.0;
					remove_invul(info->player);
					MAX_SUP_set_hp(info->player, -10.0);
				}
			}
			break;

		} // switch(PL_PREPADAVANI_gphase)

		break;
	//------------------------------------
	case SC_PLSCR_MSG_SCRIPT_MESSAGE:
		switch (info->param1) {
		case 1:
			break;

		case 2222:
			PL_PREPADAVANI_celkem++;
			PL_PREPADAVANI_zustava++;
			break;

		case 2223:
			PL_PREPADAVANI_zustava--;
			break;

		case 2224:
			PL_PREPADAVANI_zustava--;
			PL_PREPADAVANI_prepadlych++;
			break;


		}// switch info->param1

		break;
	//------------------------------------
	case SC_PLSCR_MSG_PL_HIT:
		if (PL_PREPADAVANI_my_hp == -1000.0) break;

		PL_PREPADAVANI_my_hp -= (200.0-MAX_SUP_get_hp(info->player)) * 1000.0;

		if ((PL_PREPADAVANI_my_hp < 50.0) && (PL_PREPADAVANI_death_timeout < 0.0))  {
			tmp1 = (PL_PREPADAVANI_celkem*PREPADAVANI_PRA - PL_PREPADAVANI_prepadlych)/(float)PL_PREPADAVANI_zustava;
			tmp2 = abs(frnd(1.0));
			if (tmp2 <= tmp1) {
				MAX_SUP_clear_maintask(info->player);
				SC_P_Ai_SetScriptMode(info->player, TRUE);
				#ifdef PREPADAVANI_FORCE_STAND
					PL_PREPADAVANI_death_timeout = 0.01;
				#else
					MAX_SUP_player_shoot_at_player(info->player, info->param1, 3.0, SC_P_PHASE_STAND, TRUE);
					PL_PREPADAVANI_death_timeout = 2.7;
				#endif
				info->next_exe_time = 0.0;
				MAX_SUP_send_message_to_group(PL_SIDE, PL_GROUP, 0, 2224, 0); // prepadl
				PL_PREPADAVANI_my_hp = -1000.0;
			} else {
				MAX_SUP_send_message_to_group(PL_SIDE, PL_GROUP, 0, 2223, 0); // neprepadl
				PL_PREPADAVANI_my_hp = -1000.0;
				remove_invul(info->player);
				MAX_SUP_set_hp(info->player, -10.0);
			}
			return 0;
		}

		MAX_SUP_set_hp(info->player, 200.0);
		break;
	//------------------------------------
	case SC_PLSCR_MSG_PL_KILLED:
		if (PL_PREPADAVANI_gphase == 10) PL_PREPAD_prepadnuti(info->player);
		break;

	} // switch(info->message)

	return TRUE;
}
