// ************************************************************************************************************************ //
//																															//
//	File:			Level.cxx																								//
//	Description:	Common code used by level scripts	    													        	//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //



#include <inc\b&a\Common.cxx>



// +++ Globals +++
dword	gPhase = GP_START;
float	g_tmShowHint = 0;
BOOL	g_bTickHint = FALSE;


// +++ Defines +++
// +++ Defines +++
// +++ Defines +++


// +++ Structs +++
// +++ Structs +++
// +++ Structs +++

//...


// +++ Functions +++
// +++ Functions +++
// +++ Functions +++


//Sets global level phase
void SetLevelPhase(dword newPhase)
{
	gPhase = newPhase;

	SC_Osi("gPhase: %d", gPhase);
	SC_Log(3, "gPhase: %d", gPhase);
}

//Init side
void InitSide(dword sideId, dword numGroups)
{
	s_SC_InitSide	is;

	CLEAR(is);

	is.side_id		= sideId;
	is.max_groups	= numGroups;

	SC_InitSide(&is);
}

//
BOOL HintSet(dword textId, dword key, float showTime)
{
	ushort	str[1024], keyName[64];


	//
	g_tmShowHint = showTime;

	//hide
	if (!textId)
	{
		g_bTickHint = FALSE;

		SC_HintSet(NULL);
		return TRUE;
	}

	//show
	if (key)
	{
		if ( !SC_GetUserKeyName(key, keyName, 64) )
			return FALSE;

		//show hint
		swprintf(str, SC_Wtxt(textId), keyName);
		SC_HintSet(str);
	}
	else
	{
		//show hint
		SC_HintSet( SC_Wtxt(textId) );
	}

	//
	g_bTickHint = TRUE;

	return TRUE;
}

//
BOOL HintTick(float time)
{
	BOOL	ret = FALSE;

	if (g_bTickHint)
	{
		g_tmShowHint -= time;

		if (g_tmShowHint <= 0)
		{
			g_bTickHint = FALSE;

			ret = HintSet(0, 0, 0);
			return ret;
		}
	}

	return ret;
}
