// ************************************************************************************************************************ //
//	
//	File:			UseObject.cxx
//	Description:	Script for usable objects
//	Author:			Beny
//	
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//default use distance
#ifndef	OBJ_USE_DIST
#define	OBJ_USE_DIST		2.0f
#endif

#ifndef	OBJ_USED_ID
#define	OBJ_USED_ID			0
#endif



//
dword	gPhase = GP_START;

//icon test
//float	time = 3;
//dword	icon = 0;


//
int ScriptMain(s_SC_OBJ_info *info)
{
	switch(info->message)
	{
	case SC_OBJ_MSG_DOTICK:
		switch(gPhase)
		{
		case GP_START:
			info->next_exe_time = 0.1f;
			gPhase = GP_INIT;
			break;

		case GP_INIT:
			gPhase = GP_IDLE;
			break;

		default:
		case GP_IDLE:
			break;
		}
		break;

	case SC_OBJ_MSG_MESSAGE:
		switch(info->param1)
		{
		}
		break;

	case SC_OBJ_MSG_USED:
		SC_LevelScriptMsg(SCM_OBJ_INTERACTION, (dword)info->master_nod, OBJ_USED_ID, NULL);
		break;


/*	//icon test
	case SC_OBJ_MSG_VALIDATE_USE:
		info->param3 = icon;

		time -= info->elapsed_time;
		if (time < 0)
		{
			time = 3;
			icon++;
			SC_Osi("Icon: %d", icon);
		}
		break;
*/
	//
	case SC_OBJ_MSG_INIT:
		info->next_exe_time = 0.1f;

#ifdef	OBJ_USE_TEXT
		SC_ActiveObj_Create(info->master_nod, OBJ_USE_DIST, OBJ_USE_TEXT);
#endif
		break;

	case SC_OBJ_MSG_JUSTLOADED:
		break;

	case SC_OBJ_MSG_RELEASE:
#ifdef	OBJ_USE_TEXT
		SC_ActiveObj_Remove(info->master_nod);
#endif
		break;


	default:
		return FALSE;
	}

	return TRUE;

}//int ScriptMain(s_SC_OBJ_info *info)
