#define PL_RESPAWN_MAX_SEE    30.0
#define PL_RESPAWN_Z_DIST	    3.0
#define MAX_RESPAWNS_IN_GROUP 10
//#define NO_RESPAWN_GROUP      1


BOOL				        PL_RESPAWN_bDead    = TRUE;
BOOL				        PL_RESPAWN_bRestart = FALSE;
BOOL				        PL_RESPAWN_bEnabled = TRUE;
int					        PL_RESPAWN_bRespawn = -1;
float			        	PL_RESPAWN_time		  = 0.0f;
s_SC_P_RespawnPos	  PL_RESPAWN_respawn_pos;
s_sphere			      PL_RESPAWN_sphere;
c_BoxOriented		    PL_RESPAWN_box;
s_SC_Area			      PL_RESPAWN_area;
sc_player			      PL_RESPAWN_list[64];
c_Vector3			      PL_RESPAWN_vec;
int					        PL_RESPAWN_num;
int					        PL_RESPAWN_i;
int					        PL_RESPAWN_COUNTER;
dword			        	PL_RESPAWN_FLAGS;
dword			        	PL_RESPAWN_hide_out;
sc_player           PL_RESPAWN_pl;

//s_SC_NOD_transform	trans;
s_SC_Plscr_info		PL_RESPAWN_sc_info;

/*#ifdef MAINTASK
int PL_MAINTASK_get();
#endif*/

void PL_RESPAWN_derespawn() {
	PL_RESPAWN_bRespawn = FALSE;
}

void PL_RESPAWN_respawn() {
	PL_RESPAWN_bRespawn = TRUE;
}

void PL_RESPAWN_restart() {
	PL_RESPAWN_bRestart = TRUE;
}

void PL_RESPAWN_enabled(BOOL b) {
	PL_RESPAWN_bEnabled = b;
}

BOOL PL_RESPAWN_is_enabled() {
	return PL_RESPAWN_bEnabled;
}
//--------------------------------------------------------------------------------------------------------------
BOOL check_death_body(s_SC_Pscript_info *info)
{
	s_SC_P_status		status;

	SC_P_GetStatus(info->player, &status);
  SC_Log(3, "PL_RESPAWN_MAINTASK - check dead body");
	PL_RESPAWN_num = 64;
	PL_RESPAWN_num = SC_EnumPlayers(SIDE, SC_P_GROUP_ALL, PL_RESPAWN_list, PL_RESPAWN_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY);
		
	for (PL_RESPAWN_i=0; PL_RESPAWN_i<PL_RESPAWN_num; PL_RESPAWN_i++)
		if (SC_P_CanSeePos(PL_RESPAWN_list[PL_RESPAWN_i], &status.pos, PL_RESPAWN_MAX_SEE, 0)) break;

	if (PL_RESPAWN_i < PL_RESPAWN_num) 	return TRUE; else return FALSE;
}
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
#ifdef RESPAWN_DYN_NAME
//#ifdef MAINTASK


//--------------------------------------------------------------------------------------------------------------
/*void check_respawn_maintasks(dword mt_coopid) 
{
	int			j;
	char		tmp[32];

	for (j=0; j<MAX_RESPAWNS_IN_GROUP; j++) 
  {
  sprintf(tmp, RESPAWN_DYN_NAME, mt_coopid, j);
		respawn_maintask[j] = SC_NOD_GetNoMessage_Entity(tmp);
	}
}       */
//--------------------------------------------------------------------------------------------------------------
void respawn_on_hideout(s_SC_Pscript_info *info)
{
	if (PL_RESPAWN_hide_out)
  {
    SC_Log(3, "PL_RESPAWN_MAINTASK - respawnuti na HO: %d", PL_RESPAWN_hide_out);
    if (!SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, TRUE);
	  SC_P_Ai_MoveAt(info->player, &PL_RESPAWN_vec, PL_RESPAWN_hide_out, 0);
    SC_P_Ai_SetScriptMode(info->player, FALSE);
    PL_RESPAWN_hide_out = 0;
	}
}
//--------------------------------------------------------------------------------------------------------------
BOOL try_respawn_maintask(s_SC_Pscript_info *info)
{
	int			           ret;
	int			           j, k;
	float              dist1, dist2;
	c_Vector3	         vec1, vec2, plpos;                                                                  
	sc_nod		         tmp_nod;
	char		           tmp[32];
	dword              side;
	s_SC_P_RespawnPos	 respawn_pos;
	sc_nod	           respawn_maintask[MAX_RESPAWNS_IN_GROUP];

	for (j=0; j<MAX_RESPAWNS_IN_GROUP; j++)
  {
		sprintf(tmp, RESPAWN_DYN_NAME, mt.cooperation_id, j+1);
		respawn_maintask[j] = SC_NOD_GetNoMessage_Entity(tmp);
	}

  SC_Log(3, "PL_RESPAWN_MAINTASK - zacatek maintasku cislo: %d", mt.cooperation_id);

	SC_P_GetHeadPos(info->player, &plpos);

//------------------------------------------------- trideni -----------------------------------------------------------
	for (j=0; j<MAX_RESPAWNS_IN_GROUP-1; j++) //pokus o bubble sort :)
  {	                                        
		if (!respawn_maintask[j]) break; //pokud je to NULL, tak konec
		SC_NOD_GetWorldPos(respawn_maintask[j], &vec1);
		dist1 = SC_2VectorsDist(&plpos, &vec1);
		for (k=j+1; k<MAX_RESPAWNS_IN_GROUP; k++) 
    {
			if (!respawn_maintask[k]) break; //pokud je to NULL, tak konec
			SC_NOD_GetWorldPos(respawn_maintask[k], &vec2);
			dist2 = SC_2VectorsDist(&plpos, &vec2);
			if (dist1 > dist2) 
      {
				tmp_nod = respawn_maintask[j];
				respawn_maintask[j] = respawn_maintask[k];
				respawn_maintask[k] = tmp_nod;
			}
		}
	}
//------------------------------------------------- testy ------------------------------------------------------------
	for (j=0; j<MAX_RESPAWNS_IN_GROUP; j++) 
  {
    SC_Log(3, "PL_RESPAWN_MAINTASK - Zjisteni na NULL: %d", j);
		if (!respawn_maintask[j]) break; //pokud je to NULL, tak konec

		SC_NOD_GetWorldPos(respawn_maintask[j], &vec1);
		dist1 = SC_2VectorsDist(&plpos, &vec1);
    SC_Log(3, "PL_RESPAWN_MAINTASK - Zjisteni na vzdalenost: %d", j);
		if (dist1 < PL_RESPAWN_Z_DIST) continue; // pokud je hrac moc blizko

		CLEAR(PL_RESPAWN_sphere);
		CLEAR(PL_RESPAWN_box);
		PL_RESPAWN_area.box	= NULL;
		PL_RESPAWN_area.boxes	= 0;
		PL_RESPAWN_area.sph	= NULL;
		PL_RESPAWN_area.sphs	= 0;

		sprintf(tmp, RESPAWN_DYN_NAME, mt.cooperation_id, j+1);
		ret = SC_GetScriptHelper(tmp, &PL_RESPAWN_sphere, &PL_RESPAWN_box);

		if (ret == SC_SCRIPTHELPER_TYPE_SPHERE) 
    {
			PL_RESPAWN_area.sphs = 1;
			PL_RESPAWN_area.sph = &PL_RESPAWN_sphere;
		} 
    else if (ret == SC_SCRIPTHELPER_TYPE_BOX) 
    {
			PL_RESPAWN_area.boxes = 1;
			PL_RESPAWN_area.box = &PL_RESPAWN_box;
		}
    //------------------------------------------------- respawn -----------------------------------------------------------
		if (ret) 
    {
			if (SIDE == SC_P_SIDE_US) side = SC_P_SIDE_VC;
			else if (SIDE == SC_P_SIDE_VC) side = SC_P_SIDE_US;
			PL_RESPAWN_num = 64;
			//zjistim zda se enemac nachazi v oblasti respawnu
      SC_Log(3, "PL_RESPAWN_MAINTASK - Zjisteni na enemace v oblasti: %d", j);
			PL_RESPAWN_num = SC_EnumPlayersArea(side, SC_P_GROUP_ALL, PL_RESPAWN_list, PL_RESPAWN_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY, &PL_RESPAWN_area);
			if (PL_RESPAWN_num) continue; // pokud ano, tak dalsi respawn

			PL_RESPAWN_hide_out = SC_GetRndHideout(&PL_RESPAWN_area, SC_GETHIDEOUT_FL_EMPTYONLY, &PL_RESPAWN_vec);
			if (PL_RESPAWN_hide_out) 
      {
				PL_RESPAWN_num = 64;
				//zjistim zda hrac vidi na HO
        SC_Log(3, "PL_RESPAWN_MAINTASK - Zjisteni zda hrac vidi na HO: %d", j);
				PL_RESPAWN_num = SC_EnumPlayers(SIDE, SC_P_GROUP_ALL, PL_RESPAWN_list, PL_RESPAWN_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY);
				PL_RESPAWN_vec.z += 1.0;
				
				for (PL_RESPAWN_i=0; PL_RESPAWN_i<PL_RESPAWN_num; PL_RESPAWN_i++)
					if (SC_P_CanSeePos(PL_RESPAWN_list[PL_RESPAWN_i], &PL_RESPAWN_vec, PL_RESPAWN_MAX_SEE, 0)) break;
				if (PL_RESPAWN_i < PL_RESPAWN_num) continue; // pokud ano, tak dalsi respawn

				PL_RESPAWN_vec.z -= 1.0;

				SC_PlScr_GetInfo(info->script, &PL_RESPAWN_sc_info);
				SC_NOD_FillRespawnPos(PL_RESPAWN_sc_info.nod, &respawn_pos);
				respawn_pos.flags = PL_RESPAWN_FLAGS;
				respawn_pos.pos.x = PL_RESPAWN_vec.x;
				respawn_pos.pos.y = PL_RESPAWN_vec.y;
				respawn_pos.pos.z = PL_RESPAWN_vec.z + 0.1;
				SC_Log(3, "PL_RESPAWN_MAINTASK - Respawn v oblasti: %d", j);

				SC_P_Respawn(info->player, &respawn_pos);

				return TRUE;
			}
		}
	}
  SC_Log(3, "PL_RESPAWN_MAINTASK - Konec: %d", j);
	return FALSE;
}
//--------------------------------------------------------------------------------------------------------------
//#endif //#ifdef MAINTASK
#endif //#ifdef RESPAWN_DYN_NAME
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------

int PL_RESPAWN(s_SC_Pscript_info *info)
{
	switch(info->message) 
  {

		case SC_PLSCR_MSG_SCRIPT_INIT:
			PL_RESPAWN_bDead	= TRUE;
			PL_RESPAWN_bRestart = FALSE;
			PL_RESPAWN_FLAGS	= RESPAWN_FLAGS;
			PL_RESPAWN_COUNTER	= RESPAWN_TIMES;
			PL_RESPAWN_bEnabled = TRUE;
			PL_RESPAWN_bRespawn = -1;
			PL_RESPAWN_hide_out =  0;

			SC_PlScr_GetInfo(info->script, &PL_RESPAWN_sc_info);
			SC_NOD_FillRespawnPos(PL_RESPAWN_sc_info.nod, &PL_RESPAWN_respawn_pos);
			PL_RESPAWN_respawn_pos.flags = PL_RESPAWN_FLAGS;
/*#ifdef RESPAWN_DYN_NAME
#ifdef MAINTASK
			check_respawn_maintasks();
#endif
#endif  */

			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:
			break;

		case SC_PLSCR_MSG_PL_CREATED:
			break;

		case SC_PLSCR_MSG_PL_RELEASED:
			PL_RESPAWN_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
			PL_RESPAWN_bDead = FALSE;
#ifdef RESPAWN_DYN_NAME
//#ifdef MAINTASK
			respawn_on_hideout(info);
			gPhase = prePhase;
//#endif
#endif
			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			PL_RESPAWN_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:
			if  (PL_RESPAWN_bEnabled == FALSE) return 0;

			if (PL_RESPAWN_bRestart) 
      {                                         // je to v ticku, protoze v restart() nemam info !!!
				SC_PlScr_GetInfo(info->script, &PL_RESPAWN_sc_info);
				SC_NOD_FillRespawnPos(PL_RESPAWN_sc_info.nod, &PL_RESPAWN_respawn_pos);
				PL_RESPAWN_COUNTER = RESPAWN_TIMES;
				PL_RESPAWN_respawn_pos.flags = PL_RESPAWN_FLAGS;
				PL_RESPAWN_bRestart = FALSE;
				return 1;
			}

			if (PL_RESPAWN_bRespawn == FALSE) 
      {
				SC_P_Derespawn(info->player);
				PL_RESPAWN_bRespawn = -1;
			} 
      else if (PL_RESPAWN_bRespawn == TRUE) 
      {
				SC_P_Respawn(info->player, &PL_RESPAWN_respawn_pos);
				PL_RESPAWN_bRespawn = -1;
			}

			if ((PL_RESPAWN_bDead) && (PL_RESPAWN_time > 0.0))
      {
				PL_RESPAWN_time -= info->elapsed_time;
				if (PL_RESPAWN_time <= 0.0) 
        {
					if (check_death_body(info)) 
          { //zjistim zda hrac vidi mrtvolu
						PL_RESPAWN_time = RESPAWN_TIME;
						return FALSE; // pokud ano, tak konec
					}

#ifdef RESPAWN_DYN_NAME
//#ifdef MAINTASK
//					if (PL_MAINTASK_get() >= 0) //musi mit maintask - asi vzdycky OK, ale ...
						if (try_respawn_maintask(info)) 
            {
							return TRUE;
						} 
            else 
            {
							PL_RESPAWN_time = RESPAWN_TIME;
							return FALSE;
						}
//#endif
#endif
					CLEAR(PL_RESPAWN_sphere);

					PL_RESPAWN_sphere.pos = PL_RESPAWN_respawn_pos.pos;
					PL_RESPAWN_sphere.rad = RESPAWN_DIST;

					PL_RESPAWN_area.sphs = 1;
					PL_RESPAWN_area.sph  = &PL_RESPAWN_sphere;

					PL_RESPAWN_num = 64;
					//detekuji pouze hrace
					PL_RESPAWN_num = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, PL_RESPAWN_list, PL_RESPAWN_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &PL_RESPAWN_area);

					for (PL_RESPAWN_i=0; PL_RESPAWN_i<PL_RESPAWN_num; PL_RESPAWN_i++)
          {
						SC_P_GetHeadPos(PL_RESPAWN_list[PL_RESPAWN_i], &PL_RESPAWN_vec);
						if (abs(PL_RESPAWN_vec.z - PL_RESPAWN_respawn_pos.pos.z) < PL_RESPAWN_Z_DIST) break;
					}
					
					if ((PL_RESPAWN_num > 0) && (PL_RESPAWN_i < PL_RESPAWN_num)) 
          {
						PL_RESPAWN_time = RESPAWN_TIME;
						SC_message("hrac v oblasti respawnu");
					}
          else 
          {
						PL_RESPAWN_num = 64;
						PL_RESPAWN_num = SC_EnumPlayers(SIDE, SC_P_GROUP_ALL, PL_RESPAWN_list, PL_RESPAWN_num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY);
						PL_RESPAWN_respawn_pos.pos.z += 1.0;
						for (PL_RESPAWN_i=0; PL_RESPAWN_i<PL_RESPAWN_num; PL_RESPAWN_i++)
							if (SC_P_CanSeePos(PL_RESPAWN_list[PL_RESPAWN_i], &PL_RESPAWN_respawn_pos.pos, PL_RESPAWN_MAX_SEE, 0)) break;

						PL_RESPAWN_respawn_pos.pos.z -= 1.0;

						if (PL_RESPAWN_i < PL_RESPAWN_num) 
            {
							PL_RESPAWN_time = RESPAWN_TIME;
							SC_message("hrac vidi na respawn");
							break;
						}

						SC_P_Respawn(info->player, &PL_RESPAWN_respawn_pos);
					}
				}
			}
			break;

		case SC_PLSCR_MSG_AI_MOVEAT_CALLBACK:
			//SC_message("dosel callback");
//H			if (info->param1 == CALLBCK_MOVEAT_FINISHED) //je jedno jestli uspel nebo ne
//H				if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE); //vypnu mu script mode
			break;

		case SC_PLSCR_MSG_PL_HIT:
			break;

		case SC_PLSCR_MSG_PL_KILLED:
#ifdef RESPAWN_GROUP
      SC_P_ChangeSideGroupMemberId(info->player, SC_P_SIDE_NEUTRAL, 0, SC_P_CREATE_MEMID_AUTO);
      PL_RESPAWN_enabled(FALSE);
      PL_RESPAWN_pl = GetRndPl(SIDE, RESPAWN_GROUP, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY);
      if (PL_RESPAWN_pl)                                                        //nejdriv prehaze do tymu vsechny zive VNMC
      {
        SC_P_ChangeSideGroupMemberId(PL_RESPAWN_pl, SIDE, GROUP, SC_P_CREATE_MEMID_AUTO);
        SC_P_ScriptMessage(PL_RESPAWN_pl, 44, 20);
      }
      else
      {                                                                         //pak az zacne respawnovat mrtve
        PL_RESPAWN_pl = GetRndPl(SIDE, RESPAWN_GROUP, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_AI_ONLY);
        if (PL_RESPAWN_pl)
        {
          SC_P_ChangeSideGroupMemberId(PL_RESPAWN_pl, SIDE, GROUP, SC_P_CREATE_MEMID_AUTO);
          SC_P_ScriptMessage(PL_RESPAWN_pl, 45, mt.cooperation_id);
        }
      }
#endif
#ifdef NO_RESPAWN_GROUP
      if (GetGroup(info->player) == NO_RESPAWN_GROUP)
        PL_RESPAWN_enabled(FALSE);
#endif
			if (PL_RESPAWN_COUNTER > 0)
      {
				if (RESPAWN_TIMES != 255)
          PL_RESPAWN_COUNTER--;
				PL_RESPAWN_bDead = TRUE;
				PL_RESPAWN_time = RESPAWN_TIME;
			}
			break;

    case SC_PLSCR_MSG_SCRIPT_MESSAGE:
      switch (info->param1)
      {
        case 44:
          gPhase = prePhase;
          break;
        case 45:
          mt.cooperation_id = info->param2;
          PL_RESPAWN_enabled(TRUE);
          gPhase = prePhase;
          break;
        }
      break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)
