#ifndef SPEECHLIBRARY
#define SPEECHLIBRARY

//library with functions for the speech

#define SPEECH_WITHWEAPON (SC_SPEECHADD_FL_SETANIMFROMSTATIV | SC_SPEECHADD_FL_ENDBY_SPEECHEND | SC_SPEECHADD_FL_LOOPED)
#define SPEECHANI_SHORT "g\\anims\\Script Anims\\an483.stg";speechdata.playanim_flags=SC_SPEECHADD_FL_ENDBY_SPEECHEND
#define SPEECHANI_EXCITED "g\\anims\\Script Anims\\an482.stg";speechdata.playanim_flags=SC_SPEECHADD_FL_ENDBY_SPEECHEND
#define SPEECHANI_COOL "g\\anims\\Script Anims\\an481.stg";speechdata.playanim_flags=SC_SPEECHADD_FL_ENDBY_SPEECHEND
#define SPEECHANI_COOLSHORT "g\\anims\\Script Anims\\an486.stg";speechdata.playanim_flags=SC_SPEECHADD_FL_ENDBY_SPEECHEND


s_SC_SpeechAdd				speechdata;


void PC_Shutup(){
	s_SC_Speech_Author	author;
	
	CLEAR(author);
	author.plid=SC_PC_Get();
	SC_Speech_Remove(&author,TRUE);
}

void Shutup(sc_player player){
	s_SC_Speech_Author	author;
	
	CLEAR(author);
	author.plid=player;
	SC_Speech_Remove(&author,TRUE);
}

BOOL P_IsTalking(sc_player who){
	s_SC_Speech_Author	author;
	
	CLEAR(author);
	author.plid=who;
	return SC_Speech_IsTalking(&author);
}

float P_GetTalkTime(sc_player who){
	s_SC_Speech_Author	author;
	
	CLEAR(author);
	author.plid=who;
	return SC_Speech_GetTalkTime(&author);
}

float PC_GetTalkTime(){
	s_SC_Speech_Author	author;
	
	CLEAR(author);
	author.plid=SC_PC_Get();;
	return SC_Speech_GetTalkTime(&author);
}

void PCSay(int what){

	speechdata.author.plid=SC_PC_Get();
	speechdata.callback_id=0;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	SC_Speech_Add(&speechdata);
}

void PCSayTo(int what, sc_player whom){

	speechdata.author.plid=SC_PC_Get();
	speechdata.callback_id=0;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=whom;
	SC_Speech_Add(&speechdata);
}

void PCSayM(int what, int callback){

	speechdata.author.plid=SC_PC_Get();
	speechdata.callback_id=callback;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	SC_Speech_Add(&speechdata);
}

void PCSayToM(int what, int callback, sc_player whom){

	speechdata.author.plid=SC_PC_Get();
	speechdata.callback_id=callback;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=whom;
	SC_Speech_Add(&speechdata);
}

void Say(sc_player who, int what){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}
	speechdata.author.plid=who;
	speechdata.callback_id=0;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	SC_Speech_Add(&speechdata);
}

void SayTo(sc_player who, int what, sc_player towho){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}
	speechdata.author.plid=who;
	speechdata.callback_id=0;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=towho;
	SC_Speech_Add(&speechdata);
}

void SayToM(sc_player who, int what, sc_player towho, int callback){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}
	speechdata.author.plid=who;
	speechdata.callback_id=callback;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=towho;
	SC_Speech_Add(&speechdata);
}

void SayToPC(sc_player who, int what){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}
	speechdata.author.plid=who;
	speechdata.callback_id=0;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=SC_PC_Get();
	SC_Speech_Add(&speechdata);
}

void SayM(sc_player who, int what, int message){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}

	speechdata.author.plid=who;
	speechdata.callback_id=message;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	SC_Speech_Add(&speechdata);
}

void SayToPCM(sc_player who, int what, int message){

	if (!who) {
		SC_Log(2,"Say Error - no player specified for text %d",what);
		return;
	}

	speechdata.author.plid=who;
	speechdata.callback_id=message;
	speechdata.force_authorname_id=0;
	speechdata.force_authorname_text=0;
	speechdata.speech_nr=what;
	speechdata.speech_text=0;
	speechdata.timer_gap=0.2f;
	speechdata.sayto_pl=SC_PC_Get();
	SC_Speech_Add(&speechdata);
}


void Force2DSpeech(){
	s_SC_SpeechProps sprops;
	SC_Speech_GetProps(&sprops);
	sprops.type=SC_SPEECHPROPS_TYPE_FORCE_2D;
	SC_Speech_SetProps(&sprops);
}

void Force3DSpeech(){
	s_SC_SpeechProps sprops;
	SC_Speech_GetProps(&sprops);
	sprops.type=SC_SPEECHPROPS_TYPE_NORMAL;
	SC_Speech_SetProps(&sprops);
}

#endif